'//+--------------------------------------------------------------------------+
'//|                                                                          |
'//|                             PhotoComposer                                |
'//|                             Version  2.01                                |
'//|                                                                          |
'//|        This GDImage project turns a photography into a postcard.         |
'//|        Ce projet GDImage transforme des images en carte postales         |
'//|                                                                          |
'//+--------------------------------------------------------------------------+
'//|                                                                          |
'//|                         Author Patrice TERRIER                           |
'//|                        pterrier@zapsolution.com                          |
'//|                          www.zapsolution.com                             |
'//|                                                                          |
'//+--------------------------------------------------------------------------+
'//|                  Project started on : 2007-06-01 (YYYY-MM-DD)            |
'//|                        Last revised : 2014-06-24 (YYYY-MM-DD)            |
'//+--------------------------------------------------------------------------+

#COMPILE EXE "PhotoCompo.exe"

DECLARE FUNCTION zTrace LIB "zTrace.DLL" ALIAS "zTrace" (zMessage AS ASCIIZ) AS LONG

TYPE POINTS
    x AS INTEGER
    y AS INTEGER
END TYPE

'------------------------------------------------------------------------------------------
#RESOURCE "control.pbr"

'// Return the SKIN Author's name
DECLARE FUNCTION SK_AUTHOR() AS STRING
'// Return SKIN color set
DECLARE FUNCTION SK_ACTIVECAPTION() AS LONG       '// COLOR ACTIVE CAPTION
DECLARE FUNCTION SK_INACTIVECAPTION() AS LONG     '// COLOR INACTIVE CAPTION
DECLARE FUNCTION SK_TEXTCOLOR() AS LONG           '// COLOR TEXT
DECLARE FUNCTION SK_BTNTEXTCOLOR() AS LONG        '// COLOR BUTTON TEXT
DECLARE FUNCTION SK_POPMENUTEXT() AS LONG         '// COLOR POPUP MENU TEXT
DECLARE FUNCTION SK_POPMENUHILITE() AS LONG       '// COLOR POPUP MENU HILIGHTED TEXT
DECLARE FUNCTION SK_ACTIVEMENUBAR() AS LONG       '// COLOR MENU BAR HILIGHTED ITEM
DECLARE FUNCTION SK_INACTIVEMENUBAR() AS LONG     '// COLOR MENU BAR DEFAULT COLOR
DECLARE FUNCTION SK_CAPTIONFONT() AS STRING       '// CAPTION FONT TO USE
DECLARE FUNCTION SK_CAPTIONFONTHEIGHT() AS LONG   '// CAPTION FONT SIZE
DECLARE FUNCTION SK_PUSHBUTFONTSIZE() AS LONG     '// PUSH BUTTON FONT SIZE
DECLARE FUNCTION SK_TRACKHICOLOR() AS LONG        '// TRACK BAR HIGHLIGHTED VALUE

#INCLUDE "ZSKIN.INC"
#INCLUDE "GDIMAGE.INC"
DECLARE SUB zKeyBd_Event LIB "GDIMAGE.DLL" ALIAS "zKeyBd_Event" (BYVAL K1 AS LONG, BYVAL K2 AS LONG)

DECLARE SUB DragAcceptFiles LIB "SHELL32.DLL" ALIAS "DragAcceptFiles" (BYVAL hwnd AS DWORD, BYVAL fAccept AS LONG)
DECLARE SUB DragFinish LIB "SHELL32.DLL" ALIAS "DragFinish" (BYVAL hDrop AS DWORD)
DECLARE FUNCTION DragQueryFile LIB "SHELL32.DLL" ALIAS "DragQueryFileA" (BYVAL hDrop AS DWORD, BYVAL uiFile AS DWORD, lpStr AS ASCIIZ, BYVAL cch AS DWORD) AS DWORD
DECLARE FUNCTION SendDlgItemMessage LIB "USER32.DLL" ALIAS "SendDlgItemMessageA" (BYVAL hDlg AS DWORD, BYVAL nIDDlgItem AS LONG, BYVAL wMsg AS DWORD, BYVAL wParam AS DWORD, BYVAL lParam AS LONG) AS LONG

%WM_DROPFILES       = &H233
%WM_NCHITTEST       = 132
%WM_NCLBUTTONDOWN   = 161
%WM_KEYDOWN         = 256
%WM_MOUSEMOVE       = 512
%WM_LBUTTONDOWN     = 513
%WM_LBUTTONDBLCLK   = 515
%WM_RBUTTONDOWN     = 516
%WM_MOUSEWHEEL      = &H20A

%VK_CONTROL         = &H11
%VK_HOME            = 36
%VK_END             = 35
%VK_PRIOR           = 33
%VK_NEXT            = 34
%VK_LEFT            = 37
%VK_UP              = 38
%VK_RIGHT           = 39
%VK_DOWN            = 40
%VK_NUMPAD4         = 100
%VK_NUMPAD8         = 104
%VK_NUMPAD6         = 102
%VK_NUMPAD2         = 98

$RegistryKey        = "SOFTWARE\zPostcard"
$RegistryBorderName = "DefaultBorderName"
$RegistrySignature  = "DefaultSignature"
$PCSextension       = "*.PCS (PhotoComposer Script)|*.pcs"
%HKEY_LOCAL_MACHINE = &H80000002???
%HKEY_CURRENT_USER  = &H80000001???

%WS_VSCROLL         = &H00200000
%WS_TABSTOP         = &H00010000
%ES_MULTILINE       = &H4&
%ES_AUTOVSCROLL     = &H40&
%ES_AUTOHSCROLL     = &H80&
%ES_READONLY        = &H800&
%EM_LIMITTEXT       = &HC5
%EM_STREAMIN        = %WM_USER + 73
%EM_STREAMOUT       = %WM_USER + 74
%SF_RTF             = &H0002

TYPE EDITSTREAM DWORD
    dwCookie AS DWORD    ' user value passed to callback as first parameter
    dwError AS DWORD     ' last error
    pfnCallback AS DWORD
END TYPE

'------------------------------------------------------------------------------------------
' LOCAL section
'------------------------------------------------------------------------------------------

%XMIN_SIZE = 1024
%YMIN_SIZE = 800

%ID_BTN_Left         = 1
%ID_BTN_Right        = 2
%ID_BTN_Play         = 3
%ID_BTN_Pause        = 4
%ID_BTN_Stop         = 5
%ID_TRACK_PlayList   = 6
%ID_TRACK_Delay      = 7
%ID_TRACK_Zoom       = 8
%ID_TRACK_Alpha      = 9
%ID_BTN_User         = 10
%ID_BTN_French       = 11
%ID_BTN_English      = 12
%ID_BTN_Script_Load  = 13
%ID_BTN_Script_Save  = 14
%ID_CHECK_Quality    = 15
%ID_CHECK_Title      = 16
%ID_CHECK_FootNote   = 17
%ID_CHECK_Stamp      = 18
%ID_BTN_Crop         = 19
%ID_BTN_TrueSize     = 20
%ID_BTN_About        = 21
%ID_BTN_Tray         = 22
%ID_BTN_Select       = 23
%ID_BTN_Send         = 24
%ID_BTN_Save         = 25
%ID_BTN_Print        = 26
%ID_BTN_Frame        = 27
%ID_BTN_Image        = 28
%ID_BTN_Anotate      = 29
%ID_BTN_Icon         = 30
%ID_BTN_Opacity      = 31
%ID_BTN_Border_Left  = 32
%ID_BTN_Border_Right = 33
%ID_LIB_Size         = 34
%ID_LIB_ZoomSize     = 35
%ID_LIB_Count        = 36
%ID_RICHEDIT         = 37
%ID_BorderList       = 38
%ID_PlayList         = 39
%ID_CHECK_Tootltip   = 40

'// Popup Text menu
%IDM_TXT_Edit           = 101
%IDM_TXT_Horz           = 103
%IDM_TXT_Vert_Up        = 104
%IDM_TXT_Vert_Down      = 105
%IDM_TXT_Copy           = 107
%IDM_TXT_Delete         = 108

'// Popup Bitmap menu
%IDM_BMP_Edit           = 201
%IDM_BMP_Flip_Horz      = 203
%IDM_BMP_Flip_Vert      = 204
%IDM_BMP_90_Left        = 205
%IDM_BMP_90_Right       = 206
%IDM_BMP_Top            = 208
%IDM_BMP_Up             = 209
%IDM_BMP_Down           = 210
%IDM_BMP_Bottom         = 211
%IDM_BMP_Sprite_128x128 = 213
%IDM_BMP_Sprite_256x256 = 214
%IDM_BMP_Clone          = 216
%IDM_BMP_Lock           = 217
%IDM_BMP_Delete         = 218


%ID_CTRL             = -1 '// Main GDImage control (use a negative value to prevent conflict with sprite ID)
%ID_THUMB            = -2 '// GDImage thumb control (use a negative value to prevent conflict with sprite ID)

%ID_PHOTO            = 1
%ID_FRAME            = 2
%ID_STAMP            = 3
%ID_FOOTNOTE         = 4
%ID_TITLE            = 5

%FORWARD             = %TRUE
%BACKWARD            = %FALSE

%AERO_TIMER          = 1
%SLIDE_TIMER         = 2
%BLINK_TIMER         = 3
%BLINK_USER          = 4

TYPE SpriteStruct
    ID              AS LONG                      '// The unique sprite object IDentifier
    objtype         AS LONG                      '// The object type
    filname         AS ASCIIZ * %MAX_PATH        '// File of the sprite bitmap
    objlabel        AS ASCIIZ * 64               '// Friendly name
    xPos            AS LONG                      '// X location
    yPos            AS LONG                      '// Y location
    xWidth          AS LONG                      '// Width of the sprite object
    yHeight         AS LONG                      '// Height of the sprite object
    ARGB            AS LONG                      '// ARGB color
    visible         AS LONG                      '// ZS_HIDDEN or ZS_VISIBLE state
    scrollmode      AS LONG                      '// True/False scrolling mode
    opacity         AS LONG                      '// True/False PNG opacity
    userotate       AS LONG                      '// Rotate90FlipNone or Rotate270FlipNone
    flipmode        AS LONG                      '// ZD_Reverse (FlipX) or ZD_Flip (FlipY) constant
    angle           AS LONG                      '// Rotation angle 0-360
    locked          AS LONG                      '// True/False condition
    zorder          AS LONG                      '// The z-order value
    scale           AS SINGLE                    '// The scale value
    style           AS LONG                      '// The object style
    quality         AS LONG                      '// The object quality
    clone           AS LONG                      '// The unique ID of the cloned object
    '//
    resizeW         AS LONG                      '// Resize width to use
    resizeH         AS LONG                      '// Resize height to use
    trueW           AS LONG                      '// True width of the native bitmap
    trueH           AS LONG                      '// True height of the native bitmap
    selected        AS BYTE                      '// Selected status
    strFormat       AS LONG                      '// String format (PhotoCompoPro)
    varop           AS BYTE                      '// Variable opacity (PhotoCompoPro)
    reserved        AS ASCIIZ * 106              '// For future extension
END TYPE

TYPE PROPERTIES
    hCtrl           AS DWORD
    hGFI            AS DWORD
    hMenuBitmap     AS DWORD
    hMenuText       AS DWORD
    nBackColor      AS LONG
    nWasAlpha       AS LONG
    nTrueWidth      AS LONG
    nTrueHeight     AS LONG
    nFocusID        AS LONG
    nMenuLockBitmap AS LONG
    nUseFrench      AS LONG
    bSlideShow      AS LONG
    bPlaying        AS LONG
    nBlinkCount     AS LONG
    rWasZoom        AS SINGLE
    sFrenchStamp    AS ASCIIZ * %MAX_PATH
    sEnglishStamp   AS ASCIIZ * %MAX_PATH
    sBorderPath     AS ASCIIZ * %MAX_PATH
    sIconPath       AS ASCIIZ * %MAX_PATH
    sScriptPath     AS ASCIIZ * %MAX_PATH
    sWebPage        AS ASCIIZ * %MAX_PATH
    sWasScriptPath  AS ASCIIZ * %MAX_PATH
    sNoPicture      AS ASCIIZ * %MAX_PATH
    sIntroPicture   AS ASCIIZ * %MAX_PATH
    sResources      AS ASCIIZ * %MAX_PATH
    sWasLabelName	AS ASCIIZ * 32
    sBackground     AS ASCIIZ * 32
    sBorder         AS ASCIIZ * 32
    sFontBoxCaption AS ASCIIZ * 32
END TYPE

GLOBAL gP AS PROPERTIES
GLOBAL gSprite() AS SpriteStruct

'// Show the GDImage GFI window
SUB GDImageShowDW()
    LOCAL nRet AS LONG, rw AS RECT
    IF gP.hGFI = 0 THEN gP.hGFI = ZI_CreateDW(zMainWindow(0))
    IF gP.hGFI THEN
       '// Use same region than parent
       nRet = SetWindowRgn(gP.hGFI, zGetWindowRgn(0, 0, zMainWindow(0)), 0)
       GetWindowRect(zMainWindow(0), rw)
       MoveWindow(gP.hGFI, rw.nLeft, rw.nTop, rw.nRight - rw.nLeft, rw.nBottom - rw.nTop, 1)
       IF Vista() THEN
          ShowWindow(gP.hGFI, %SW_SHOW)
       END IF
    END IF
END SUB

'// Hide the GDImage WWD window
SUB GDImageHideDW()
    LOCAL rc AS RECT, x, y, w, h AS LONG
    IF gP.hGFI THEN
       GetClientRect(gP.hGFI, rc)
       '// Drop it out of screen
       IF Vista() THEN
          ShowWindow(gP.hGFI, %SW_HIDE)
          x = 0: y = 0: w = 0: h = 0
       ELSE
          x = -9000: y = -9000: w = rc.nRight: h = rc.nBottom
       END IF
       MoveWindow(gP.hGFI, x, y, w, h, 0)
    END IF
END SUB

'// Main entry point
FUNCTION WINMAIN (BYVAL hInstance     AS LONG, _
                  BYVAL hPrevInstance AS LONG, _
                  BYVAL lpCmdLine     AS ASCIIZ PTR, _
                  BYVAL iCmdShow      AS LONG) AS LONG

    LOCAL Msg         AS tagMsg
    LOCAL wcx         AS WndClassEx
    LOCAL zClass      AS ASCIIZ * 80
    LOCAL dwExStyle   AS DWORD
    LOCAL dwStyle     AS DWORD
    LOCAL rc          AS RECT
    LOCAL x           AS LONG
    LOCAL y           AS LONG
    LOCAL hMutex      AS DWORD
    LOCAL hFound      AS DWORD
    LOCAL hMain       AS LONG
'
    LOCAL hWinXP_Lib           AS LONG ' Handle to WinXP Theme DLL
    LOCAL hWinXP_IsThemeActive AS LONG ' Handle to WinXP's IsThemeActive function
    LOCAL IsInitialized        AS LONG
    LOCAL hRichEdit            AS LONG
    LOCAL sCLN                 AS STRING

    zClass = "ZPHOTOCOMPOSER"
'
    hMutex = CreateMutex(BYVAL %Null, 0, zClass)
    IF hMutex THEN
       IF GetLastError = %ERROR_ALREADY_EXISTS THEN
          DO
             hFound = FindWindow(zClass, ""): IF hFound THEN EXIT DO
             WHILE PeekMessage(Msg, %NULL, %NULL, %NULL, %PM_REMOVE): WEND
          LOOP
          IF IsIconic(hFound) THEN ShowWindow(hFound, %SW_RESTORE)
          SetForeGroundWindow(hFound)
          FUNCTION = 0
          EXIT FUNCTION
       END IF
    END IF
'
    wcx.cbSize = SIZEOF(wcx)
    IsInitialized = GetClassInfoEx(zsInstance(), zClass, wcx)
    IF IsInitialized    = 0 THEN
       wcx.style         = %CS_HREDRAW OR %CS_VREDRAW OR %CS_DBLCLKS ' OR %CS_DROPSHADOW
       wcx.lpfnWndProc   = CODEPTR(WndProc)
       wcx.cbClsExtra    = 0
       wcx.cbWndExtra    = %EXTEND_EXTRA * 4
       wcx.hInstance     = zsInstance()
       wcx.hIcon         = %NULL ' LoadIcon(wcx.hInstance, "PROGRAM")
       wcx.hCursor       = %NULL
       wcx.hbrBackground = %NULL ' Don't paint the class window background
       wcx.lpszMenuName  = %NULL
       wcx.lpszClassName = VARPTR(zClass)
       wcx.hIconSm       = wcx.hIcon
       IF RegisterClassEx(wcx) THEN IsInitialized = %TRUE
    END IF
'
    IF IsInitialized THEN
'
     ' Load the WinXP Theme support (if applicable)
       'IF zOsVersion() < 600 THEN
          hWinXP_Lib = LoadLibrary("UxTheme.dll")
          IF hWinXP_Lib THEN hWinXP_IsThemeActive = GetProcAddress(hWinXP_Lib, "IsThemeActive")
       'END IF
'
       InitCommonControls()

      ' Window Extended Style
       dwExStyle = 0
'     ' Windows Style, if you can avoid using %WS_CLIPSIBLINGS OR %WS_CLIPCHILDREN
       dwStyle = %WS_POPUP
'
       SetRect(rc, 0, 0, %XMIN_SIZE, %YMIN_SIZE)
       '// Note: indeed we don't need AdjustWindowRectEx, because we use do not use a non-client area
       '// but it won't hurt anything to keep it, in case we change our mind ;)
       AdjustWindowRectEx(rc, dwStyle, %FALSE, dwExStyle)  ' Adjust Window To True Requested Size
'
       x = MAX&((GetSystemMetrics(%SM_CXSCREEN) - rc.nRight - rc.nLeft) \ 2, 0)
       y = MAX&((GetSystemMetrics(%SM_CYSCREEN) - rc.nBottom - rc.nTop) \ 2, 0)
'
     ' Create The Window
       MyTitle$ = "PhotoComposer"
       hMain = CreateWindowEx(dwExStyle, _           ' Extended Style For The Window
                             zClass, _               ' Class Name
                             (MyTitle$), _           ' Window Title
                             dwStyle, _              ' Defined Window Style
                             x, y, _                 ' Window Position
                             rc.nRight - rc.nLeft, _ ' Calculate Window Width
                             rc.nBottom - rc.nTop, _ ' Calculate Window Height
                             %NULL, _                ' No Parent Window
                             %NULL, _                ' No Menu
                             wcx.hInstance, _         ' Instance
                             BYVAL %NULL)            ' Dont Pass Anything To WM_CREATE
'
       IF hMain THEN

          ZI_LoadDLL("") '// Init GDImage

          '// Apply WinXP Theme support
          LOCAL lRes AS LONG, pProc AS DWORD
          IF hWinXP_IsThemeActive THEN
             CALL DWORD hWinXP_IsThemeActive USING IsThemeActive TO lRes
             IF lRes  THEN pProc = GetProcAddress(lRes, "EnableThemeDialogTexture")
             IF pProc THEN CALL DWORD pProc USING EnableDialogTheme(hMain, &H01 OR &H02 OR &H04 OR &H06)
          END IF

          '// Load richedit component
          hRichEdit = LoadLibrary("RICHED20.DLL")

          '// Load SKIN components and create SYS buttons
          zInitSkin(hMain, "PhotoCompo.zsk")

          '// Add the child controls being used by the application
          AddChildControls(hMain)
          '// Add tooltip support for GDImage objects
          gP.sWasLabelName = gP.sBackground: ZI_CreateToolTip(gP.hCtrl, gP.sWasLabelName)

          '// To perform audio file drag and drop
          DragAcceptFiles(hMain, %TRUE)

          '// *************************************************
          '// Show main window
          '// Create region and paint controls to double buffer
          UseThisZoom() ' Set the default backgroud size
          zShowMainWindow(0) ' 0 = Do not use animation
          '// *************************************************

          '// To let the user know that he should click this button to select new pictures
          SetTimer(hMain, %BLINK_TIMER, 333, %NULL)

          IF SK_AEROEMULATE() THEN SetTimer(hMain, %AERO_TIMER, SK_AEROTIMERDELAY(), %NULL)
          WHILE GetMessage(Msg, %NULL, 0, 0)  ' SK_MILLISECOND
             IF IsDialogMessage(hMain, Msg) = %FALSE THEN
                TranslateMessage(Msg)
                DispatchMessage(Msg)
             END IF
          WEND
          IF SK_AEROEMULATE() THEN KillTimer(hMain, %AERO_TIMER)

          FUNCTION = msg.wParam
       END IF

       '// Delete popup menus
       IF gP.hMenuText THEN DestroyMenu(gP.hMenuText)
       IF gP.hMenuBitmap THEN DestroyMenu(gP.hMenuBitmap)

       '// UNLOAD the WinXP Theme DLL (if necessary)
       IF hWinXP_Lib THEN FreeLibrary(hWinXP_Lib)

       '// UNLOAD richedit
       IF hRichEdit THEN FreeLibrary(hRichEdit)

    END IF
'
    IF hMutex THEN CloseHandle(hMutex)
'
END FUNCTION

FUNCTION RichLoad_Callback(BYVAL dwCookie AS DWORD, BYVAL pbbuff AS BYTE PTR, BYVAL cb AS LONG, BYREF pcb AS LONG) AS LONG
    LOCAL psBuffer AS STRING PTR
    psBuffer = dwCookie
    pcb = MIN&(LEN(@psBuffer), cb)
    IF pcb > 0 THEN
        POKE$ pbBuff, LEFT$(@psBuffer, pcb)
        @psBuffer = MID$(@psBuffer, pcb + 1)
    END IF
END FUNCTION

FUNCTION RichLoadFromFile(BYVAL hWndRTF AS LONG, zFileName AS ASCIIZ) AS LONG
    LOCAL ES AS EDITSTREAM
    LOCAL hFile AS LONG
    LOCAL sBuffer AS STRING
    IF zsExist(zFileName) THEN
       zsFOpen(zFileName, 0, 2, hFile)
       sBuffer = STRING$(zsFlof(hFile), 0)
       zsFGet(hFile, sBuffer)
       zsFClose(hFile)
       es.dwCookie = VARPTR(sBuffer)
       es.pfnCallback = CODEPTR(RichLoad_Callback)
       FUNCTION = SendMessage(hWndRTF, %EM_STREAMIN, %SF_RTF, VARPTR(es))
    END IF
END FUNCTION

SUB ListDeleteAll(BYVAL hList AS LONG)
    IF hList THEN SendMessage(hList, %LB_RESETCONTENT, 0, 0)
END SUB

SUB ListDelete(BYVAL hList AS LONG, BYVAL nIndex AS LONG)
    IF nIndex > 0 THEN DECR nIndex '// Because ListBox is zero based
    IF hList THEN SendMessage(hList, %LB_DELETESTRING, nIndex, 0)
END SUB

SUB ListSelectPlus(BYVAL hList AS LONG, BYVAL nSelected AS LONG)
    IF nSelected > 0 THEN DECR nSelected '// Because ListBox is zero based
    IF hList THEN SendMessage(hList, %LB_SETCURSEL, nSelected, 0)
END SUB

FUNCTION ListFindString(BYVAL hList AS LONG, zTmp AS ASCIIZ) AS LONG
    LOCAL nIndex AS LONG
    nIndex = SendMessage(hList, %LB_FINDSTRING, -1, VARPTR(zTmp))
    IF nIndex > -1 THEN INCR nIndex: FUNCTION = nIndex
END FUNCTION

FUNCTION ListCount(BYVAL hList AS LONG) AS LONG
    IF hList THEN FUNCTION = SendMessage(hList, %LB_GETCOUNT, 0, 0)
END FUNCTION

FUNCTION ListGetCursel(BYVAL hList AS LONG) AS LONG
    LOCAL nSelected AS LONG
    IF hList THEN
       nSelected = SendMessage(hList, %LB_GETCURSEL, 0, 0)
       IF nSelected > -1 THEN INCR nSelected '// Because ListBox is zero based
    END IF
    FUNCTION = nSelected
END FUNCTION

FUNCTION ListAdd(BYVAL hList AS LONG, zTmp AS ASCIIZ) AS LONG
    IF hList THEN
       IF LEN(zTmp) THEN FUNCTION = SendMessage(hList, %LB_ADDSTRING, 0, VARPTR(zTmp))
    END IF
END FUNCTION

FUNCTION ListGetText(BYVAL hList AS LONG, BYVAL ITEM AS LONG) AS STRING
    LOCAL sItem AS STRING, nLEN AS LONG
    IF ITEM > 0 THEN
       DECR ITEM
       nLEN = SendMessage(hList, %LB_GETTEXTLEN, ITEM, 0)
       sItem = SPACE$(nLEN)
       SendMessage(hList, %LB_GETTEXT, ITEM, BYVAL STRPTR(sItem))
       FUNCTION = sItem
    END IF
END FUNCTION

FUNCTION NumToString(BYVAL N AS DOUBLE) AS STRING
    FUNCTION = LTRIM$(STR$(N))
END FUNCTION

SUB UpdateBorderList(sUseBorderName AS STRING)
    LOCAL hList, WashFind, hFind, BorderCount, nSelected AS LONG
    LOCAL fd AS WIN32_FIND_DATA
    LOCAL zTmp AS ASCIIZ * %MAX_PATH

    hList = zGetMainItem(%ID_BorderList)
    ListDeleteAll(hList)

    sUseBorderName = zCharLower((sUseBorderName))

    WashFind = MyFindFirstFile((gP.sBorderPath + "*.png"), fd)
    hFind = WashFind
    DO WHILE hFind > 0
       IF ASC(fd.cFileName) <> 46 THEN
          IF INSTR(CHR$(0,1,32,33,128), CHR$(fd.dwFileAttributes)) THEN
             zTmp = gP.sBorderPath + fd.cFileName: CharLower(zTmp)
             IF ListAdd(hList, zTmp) > -1 THEN
                INCR BorderCount
                'IF zTmp = sUseBorderName THEN nSelected = BorderCount
             END IF
          END IF
       END IF
       hFind = FindNextFile(WashFind, fd)
    LOOP
    FindClose(WashFind)

    nSelected = ListFindString(hList, (sUseBorderName))
    ListSelectPlus(hList, nSelected)

    IF BorderCount > 1 THEN
       EnableWindow(zGetMainItem(%ID_BTN_Border_Left), %TRUE)
       EnableWindow(zGetMainItem(%ID_BTN_Border_Right), %TRUE)
    ELSE
       EnableWindow(zGetMainItem(%ID_BTN_Border_Left), %FALSE)
       EnableWindow(zGetMainItem(%ID_BTN_Border_Right), %FALSE)
    END IF

END SUB

SUB UpdateCount()
    LOCAL hList AS LONG
    hList = zGetMainItem(%ID_PlayList)
    zSetCTLText(zGetMainItem(%ID_LIB_Count), (NumToString(MAX&(ListGetCursel(hList), 1)) + " / " + NumToString(MAX&(ListCount(hList), 1))))
END SUB

SUB GDImageSetZoomRange(BYVAL bmW AS LONG, BYVAL bmH AS LONG, xSize AS LONG, ySize AS LONG)
    LOCAL hCtrl, xPos, yPos AS LONG, rc AS RECT
    GetClientRect(gP.hCtrl, rc)
    ZI_Iconise(bmW, bmH, rc.nRight+16, rc.nBottom+16, xPos, yPos, xSize, ySize)
    hCtrl = zGetMainItem(%ID_TRACK_Zoom)
    zSetProperty(hCtrl, %TRACK_MINVAL, (xSize / bmW) * 128)
    zSetProperty(hCtrl, %TRACK_MAXVAL, 1500)
END SUB

'// Assign the ZOBJECT structure/type parameters to the Sprite array
SUB SpriteArrayGet(BYVAL ID AS LONG)

    DIM zItem AS ZOBJECT
    ZD_GetObjectProperties(ID, zItem)                 '// Retrieves all the details about a GDImage sprite object in one single step.
    gSprite(ID).ID = ID                               '// The unique sprite object IDentifier
    gSprite(ID).objtype = zItem.objType               '// The object type (bitmap, text, arrow, curve, rectangle, ellipse, polypolyline)
    gSprite(ID).objlabel = zItem.objLabel             '// Friendly name
    gSprite(ID).xPos = zItem.x1                       '// X location
    gSprite(ID).yPos = zItem.y1                       '// Y location
    gSprite(ID).xWidth = zItem.x2                     '// Width of the sprite object
    gSprite(ID).yHeight = zItem.y2                    '// Height of the sprite object
    gSprite(ID).ARGB = zItem.useARGB                  '// ARGB color
    gSprite(ID).visible = zItem.visible               '// ZS_HIDDEN or ZS_VISIBLE state
    IF (zItem.Style AND %ZS_SCROLL) = %ZS_SCROLL THEN '// Scrolling mode
       gSprite(ID).scrollmode = -1
    ELSE
       gSprite(ID).scrollmode = 0
    END IF
    gSprite(ID).opacity = zItem.opacity               '// True/False PNG opacity
    gSprite(ID).userotate = zItem.userotate           '// Rotate90FlipNone or Rotate270FlipNone
    gSprite(ID).flipmode = zItem.flipmode             '// True/False condition
    gSprite(ID).angle = zItem.angle                   '// Rotation angle 0-360
    gSprite(ID).locked = zItem.locked                 '// True/False condition
    gSprite(ID).zorder = zItem.order                  '// The z-order value
    gSprite(ID).scale = zItem.scale                   '// The scale value
    gSprite(ID).style = zItem.Style                   '// The object style
    gSprite(ID).quality = zItem.quality               '// The object quality
    gSprite(ID).clone = zItem.clone                   '// The unique ID of the cloned object
    gSprite(ID).selected = 0                          '// Set selected status to Off
    gSprite(ID).strFormat = zItem.strFormat           '// String format (PhotoCompoPro)

END SUB

SUB UseThisPhoto(BYVAL sUsePhoto AS STRING)
    LOCAL nHbitmap, bmW, bmH, xPos, yPos, xSize, ySize, hCtrl AS LONG
    LOCAL rZoomValue AS SINGLE
    LOCAL sTitle AS STRING
    LOCAL rc AS RECT

'// Make sure to disable the crop rectangle if any
    IF ZI_GetToolCropStatus(gP.hCtrl) THEN ZI_DisableCropRectangle(gP.hCtrl)

    nHbitmap = ZI_CreateBitmapFromFile((sUsePhoto), bmW, bmH)
    IF nHbitmap THEN
       gP.nTrueWidth = bmW: gP.nTrueHeight = bmH

       '// Compute the zoom range based on image size
       GDImageSetZoomRange(bmW, bmH, xSize, ySize)
       '// Update the zoom trackbar
       rZoomValue = xSize / bmW
       ZD_SetObjectScale(%ID_PHOTO, rZoomValue)
       GetClientRect(gP.hCtrl, rc)
       xPos = (rc.nRight - bmW) \ 2
       yPos = (rc.nBottom - bmH) \ 2
       '//ZD_SetObjectXY(%ID_PHOTO, xPos, yPos, %FALSE)
       ZD_SetObjectAngle(%ID_PHOTO, 0, %FALSE)

       '// Change to version 1.1
       '//ZD_DrawBitmapToCtrl(gP.hCtrl, xPos, yPos, nHbitmap, ZD_ColorARGB(255, 0), %ID_PHOTO, %ZS_VISIBLE)
       ZD_DrawBitmapToCtrl(gP.hCtrl, xPos, yPos, nHbitmap, ZD_ColorARGB(255, 0), %ID_PHOTO, %ZS_HIDDEN) '// ZS_VISIBLE) Version 1.1
       ZD_SetObjectHidden(%ID_PHOTO, %TRUE) '// Version 1.1
       ZD_SetObjectScale(%ID_PHOTO, rZoomValue)
       ZD_CopyToBackground(gP.hCtrl, %ID_PHOTO, %TRUE, RGB(0,0,0)) '// Version 1.1

       ZD_SetObjectScale(%ID_PHOTO, rZoomValue)
       zSplitN(sUsePhoto, "", sTitle): REPLACE "_" WITH " " IN sTitle
       sTitle = RTRIM$(LEFT$(sTitle, INSTR(-1, sTitle, $Dot)), $Dot)
       IF sUsePhoto = gP.sIntroPicture THEN
          IF IsFrench() THEN sTitle = "Bienvenue"
       END IF
       ZD_SetObjectImageLabel(%ID_PHOTO, (sTitle))
       ZD_SetObjectText(%ID_TITLE, ZD_GetObjectImageLabel(%ID_PHOTO))
       ZD_SetStringFormat(%ID_TITLE, %ZD_TextHorzUp, %FALSE) '// Switch to horizontal text mode

       '// For better resize quality
       IF zGetCheckButtonStatus(zGetMainItem(%ID_CHECK_Quality)) THEN
          ZD_SetObjectQuality(%ID_PHOTO, %InterpolationModeHighQuality, %FALSE)
       END IF

       '//  We need to use PNG opcity for the image background %ID_PHOTO, or we won't be able to resize it
       ZD_UsePngOpacity(%ID_PHOTO, %TRUE)

       ZD_GetObjectBound(%ID_PHOTO, bmW, bmH)

       ZI_SetObjectFocusID(%ID_PHOTO)
       gP.nFocusID = %ID_PHOTO
       gP.rWasZoom = 0
       gP.nWasAlpha = 255

       gSprite(%ID_PHOTO).filname = sUsePhoto  '// Full path name to the sprite bitmap
       SpriteArrayGet(%ID_PHOTO)          '// Assign the ZOBJECT structure/type parameters to the Sprite array

       hCtrl = zGetMainItem(%ID_LIB_ZoomSize)
       IF IsWindowVisible(hCtrl) = %FALSE THEN ShowWindow(hCtrl, %SW_SHOW)
       hCtrl = zGetMainItem(%ID_LIB_Size)
       zSetCTLText(hCtrl, (NumToString(gP.nTrueWidth) + " x " + NumToString(gP.nTrueHeight)))
       IF IsWindowVisible(hCtrl) = %FALSE THEN ShowWindow(hCtrl, %SW_SHOW)

       zSetTrackValue(zGetMainItem(%ID_TRACK_Zoom), rZoomValue * 1000)
       zSetTrackValue(zGetMainItem(%ID_TRACK_Alpha), gP.nWasAlpha)
       zSetCTLText(zGetMainItem(%ID_LIB_ZoomSize), NumToString(CLNG(bmW * rZoomValue)) + " x " + NumToString(CLNG(bmH * rZoomValue)))
       UpdateCount()

    END IF
END SUB

SUB UpdateRegistryBorderName(sBorderPathName AS STRING)
    IF LEN(sBorderPathName) THEN zSetReg(%HKEY_LOCAL_MACHINE, $RegistryKey, $RegistryBorderName, (sBorderPathName))
END SUB

SUB UseThisBorder(sUseBorderName AS STRING)
    LOCAL nHbitmap, bmW, bmH AS LONG
'// Make sure to disable the crop rectangle if any
    IF ZI_GetToolCropStatus(gP.hCtrl) THEN ZI_DisableCropRectangle(gP.hCtrl)
    nHbitmap = ZI_CreateBitmapFromFile((sUseBorderName), bmW, bmH)
    IF nHbitmap THEN
       ZD_DrawBitmapToCtrl(gP.hCtrl, 0, 0, nHbitmap, ZD_ColorARGB(255, 0), %ID_FRAME, %ZS_VISIBLE)
       '// Remember the last border being used.
       UpdateRegistryBorderName(sUseBorderName)
       gSprite(%ID_FRAME).filname = sUseBorderName '// Full path name to border bitmap file
       SpriteArrayGet(%ID_FRAME)                   '// Assign the ZOBJECT structure/type parameters to the Sprite array
    END IF
END SUB

'// Add child controls to main window
SUB AddChildControls(BYVAL hMain AS LONG)

    LOCAL hCtrl, CaptionHeight AS LONG
    LOCAL dwExStyle   AS DWORD
    LOCAL dwStyle     AS DWORD
    LOCAL CtrlW, CtrlH AS LONG

'   // ***************************
'   // Init our globals
    gP.nBackColor          = 0
    gP.nWasAlpha           = 255
    gP.nFocusID            = %ID_PHOTO

    REDIM gSprite (1 TO 5) AS SpriteStruct
    gP.sResources    = zsExePath() + "Resources\"
    gP.sNoPicture    = gP.sResources + "No_Picture.png"
    gP.sIntroPicture = gP.sResources + "Welcome.jpg"
    gP.sFrenchStamp  = gP.sResources + "Stamp_fr.png"
    gP.sEnglishStamp = gP.sResources + "Stamp_us.png"
    gP.sBorderPath   = zsExePath() + "Borders\"
    gP.sIconPath     = zsExePath() + "Icons\"
    gP.sScriptPath   = zsExePath() + "Script\"
    zMakeDir((gP.sScriptPath))

    gP.bSlideShow = %FORWARD
    gP.bPlaying = %FALSE
'   // ***************************

    hCtrl = zButImage(hMain, (SK_FOLDER() + "BTN_Left.png"), 438, 754, %ID_BTN_Left, 0)
    zSetAnchorMode(hCtrl, %ANCHOR_CENTER_HORZ_BOTTOM)
    EnableWindow(hCtrl, %FALSE)
    zCreateToolTip(hCtrl, "")

    hCtrl = zButImage(hMain, (SK_FOLDER() + "BTN_Right.png"), 532, 754, %ID_BTN_Right, 0)
    zSetAnchorMode(hCtrl, %ANCHOR_CENTER_HORZ_BOTTOM)
    EnableWindow(hCtrl, %FALSE)
    zCreateToolTip(hCtrl, "")

    hCtrl = zButImage(hMain, (SK_FOLDER() + "BTN_Play.png"), 489, 742, %ID_BTN_Play, 0)
    zSetAnchorMode(hCtrl, %ANCHOR_CENTER_HORZ_BOTTOM)
    ShowWindow(hCtrl, %SW_HIDE)
    zCreateToolTip(hCtrl, "")

    hCtrl = zButImage(hMain, (SK_FOLDER() + "BTN_Pause.png"), 489, 742, %ID_BTN_Pause, 0)
    zSetAnchorMode(hCtrl, %ANCHOR_CENTER_HORZ_BOTTOM)
    EnableWindow(hCtrl, %FALSE)
    zCreateToolTip(hCtrl, "")

    hCtrl = zButImage(hMain, (SK_FOLDER() + "BTN_Stop.gif"), 409, 754, %ID_BTN_Stop, 0)
    zSetAnchorMode(hCtrl, %ANCHOR_CENTER_HORZ_BOTTOM)
    zCreateToolTip(hCtrl, "")

    hCtrl = zTrackbar(hMain, (SK_FOLDER() + "BTN_Thumb.png"), 5, 732, 952, 10, %ID_TRACK_PlayList, 1, 100, 1, SK_TRACKHICOLOR())
    zSetAnchorMode(hCtrl, %ANCHOR_BOTTOM_WIDTH)
    zCreateToolTip(hCtrl, "")

    hCtrl = zTrackbar(hMain, (SK_FOLDER() + "BTN_Thumb.png"), 149, 758, 100, 13, %ID_TRACK_Delay, 0, 8, 4, SK_TRACKHICOLOR())
    zSetAnchorMode(hCtrl, %ANCHOR_CENTER_HORZ_BOTTOM)
    zCreateToolTip(hCtrl, "")

    hCtrl = zTrackbar(hMain, (SK_FOLDER() + "BTN_Thumb.png"), 654, 752, 131, 13, %ID_TRACK_Zoom, 194, 1024, 194, SK_TRACKHICOLOR())
    zSetAnchorMode(hCtrl, %ANCHOR_CENTER_HORZ_BOTTOM)
    zCreateToolTip(hCtrl, "")

    hCtrl = zTrackbar(hMain, (SK_FOLDER() + "BTN_Thumb.png"), 654, 767, 131, 13, %ID_TRACK_Alpha, 10, 255, 255, SK_TRACKHICOLOR())
    zSetAnchorMode(hCtrl, %ANCHOR_CENTER_HORZ_BOTTOM)
    zCreateToolTip(hCtrl, "")

    hCtrl = zButImage(hMain, (SK_FOLDER() + "BTN_User.gif"), 3, 782, %ID_BTN_User, 0)
    zSetAnchorMode(hCtrl, %ANCHOR_BOTTOM)
    zCreateToolTip(hCtrl, "")

    hCtrl = zButImage(hMain, (SK_FOLDER() + "FLAG_English.gif"), 24, 787, %ID_BTN_English, 1)
    zSetAnchorMode(hCtrl, %ANCHOR_BOTTOM)
    ShowWindow(hCtrl, %SW_HIDE)
    zCreateToolTip(hCtrl, "")

    hCtrl = zButImage(hMain, (SK_FOLDER() + "FLAG_French.gif"), 24, 787, %ID_BTN_French, 1)
    zSetAnchorMode(hCtrl, %ANCHOR_BOTTOM)
    zCreateToolTip(hCtrl, "")

    hCtrl = zButImage(hMain, (SK_FOLDER() + "BTN_Script_load.gif"), 93, 754, %ID_BTN_Script_Load, 0)
    zSetAnchorMode(hCtrl, %ANCHOR_CENTER_HORZ_BOTTOM)
    zCreateToolTip(hCtrl, "")

    hCtrl = zButImage(hMain, (SK_FOLDER() + "BTN_Script_Save.gif"), 119, 754, %ID_BTN_Script_Save, 0)
    zSetAnchorMode(hCtrl, %ANCHOR_CENTER_HORZ_BOTTOM)
    zCreateToolTip(hCtrl, "")

    hCtrl = zCheckButton(hMain, (SK_FOLDER() + "BTN_Check.png"), "", 654, 784, 164, 15, %ID_CHECK_Quality, SK_TEXTCOLOR(), 0)
    zSetAnchorMode(hCtrl, %ANCHOR_CENTER_HORZ_BOTTOM)
    zCreateToolTip(hCtrl, "")

    hCtrl = zCheckButton(hMain, (SK_FOLDER() + "BTN_Check.png"), "", 792, 758, 46, 15, %ID_CHECK_Title, SK_TEXTCOLOR(), 0)
    zSetCheckButtonStatus(hCtrl, %TRUE)
    zSetAnchorMode(hCtrl, %ANCHOR_CENTER_HORZ_BOTTOM)
    zCreateToolTip(hCtrl, "")

    hCtrl = zCheckButton(hMain, (SK_FOLDER() + "BTN_Check.png"), "", 844, 758, 70, 15, %ID_CHECK_FootNote, SK_TEXTCOLOR(), 0)
    zSetCheckButtonStatus(hCtrl, %TRUE)
    zSetAnchorMode(hCtrl, %ANCHOR_CENTER_HORZ_BOTTOM)
    zCreateToolTip(hCtrl, "")

    hCtrl = zCheckButton(hMain, (SK_FOLDER() + "BTN_Check.png"), "", 938, 758, 70, 15, %ID_CHECK_Stamp, SK_TEXTCOLOR(), 0)
    zSetAnchorMode(hCtrl, %ANCHOR_CENTER_HORZ_BOTTOM)
    zCreateToolTip(hCtrl, "")

    hCtrl = zButImage(hMain, (SK_FOLDER() + "BTN_Crop.gif"), 590, 754, %ID_BTN_Crop, 0)
    zSetAnchorMode(hCtrl, %ANCHOR_CENTER_HORZ_BOTTOM)
    zCreateToolTip(hCtrl, "")

    hCtrl = zButImage(hMain, (SK_FOLDER() + "BTN_TrueSize.gif"), 618, 754, %ID_BTN_TrueSize, 0)
    zSetAnchorMode(hCtrl, %ANCHOR_CENTER_HORZ_BOTTOM)
    zCreateToolTip(hCtrl, "")

    hCtrl = zButImage(hMain, (SK_FOLDER() + "BTN_About.gif"), 934, 784, %ID_BTN_About, 0)
    zSetAnchorMode(hCtrl, %ANCHOR_BOTTOM_RIGHT)
    zCreateToolTip(hCtrl, "")

    hCtrl = zButImage(hMain, (SK_FOLDER() + "BTN_Tray.gif"), 253, 754, %ID_BTN_Tray, 0)
    zSetAnchorMode(hCtrl, %ANCHOR_CENTER_HORZ_BOTTOM)
    zCreateToolTip(hCtrl, "")

    hCtrl = zButImage(hMain, (SK_FOLDER() + "BTN_Select.gif"), 279, 754, %ID_BTN_Select, 0)
    zSetAnchorMode(hCtrl, %ANCHOR_CENTER_HORZ_BOTTOM)
    zCreateToolTip(hCtrl, "")

    hCtrl = zButImage(hMain, (SK_FOLDER() + "BTN_Send.gif"), 305, 754, %ID_BTN_Send, 0)
    zSetAnchorMode(hCtrl, %ANCHOR_CENTER_HORZ_BOTTOM)
    zCreateToolTip(hCtrl, "")

    hCtrl = zButImage(hMain, (SK_FOLDER() + "BTN_Save.gif"), 331, 754, %ID_BTN_Save, 0)
    zSetAnchorMode(hCtrl, %ANCHOR_CENTER_HORZ_BOTTOM)
    zCreateToolTip(hCtrl, "")

    hCtrl = zButImage(hMain, (SK_FOLDER() + "BTN_Print.gif"), 357, 754, %ID_BTN_Print, 0)
    zSetAnchorMode(hCtrl, %ANCHOR_CENTER_HORZ_BOTTOM)
    zCreateToolTip(hCtrl, "")

    hCtrl = zButImage(hMain, (SK_FOLDER() + "BTN_Frame.gif"), 383, 754, %ID_BTN_Frame, 0)
    zSetAnchorMode(hCtrl, %ANCHOR_CENTER_HORZ_BOTTOM)
    zCreateToolTip(hCtrl, "")

    hCtrl = zButImage(hMain, (SK_FOLDER() + "BTN_Image.gif"), 264, 782, %ID_BTN_Image, 0)
    zSetAnchorMode(hCtrl, %ANCHOR_CENTER_HORZ_BOTTOM)
    zCreateToolTip(hCtrl, "")

    hCtrl = zButImage(hMain, (SK_FOLDER() + "BTN_Anotate.gif"), 284, 782, %ID_BTN_Anotate, 0)
    zSetAnchorMode(hCtrl, %ANCHOR_CENTER_HORZ_BOTTOM)
    zCreateToolTip(hCtrl, "")

    hCtrl = zButImage(hMain, (SK_FOLDER() + "BTN_Icon.gif"), 299, 782, %ID_BTN_Icon, 0)
    zSetAnchorMode(hCtrl, %ANCHOR_CENTER_HORZ_BOTTOM)
    zCreateToolTip(hCtrl, "")

    hCtrl = zButImage(hMain, (SK_FOLDER() + "BTN_Opacity.gif"), 319, 782, %ID_BTN_Opacity, 0)
    zSetAnchorMode(hCtrl, %ANCHOR_CENTER_HORZ_BOTTOM)
    zCreateToolTip(hCtrl, "")

    hCtrl = zButImage(hMain, (SK_FOLDER() + "BTN_Border_Left.gif"), 384, 782, %ID_BTN_Border_Left, 0)
    zSetAnchorMode(hCtrl, %ANCHOR_CENTER_HORZ_BOTTOM)
    zCreateToolTip(hCtrl, "")

    hCtrl = zButImage(hMain, (SK_FOLDER() + "BTN_Border_Right.gif"), 395, 782, %ID_BTN_Border_Right, 0)
    zSetAnchorMode(hCtrl, %ANCHOR_CENTER_HORZ_BOTTOM)
    zCreateToolTip(hCtrl, "")

    hCtrl = zStaticLabel(hMain, "", 22, 752, 64, 13, %ID_LIB_Size, SK_TEXTCOLOR(), %BS_LABEL_LEFT)

    hCtrl = zStaticLabel(hMain, "", 22, 766, 64, 13, %ID_LIB_ZoomSize, SK_TEXTCOLOR(), %BS_LABEL_LEFT)

    hCtrl = zStaticLabel(hMain, "", 959, 731, 66, 12, %ID_LIB_Count, SK_TEXTCOLOR(), %BS_LABEL_LEFT)

    hCtrl = zCheckButton(hMain, (SK_FOLDER() + "BTN_Check.png"), "", 44, 784, 140, 15, %ID_CHECK_Tootltip, SK_TEXTCOLOR(), 0)
    '//zSetCheckButtonStatus(hCtrl, %TRUE)
    zSetAnchorMode(hCtrl, %ANCHOR_BOTTOM)
    zCreateToolTip(hCtrl, "")

    dwExStyle = 0
    dwStyle = %WS_CHILD OR %WS_VSCROLL OR %ES_MULTILINE OR %ES_READONLY ' OR %WS_VISIBLE
    zGetImageSize(zGetProperty(hMain, %FORM_TopMid), 0, CaptionHeight)
    hCtrl = CreateWindowEx(dwExStyle, _            ' Extended Style For The Window
                           "RichEdit20A", _        ' Class Name
                           "", _                   ' Window Title
                           dwStyle, _              ' Defined Window Style
                           4, CaptionHeight, _     ' Window Position
                           1016, _                 ' Calculate Window Width
                           730 - CaptionHeight, _  ' Calculate Window Height
                           hMain, _                ' No Parent Window
                           %ID_RICHEDIT, _         ' No Menu
                           zsInstance(), _         ' Instance
                           BYVAL %NULL)            ' Dont Pass Anything To WM_CREATE
    'IF hCtrl THEN SendMessage(hCtrl, %EM_AUTOURLDETECT, %TRUE, 0)

    dwExStyle = 0
    dwStyle = %WS_CHILD OR %WS_VISIBLE '// + WS_HSCROLL + WS_VSCROLL
    CtrlW = 1024: CtrlH = 731
    gP.hCtrl = CreateWindowEx(dwExStyle, $GDImageClassName, "", dwStyle, 0, 0, CtrlW, CtrlH, hMain, %ID_CTRL, zsInstance(), BYVAL %NULL)
    IF gP.hCtrl THEN
       LOCAL sUseBorderName AS STRING
       sUseBorderName = zGetReg(%HKEY_LOCAL_MACHINE, $RegistryKey, $RegistryBorderName)
       IF LEN(sUseBorderName) THEN
          zSplitN(sUseBorderName, "", sFileName$)
          sUseBorderName = gP.sBorderPath + sFileName$
          IF NOT zsExist((sUseBorderName)) THEN sUseBorderName = ""
       END IF
       IF LEN(sUseBorderName) = 0 THEN
          sUseBorderName = gP.sBorderPath + "Black.png"
       END IF

       hCtrl = CreateWindowEx(0, "LISTBOX", "", %WS_CHILD OR %LBS_SORT, 0, 0, 0, 0, hMain, %ID_BorderList, zsInstance(), BYVAL %NULL)
       UpdateBorderList(sUseBorderName)

       ZI_SetProperty(gP.hCtrl, %ZI_GradientTop, gP.nBackColor)
       ZI_SetProperty(gP.hCtrl, %ZI_GradientBottom, gP.nBackColor)

       '// We use a callback to monitor the messages from the GDImage control
       GDImageEnableEvents()

       LOCAL nHbitmap, bmW, bmH AS LONG
       LOCAL sImagePath, sUsePhoto AS STRING
       sImagePath = zsExePath()

       '// We use image backround to speed up the display,
       '// instead of a slower empty bitmap ZI_SetCtrlEmptyBitmap(gP.hCtrl, gP.nBackColor).
       ZI_CreateImageBackground(gP.hCtrl, CtrlW, CtrlH)

       sUsePhoto = gP.sIntroPicture
       UseThisPhoto(sUsePhoto)

       hCtrl = CreateWindowEx(0, "LISTBOX", "", %WS_CHILD OR %LBS_SORT, 0, 0, 0, 0, hMain, %ID_PlayList, zsInstance(), BYVAL %NULL)
       ListDeleteAll(hCtrl)
       ListAdd(hCtrl, (sUsePhoto))
       ListSelectPlus(hCtrl, 1)

       nHbitmap = ZI_CreateBitmapFromFile((sUseBorderName), bmW, bmH)
       ZD_DrawBitmapToCtrl(gP.hCtrl, 0, 0, nHbitmap, ZD_ColorARGB(255, 0), %ID_FRAME, %ZS_VISIBLE)
       '// We lock the frame
       '// Le cadre doit tre verrouill pour viter qu'il ne soit dplac.
       ZD_SetObjectLocked (%ID_FRAME, %TRUE)
       ZD_UsePngOpacity(%ID_FRAME, %TRUE)
       gSprite(%ID_FRAME).ID = %ID_FRAME
       gSprite(%ID_FRAME).filname = sUseBorderName    '// Full path name to the sprite bitmap
       SpriteArrayGet(%ID_FRAME)                      '// Assign the ZOBJECT structure/type parameters to the Sprite array

       '// Make sure that the photography is at the z-order's bottom
       '// On s'assure que la photo se trouve tout en bas du z-order
       ZD_SetObjectZorder(%ID_PHOTO, %ZD_ORDER_BOTTOM)
       gSprite(%ID_PHOTO).ID = %ID_PHOTO
       gSprite(%ID_PHOTO).filname = sUsePhoto         '// Full path name to the sprite bitmap
       SpriteArrayGet(%ID_PHOTO)                      '// Assign the ZOBJECT structure/type parameters to the Sprite array

       '// Add STAMP
       IF IsFrench() THEN
          sUsePhoto = gP.sFrenchStamp
       ELSE
          sUsePhoto = gP.sEnglishStamp
       END IF
       nHbitmap = ZI_CreateBitmapFromFile((sUsePhoto), bmW, bmH)
       ZD_DrawBitmapToCtrl(gP.hCtrl, CtrlW - bmW - 10, 10, nHbitmap, ZD_ColorARGB(255, 0), %ID_STAMP, %ZS_HIDDEN)

       '// For better resize quality
       IF zGetCheckButtonStatus(zGetMainItem(%ID_CHECK_Quality)) THEN
          ZD_SetObjectQuality(%ID_STAMP, %InterpolationModeHighQuality, %FALSE)
       END IF

       ZD_UsePngOpacity(%ID_STAMP, %TRUE)
       gSprite(%ID_STAMP).ID = %ID_STAMP
       gSprite(%ID_STAMP).filname = sUsePhoto         '// Full path name to the sprite bitmap
       SpriteArrayGet(%ID_STAMP)                      '// Assign the ZOBJECT structure/type parameters to the Sprite array

       LOCAL ARGB, nBoundWidth, nBoundHeight, nFontUseSize, nFontUse3D AS LONG
       LOCAL sFontToUse, sUseText AS STRING
       ARGB = ZD_ColorARGB(128, RGB(255,255,255))
       nFontUseSize = 36
       sFontToUse = "Times New Roman"
       nFontUse3D = 1

       sUseText = ZD_GetObjectImageLabel(%ID_PHOTO)
       ZD_DrawTextToCtrl(gP.hCtrl, (sUseText), 0, 0, ARGB, (sFontToUse), nFontUseSize, %ID_TITLE, %ZS_VISIBLE, nFontUse3D, 0)
       ZD_GetObjectBound(%ID_TITLE, nBoundWidth, nBoundHeight)
       ZD_SetObjectXY(%ID_TITLE, (CtrlW - nBoundWidth) \ 2, 2, %ZD_DRAW_DEFERRED)
       ZD_SetObjectVisibility(%ID_TITLE, %TRUE)
       '// Store the font name properties (260 characters)
       gSprite(%ID_TITLE).ARGB = ARGB
       gSprite(%ID_TITLE).filname = NumToString(nFontUseSize) + $zLim + NumToString(nFontUse3D) + $zLim + sFontToUse + $zLim + sUseText
       gSprite(%ID_TITLE).ID = %ID_TITLE

       '// Check for the signature to use as footnote
       sUseText = zGetReg(%HKEY_LOCAL_MACHINE, $RegistryKey, $RegistrySignature)
       IF LEN(sUseText) = 0 THEN sUseText = zGetCTLText(hMain)

       ZD_DrawTextToCtrl(gP.hCtrl, (sUseText), 0, 0, ARGB, (sFontToUse), nFontUseSize, %ID_FOOTNOTE, %ZS_VISIBLE, nFontUse3D, 0)
       ZD_GetObjectBound(%ID_FOOTNOTE, nBoundWidth, nBoundHeight)
       ZD_SetObjectXY(%ID_FOOTNOTE, (CtrlW - nBoundWidth) - 40, CtrlH - (nBoundHeight * 1), %ZD_DRAW_DEFERRED)
       ZD_SetObjectVisibility(%ID_FOOTNOTE, %TRUE)
       '// Store the font name properties (260 characters)
       gSprite(%ID_FOOTNOTE).ARGB = ARGB
       gSprite(%ID_FOOTNOTE).filname = NumToString(nFontUseSize) + $zLim + NumToString(nFontUse3D) + $zLim + sFontToUse + $zLim +     sUseText
       gSprite(%ID_FOOTNOTE).ID = %ID_FOOTNOTE

    END IF

'   // Create popup menus
    hCtrl = CreatePopupMenu()   '// The text popup menu
    IF hCtrl THEN
       AppendMenu(hCtrl, %MF_OWNERDRAW, %IDM_TXT_Edit     , "")
       AppendMenu(hCtrl, %MF_SEPARATOR, 102               , "")
       AppendMenu(hCtrl, %MF_OWNERDRAW, %IDM_TXT_Horz     , "")
       AppendMenu(hCtrl, %MF_OWNERDRAW, %IDM_TXT_Vert_Up  , "")
       AppendMenu(hCtrl, %MF_OWNERDRAW, %IDM_TXT_Vert_Down, "")
       AppendMenu(hCtrl, %MF_SEPARATOR, 106               , "")
       AppendMenu(hCtrl, %MF_OWNERDRAW, %IDM_TXT_Copy     , "")
       AppendMenu(hCtrl, %MF_OWNERDRAW, %IDM_TXT_Delete   , "")
    END IF
    gP.hMenuText = hCtrl

    hCtrl = CreatePopupMenu() '// The bitmap popup menu
    IF hCtrl THEN
       AppendMenu(hCtrl, %MF_OWNERDRAW, %IDM_BMP_Edit          , "")
       AppendMenu(hCtrl, %MF_SEPARATOR, 202                    , "")
       AppendMenu(hCtrl, %MF_OWNERDRAW, %IDM_BMP_Flip_Horz     , "")
       AppendMenu(hCtrl, %MF_OWNERDRAW, %IDM_BMP_Flip_Vert     , "")
       AppendMenu(hCtrl, %MF_OWNERDRAW, %IDM_BMP_90_Left       , "")
       AppendMenu(hCtrl, %MF_OWNERDRAW, %IDM_BMP_90_Right      , "")
       AppendMenu(hCtrl, %MF_SEPARATOR, 207                    , "")
       AppendMenu(hCtrl, %MF_OWNERDRAW, %IDM_BMP_Top           , "")
       AppendMenu(hCtrl, %MF_OWNERDRAW, %IDM_BMP_Up            , "")
       AppendMenu(hCtrl, %MF_OWNERDRAW, %IDM_BMP_Down          , "")
       AppendMenu(hCtrl, %MF_OWNERDRAW, %IDM_BMP_Bottom        , "")
       AppendMenu(hCtrl, %MF_SEPARATOR, 212                    , "")
       AppendMenu(hCtrl, %MF_OWNERDRAW, %IDM_BMP_Sprite_128x128, "")
       AppendMenu(hCtrl, %MF_OWNERDRAW, %IDM_BMP_Sprite_256x256, "")
       AppendMenu(hCtrl, %MF_SEPARATOR, 215                    , "")
       AppendMenu(hCtrl, %MF_OWNERDRAW, %IDM_BMP_Clone         , "")
       AppendMenu(hCtrl, %MF_OWNERDRAW, %IDM_BMP_Lock          , "")
       AppendMenu(hCtrl, %MF_OWNERDRAW, %IDM_BMP_Delete        , "")
    END IF
    gP.hMenuBitmap = hCtrl

    GDImageSetupLanguage(IsFrench())

END SUB

'// Update the GDImage focus
SUB GDImageChangeFocus(BYVAL nObjectID AS LONG)
    LOCAL bmW, bmH, xSize, ySize AS LONG
    LOCAL rZoomValue AS SINGLE
    ZD_GetObjectBound(nObjectID, bmW, bmH)
'   // Compute the zoom range for the active nObjectID
    GDImageSetZoomRange(bmW, bmH, xSize, ySize)
    rZoomValue = ZD_GetObjectScale(nObjectID)
    zSetTrackValue(zGetMainItem(%ID_TRACK_Zoom), rZoomValue * 1000)

    gP.rWasZoom = 0
    gP.nWasAlpha =  ZD_GetObjectAlpha(nObjectID)
    zSetTrackValue(zGetMainItem(%ID_TRACK_Alpha), gP.nWasAlpha)

    gP.nFocusID = nObjectID
END SUB

FUNCTION GDImageCallBack(BYVAL hWnd AS LONG, BYVAL Msg AS LONG, BYVAL wParam AS LONG, BYVAL lParam AS LONG) EXPORT AS LONG
    LOCAL lpr AS RECT, p AS POINTAPI
    LOCAL nRet, nObjectID, x, y, x1, y1, ObjectType AS LONG
    LOCAL sID, sIDx, sIDy AS STRING
    LOCAL szLabelName AS ASCIIZ * 64
    LOCAL hMain, MenuChoice AS LONG

    hMain = zMainWindow(0)

    IF GetDlgCtrlID(hWnd) = %ID_CTRL THEN
       nObjectID = ZI_MouseOverObjectID()

       IF nObjectID = %ID_CTRL THEN nObjectID = %ID_PHOTO: ZI_SetObjectFocusID(%ID_PHOTO) '// Version 1.1

       SELECT CASE LONG Msg

       CASE %WM_LBUTTONDOWN
            IF nObjectID THEN
               IF nObjectID <> %ID_CTRL THEN
                  IF nObjectID <> %ID_FRAME THEN
                     '//nSelected AS LONG = ZD_GetObjectSelected(nObjectID)
                     ObjectType = ZD_GetObjectType(nObjectID)
                     IF (ObjectType = %OBJECT_BITMAP) OR (ObjectType = %OBJECT_TEXTBITMAP) THEN
                        IF gP.nFocusID <> nObjectID THEN
                           GDImageChangeFocus(nObjectID)
                        END IF
                     END IF
                  END IF
               END IF
            END IF
       CASE %WM_LBUTTONDBLCLK
            IF nObjectID THEN
               IF nObjectID = %ID_STAMP THEN
                  zPutFocusOn(zGetMainItem(%ID_BTN_Send))
               END IF
            END IF
            '// Switch to Iconize mode
            '// Bascule en mode Reduction
            IF nObjectID = %ID_FRAME OR nObjectID = %ID_CTRL THEN ShowWindow(hMain, %SW_MINIMIZE)

       CASE %WM_RBUTTONDOWN
            x = LO(INTEGER, lParam): y = HI(INTEGER, lParam)
            '// No change allowed to the frame.
            '// On ne permet pas de modifier le cadre.
            IF nObjectID = %ID_FRAME THEN nObjectID = 0

            IF nObjectID THEN
               IF nObjectID <> %ID_CTRL THEN

                  IF ZD_GetObjectSelected(nObjectID) THEN
                  ELSE
                     IF nObjectID <> ZI_GetObjectFocusID() THEN
                        ZI_SetObjectFocusID(nObjectID)
                        gP.nFocusID = nObjectID
                        gP.rWasZoom = 0
                        gP.nWasAlpha = 255
                        zSetTrackValue(zGetMainItem(%ID_TRACK_Alpha), gP.nWasAlpha)
                     END IF

                     ObjectType = ZD_GetObjectType(nObjectID)
                     SELECT CASE LONG ObjectType
                     CASE %OBJECT_TEXT
                          IF nObjectID > %ID_TITLE THEN
                             EnableMenuItem(gP.hMenuText, %IDM_TXT_Delete, %MF_ENABLED)
                          ELSE
                             EnableMenuItem(gP.hMenuText, %IDM_TXT_Delete, %MF_GRAYED)
                          END IF
                          GetCursorPos(p)
                          MenuChoice = TrackPopupMenuEx(gP.hMenuText, %TPM_RETURNCMD, p.x, p.y, hMain, BYVAL %NULL)
                          IF MenuChoice THEN SendMessage(hMain, %WM_COMMAND, MAKLNG(MenuChoice, 0), 0)
                     'CASE %OBJECT_ELLIPSE
                     'CASE %OBJECT_RECT
                     'CASE %OBJECT_CURVE
                     'CASE %OBJECT_ARROW
                     'CASE %OBJECT_POLYLINE
                     CASE %OBJECT_BITMAP, %OBJECT_TEXTBITMAP

                          IF nObjectID > %ID_PHOTO THEN
                             EnableMenuItem(gP.hMenuBitmap, %IDM_BMP_Top, %MF_ENABLED)
                             EnableMenuItem(gP.hMenuBitmap, %IDM_BMP_Up, %MF_ENABLED)
                             EnableMenuItem(gP.hMenuBitmap, %IDM_BMP_Down, %MF_ENABLED)
                             EnableMenuItem(gP.hMenuBitmap, %IDM_BMP_Bottom, %MF_ENABLED)
                          ELSE
                             EnableMenuItem(gP.hMenuBitmap, %IDM_BMP_Top, %MF_GRAYED)
                             EnableMenuItem(gP.hMenuBitmap, %IDM_BMP_Up, %MF_GRAYED)
                             EnableMenuItem(gP.hMenuBitmap, %IDM_BMP_Down, %MF_GRAYED)
                             EnableMenuItem(gP.hMenuBitmap, %IDM_BMP_Bottom, %MF_GRAYED)
                          END IF

                          IF ObjectType = %OBJECT_TEXTBITMAP THEN
                             EnableMenuItem(gP.hMenuBitmap, %IDM_BMP_Edit, %MF_ENABLED)
                          ELSE
                             EnableMenuItem(gP.hMenuBitmap, %IDM_BMP_Edit, %MF_GRAYED)
                          END IF

                          IF ZD_GetObjectLocked(nObjectID) THEN
                             gP.nMenuLockBitmap = -1
                          ELSE
                             gP.nMenuLockBitmap = 0
                          END IF

                          IF ObjectType = %OBJECT_BITMAP THEN
                             EnableMenuItem(gP.hMenuBitmap, %IDM_BMP_Delete, %MF_GRAYED)
                             IF nObjectID = %ID_PHOTO THEN
                                EnableMenuItem(gP.hMenuBitmap, %IDM_BMP_Clone, %MF_GRAYED)
                             ELSE
                                EnableMenuItem(gP.hMenuBitmap, %IDM_BMP_Clone, %MF_ENABLED)
                                IF nObjectID > %ID_STAMP THEN
                                   EnableMenuItem(gP.hMenuBitmap, %IDM_BMP_Delete, %MF_ENABLED)
                                END IF
                             END IF
                          ELSE
                             EnableMenuItem(gP.hMenuBitmap, %IDM_BMP_Clone, %MF_ENABLED)
                             EnableMenuItem(gP.hMenuBitmap, %IDM_BMP_Delete, %MF_ENABLED)
                          END IF
                          GetCursorPos(p)
                          MenuChoice = TrackPopupMenuEx(gP.hMenuBitmap, %TPM_RETURNCMD, p.x, p.y, hMain, BYVAL %NULL)
                          IF MenuChoice THEN SendMessage(hMain, %WM_COMMAND, MAKLNG(MenuChoice, 0), 0)

                     'CASE %OBJECT_BEZIER
                     'CASE %OBJECT_POLYPOLYGON
                     'CASE ELSE
                     END SELECT

                  END IF
               END IF
            END IF

       CASE %WM_MOUSEMOVE
            IF nObjectID THEN
               szLabelName = "": sID = "": sIDx = "": sIDy = ""

               IF nObjectID <> %ID_CTRL THEN
                  SELECT CASE LONG nObjectID
                  CASE %ID_PHOTO
                       szLabelName = gP.sBackground

                       '// Version 1.1
                       IF ZD_ObjectMouseCaptured() = %ID_PHOTO THEN
                          ZD_CopyToBackground(gP.hCtrl, %ID_PHOTO, %TRUE, RGB(0,0,0))
                          ZI_UpdateWindow(gP.hCtrl, 0)
                       END IF

                  CASE %ID_FRAME
                       szLabelName = gP.sBorder
                  CASE ELSE
                       szLabelName = ZD_GetObjectImageLabel(nObjectID)
                  END SELECT

                  '// Tooltip hover image
                  IF zGetCheckButtonStatus(zGetMainItem(%ID_CHECK_Tootltip)) = 0 THEN szLabelName = ""
                  IF szLabelName <> gP.sWasLabelName THEN ZI_SetToolTipText(gP.hCtrl, szLabelName)
                  gP.sWasLabelName = szLabelName

               END IF

               IF nObjectID = %ID_FRAME OR nObjectID = %ID_CTRL THEN
                  IF ZI_IsLButtonDown() THEN
                     '// Use the low level API to Move the window form
                     SendMessage(hMain, %WM_NCLBUTTONDOWN, %HTCAPTION, 0)
                  END IF
               END IF
            END IF

       CASE %WM_KEYDOWN
            nObjectID = ZI_GetObjectFocusID() '// On rcupre l'ID du sprite qui a le focus
            IF nObjectID THEN '// Handle the sprites move
               ZD_GetObjectXY(nObjectID, x, y)
               x1 = x '// Make a copy to preserve original value
               y1 = y '// Make a copy to preserve original value
               '// Check if keyboard accelerator keys are yeld down
               LOCAL UseStep AS LONG
               IF ZI_IsCtrlKeyPressed() THEN
                  UseStep = 4
                  IF ZI_IsShiftKeyPressed THEN UseStep = 16
               ELSEIF ZI_IsShiftKeyPressed THEN
                  UseStep = 2
               ELSE
                  UseStep = 1
               END IF
               LOCAL useWidth, useHeight AS LONG
               '// Does the sprite must move with the background?
               IF ZD_GetObjectScroll(nObjectID) THEN
                  '// Get the image background size
                  ZI_GetBitmapSize(ZI_GetBMP(zGetMainItem(%ID_CTRL)), useWidth, useHeight)
               ELSE
                  '// Get the client size of the control
                  GetClientRect(zGetMainItem(%ID_CTRL), lpr)
                  useWidth = lpr.nRight: useHeight = lpr.nBottom
               END IF
               LOCAL BoundWidth, BoundHeight, x2Div2, y2Div2 AS LONG
               '// Retrieve the sprite's size
               ZD_GetObjectBound(nObjectID, BoundWidth, BoundHeight)
               x2Div2 = BoundWidth \ 2
               y2Div2 = BoundHeight \ 2
               SELECT CASE LONG wParam
               CASE %VK_HOME
                    x1 = 0
               CASE %VK_END
                    x1 = MAX&(useWidth - BoundWidth, 0)
               CASE %VK_PRIOR
                    y1 = 0
               CASE %VK_NEXT
                    y1 = MAX&(useHeight - BoundHeight, 0)
               CASE %VK_LEFT, %VK_NUMPAD4
                    IF x1 > -x2Div2 THEN x1 = MAX&(x1 - UseStep, -x2Div2)
               CASE %VK_UP, %VK_NUMPAD8
                    IF y1 > -y2Div2 THEN y1 = MAX&(y1 - UseStep, -y2Div2)
               CASE %VK_RIGHT, %VK_NUMPAD6
                    IF x1 < useWidth - x2Div2 THEN
                       x1 = MIN&(x1 + UseStep, useWidth - x2Div2)
                    END IF
               CASE %VK_DOWN, %VK_NUMPAD2
                    IF y1 < useHeight - y2Div2 THEN
                       y1 = MIN&(y1 + UseStep, useHeight - y2Div2)
                    END IF
               END SELECT

               IF x <> x1 OR y <> y1 THEN
                  x = x1: y = y1
                  ZD_SetObjectXY(nObjectID, x1, y1, %TRUE)
               END IF

               IF nObjectID = %ID_PHOTO THEN '// Version 1.1
                  ZD_CopyToBackground(gP.hCtrl, %ID_PHOTO, %TRUE, RGB(0,0,0)) '// Version 1.1
                  ZI_UpdateWindow(gP.hCtrl, %FALSE)
               END IF

            END IF

       CASE %WM_MOUSEWHEEL '// Version 1.1
            IF gP.nFocusID = %ID_PHOTO THEN '// Version 1.1
               IF ZI_IsShiftKeyPressed() THEN
                  ZD_CopyToBackground(gP.hCtrl, %ID_PHOTO, %TRUE, RGB(0,0,0))
                  ZI_UpdateWindow(gP.hCtrl, 0)
               END IF
            END IF

       END SELECT
    END IF

    FUNCTION = nRet
END FUNCTION

'// Resize the photo to match the zoom being used
SUB UseThisZoom()
'// Make sure to disable the crop rectangle if any
    LOCAL bmW, bmH, hCtrl AS LONG, rZoomValue AS SINGLE
    IF ZI_GetToolCropStatus(gP.hCtrl) THEN ZI_DisableCropRectangle(gP.hCtrl)

    rZoomValue = zGetTrackValue(zGetMainItem(%ID_TRACK_Zoom)) / 1000
    IF rZoomValue <> gP.rWasZoom THEN
       '//ZD_SetObjectScale(ID_PHOTO, rZoomValue)
       ZD_SetObjectScale(gP.nFocusID, rZoomValue)
       IF gP.nFocusID = %ID_PHOTO THEN
          ZD_GetObjectBound(%ID_PHOTO, bmW, bmH)

          hCtrl = zGetMainItem(%ID_LIB_ZoomSize)
          zSetCTLText(hCtrl, NumToString(CLNG(bmW * rZoomValue)) + " x " + NumToString(CLNG(bmH * rZoomValue)))

          ZD_CopyToBackground(gP.hCtrl, %ID_PHOTO, %TRUE, RGB(0,0,0)) '// Version 1.1

       END IF
       ZI_UpdateWindow(gP.hCtrl, %FALSE)
    END IF
    gP.rWasZoom = rZoomValue
END SUB

'// Setup object opacity
SUB UseThisAlpha()
'// Make sure to disable the crop rectangle if any
    LOCAL nAlphaValue AS LONG
    IF ZI_GetToolCropStatus(gP.hCtrl) THEN ZI_DisableCropRectangle(gP.hCtrl)
    nAlphaValue = zGetTrackValue(zGetMainItem(%ID_TRACK_Alpha))
    IF nAlphaValue <> gP.nWasAlpha THEN
       IF gP.nFocusID <> %ID_PHOTO THEN
          ZD_SetObjectAlpha(gP.nFocusID, nAlphaValue, %TRUE)
       ELSE
          nAlphaValue = 255
          zSetTrackValue(zGetMainItem(%ID_TRACK_Alpha), nAlphaValue)
          ZI_UpdateWindow(zGetMainItem(%ID_TRACK_Alpha), %FALSE)
       END IF
    END IF
    gP.nWasAlpha = nAlphaValue
END SUB

'// Increment the global sprite ID and enlarge the global gSprite array
FUNCTION IncrID() AS LONG
    LOCAL K, nRet, nCount AS LONG
    nCount = UBOUND(gSprite)
    '// Detect first for any deleted ID, then we use it instead of creating a new one
    FOR K = 1 TO nCount
        IF gSprite(K).ID = 0 THEN nRet = K: EXIT FOR
    NEXT
    IF nRet = 0 THEN
       nRet = MAX&(nCount + 1, 1)
       REDIM PRESERVE gSprite(1 TO nRet) AS SpriteStruct
    END IF
    FUNCTION = nRet
END FUNCTION

'// Make sure that stamp, footnote and title are still on top of everything
SUB GDImageCheckZorder()
    ZD_SetObjectZorder(%ID_STAMP, %ZD_ORDER_TOP)
    ZD_SetObjectZorder(%ID_FOOTNOTE, %ZD_ORDER_TOP)
    ZD_SetObjectZorder(%ID_TITLE, %ZD_ORDER_TOP)
    gSprite(%ID_STAMP).zorder = ZD_GetObjectZorder(%ID_STAMP)       '// The z-order value
    gSprite(%ID_FOOTNOTE).zorder = ZD_GetObjectZorder(%ID_FOOTNOTE) '// The z-order value
    gSprite(%ID_TITLE).zorder = ZD_GetObjectZorder(%ID_TITLE)       '// The z-order value
END SUB

SUB GDImageSelectPicture(VariableOpacity AS BYTE)
    LOCAL sFileName, sTitle AS STRING
    LOCAL NewID, nHbitmap, bmW, bmH, xPos, yPos, xSize, ySize AS LONG
    LOCAL rZoomValue AS SINGLE, rc AS RECT

    GDImageShowDW()
    sFileName = ZI_LoadDialog(zMainWindow(0))
    GDImageHideDW()
    IF LEN(sFileName) THEN
       '//nHbitmap = ZI_CreateMirrorBitmapFromFile(sFileName, bmW, bmH)
       IF VariableOpacity = 1 THEN
          nHbitmap = ZI_CreateVariableOpacityBitmap((sFileName), bmW, bmH)
       ELSE
          nHbitmap = ZI_CreateBitmapFromFile((sFileName), bmW, bmH)
       END IF
       IF nHbitmap THEN
          NewID = IncrID() '// Increment ID and gSprite array

          GetClientRect(gP.hCtrl, rc)
          '// On calcule les bornes en fonction de la taille de l'image
          GDImageSetZoomRange(bmW, bmH, xSize, ySize)
          '// On rduit la taille de l'image  la moiti de celle du contrle GDImage
          ZI_Iconise(bmW, bmH, rc.nRight \ 2, rc.nBottom \ 2, xPos, yPos, xSize, ySize)

          '// Add this new bitmap to the GDImage control
          xPos = (rc.nRight - bmW) \ 2
          yPos = (rc.nBottom - bmH) \ 2
          ZD_DrawBitmapToCtrl(gP.hCtrl, xPos, yPos, nHbitmap, ZD_ColorARGB(255, 0), NewID, %ZS_VISIBLE)

          '// Setup zoom value
          rZoomValue = xSize / bmW
          zSetTrackValue(zGetMainItem(%ID_TRACK_Zoom), rZoomValue * 1000)
          ZD_SetObjectScale(NewID, rZoomValue)

          '// Use filename as default label
          zSplitN(sFileName, "", sTitle): REPLACE "_" WITH " " IN sTitle
          sTitle = RTRIM$(LEFT$(sTitle, INSTR(-1, sTitle, $Dot)), $Dot)
          ZD_SetObjectImageLabel(NewID, (sTitle))

          '// For better resize quality
          IF zGetCheckButtonStatus(zGetMainItem(%ID_CHECK_Quality)) THEN
             ZD_SetObjectQuality(NewID, %InterpolationModeHighQuality, %FALSE)
          END IF

          '// Use GDImage Pro version alpha channel
          ZD_UsePngOpacity(NewID, %TRUE)

          ZD_SetObjectZorder(NewID, %ZD_ORDER_TOP)
          GDImageCheckZorder()

          gSprite(NewID).filname = sFileName      '// Full path name to the sprite bitmap
          SpriteArrayGet(NewID)              '// Assign the ZOBJECT structure/type parameters to the Sprite array
          gSprite(NewID).varop = VariableOpacity  '// Variable opacity

          SetFocus(gP.hCtrl)
          ZI_SetObjectFocusID(NewID)
          gP.nFocusID = NewID
          gP.rWasZoom = 0
          gP.nWasAlpha = 255: zSetTrackValue(zGetMainItem(%ID_TRACK_Alpha), gP.nWasAlpha)

          ZI_UpdateWindow(gP.hCtrl, %FALSE)     '// Show new sprite
       END IF
    END IF
END SUB

FUNCTION CheckForImage(zTmp AS ASCIIZ) AS LONG
    FUNCTION = INSTR(".jpg.png.bmp.gif.tif.", RIGHT$(zTmp, 4) + ".")
END FUNCTION

'// Update the playlist
SUB UpdatePlayList(sUseFile AS STRING)
    LOCAL hList, hCtrl, WashFind, hFind, ImageCount, nSelected, DoIt AS LONG
    LOCAL fd AS WIN32_FIND_DATA
    LOCAL zTmp AS ASCIIZ * %MAX_PATH
    LOCAL sPath AS STRING

    hList = zGetMainItem(%ID_PlayList)
    ListDeleteAll(hList)

    sUseFile = zCharLower((sUseFile))
    zSplitN(sUseFile, sPath, "")

    WashFind = MyFindFirstFile((sPath + "*.*"), fd)
    hFind = WashFind
    DO WHILE hFind > 0

       IF ASC(fd.cFileName) <> 46 THEN
          IF INSTR(CHR$(0,1,32,33,128), CHR$(fd.dwFileAttributes)) THEN
             zTmp = sPath + fd.cFileName: CharLower(zTmp)
             IF CheckForImage(zTmp) THEN
                IF ListAdd(hList, zTmp) > -1 THEN
                   INCR ImageCount
                   'IF zTmp = sUseFile THEN nSelected = ImageCount
                END IF
             END IF
          END IF
       END IF
       hFind = FindNextFile(WashFind, fd)

    LOOP
    FindClose(WashFind)
    nSelected = ListFindString(hList, (sUseFile))
    ListSelectPlus(hList, nSelected)

    IF ImageCount > 1 THEN
       hCtrl = zGetMainItem(%ID_BTN_Left): EnableWindow(hCtrl, %TRUE): zSetZorder(hCtrl, %HWND_BOTTOM)
       zUpdateWindow(hCtrl, 0)
       hCtrl = zGetMainItem(%ID_BTN_Right): EnableWindow(hCtrl, %TRUE): zSetZorder(hCtrl, %HWND_BOTTOM)
       zUpdateWindow(hCtrl, 0)
       hCtrl = zGetMainItem(%ID_TRACK_PlayList)
       zSetProperty(hCtrl, %TRACK_MINVAL, 1)
       zSetProperty(hCtrl, %TRACK_MAXVAL, ImageCount)
       EnableWindow(hCtrl, %TRUE)
       hCtrl = zGetMainItem(%ID_BTN_Pause): ShowWindow(hCtrl, %SW_HIDE): EnableWindow(hCtrl, %TRUE)
       hCtrl = zGetMainItem(%ID_BTN_Play): ShowWindow(hCtrl, %SW_SHOW): zSetZorder(hCtrl, %HWND_TOP)
       zUpdateWindow(hCtrl, 0)
    ELSE
       hCtrl = zGetMainItem(%ID_BTN_Left): EnableWindow(hCtrl, %FALSE): zSetZorder(hCtrl, %HWND_BOTTOM)
       zUpdateWindow(hCtrl, 0)
       hCtrl = zGetMainItem(%ID_BTN_Right): EnableWindow(hCtrl, %FALSE): zSetZorder(hCtrl, %HWND_BOTTOM)
       zUpdateWindow(hCtrl, 0)
       hCtrl = zGetMainItem(%ID_TRACK_PlayList)
       nSelected = 1
       zSetProperty(hCtrl, %TRACK_MINVAL, 1)
       zSetProperty(hCtrl, %TRACK_MAXVAL, 1)
       EnableWindow(hCtrl, %FALSE)
       hCtrl = zGetMainItem(%ID_BTN_Pause): ShowWindow(hCtrl, %SW_SHOW): zSetZorder(hCtrl, %HWND_TOP)
       EnableWindow(hCtrl, %FALSE)
       zUpdateWindow(hCtrl, 0)
    END IF
    zSetTrackValue(zGetMainItem(%ID_TRACK_PlayList), nSelected)
    IF ImageCount > 0 THEN UpdateCount()
END SUB

'// Update the title
SUB UpdateTitle()
    LOCAL nFontUseSize, nFontUse3D, nBoundWidth, nBoundHeight, x, y AS LONG
    LOCAL sFontUseName AS STRING, rw AS RECT
    nFontUseSize = VAL(PARSE$(gSprite(%ID_TITLE).filname, $zLim, 1))
    nFontUse3D   = VAL(PARSE$(gSprite(%ID_TITLE).filname, $zLim, 2))
    sFontUseName = PARSE$(gSprite(%ID_TITLE).filname, $zLim, 3)
    gSprite(%ID_TITLE).filname = NumToString(nFontUseSize) + $zLim + NumToString(nFontUse3D) + $zLim + sFontUseName + $zLim + ZD_GetObjectImageLabel(%ID_TITLE)
    ZD_GetObjectBound(%ID_TITLE, nBoundWidth, nBoundHeight)
    ZD_GetObjectXY(%ID_TITLE, x, y)
    GetWindowRect(zMainWindow(0), rw)
    x = (rw.nRight - rw.nLeft - nBoundWidth) \ 2
    ZD_SetObjectXY(%ID_TITLE, x, y, %ZD_DRAW_DEFERRED)'// %ZD_DRAW_REDRAW)
END SUB

SUB CLICK_BTN_Left()
    LOCAL hList, nItem AS LONG

    IF gP.bPlaying THEN
       'SlideShowStop()
       'IF zIsLButtonDown() AND zMainWindow(0) = GetForeGroundWindow THEN SlideShowStart(): EXIT SUB
       IF zIsLButtonDown() AND zMainWindow(0) = GetForeGroundWindow THEN EXIT SUB
    END IF

    gP.bSlideShow = %BACKWARD
    hList = zGetMainItem(%ID_PlayList)
    nItem = ListGetCursel(hList)
    IF nItem > 1 THEN
       DECR nItem
       ListSelectPlus(hList, nItem)
    ELSE
       nItem = ListCount(hList)
       ListSelectPlus(hList, nItem)
    END IF

    UseThisPhoto(ListGetText(hList, nItem))
    zSetTrackValue(zGetMainItem(%ID_TRACK_PlayList), nItem)

    UpdateTitle()

    IF gP.bPlaying THEN
       ZI_UpdateWindow(gP.hCtrl, %FALSE)
       SlideShowStart()
    ELSE
       '// Update the control panel and GDImage altogether
       zUpdateWindow(zMainWindow(0), 0)
    END IF

END SUB

SUB CLICK_BTN_Right()
    LOCAL hList, nItem AS LONG

    IF gP.bPlaying THEN
       'SlideShowStop()
       'IF zIsLButtonDown() AND zMainWindow(0) = GetForeGroundWindow THEN SlideShowStart(): EXIT SUB
       IF zIsLButtonDown() AND zMainWindow(0) = GetForeGroundWindow THEN EXIT SUB
    END IF

    gP.bSlideShow = %FORWARD
    hList = zGetMainItem(%ID_PlayList)
    nItem = ListGetCursel(hList)
    IF nItem < ListCount(hList) THEN
       INCR nItem
       ListSelectPlus(hList, nItem)
    ELSE
       nItem = 1
       ListSelectPlus(hList, nItem)
    END IF

    UseThisPhoto(ListGetText(hList, nItem))
    zSetTrackValue(zGetMainItem(%ID_TRACK_PlayList), nItem)

    UpdateTitle()

    IF gP.bPlaying THEN
       ZI_UpdateWindow(gP.hCtrl, %FALSE)
       SlideShowStart()
    ELSE
       '// Update the control panel and GDImage altogether
       zUpdateWindow(zMainWindow(0), 0)
    END IF

END SUB

SUB SlideShowPlay()
    IF gP.bSlideShow = %FORWARD THEN
       CLICK_BTN_Right()
    ELSE
       CLICK_BTN_Left()
    END IF
END SUB

SUB SlideShowStart()
    LOCAL nDelay, hCtrl AS LONG
    hCtrl = zGetMainItem(%ID_TRACK_Delay)
    nDelay = MAX&(zGetTrackValue(hCtrl) * 1000, 0)'100)
    SetTimer(zMainWindow(0), %SLIDE_TIMER, nDelay, %NULL)
END SUB

SUB SlideShowStop()
    KillTimer(zMainWindow(0), %SLIDE_TIMER)
END SUB

SUB UpdateTitleStatus()
    IF zGetCheckButtonStatus(zGetMainItem(%ID_CHECK_Title)) THEN
       ZD_ShowObject(%ID_TITLE, %ZS_VISIBLE)
    ELSE
       ZD_ShowObject(%ID_TITLE, %ZS_HIDDEN)
    END IF
END SUB

SUB UpdateFootNoteStatus()
    IF zGetCheckButtonStatus(zGetMainItem(%ID_CHECK_FootNote)) THEN
       ZD_ShowObject(%ID_FOOTNOTE, %ZS_VISIBLE)
    ELSE
       ZD_ShowObject(%ID_FOOTNOTE, %ZS_HIDDEN)
    END IF
END SUB

SUB UpdateStampStatus()
    IF zGetCheckButtonStatus(zGetMainItem(%ID_CHECK_Stamp)) THEN
       ZD_ShowObject(%ID_STAMP, %ZS_VISIBLE)
    ELSE
       ZD_ShowObject(%ID_STAMP, %ZS_HIDDEN)
    END IF
END SUB

SUB UpdateQualityStatus()
    LOCAL nCount, nObjectType, nInterpolation, nObjectID AS LONG
    nCount = ZI_GetCtrlObjectCount(gP.hCtrl)
    IF zGetCheckButtonStatus(zGetMainItem(%ID_CHECK_Quality)) THEN
       nInterpolation = %InterpolationModeHighQuality
    ELSE
       nInterpolation = %InterpolationModeDefault
    END IF
    FOR nObjectID = 1 TO nCount
        IF nObjectID <> %ID_FRAME THEN
           nObjectType = ZD_GetObjectType(nObjectID)
           IF (nObjectType = %OBJECT_BITMAP) OR (nObjectType = %OBJECT_TEXTBITMAP) THEN
              ZD_SetObjectQuality(nObjectID, nInterpolation, %FALSE)
           END IF
        END IF
    NEXT
    ZD_CopyToBackground(gP.hCtrl, %ID_PHOTO, %TRUE, RGB(0,0,0))
    ZI_UpdateWindow(gP.hCtrl, %FALSE)
END SUB

FUNCTION GDImageAddSpriteTextImage() AS LONG
    LOCAL zUseText AS ASCIIZ * 512
    LOCAL zUseFont AS ASCIIZ * 256
    LOCAL nChoice, nFontUseSize, nFontUseARGB, nFontUse3D, NewID AS LONG
    LOCAL xPos, yPos, bmW, bmH, xSize, ySize, hBitmap AS LONG
    LOCAL rZoomValue AS SINGLE, rc AS RECT

    ZI_SetFontBoxParameters(800, 512, 64) '// Setup FontBox default parameters 800x800, 512 pixels, 64 characters
    GDImageShowDW()
    zCursorWait()
    nChoice = ZI_FontBox(zMainWindow(0), gP.sFontBoxCaption, zUseText, zUseFont, nFontUseSize, nFontUseARGB, nFontUse3D)

    zCursorStd()
    GDImageHideDW()
    NewID = 0
    IF nChoice = 2 THEN
       hBitmap = ZD_CreateBitmapFromText(zUseText, zUseFont, nFontUseSize, nFontUseARGB, nFontUse3D, 0)
       IF hBitmap THEN
          ZI_GetBitmapSize(hBitmap, bmW, bmH)
          NewID = IncrID() '// Increment ID and gSprite array

          '// Update the zoom track bar range matching this NewID
          GDImageSetZoomRange(bmW, bmH, xSize, ySize)

          rZoomValue = ZI_GetZoomValue(gP.hCtrl) '// Get current Zoom value
          IF rZoomValue < 0.001 THEN rZoomValue = 1

          GetClientRect(gP.hCtrl, rc)

          xPos = (ZI_GetXscroll(gP.hCtrl) / rZoomValue) + (rc.nRight - bmW) \ 2
          yPos = (ZI_GetYscroll(gP.hCtrl) / rZoomValue) + (rc.nBottom - bmH) \ 2

          ZD_DrawTextBitmapToCtrl(gP.hCtrl, xPos, yPos, hBitmap, nFontUseARGB, NewID, %ZS_VISIBLE)
          ZD_SetObjectImageLabel(NewID, zUseText)
          ZD_SetObjectScroll(NewID, %TRUE)
          ZD_UsePngOpacity(NewID, %TRUE)

          GDImageCheckZorder()

          SpriteArrayGet(NewID)

          gSprite(NewID).filname = NumToString(nFontUseSize) + $zLim + _
                                               NumToString(nFontUse3D) + $zLim + _
                                               zUseFont + $zLim + _  '// We use it to store the font name (260 characters)
                                               zUseText
          SetFocus(gP.hCtrl)
          ZI_SetObjectFocusID(NewID)
          gP.nFocusID = NewID
          gP.rWasZoom = 0
          gP.nWasAlpha = 255: zSetTrackValue(zGetMainItem(%ID_TRACK_Alpha), gP.nWasAlpha)

          ZI_UpdateWindow(gP.hCtrl, %FALSE) '// Show new sprite
       END IF
    END IF
    FUNCTION = NewID
END FUNCTION

'//  Load the script array from a PCS file
SUB SpriteArrayLoad(sFileName AS STRING)
    LOCAL ID, BufferSize, fHandle, ObjectType, hBitmap, nObject, ByttesReaded AS LONG
    LOCAL nFontUseSize, nFontUse3D AS LONG
    LOCAL sFontUseName, sTextToUse AS STRING

    IF zsExist((sFileName)) THEN
       zCursorWait()

       BufferSize = zsFileSize((sFileName))
       IF BufferSize THEN
          '// Remove all current objects
          ZI_DeleteCtrlObject(gP.hCtrl)
          nObject = UBOUND(gSprite)
'//       nID is int
'//       IF nObject > ID_TITLE THEN
'//       FOR K = 1 TO nObject
'//           nID = gSprite(K).ID
'//           IF nID > ID_TITLE THEN ZD_DeleteObject(nID)
'//       NEXT
'//       END IF

          nObject = BufferSize / SIZEOF(SpriteStruct)
          REDIM gSprite(1 TO nObject) AS SpriteStruct

          IF zsFOpen((sFileName), 0, 2, fHandle) = 0 THEN
             ReadFile(fHandle, BYVAL VARPTR(gSprite(1)), BufferSize, ByttesReaded, BYVAL %NULL)
             zsFClose(fHandle): fHandle = 0
          END IF

          DIM zItem AS ZOBJECT

          FOR ID = 1 TO nObject
              gSprite(ID).ID = ID '// The unique sprite object IDentifier
              ObjectType = gSprite(ID).objtype
              IF ObjectType = %OBJECT_BITMAP THEN
                 IF gSprite(ID).clone = 0 THEN
                    '// Check if we must resize the OBJECT_BITMAP
                    IF gSprite(ID).resizeW = gSprite(ID).trueW AND gSprite(ID).resizeH = gSprite(ID).trueH THEN
                       gSprite(ID).resizeW = 0: gSprite(ID).resizeH = 0
                       gSprite(ID).trueW = 0: gSprite(ID).trueH = 0
                    END IF
                    IF gSprite(ID).resizeW > 0 AND gSprite(ID).resizeH > 0 THEN
                       hBitmap = ZI_ResizeBitmapFromFile(gSprite(ID).filname, gSprite(ID).resizeW, gSprite(ID).resizeH)
                    ELSE
                       IF gSprite(ID).varop = 1 THEN
                          hBitmap = ZI_CreateVariableOpacityBitmap(gSprite(ID).filname, 0, 0)
                       ELSE
                          hBitmap = ZI_CreateBitmapFromFile(gSprite(ID).filname, 0, 0)
                       END IF
                    END IF
                    IF hBitmap THEN
                       ZD_DrawBitmapToCtrl(gP.hCtrl, gSprite(ID).xPos, gSprite(ID).yPos, hBitmap, gSprite(ID).ARGB, ID, %ZS_HIDDEN)
                    END IF
                 ELSE
                    ZD_CloneObject(gSprite(ID).clone, ID, gSprite(ID).xPos, gSprite(ID).yPos)
                 END IF
              ELSEIF ObjectType = %OBJECT_TEXTBITMAP THEN
                 IF gSprite(ID).clone = 0 THEN
                    nFontUseSize = VAL(PARSE$(gSprite(ID).filname, $zLim, 1))
                    nFontUse3D =  VAL(PARSE$(gSprite(ID).filname, $zLim, 2))
                    sFontUseName = PARSE$(gSprite(ID).filname, $zLim, 3)
                    sTextToUse = PARSE$(gSprite(ID).filname, $zLim, 4)
                    IF LEN(sTextToUse) = 0 THEN sTextToUse = gSprite(ID).objlabel
                    hBitmap = ZD_CreateBitmapFromText((sTextToUse), (sFontUseName), nFontUseSize, gSprite(ID).ARGB, nFontUse3D, 0)
                    IF hBitmap THEN
                       ZD_DrawTextBitmapToCtrl(gP.hCtrl, gSprite(ID).xPos, gSprite(ID).yPos, hBitmap, gSprite(ID).ARGB, ID, %ZS_HIDDEN)
                    END IF
                 ELSE
                    ZD_CloneObject(gSprite(ID).clone, ID, gSprite(ID).xPos, gSprite(ID).yPos)
                 END IF
              ELSEIF ObjectType = %OBJECT_TEXT THEN
                 IF gSprite(ID).clone = 0 THEN
                    nFontUseSize = VAL(PARSE$(gSprite(ID).filname, $zLim, 1))
                    nFontUse3D =  VAL(PARSE$(gSprite(ID).filname, $zLim, 2))
                    sFontUseName = PARSE$(gSprite(ID).filname, $zLim, 3)
                    sTextToUse = PARSE$(gSprite(ID).filname, $zLim, 4)
                    IF LEN(sTextToUse) = 0 THEN sTextToUse = gSprite(ID).objlabel

                    '//ZD_SetObjectVisibility(ID, false)
                    ZD_DrawTextToCtrl(gP.hCtrl, _
                    (sTextToUse), _                       '// The text to be displayed
                    gSprite(ID).xPos, _                   '// X coordinate
                    gSprite(ID).yPos, _                   '// Y coordinate
                    gSprite(ID).ARGB, _                   '// ARGB color to use
                    (sFontUseName), _                     '// The True Type Font to use (must be a valid one)
                    nFontUseSize, _                       '// The font size in pixel
                    ID, _                                 '// The unique object ID
                    %ZS_HIDDEN, _                         '// Overlay visible at startup
                    nFontUse3D, _                         '// Optional shadow effect (offset in pixel)
                    gSprite(ID).strFormat)                '// Optional string format

                 ELSE
                    ZD_CloneObject(gSprite(ID).clone, ID, gSprite(ID).xPos, gSprite(ID).yPos)
                 END IF
              END IF

              ZD_SetObjectRotation(ID, gSprite(ID).userotate) '// Rotate90FlipNone or Rotate270FlipNone
              ZD_SetObjectFlipMode(ID, gSprite(ID).flipmode)  '// ZD_Reverse or ZD_Flip constant

              gSprite(ID).selected = 0                             '// Set selected status to Off

              ZD_GetObjectProperties(ID, zItem)                    '// Retrieve properties
              IF gSprite(ID).scrollmode THEN
                 zItem.Style = zItem.Style OR %ZS_SCROLL           '// Scrolling mode
              END IF
              gSprite(ID).ID = ID                                  '// The unique sprite object IDentifier
              zItem.objType = gSprite(ID).objtype                  '// The object type (bitmap, text, arrow, curve, rectangle, ellipse, polypolyline)
              zItem.objLabel = gSprite(ID).objlabel                '// Friendly name
              zItem.x1 = gSprite(ID).xPos                          '// X location
              zItem.y1 = gSprite(ID).yPos                          '// Y location
              zItem.useARGB = gSprite(ID).ARGB                     '// ARGB color
              zItem.visible = %ZS_HIDDEN                           '// ZS_HIDDEN or ZS_VISIBLE state
              zItem.opacity = gSprite(ID).opacity                  '// True/False PNG opacity
              zItem.angle = gSprite(ID).angle                      '// Rotation angle 0-360
              zItem.locked = gSprite(ID).locked                    '// True/False condition
              zItem.order = gSprite(ID).zorder                     '// The z-order value
              zItem.scale = gSprite(ID).scale                      '// The scale value
              zItem.Style = gSprite(ID).style                      '// The object style
              zItem.quality = gSprite(ID).quality                  '// The object quality
              zItem.clone = gSprite(ID).clone                      '// The unique ID of the cloned object
              zItem.selected = gSprite(ID).selected                '// Set selected status to Off
              zItem.strFormat = gSprite(ID).strFormat              '// Set string format (PhotoCompoPro)

              ZD_SetObjectProperties(ID, zItem)               '// Update properties
          NEXT

          FOR ID = 1 TO nObject
              IF gSprite(ID).visible THEN ZD_SetObjectVisibility(ID, %TRUE)
          NEXT
          ZD_SetObjectHidden(%ID_PHOTO, %TRUE) '// Version 1.1
          ZD_CopyToBackground(gP.hCtrl, %ID_PHOTO, %TRUE, RGB(0,0,0)) '// Version 1.1

          ZI_UpdateWindow(gP.hCtrl, %FALSE) '// Show new sprite

          '// Update PhotoCompoPro specific controls
          zSetCheckButtonStatus(zGetMainItem(%ID_CHECK_Title), gSprite(%ID_TITLE).visible)
          zSetCheckButtonStatus(zGetMainItem(%ID_CHECK_FootNote), gSprite(%ID_FOOTNOTE).visible)
          zSetCheckButtonStatus(zGetMainItem(%ID_CHECK_Stamp), gSprite(%ID_STAMP).visible)
          UpdateBorderList((gSprite(%ID_FRAME).filname))

          zCursorStd()

       END IF
    END IF
END SUB

'// The place to save the sprite array to a PCS script file
SUB SpriteArraySave(sFileName AS STRING)
    LOCAL TrueCount, K, J, ID, DeleteFlag, BufferSize, ByttesWritten, fHandle AS LONG
    TrueCount = 0
    DeleteFlag = 0
    FOR K = UBOUND(gSprite) TO 1 STEP -1
        ID = gSprite(K).ID
        IF ID THEN
           INCR TrueCount
           SpriteArrayGet(ID)
        ELSE
           DeleteFlag = -1
           ARRAY DELETE gSprite(K) '// Remove the deleted sprite object from the global sprite array
           FOR J = 1 TO UBOUND(gSprite)
               IF gSprite(J).clone > K THEN '// We must shift down the clone pointer
                  gSprite(J).clone = gSprite(J).clone - 1
               END IF
           NEXT
       END IF
    NEXT

'/////////////////////////////////////
'// SAVE DIALOG must be added there //
'/////////////////////////////////////

'// Save full array directly from memory pointer to disk in one single write step (BSAVE)
    zKillFile((sFileName))
    IF TrueCount THEN
       IF DeleteFlag THEN
          FOR K = 1 TO UBOUND(gSprite)
              gSprite(K).ID = K '// Update the unique ID for further retrieval
          NEXT
       END IF
       IF zsFOpen((sFileName), 2, 1, fHandle) = 0 THEN
          BufferSize = SIZEOF(SpriteStruct) * UBOUND(gSprite)
          WriteFile&(fHandle, BYVAL VARPTR(gSprite(1)), BufferSize, ByttesWritten, BYVAL %NULL)
          zsFClose(fHandle): fHandle = 0
       END IF
    END IF
END SUB

SUB MenuTextEdit()
    LOCAL zUseText AS ASCIIZ * 512
    LOCAL zUseFont AS ASCIIZ * 256
    LOCAL x, y, Choice, ID, nFontUseSize, nFontUse3D, nFontUseARGB AS LONG

    ID = ZI_MouseOverObjectID()
    nFontUseSize = VAL(PARSE$(gSprite(ID).filname, $zLim, 1))
    nFontUse3D = VAL(PARSE$(gSprite(ID).filname, $zLim, 2))
    zUseFont = PARSE$(gSprite(ID).filname, $zLim, 3)
    zUseText = PARSE$(gSprite(ID).filname, $zLim, 4)
    IF LEN(zUseText) = 0 THEN zUseText = gSprite(ID).objlabel
    nFontUseARGB = gSprite(ID).ARGB

    GDImageShowDW()
    zCursorWait()
    Choice = ZI_FontBox(zMainWindow(0), gP.sFontBoxCaption, zUseText, zUseFont, nFontUseSize, nFontUseARGB, nFontUse3D)
    zCursorStd()
    GDImageHideDW()

    IF Choice = 2 THEN
       ZD_GetObjectXY(ID, x, y)
       '// Update the ID text sprite object
       '// Mise  jour du sprite text ID
       ZD_DrawTextToCtrl(gP.hCtrl, _
                              zUseText, _            '// The text to be displayed
                              x, _                   '// X coordinate
                              y, _                   '// Y coordinate
                              nFontUseARGB, _        '// ARGB color to use
                              zUseFont, _            '// The %TRUE Type Font to use (must be a valid one)
                              nFontUseSize, _        '// The font size in pixel
                              ID, _                  '// The unique object ID
                              %ZS_VISIBLE, _         '// Overlay visible at startup
                              nFontUse3D, _          '// Optional shadow effect (offset in pixel)
                              ZD_GetStringFormat(ID))'// Optional string format
       '// Update the global gSprite() sprite array
       '// Mise  jour du tableau global gSprite()
       SpriteArrayGet(ID)
       gSprite(ID).filname = NumToString(nFontUseSize) + $zLim + NumToString(nFontUse3D) + $zLim + zUseFont + $zLim + zUseText
       IF ID = %ID_FOOTNOTE THEN
          IF LEN(zUseText) THEN zSetReg(%HKEY_LOCAL_MACHINE, $RegistryKey, $RegistrySignature, zUseText)
       END IF
       ZI_UpdateWindow(gP.hCtrl, 0)
    END IF
END SUB

SUB GDImageDeleteObject()
    LOCAL K, ID AS LONG
    LOCAL SpriteNull AS SpriteStruct '// Means this item has been deleted
    ID = ZI_MouseOverObjectID()
    ZD_DeleteObject(ID)
'   // Detect the matching gSprite item
    FOR K = 1 TO UBOUND(gSprite)
        IF gSprite(K).ID = ID THEN gSprite(K) = SpriteNull: EXIT FOR
    NEXT
    ZI_UpdateWindow(gP.hCtrl, %FALSE)
    GDImageChangeFocus(%ID_PHOTO)
END SUB

SUB GDImageSaveMiniature(sCaption AS STRING, nUseSize AS LONG)
    LOCAL ID, nBitmap AS LONG, sUserFileName, sUseSize, sDefaultFileName AS STRING
    ID = ZI_MouseOverObjectID()
    nBitmap = ZD_GetObjectBitmap(ID)
    IF nBitmap THEN
       sUseSize = "_" + NumToString(nUseSize) + "x" + NumToString(nUseSize) + ".png"
       sDefaultFileName = gP.sIconPath + ZD_GetObjectImageLabel(ID) + sUseSize
       ZI_SetSaveDialogMsg(zGetToolTipText(zGetMainItem(%ID_BTN_Select)), _
                               (sCaption), "PhotoCompo")
       GDImageShowDW()
       sUserFileName = ZI_ChooseSaveFileName(gP.hCtrl, (sDefaultFileName))
       GDImageHideDW()
       IF LEN(sUserFileName) THEN
          ZI_CreateSpriteFileFromBitmap((sUserFileName), nBitmap, nUseSize, 0)
       END IF
    END IF
END SUB

SUB HideHelp()
    IF IsWindowVisible(zGetMainItem(%ID_RICHEDIT)) THEN
       PostMessage(zMainWindow(0), %WM_COMMAND, MAKLNG(%ID_BTN_User, 0), 0)
    END IF
END SUB

FUNCTION GetMenuTxt(BYVAL ItemId AS LONG, Img AS LONG) AS STRING
    LOCAL sItem AS STRING
    IF gP.nUseFrench THEN
       SELECT CASE ItemId
       CASE %IDM_TXT_Edit          : FUNCTION = "Edite le texte"
       CASE %IDM_TXT_Horz          : FUNCTION = "Horizontal"
       CASE %IDM_TXT_Vert_Up       : FUNCTION = "Vertical vers le haut"
       CASE %IDM_TXT_Vert_Down     : FUNCTION = "Vertical vers le bas"
       CASE %IDM_TXT_Copy          : FUNCTION = "Duplique"
       CASE %IDM_TXT_Delete        : FUNCTION = "Supprime"

       CASE %IDM_BMP_Edit          : FUNCTION = "Edite le texte"
       CASE %IDM_BMP_Flip_Horz     : FUNCTION = "Miroir horizontal"
       CASE %IDM_BMP_Flip_Vert     : FUNCTION = "Miroir vertical"
       CASE %IDM_BMP_90_Left       : FUNCTION = "90  gauche"
       CASE %IDM_BMP_90_Right      : FUNCTION = "90  droite"
       CASE %IDM_BMP_Top           : FUNCTION = "En haut"
       CASE %IDM_BMP_Up            : FUNCTION = "Monte"
       CASE %IDM_BMP_Down          : FUNCTION = "Descend"
       CASE %IDM_BMP_Bottom        : FUNCTION = "En bas"
       CASE %IDM_BMP_Sprite_128x128: FUNCTION = "Miniature 128x128"
       CASE %IDM_BMP_Sprite_256x256: FUNCTION = "Miniature 256x256"
       CASE %IDM_BMP_Clone         : FUNCTION = "Clone"
       CASE %IDM_BMP_Lock          : FUNCTION = "Verrouille dplacement"
       CASE %IDM_BMP_Delete        : FUNCTION = "Supprime"

       END SELECT
    ELSE
       SELECT CASE ItemId
       CASE %IDM_TXT_Edit          : FUNCTION = "Text edit"
       CASE %IDM_TXT_Horz          : FUNCTION = "Horizontal"
       CASE %IDM_TXT_Vert_Up       : FUNCTION = "Vertical up"
       CASE %IDM_TXT_Vert_Down     : FUNCTION = "Vertical down"
       CASE %IDM_TXT_Copy          : FUNCTION = "Duplicate"
       CASE %IDM_TXT_Delete        : FUNCTION = "Delete"

       CASE %IDM_BMP_Edit          : FUNCTION = "Text edit"
       CASE %IDM_BMP_Flip_Horz     : FUNCTION = "Flip horizontaly"
       CASE %IDM_BMP_Flip_Vert     : FUNCTION = "Flip verticaly"
       CASE %IDM_BMP_90_Left       : FUNCTION = "Rotate 90 counterclock"
       CASE %IDM_BMP_90_Right      : FUNCTION = "Rotate 90 clockwise"
       CASE %IDM_BMP_Top           : FUNCTION = "Top"
       CASE %IDM_BMP_Up            : FUNCTION = "Up"
       CASE %IDM_BMP_Down          : FUNCTION = "Down"
       CASE %IDM_BMP_Bottom        : FUNCTION = "Bottom"
       CASE %IDM_BMP_Sprite_128x128: FUNCTION = "Miniature 128x128"
       CASE %IDM_BMP_Sprite_256x256: FUNCTION = "Miniature 256x256"
       CASE %IDM_BMP_Clone         : FUNCTION = "Clone"
       CASE %IDM_BMP_Lock          : FUNCTION = "Lock move"
       CASE %IDM_BMP_Delete        : FUNCTION = "Delete"

       END SELECT
    END IF

    SELECT CASE ItemId
    CASE %IDM_TXT_Edit             : sItem = "TXT_Edit.gif"
    CASE %IDM_TXT_Horz             : sItem = "TXT_Horz.gif"
    CASE %IDM_TXT_Vert_Up          : sItem = "TXT_Vert_Up.gif"
    CASE %IDM_TXT_Vert_Down        : sItem = "TXT_Vert_Down.gif"
    CASE %IDM_TXT_Copy             : sItem = "Clone.gif"
    CASE %IDM_TXT_Delete           : sItem = "Delete.gif"
    CASE %IDM_BMP_Edit             : sItem = "TXT_Edit.gif"
    CASE %IDM_BMP_Flip_Horz        : sItem = "Flip_Horz.gif"
    CASE %IDM_BMP_Flip_Vert        : sItem = "Flip_Vert.gif"
    CASE %IDM_BMP_90_Left          : sItem = "Rotate_left.gif"
    CASE %IDM_BMP_90_Right         : sItem = "Rotate_right.gif"
    CASE %IDM_BMP_Top              : sItem = "Top.gif"
    CASE %IDM_BMP_Up               : sItem = "Up.gif"
    CASE %IDM_BMP_Down             : sItem = "Down.gif"
    CASE %IDM_BMP_Bottom           : sItem = "Bottom.gif"
    CASE %IDM_BMP_Sprite_128x128   : sItem = "Miniature.gif"
    CASE %IDM_BMP_Sprite_256x256   : sItem = "Miniature.gif"
    CASE %IDM_BMP_Clone            : sItem = "Clone.gif"
    CASE %IDM_BMP_Lock             : IF gP.nMenuLockBitmap THEN sItem = "Lock.gif" ELSE sItem = "Unlock.gif"
    CASE %IDM_BMP_Delete           : sItem = "Delete.gif"
    END SELECT
    Img = zAddResource(SK_FOLDER()+ sItem)

END FUNCTION

'// Main window procedure
FUNCTION WndProc(BYVAL hWnd AS LONG, BYVAL Msg AS LONG, BYVAL wParam AS LONG, BYVAL lParam AS LONG) EXPORT AS LONG
    LOCAL ps AS PAINTSTRUCT
    LOCAL rZoomValue AS SINGLE, IDtoClone, nLimit, DoIt AS LONG
    LOCAL rc AS RECT, x ,y, bmW, bmH, UseWidth, useHeight, hBitmap, ID, NewID AS LONG
    LOCAL hDC, nItem, hList, hCtrl, nUseWidth, nUseHeight, nFilesDropped AS LONG
    LOCAL sWasPath, sFileName, sUseThisPath, sUserFileName, sUseLabel AS STRING
    LOCAL nChoice, nFontUseSize, nFontUse3D, nFontUseARGB AS LONG
    LOCAL szFileName AS ASCIIZ * %MAX_PATH
    LOCAL lpmis AS MEASUREITEMSTRUCT PTR
    LOCAL lpdis AS DRAWITEMSTRUCT PTR

    SELECT CASE LONG Msg

'    CASE %WM_GETMINMAXINFO
'         LOCAL pMM AS MINMAXINFO PTR
'         pMM = lParam
'         @pMM.ptMinTrackSize.x = zMinTrackSizeX(0)
'         @pMM.ptMinTrackSize.y = zMinTrackSizeY(0)

    CASE %WM_SYSKEYDOWN
         FUNCTION = 0: EXIT FUNCTION

    CASE %WM_MEASUREITEM
         lpmis = lParam
         IF wParam = 0 THEN
            'IF skMenuSkinItemOk(@lpmis.itemID) THEN ' Ok, we can skin it
               @lpmis.itemWidth = 120'LOWRD(@lpmis.itemData)
               @lpmis.itemHeight = 18'HIWRD(@lpmis.itemData)
               FUNCTION = 1: EXIT FUNCTION
            'END IF
         END IF

    CASE %WM_DROPFILES '// Drag & drop 2007-11-24
         nFilesDropped = DragQueryFile(wParam, -1, "", 0)
         szFileName = ""
         IF nFilesDropped > 0 THEN
            DragQueryFile(wParam, 0, szFileName, %MAX_PATH)
            sFileName = zCharLower(szFileName)
         END IF
         IF CheckForImage((sFileName)) THEN
            SetForegroundWindow(hWnd)
            UseThisPhoto(sFileName)
            UpdatePlayList(sFileName)
            UpdateTitle()
            ZI_UpdateWindow(gP.hCtrl, 0)
         ELSEIF RIGHT$(sFileName, 4) = ".pcs" THEN
            SpriteArrayLoad(sFileName)
         END IF
         DragFinish(wParam)

    CASE %WM_TIMER
         IF wParam = %SLIDE_TIMER THEN
            IF gP.bPlaying THEN
               SlideShowPlay()
            END IF
            FUNCTION = 0: EXIT FUNCTION
         ELSEIF wParam = %BLINK_TIMER THEN
            ButtonBlink(%ID_BTN_Select, 0)
            FUNCTION = 0: EXIT FUNCTION
         ELSEIF wParam = %BLINK_USER THEN
            ButtonBlink(%ID_BTN_User, 0)
            FUNCTION = 0: EXIT FUNCTION
         END IF

    CASE %WM_DRAWITEM
         lpdis = lParam
         SELECT CASE LONG @lpdis.CtlType
         CASE %ODT_MENU     ' 1 Owner-drawn menu item
              LOCAL zTxt AS ASCIIZ * 128, nDrawIt AS LONG

              zTxt = GetMenuTxt(@lpdis.ItemID, Img&)
              nDrawIt = -1
              IF (@lpdis.itemState AND %ODS_SELECTED) THEN
                 SetTextColor @lpdis.hDC, GetSysColor(%COLOR_HIGHLIGHTTEXT)
                 SetBkColor @lpdis.hDC, GetSysColor(%COLOR_HIGHLIGHT)
              ELSE
                 SetTextColor @lpdis.hDC, GetSysColor(%COLOR_MENUTEXT)
                 SetBkColor @lpdis.hDC, GetSysColor(%COLOR_MENU)
              END IF

              IF (@lpdis.itemState AND %ODS_GRAYED) THEN
                 SetTextColor @lpdis.hDC, GetSysColor(%COLOR_GRAYTEXT)
                 nDrawIt = 0
              END IF

              ExtTextOut(@lpdis.hDC, 6 + 16 + @lpdis.rcItem.nleft, _
                              @lpdis.rcItem.nTop + 3, %ETO_OPAQUE, _
                              @lpdis.rcItem, zTxt, LEN(zTxt), BYVAL 0)

              IF nDrawIt AND GdipCreateFromHDC(@lpdis.hDC, graphics&) = 0 THEN
                 zGetImageSize(Img&, imgW&, imgH&)
                 GdipDrawImageRectRectI(graphics&, Img&, _
                                             @lpdis.rcItem.nleft + 1, @lpdis.rcItem.nTop + 1, ImgW&, ImgH&, _
                                             0, 0, ImgW&, ImgH&, %UnitPixel, _
                                            ImgAttr&)
                 GdipDeleteGraphics(graphics&)
              END IF

              FUNCTION = 1: EXIT FUNCTION

         END SELECT

    CASE %WM_COMMAND
         IF gP.nBlinkCount THEN ButtonBlink(%ID_BTN_Select, 1) '// Stop it

         IF zButtonSysCommand(hWnd, wParam) THEN FUNCTION = 0: EXIT FUNCTION

         SELECT CASE LONG LO(INTEGER, wParam) ' LOWRD(wParam)

         CASE %ID_CTRL
              SELECT CASE LONG HI(INTEGER, wParam)
              CASE %ZM_Size
                 'LOCAL sMessage AS STRING
                 'zSplitN(sFileName, "", sName$)
                 'sMessage = sName$ + STR$(LOWRD(lParam)) + " x" + STR$(HIWRD(lParam))
                 'SetWindowText(GetDlgItem(hWnd, %ID_STATUSBAR), (sMessage))
              CASE %ZM_Crop
                 IF lParam = 1 THEN ' Selected
                    ZI_GetCropCoordinates(x, y, UseWidth, UseHeight)
                    hBitmap = ZI_CropWindowToBitmap(gP.hCtrl, x, y, UseWidth, useHeight)
                    IF ZI_PutBitmapToClipboard(hBitmap) THEN
                    END IF
                 END IF
              END SELECT
              FUNCTION = 0: EXIT FUNCTION

         CASE %ID_BTN_Left
              HideHelp()
              CLICK_BTN_Left()
              FUNCTION = 0: EXIT FUNCTION

         CASE %ID_BTN_Right
              HideHelp()
              CLICK_BTN_Right()
              FUNCTION = 0: EXIT FUNCTION

         CASE %ID_BTN_Play
              HideHelp()
              gP.bPlaying = %TRUE
              ShowWindow(zGetMainItem(%ID_BTN_Play), %SW_HIDE): zSetZorder(zGetMainItem(%ID_BTN_Play), %HWND_Bottom)
              ShowWindow(zGetMainItem(%ID_BTN_Pause), %SW_SHOW): zSetZorder(zGetMainItem(%ID_BTN_Pause), %HWND_TOP)
              'zPutFocusOn(gP.hCtrl)
              'zUpdateWindow(hWnd, 0)
              zRedrawBackground(hWnd)
              SlideShowPlay()
              SlideShowStart()
              FUNCTION = 0: EXIT FUNCTION

         CASE %ID_BTN_Pause
              HideHelp()
              gP.bPlaying = %FALSE
              SlideShowStop()
              ShowWindow(zGetMainItem(%ID_BTN_Pause), %SW_HIDE): zSetZorder(zGetMainItem(%ID_BTN_Pause), %HWND_BOTTOM)
              ShowWindow(zGetMainItem(%ID_BTN_Play), %SW_SHOW): zSetZorder(zGetMainItem(%ID_BTN_Play), %HWND_TOP)
              'zPutFocusOn(gP.hCtrl)
              zUpdateWindow(hWnd, 0)
              FUNCTION = 0: EXIT FUNCTION

         CASE %ID_TRACK_PlayList
              hCtrl = zGetMainItem(%ID_TRACK_PlayList)
              hList = zGetMainItem(%ID_PlayList)
              nItem = zGetTrackValue(hCtrl)
              IF nItem <> ListGetCursel(hList) THEN
                 HideHelp()
                 ListSelectPlus(hList, nItem)
                 UseThisPhoto(ListGetText(hList, ListGetCursel(hList)))
                 UpdateTitle()
                 ZI_UpdateWindow(gP.hCtrl, %FALSE)
              END IF
              FUNCTION = 0: EXIT FUNCTION

         CASE %ID_BTN_Stop
              SendMessage(hWnd, %WM_CLOSE, 0, 0)
              FUNCTION = 0: EXIT FUNCTION

         CASE %ID_TRACK_Zoom
              HideHelp()
              UseThisZoom()
              FUNCTION = 0: EXIT FUNCTION

         CASE %ID_TRACK_Alpha
              HideHelp()
              UseThisAlpha()
              FUNCTION = 0: EXIT FUNCTION

         CASE %ID_BTN_User
              IF IsWindowVisible(gP.hCtrl) = %TRUE THEN
                 'exStyles = GetWindowLong(hWnd, %GWL_EXSTYLE)
                 ShowWindow(gP.hCtrl, %SW_HIDE)
IF NOT Vista() THEN SetWindowLong(hWnd, -16, GetWindowLong(hWnd, -16) OR %WS_CLIPCHILDREN) '// 2007-11-05
                 ShowWindow(zGetMainItem(%ID_RICHEDIT), %SW_SHOW)
                 zUpdateWindow(zGetMainItem(%ID_RICHEDIT), 1)
                 SetTimer(hWnd, %BLINK_USER, 333, %NULL)
                 SetFocus(zGetMainItem(%ID_RICHEDIT))
              ELSE
                 ButtonBlink(%ID_BTN_User, 1)
IF NOT Vista() THEN SetWindowLong(hWnd, -16, GetWindowLong(hWnd, -16) XOR %WS_CLIPCHILDREN) '// 2007-11-05
                 ShowWindow(zGetMainItem(%ID_RICHEDIT), %SW_HIDE)
                 ShowWindow(gP.hCtrl, %SW_SHOW)
              END IF

              FUNCTION = 0: EXIT FUNCTION

         CASE %ID_BTN_French
              GDImageSetupLanguage(%FALSE)
              ZD_SetObjectBitmapFromFile((gP.sEnglishStamp), %ID_STAMP, %TRUE)
              '// Redraw background
              zDrawBackground()

              IF IsWindowVisible(zGetMainItem(%ID_RICHEDIT)) THEN
                 zPutFocusOn(zGetMainItem(%ID_RICHEDIT))
                 zKeyBd_Event(%VK_CONTROL, %VK_HOME)
              END IF

              FUNCTION = 0: EXIT FUNCTION

         CASE %ID_BTN_English
              GDImageSetupLanguage(%TRUE)
              ZD_SetObjectBitmapFromFile((gP.sFrenchStamp), %ID_STAMP, %TRUE)
              '// Redraw background
              zDrawBackground()

              IF IsWindowVisible(zGetMainItem(%ID_RICHEDIT)) THEN
                 zPutFocusOn(zGetMainItem(%ID_RICHEDIT))
                 zKeyBd_Event(%VK_CONTROL, %VK_HOME)
              END IF

              FUNCTION = 0: EXIT FUNCTION

         CASE %ID_BTN_Script_Load
              HideHelp()
              ZI_SetSaveDialogMsg(zGetToolTipText(zGetMainItem(%ID_BTN_Script_Load)), _
                                       zGetToolTipText(zGetMainItem(%ID_BTN_Save)), _
                                       "PhotoCompo")
              '// Save previous path
              sWasPath = ZI_LoadSavePath("", 0)
              '// Change path to the Script's one
              sUseThisPath = gP.sWasScriptPath
              IF LEN(sUseThisPath) = 0 THEN sUseThisPath = gP.sScriptPath
              ZI_LoadSavePath((sUseThisPath), 1)
              '// Change default extension
              ZI_SetLoadExtension($PCSextension, 1)
              GDImageShowDW()
              sFileName = ZI_LoadDialog(hWnd)
              GDImageHideDW()
              IF LEN(sFileName) THEN
                 SpriteArrayLoad(sFileName)
                 zSplitN(sFileName, sUseThisPath, "")
                 gP.sWasScriptPath = sUseThisPath
              END IF
              '// Restore original path
              IF LEN(sWasPath) THEN ZI_LoadSavePath((sWasPath), 1)
              '// Restore original extension
              ZI_SetLoadExtension("", 1)
              FUNCTION = 0: EXIT FUNCTION

         CASE %ID_BTN_Script_Save
              HideHelp()
              sFileName = PARSE$(gSprite(%ID_TITLE).filname, $zLim, 4)
              IF LEN(sFileName) = 0 THEN sFileName = ZD_GetObjectImageLabel(%ID_PHOTO)
              sUseThisPath = gP.sWasScriptPath
              IF LEN(sUseThisPath) = 0 THEN sUseThisPath = gP.sScriptPath
              sFileName = sUseThisPath + sFileName + ".pcs"
              ZI_SetSaveDialogMsg(zGetToolTipText(zGetMainItem(%ID_BTN_Select)), _
                                       zGetToolTipText(zGetMainItem(%ID_BTN_Script_Save)), _
                                       "PhotoCompo")
              '// Change default extension
              ZI_SetSaveExtension($PCSextension, 1)
              GDImageShowDW()
              sUserFileName = ZI_ChooseSaveFileName(gP.hCtrl, (sFileName))
              GDImageHideDW()
              IF LEN(sUserFileName) THEN
                 SpriteArraySave(sUserFileName)
                 zSplitN(sUserFileName, sUseThisPath, "")
                 gP.sWasScriptPath = sUseThisPath
              END IF
              '// Restore original extension
              ZI_SetSaveExtension("", 1)
              FUNCTION = 0: EXIT FUNCTION

         CASE %ID_CHECK_Quality
              HideHelp()
              UpdateQualityStatus()
              FUNCTION = 0: EXIT FUNCTION

         CASE %ID_CHECK_Title
              HideHelp()
              UpdateTitleStatus()
              FUNCTION = 0: EXIT FUNCTION

         CASE %ID_CHECK_FootNote
              HideHelp()
              UpdateFootNoteStatus()
              FUNCTION = 0: EXIT FUNCTION

         CASE %ID_CHECK_Stamp
              HideHelp()
              UpdateStampStatus()
              FUNCTION = 0: EXIT FUNCTION

         CASE %ID_BTN_Crop
              HideHelp()
              ZI_EnableCropRectangle(gP.hCtrl)
              FUNCTION = 0: EXIT FUNCTION

         CASE %ID_BTN_TrueSize
              HideHelp()
              zSetTrackValue(zGetMainItem(%ID_TRACK_Zoom), 1000)
              UseThisZoom()
              FUNCTION = 0: EXIT FUNCTION

         CASE %ID_BTN_About
              HideHelp()
              ShellExecute(BYVAL %NULL, "open", (gP.sWebPage), "", "", %SW_SHOW)
              FUNCTION = 0: EXIT FUNCTION

         CASE %ID_BTN_Tray
              HideHelp()
              hList = zGetMainItem(%ID_PlayList)
              nItem = ListGetCursel(hList)
              sFileName = ListGetText(hList, nItem)
              IF ListCount(hList) > 1 THEN
                 ListDelete(hList, nItem)
                 IF nItem > ListCount(hList) THEN DECR nItem
                 ListSelectPlus(hList, nItem)

                 ZI_MoveToTray((sFileName)) '// Move file to tray. On envoi dans la corbeille

                 sFileName = ListGetText(hList, nItem)
                 UseThisPhoto(sFileName)

                 hCtrl = zGetMainItem(%ID_TRACK_PlayList)
                 zSetProperty(hCtrl, %TRACK_MINVAL, 1)
                 zSetProperty(hCtrl, %TRACK_MAXVAL, ListCount(hList))

                 UpdateCount()
              ELSE
                 sFileName = zCharLower((sFileName))
                 IF sFileName <> zCharLower((gP.sNoPicture)) THEN
                    IF sFileName <> zCharLower((gP.sIntroPicture)) THEN
                       ZI_MoveToTray((sFileName)) '// Move file to tray
                    END IF
                 END IF

                 EnableWindow(zGetMainItem(%ID_BTN_Left), %FALSE)
                 EnableWindow(zGetMainItem(%ID_BTN_Right), %FALSE)

                 hCtrl = zGetMainItem(%ID_TRACK_PlayList)
                 zSetProperty(hCtrl, %TRACK_MINVAL, 1)
                 zSetProperty(hCtrl, %TRACK_MAXVAL, 1)
                 zSetTrackValue(hCtrl, 1)
                 EnableWindow(hCtrl, %FALSE)

                 UseThisPhoto((gP.sNoPicture))

                 ShowWindow(zGetMainItem(%ID_LIB_Size), %SW_HIDE)
                 ShowWindow(zGetMainItem(%ID_LIB_ZoomSize), %SW_HIDE)
                 zSetCTLText(zGetMainItem(%ID_LIB_Count), "")

              END IF
              UpdateTitle()
              ZI_UpdateWindow(gP.hCtrl, %FALSE)
              FUNCTION = 0: EXIT FUNCTION

         CASE %ID_BTN_Select
              HideHelp()
              ZI_SetSaveDialogMsg(zGetToolTipText(zGetMainItem(%ID_BTN_Select)), _
                                       zGetToolTipText(zGetMainItem(%ID_BTN_Select)), _
                                       "PhotoCompo")
              GDImageShowDW()
              sFileName = ZI_LoadDialog(hWnd)
              GDImageHideDW()
              IF LEN(sFileName) THEN
                 IF gP.bPlaying THEN
                    SendMessage(hWnd, %WM_COMMAND, MAKLNG(%ID_BTN_Pause,0), 0)
                 END IF
                 UpdatePlayList(sFileName)
                 UseThisPhoto(sFileName)
                 UpdateTitle()
                 ZI_UpdateWindow(gP.hCtrl, %FALSE)
              END IF
              FUNCTION = 0: EXIT FUNCTION

         CASE %ID_BTN_Send
              HideHelp()
              LOCAL nJpegQuality, nRotation AS LONG
              LOCAL sProfileName, sPassword, sSubject, sNote, sNames, sAddresses AS STRING

              nUseWidth    = 1280        '// maximum width size
              nUseHeight   = 1024        '// maximum height size
              sFileName    = zGetTempPath + "postcard.jpg"
              nJpegQuality = 99          '// We use a very high jpeg quality
              nRotation    = %RotateNoneFlipNone
              IF ZI_RenderLayersToFile(gP.hCtrl, (sFileName), nJpegQuality, nRotation, nUseWidth, nUseHeight) = 0 THEN
                 sProfileName = "Outlook"
                 sPassword    = ""
                 IF IsFrench() THEN
                    sSubject = "Carte postale"
                    sNote = "Voir la carte postale en pice jointe ..."
                 ELSE
                    sSubject = "Postcard"
                    sNote = "See the attached picture ..."
                 END IF
                 sNames = ""
                 sAddresses = ""
                 zSendMapiMail((sProfileName), (sPassword), (sSubject), (sNote), (sNames), (sAddresses), (sFileName))
              END IF
              FUNCTION = 0: EXIT FUNCTION

         CASE %ID_BTN_Save
              HideHelp()
              ZI_SetSaveDialogMsg(zGetToolTipText(zGetMainItem(%ID_BTN_Select)), _
                                       zGetToolTipText(zGetMainItem(%ID_BTN_Save)), _
                                       "PhotoCompo")
              nUseWidth  = 1280
              nUseHeight = 1024
              GDImageShowDW()
              '// Last two parameters are used to fit the image into a specific size range
              ZI_SaveLayersDialog(hWnd, gP.hCtrl, 0, 0, nUseWidth, nUseHeight)
              GDImageHideDW()
              FUNCTION = 0: EXIT FUNCTION

         CASE %ID_BTN_Print
              HideHelp()
              GDImageShowDW()
              ZI_PrintFull(gP.hCtrl)
              GDImageHideDW()
              FUNCTION = 0: EXIT FUNCTION

         CASE %ID_BTN_Frame
              HideHelp()
              IF ZD_IsObjectVisible(%ID_FRAME) THEN
                 ZD_ShowObject(%ID_FRAME, %FALSE)
              ELSE
                 ZD_ShowObject(%ID_FRAME, %TRUE)
              END IF
              FUNCTION = 0: EXIT FUNCTION

         CASE %ID_BTN_Image
              HideHelp()
              ZI_SetSaveDialogMsg(zGetToolTipText(zGetMainItem(%ID_BTN_Image)), _
                                       zGetToolTipText(zGetMainItem(%ID_BTN_Save)), "PhotoCompo")
              GDImageSelectPicture(0)
              FUNCTION = 0: EXIT FUNCTION

         CASE %ID_BTN_Anotate
              HideHelp()
              GDImageAddSpriteTextImage()
              FUNCTION = 0: EXIT FUNCTION

         CASE %ID_BTN_Icon
              HideHelp()
              ZI_SetSaveDialogMsg(zGetToolTipText(zGetMainItem(%ID_BTN_Icon)), _
                                       zGetToolTipText(zGetMainItem(%ID_BTN_Save)), "PhotoCompo")
              '// Save previous path
              sWasPath = ZI_LoadSavePath("", 0)
              '// Change path to the Icon's one
              ZI_LoadSavePath((gP.sIconPath), 1)

              GDImageSelectPicture(0)

              '// Restore original path
              IF LEN(sWasPath) THEN ZI_LoadSavePath((sWasPath), 1)
              FUNCTION = 0: EXIT FUNCTION

         CASE %ID_BTN_Opacity
              HideHelp()
              ZI_SetSaveDialogMsg(zGetToolTipText(zGetMainItem(%ID_BTN_Opacity)), _
                                       zGetToolTipText(zGetMainItem(%ID_BTN_Save)), _
                                       "PhotoCompo")
              GDImageSelectPicture(1)
              FUNCTION = 0: EXIT FUNCTION

         CASE %ID_BTN_Border_Left
              HideHelp()
              hList = zGetMainItem(%ID_BorderList)
              nItem = ListGetCursel(hList)
              IF nItem > 1 THEN
                 DECR nItem
                 ListSelectPlus(hList, nItem)
              ELSE
                 nItem = ListCount(hList)
                 ListSelectPlus(hList, nItem)
              END IF
              UseThisBorder(ListGetText(hList, nItem))
              ZI_UpdateWindow(gP.hCtrl, %FALSE)
              FUNCTION = 0: EXIT FUNCTION

         CASE %ID_BTN_Border_Right
              HideHelp()
              hList = zGetMainItem(%ID_BorderList)
              nItem = ListGetCursel(hList)
              IF nItem < ListCount(hList) THEN
                 INCR nItem
                 ListSelectPlus(hList, nItem)
              ELSE
                 nItem = 1
                 ListSelectPlus(hList, nItem)
              END IF
              UseThisBorder(ListGetText(hList, nItem))
              ZI_UpdateWindow(gP.hCtrl, %FALSE)
              FUNCTION = 0: EXIT FUNCTION

         CASE %ID_CHECK_Tootltip
              HideHelp()
              IF zGetCheckButtonStatus(zGetMainItem(%ID_CHECK_Tootltip)) = 0 THEN
                 ZI_SetToolTipText(gP.hCtrl, "")
              END IF
              FUNCTION = 0: EXIT FUNCTION

         CASE %IDM_TXT_Edit
              MenuTextEdit()
              FUNCTION = 0: EXIT FUNCTION

         CASE %IDM_TXT_Horz
              ZD_SetStringFormat(ZI_MouseOverObjectID(), %ZD_TextHorzUp, %TRUE)
              FUNCTION = 0: EXIT FUNCTION

         CASE %IDM_TXT_Vert_Up
              ZD_SetStringFormat(ZI_MouseOverObjectID(), %ZD_TextVertUp, %TRUE)
              FUNCTION = 0: EXIT FUNCTION

         CASE %IDM_TXT_Vert_Down
              ZD_SetStringFormat(ZI_MouseOverObjectID(), %ZD_TextVertDn, %TRUE)
              FUNCTION = 0: EXIT FUNCTION

         CASE %IDM_TXT_Copy
              rZoomValue = ZI_GetZoomValue(gP.hCtrl) '// Get current Zoom value
              IF rZoomValue < 0.001 THEN rZoomValue = 1
              IDtoClone = ZI_MouseOverObjectID()
              NewID = IncrID() '// Increment ID and gSprite array
              x = ZI_GetXscroll(gP.hCtrl) / rZoomValue
              y = ZI_GetYscroll(gP.hCtrl) / rZoomValue

              ZD_TwinObject(IDtoClone, NewID, x, y)
              ZD_SetObjectImageLabel(NewID, ZD_GetObjectImageLabel(IDtoClone))
              ZD_SetObjectScroll(NewID, %TRUE)

              gSprite(NewID).filname = gSprite(IDtoClone).filname '// Full path name to the sprite bitmap
              SpriteArrayGet(NewID) '// Assign the ZOBJECT structure/type parameters to the Sprite array
              ZI_UpdateWindow(gP.hCtrl, %FALSE) '// Show new sprite
              FUNCTION = 0: EXIT FUNCTION

         CASE %IDM_TXT_Delete
              GDImageDeleteObject()
              FUNCTION = 0: EXIT FUNCTION

         CASE %IDM_BMP_Edit
              LOCAL zUseText AS ASCIIZ * 512
              LOCAL zUseFont AS ASCIIZ * 256
              ID = ZI_MouseOverObjectID()
              nFontUseSize = VAL(PARSE$(gSprite(ID).filname, $zLim, 1))
              nFontUse3D = VAL(PARSE$(gSprite(ID).filname, $zLim, 2))
              zUseFont = PARSE$(gSprite(ID).filname, $zLim, 3)
              zUseText = PARSE$(gSprite(ID).filname, $zLim, 4)
              IF LEN(zUseText) = 0 THEN zUseText = gSprite(ID).objlabel
              nFontUseARGB = gSprite(ID).ARGB

              GDImageShowDW()
              zCursorWait()
              nChoice = ZI_FontBox(hWnd, gP.sFontBoxCaption, zUseText, zUseFont, nFontUseSize, nFontUseARGB, nFontUse3D)
              zCursorStd()
              GDImageHideDW()

              IF nChoice = 2 THEN
                 hBitmap = ZD_CreateBitmapFromText(zUseText, zUseFont, nFontUseSize, nFontUseARGB, nFontUse3D, 0)
                 IF hBitmap THEN
                    ZD_SetObjectBitmapFromBitmap(hBitmap, ID, %TRUE)
                    gSprite(ID).filname = NumToString(nFontUseSize) + $zLim + NumToString(nFontUse3D) + $zLim + zUseFont + $zLim + zUseText
                    '//ZD_SetObjectImageLabel(ID, zUseText)
                    ZD_SetObjectARGBcolor(ID, nFontUseARGB)

                    SpriteArrayGet(ID)

                    ZI_UpdateWindow(gP.hCtrl, %FALSE) '// Show new sprite
                 END IF
              END IF
              FUNCTION = 0: EXIT FUNCTION

         CASE %IDM_BMP_Flip_Horz
              ID = ZI_MouseOverObjectID()
              ZD_FlipObjectX(ID)
              SpriteArrayGet(ID)

              IF ID = %ID_PHOTO THEN ZD_CopyToBackground(gP.hCtrl, %ID_PHOTO, %TRUE, RGB(0,0,0)) '// Version 1.1
              ZI_UpdateWindow(gP.hCtrl, %FALSE)

              FUNCTION = 0: EXIT FUNCTION

         CASE %IDM_BMP_Flip_Vert
              ID = ZI_MouseOverObjectID()
              ZD_FlipObjectY(ID)
              SpriteArrayGet(ID)

              IF ID = %ID_PHOTO THEN ZD_CopyToBackground(gP.hCtrl, %ID_PHOTO, %TRUE, RGB(0,0,0)) '// Version 1.1
              ZI_UpdateWindow(gP.hCtrl, %FALSE)

              FUNCTION = 0: EXIT FUNCTION

         CASE %IDM_BMP_90_Left
              ID = ZI_MouseOverObjectID()
              ZD_RotateObjectCounterclock90(ID)
              SpriteArrayGet(ID)

              IF ID = %ID_PHOTO THEN ZD_CopyToBackground(gP.hCtrl, %ID_PHOTO, %TRUE, RGB(0,0,0)) '// Version 1.1
              ZI_UpdateWindow(gP.hCtrl, %FALSE)

              FUNCTION = 0: EXIT FUNCTION

         CASE %IDM_BMP_90_Right
              ID = ZI_MouseOverObjectID()
              ZD_RotateObjectClockWise90(ID)
              SpriteArrayGet(ID)

              IF ID = %ID_PHOTO THEN ZD_CopyToBackground(gP.hCtrl, %ID_PHOTO, %TRUE, RGB(0,0,0)) '// Version 1.1
              ZI_UpdateWindow(gP.hCtrl, %FALSE)

              FUNCTION = 0: EXIT FUNCTION

         CASE %IDM_BMP_Top
              ID = ZI_MouseOverObjectID()
              nLimit = ZI_GetCtrlObjectCount(gP.hCtrl) + 1
              IF ZD_GetObjectZorder(ID) < nLimit - 1 THEN
                 ZD_SetObjectZorder(ID, nLimit - 1)
                 GDImageCheckZorder()
                 '// Update the matching sprite array member
                 gSprite(ID).zorder = ZD_GetObjectZorder(ID) '// The z-order value
                 ZI_UpdateWindow(gP.hCtrl, %FALSE)
              END IF
              FUNCTION = 0: EXIT FUNCTION

         CASE %IDM_BMP_Up
              ID = ZI_MouseOverObjectID()
              nLimit = ZI_GetCtrlObjectCount(gP.hCtrl)
              IF ZD_GetObjectZorder(ID) < nLimit - 1 THEN
                 ZD_SetObjectZorder(ID, ZD_GetObjectZorder(ID) + 1)
                 GDImageCheckZorder()
                 '// Update the matching sprite array member
                 gSprite(ID).zorder = ZD_GetObjectZorder(ID) '// The z-order value
                 ZI_UpdateWindow(gP.hCtrl, %FALSE)
              END IF
              FUNCTION = 0: EXIT FUNCTION

         CASE %IDM_BMP_Down
              ID = ZI_MouseOverObjectID()
              IF ZD_GetObjectZorder(ID) > 2 THEN
                 ZD_SetObjectZorder(ID, ZD_GetObjectZorder(ID) - 1)
                 '// Update the matching sprite array member
                 gSprite(ID).zorder = ZD_GetObjectZorder(ID) '// The z-order value
                 ZI_UpdateWindow(gP.hCtrl, %FALSE)
              END IF
              FUNCTION = 0: EXIT FUNCTION

         CASE %IDM_BMP_Bottom
              ID = ZI_MouseOverObjectID()
              IF ZD_GetObjectZorder(ID) > 2 THEN
                 ZD_SetObjectZorder(ID, 2)
                 '// Update the matching sprite array member
                 gSprite(ID).zorder = ZD_GetObjectZorder(ID) '// The z-order value
                 ZI_UpdateWindow(gP.hCtrl, %FALSE)
              END IF
              FUNCTION = 0: EXIT FUNCTION

         CASE %IDM_BMP_Sprite_128x128
              GDImageSaveMiniature(zGetCTLText(hWnd), 128)
              FUNCTION = 0: EXIT FUNCTION

         CASE %IDM_BMP_Sprite_256x256
              GDImageSaveMiniature(zGetCTLText(hWnd), 256)
              FUNCTION = 0: EXIT FUNCTION

         CASE %IDM_BMP_Clone
              rZoomValue = ZI_GetZoomValue(gP.hCtrl) '// Get current Zoom value
              IF rZoomValue < 0.001 THEN rZoomValue = 1
              IDtoClone = ZI_MouseOverObjectID()

              NewID = IncrID() '// Increment ID and gSprite array
              ZD_GetObjectBound(IDtoClone, bmW, bmH)
              GetClientRect(gP.hCtrl, rc)
              x = (ZI_GetXscroll(gP.hCtrl) / rZoomValue) + (rc.nRight - bmW) \ 2
              y = (ZI_GetYscroll(gP.hCtrl) / rZoomValue) + (rc.nBottom - bmH) \ 2

              sUselabel = PARSE$(ZD_GetObjectImageLabel(IDtoClone), " (", 1) + " (" + NumToString(NewID) + ")"

              ZD_CloneObject(IDtoClone, NewID, x, y)
              ZD_SetObjectImageLabel(NewID, (sUseLabel))
              ZD_SetObjectScroll(NewID, %TRUE)
              ZD_UsePngOpacity(NewID, %TRUE)

              ZD_SetObjectZorder(NewID, %ZD_ORDER_TOP)
              GDImageCheckZorder()

              gSprite(NewID).filname = gSprite(IDtoClone).filname  '// Full path name to the sprite bitmap
              gSprite(NewID).varop = gSprite(IDtoClone).varop      '// Variable opacity
              SpriteArrayGet(NewID)                           '// Assign the ZOBJECT structure/type parameters to the Sprite array

              ZI_SetObjectFocusID(NewID)
              gP.nFocusID = NewID
              gP.rWasZoom = 0: gP.nWasAlpha = 0

              ZI_UpdateWindow(gP.hCtrl, %FALSE) '// Show new sprite
              FUNCTION = 0: EXIT FUNCTION


         CASE %IDM_BMP_Lock
              ID = ZI_MouseOverObjectID()
              IF ZD_GetObjectLocked(ID) THEN
                 ZD_SetObjectLocked(ID, %FALSE)
              ELSE
                 ZD_SetObjectLocked(ID, %TRUE)
              END IF
              FUNCTION = 0: EXIT FUNCTION

         CASE %IDM_BMP_Delete
              GDImageDeleteObject()
              FUNCTION = 0: EXIT FUNCTION

         END SELECT

    CASE %WM_SIZE
         EnumChildWindows(hWnd, CODEPTR(AnchorEnum), 0)
         zDrawBackground()

    CASE %WM_SETTEXT
         '// Windows please do your job first.
         FUNCTION = DefWindowProc(hWnd, Msg, wParam, lParam)
         '// Update caption
         zPaintBackground(0)
         '// Repaint only the caption.
         GetClientRect(hWnd, rc)
         zGetImageSize(zGetProperty(hWnd, %FORM_TopMid), 0, rc.nBottom)
         InvalidateRect(hWnd, rc, 0)
         UpdateWindow(hWnd)
         EXIT FUNCTION

    CASE %WM_NCLBUTTONDBLCLK
         IF IsIconic(hWnd) = 0 THEN
            LOCAL CaptionHeight AS LONG, p AS POINTAPI
            p.X = LO(INTEGER, lParam): p.Y = HI(INTEGER, lParam)
            ScreenToClient(hWnd, p)
            zGetImageSize(zGetProperty(hWnd, %FORM_TopMid), 0, CaptionHeight)
            IF p.Y < CaptionHeight THEN
               IF IsZoomed(hWnd) THEN
                  zButtonSysCommand(hWnd, MAKLNG(%ID_RESTORE, 0))
               ELSE
                  zButtonSysCommand(hWnd, MAKLNG(%ID_MAXIMIZE, 0))
               END IF
               FUNCTION = 0: EXIT FUNCTION
            END IF
         END IF

    CASE %WM_NCACTIVATE
         LOCAL hBut AS LONG
         hBut = GetDlgItem(hWnd, %ID_LED)
         IF hBut THEN
'           // Windows please do your job first.
            FUNCTION = DefWindowProc(hWnd, Msg, wParam, lParam)
            IF zMainWindow(0) = GetForegroundWindow THEN
               gColorCaption = SK_ACTIVECAPTION()
            ELSE
               gColorCaption = SK_INACTIVECAPTION()
            END IF
'           // Update caption
            zPaintBackground(0)

'           // Repaint only the caption.
            GetClientRect(hWnd, rc)
            zGetImageSize(zGetProperty(hWnd, %FORM_TopMid), 0, rc.nBottom)
            InvalidateRect(hWnd, rc, 0)
'           // Invalidate also the LED
            InvalidateRect(hBut, BYVAL %NULL, 0)

            UpdateWindow(hWnd)

            EXIT FUNCTION
         END IF

    CASE %WM_ERASEBKGND
         'FUNCTION = 1: EXIT FUNCTION

    CASE %WM_PAINT
         BeginPaint(hWnd, ps)
         zPaintDoubleBuffer(hWnd, ps.hDC)
         EndPaint(hWnd, ps)
         FUNCTION = 0: EXIT FUNCTION

    CASE %WM_DESTROY
         '// Remove all image resource from memory
         '// Must be done just before to exit the main program in case zAddResource
         '// has been used to store image handles that are not tied to a specific control.
         '// For example: Image used in an ownerdrawn menu.
         zRemoveAllImageResource()

         '// Delete Image, Bitmap and DC matching this window
         zDestroyWindowResource(hWnd)

         PostQuitMessage(0)
         FUNCTION = 0: EXIT FUNCTION

    END SELECT

    FUNCTION = zDefWindowProc(hWnd, Msg, wParam, lParam)

END FUNCTION

'// We use a callback to monitor messages from the GDImage control
SUB GDImageEnableEvents()
    LOCAL cpCallBack AS DWORD
    cpCallBack = CODEPTR(GDImageCallBack)
    ZI_EventMessage(cpCallBack, %WM_LBUTTONDOWN, %TRUE)
    ZI_EventMessage(cpCallBack, %WM_LBUTTONDBLCLK, %TRUE)
    ZI_EventMessage(cpCallBack, %WM_RBUTTONDOWN, %TRUE)
    ZI_EventMessage(cpCallBack, %WM_KEYDOWN, %TRUE)
    ZI_EventMessage(cpCallBack, %WM_MOUSEMOVE, %TRUE)
    ZI_EventMessage(cpCallBack, %WM_NCHITTEST, %TRUE)
    ZI_EventMessage(cpCallBack, %WM_MOUSEWHEEL, %TRUE)
END SUB

'// Setup messages to match the host computer language
SUB GDImageSetupLanguage(BYVAL nIsFrench AS LONG)
    LOCAL hCtrl AS LONG, sHelpFile, sMessage AS STRING

    IF nIsFrench THEN
        gP.nUseFrench = nIsFrench
        sMessage = "Slectionne,Annule"
        gP.sBorder = "Cadre"
        gP.sBackground = "Arrire plan"
        gP.sFontBoxCaption = "Texte  diter"

        ShowWindow(zGetMainItem(%ID_BTN_English), %SW_HIDE)
        ShowWindow(zGetMainItem(%ID_BTN_French), %SW_SHOW)

        zSetToolTipText(zGetMainItem(%ID_BTN_Frame), "Affiche ou masque le cadre")
        zSetToolTipText(zGetMainItem(%ID_BTN_Border_Left), "Cadre prcdent")
        zSetToolTipText(zGetMainItem(%ID_BTN_Border_Right), "Cadre suivant")
        zSetToolTipText(zGetMainItem(%ID_BTN_Left), "Fond prcdent")
        zSetToolTipText(zGetMainItem(%ID_BTN_Play), "Jouer en boucle")
        zSetToolTipText(zGetMainItem(%ID_BTN_Print), "Imprimer")
        zSetToolTipText(zGetMainItem(%ID_BTN_Right), "Fond suivant")
        zSetToolTipText(zGetMainItem(%ID_BTN_Save), "Enregistrer la PhotoComposition")
        zSetToolTipText(zGetMainItem(%ID_BTN_Select), "Choisir une image de fond")
        zSetToolTipText(zGetMainItem(%ID_BTN_Stop), "Fermer")
        zSetToolTipText(zGetMainItem(%ID_BTN_Tray), "Envoyer l'image de fond dans la corbeille")
        zSetToolTipText(zGetMainItem(%ID_BTN_Crop), "Dlimiter une section")
        zSetToolTipText(zGetMainItem(%ID_BTN_TrueSize), "Taille relle")
        zSetToolTipText(zGetMainItem(%ID_CHECK_FootNote), "Affiche ou masque la signature")
        zSetToolTipText(zGetMainItem(%ID_CHECK_Stamp), "Affiche ou masque le timbre")
        zSetCTLText(zGetMainItem(%ID_CHECK_Stamp), "Timbre")
        zSetToolTipText(zGetMainItem(%ID_CHECK_Title), "Affiche ou masque le titre")
        zSetCTLText(zGetMainItem(%ID_CHECK_Title), "Titre")
        zSetToolTipText(zGetMainItem(%ID_TRACK_PlayList), "Recherche")
        zSetToolTipText(zGetMainItem(%ID_TRACK_Delay), "Vitesse de dfilement")
        zSetToolTipText(zGetMainItem(%ID_TRACK_Zoom), "Zoom numrique")
        zSetToolTipText(zGetMainItem(%ID_TRACK_Alpha), "Rglage de la transparence")

        zSetToolTipText(zGetMainItem(%ID_BTN_Send), "Envoyer en carte postale")
        zSetToolTipText(zGetMainItem(%ID_BTN_French), "Bascule la langue de Franais en Anglais (English)")
        zSetToolTipText(zGetMainItem(%ID_BTN_User), "Cliquer ici pour consulter ou fermer le mode d'emploi")
        zSetToolTipText(zGetMainItem(%ID_BTN_Image), "Ajouter une image")
        zSetToolTipText(zGetMainItem(%ID_BTN_Anotate), "Ajouter une annotation")
        zSetToolTipText(zGetMainItem(%ID_BTN_Icon), "Ajouter une icne")
        zSetToolTipText(zGetMainItem(%ID_BTN_Script_Load), "Relit un script PCS (PhotoComposer Script)")
        zSetToolTipText(zGetMainItem(%ID_BTN_Script_Save), "Enregistre au format PCS (PhotoComposer Script)")
        zSetToolTipText(zGetMainItem(%ID_CHECK_Quality), "Utilise rchantillonage bicubic (plus lent)")
        zSetCTLText(zGetMainItem(%ID_CHECK_Quality), "Affichage haute qualit")
        zSetToolTipText(zGetMainItem(%ID_BTN_Opacity), "Ajouter une image en mode opacit variable")

        zSetCTLText(zGetMainItem(%ID_CHECK_Tootltip), "Bulle d'aide sur image")
        zSetToolTipText(zGetMainItem(%ID_CHECK_Tootltip), "Affiche le nom de l'objet graphique survol par la souris")

        sHelpFile = gP.sResources + "HELP_fr.rtf"

        gP.sWebPage = "http://www.zapsolution.com/zmsidxfr.htm"

    ELSE
        gP.nUseFrench = nIsFrench
        sMessage = "Select,Cancel"
        gP.sBorder = "Frame"
        gP.sBackground = "Background"
        gP.sFontBoxCaption = "Text to edit"

        ShowWindow(zGetMainItem(%ID_BTN_French), %SW_HIDE)
        ShowWindow(zGetMainItem(%ID_BTN_English), %SW_SHOW)

        zSetToolTipText(zGetMainItem(%ID_BTN_Frame), "Show or hide the frame")
        zSetToolTipText(zGetMainItem(%ID_BTN_Border_Left), "Previous frame")
        zSetToolTipText(zGetMainItem(%ID_BTN_Border_Right), "Next frame")
        zSetToolTipText(zGetMainItem(%ID_BTN_Left), "Previous background")
        zSetToolTipText(zGetMainItem(%ID_BTN_Play), "Play loop mode")
        zSetToolTipText(zGetMainItem(%ID_BTN_Print), "Print")
        zSetToolTipText(zGetMainItem(%ID_BTN_Right), "Next background")
        zSetToolTipText(zGetMainItem(%ID_BTN_Save), "Save PhotoComposition")
        zSetToolTipText(zGetMainItem(%ID_BTN_Select), "Select background picture")
        zSetToolTipText(zGetMainItem(%ID_BTN_Stop), "Close")
        zSetToolTipText(zGetMainItem(%ID_BTN_Tray), "Move the background image to tray")
        zSetToolTipText(zGetMainItem(%ID_BTN_Crop), "Delimit crop section")
        zSetToolTipText(zGetMainItem(%ID_BTN_TrueSize), "True size")
        zSetToolTipText(zGetMainItem(%ID_CHECK_FootNote), "Show or hide the signature")
        zSetToolTipText(zGetMainItem(%ID_CHECK_Stamp), "Show or hide the stamp")
        zSetCTLText(zGetMainItem(%ID_CHECK_Stamp), "Stamp")
        zSetToolTipText(zGetMainItem(%ID_CHECK_Title), "Show or hide the title")
        zSetCTLText(zGetMainItem(%ID_CHECK_Title), "Title")
        zSetToolTipText(zGetMainItem(%ID_TRACK_PlayList), "Search")
        zSetToolTipText(zGetMainItem(%ID_TRACK_Delay), "Slide show delay")
        zSetToolTipText(zGetMainItem(%ID_TRACK_Zoom), "Zooming")
        zSetToolTipText(zGetMainItem(%ID_TRACK_Alpha), "Opacity level")

        zSetToolTipText(zGetMainItem(%ID_BTN_Send), "Send postcard")
        zSetToolTipText(zGetMainItem(%ID_BTN_English), "Switch language from English to French (Franais)")
        zSetToolTipText(zGetMainItem(%ID_BTN_User), "Click here to read or close the help file")
        zSetToolTipText(zGetMainItem(%ID_BTN_Image), "Add picture")
        zSetToolTipText(zGetMainItem(%ID_BTN_Anotate), "Add annotation")
        zSetToolTipText(zGetMainItem(%ID_BTN_Icon), "Add icon")
        zSetToolTipText(zGetMainItem(%ID_BTN_Script_Load), "Load a PCS file (PhotoComposer Scipt)")
        zSetToolTipText(zGetMainItem(%ID_BTN_Script_Save), "Save as a PCS file (PhotoComposer Script)")
        zSetToolTipText(zGetMainItem(%ID_CHECK_Quality), "Switch interpolation to bicubic mode (slower)")
        zSetCTLText(zGetMainItem(%ID_CHECK_Quality), "Use high quality display")
        zSetToolTipText(zGetMainItem(%ID_BTN_Opacity), "Add picture using variable opacity")

        zSetCTLText(zGetMainItem(%ID_CHECK_Tootltip), "Tooltip hover image")
        zSetToolTipText(zGetMainItem(%ID_CHECK_Tootltip), "Show object's name while mouse hover image section")

        sHelpFile = gP.sResources + "HELP_us.rtf"

        gP.sWebPage = "http://www.zapsolution.com/zmsidxus.htm"

    END IF

    ZI_SetCropPopupText((sMessage))
    zSetToolTipText(zGetMainItem(%ID_BTN_Pause), "Pause")
    zSetCTLText(zGetMainItem(%ID_CHECK_FootNote), "Signature")
'
    zSetToolTipText(zGetMainItem(%ID_BTN_About), ("Copyright (c) " + RIGHT$(DATE$, 4) + " Patrice Terrier"))
'
    hCtrl = zGetMainItem(%ID_RICHEDIT)
    IF hCtrl THEN RichLoadFromFile(hCtrl, (sHelpFile))

END SUB

SUB ButtonBlink(BYVAL ID AS LONG, BYVAL nStop AS LONG)
    LOCAL hBut, Img, hDC, graphics, UseTimer AS LONG
    LOCAL rw AS RECT
    LOCAL lp AS POINTAPI
    STATIC UseState AS LONG
    INCR gP.nBlinkCount
    hBut = zGetMainItem(ID) ' // %ID_BTN_Select
    Img = zGetButImageBackProperty(hBut)
    GetWindowRect(hBut, rw)
    lp.x = rw.nLeft: lp.y = rw.nTop
    ScreenToClient(zMainwindow(0), lp)
    IF UseState < 5 THEN UseState = 5 ELSE UseState = 1
    IF nStop THEN UseState = 1
    hDC = GetDC(zMainwindow(0))
    IF GdipCreateFromHDC(hDC, graphics) = 0 THEN
       zPaintButton(graphics, UseState, Img, lp.X, lp.Y, rw.nRight - rw.nLeft, rw.nBottom - rw.nTop, %BS_PUSHBUTTON, 0)
       GdipDeleteGraphics(graphics)
    END IF
    ReleaseDC(zMainwindow(0), hDC)
    IF ID = %ID_BTN_User THEN
       UseTimer = %BLINK_USER: gP.nBlinkCount = 1
    ELSE
       UseTimer = %BLINK_TIMER
    END IF
    IF gP.nBlinkCount > 29 OR nStop THEN
       gP.nBlinkCount = 0: KillTimer(zMainWindow(0), UseTimer)
    END IF
END SUB

