'+--------------------------------------------------------------------------+
'|                                 zSkin                                    |
'|                                                                          |
'|                  Set/Get the skin component properties.                  |
'|                                                                          |
'+--------------------------------------------------------------------------+
'|                                                                          |
'|                         Author Patrice TERRIER                           |
'|                            copyright(c) 2011                             |
'|                           www.zapsolution.com                            |
'|                        pterrier@zapsolution.com                          |
'|                                                                          |
'|  If you are not a registered user of GDImage, then you are not allowed   |
'|  to produce derivated work or any translation of this code to another    |
'|  language, without the written permission of the author.                 |
'|                                                                          |
'+--------------------------------------------------------------------------+
'|                  Project started on : 08-04-2007 (MM-DD-YYYY)            |
'|                        Last revised : 07-30-2011 (MM-DD-YYYY)            |
'+--------------------------------------------------------------------------+

'-----------------------------------------------------------------
' Equates
'-----------------------------------------------------------------
'''''''''''''''''''''''''''''''''''''''''
%ZS_TextHorzUp = 0          ' Horizontal text orientation
%ZS_TextVertUp = 4          ' Vertical text orientation from bottom to top
%ZS_TextVertDn = 8          ' Vertical text orientation from top to bottom

%VK_LSHIFT                                      = &HA0
%VK_RSHIFT                                      = &HA1
%VK_LCONTROL                                    = &HA2
%VK_RCONTROL                                    = &HA3
%VK_LMENU                                       = &HA4
%VK_RMENU                                       = &HA5
%VK_LALT                                        = %VK_LMENU
%VK_RALT                                        = %VK_RMENU
%VK_LCTRL                                       = %VK_LCONTROL
%VK_RCTRL                                       = %VK_RCONTROL
%WM_SYSKEYDOWN                                  = &H104
%WM_UPDATEUISTATE                               = &H0128

%VK_F1                                          = &H70

%SB_BOTH                                        = 3
%IDC_ARROW                                      = 32512&
%IDC_WAIT                                       = 32514&
%WINAPI                                         = 1
%TRUE                                           = 1
%FALSE                                          = 0
%WRITE                                          = %TRUE
%READ                                           = %FALSE
%NULL                                           = 0
%RGN_AND                                        = 1
%RGN_XOR                                        = 3
%WM_QUIT                                        = &H12
%WM_USER                                        = &H400
%WM_SETREDRAW                                   = &HB
%ERROR_ALREADY_EXISTS                           = 183
%LOCALE_USER_DEFAULT                            = &H0400&
%LOCALE_SENGLANGUAGE                            = &H00001001   ' English name of language
%MAX_PATH                                       = 260  ' max. length of full pathname
%SRCCOPY                                        = &H00CC0020 ' (DWORD) dest = source
%BI_RGB                                         = 0&
%RGN_OR                                         = 2
%RDH_RECTANGLES                                 = 1
%ANSI_VAR_FONT                                  = 12
%DIB_RGB_COLORS                                 = 0 ' color table in RGBs
%CCHDEVICENAME                                  = 32
%CCHFORMNAME                                    = 32
%GRADIENT_FILL_RECT_H                           = &H00000000
%GRADIENT_FILL_RECT_V                           = &H00000001
%PRF_CHECKVISIBLE                               = &H00000001&
%PRF_OWNED                                      = &H00000020&
%PRF_NONCLIENT                                  = &H00000002&
%PRF_CLIENT                                     = &H00000004&
%PRF_CHILDREN                                   = &H00000010&
%BDR_RAISEDOUTER                                = &H0001
%BDR_RAISEDINNER                                = &H0004
%EDGE_RAISED                                    = %BDR_RAISEDOUTER OR %BDR_RAISEDINNER
%BF_LEFT                                        = &H0001
%BF_TOP                                         = &H0002
%BF_RIGHT                                       = &H0004
%BF_BOTTOM                                      = &H0008
%BF_RECT                                        = %BF_LEFT OR %BF_TOP OR %BF_RIGHT OR %BF_BOTTOM
%BS_LEFT                                        = &H100&
%BS_VCENTER                                     = &HC00&
%BM_GETCHECK                                    = &HF0
%BM_SETCHECK                                    = &HF1
%COLORONCOLOR                                   = 3
%HALFTONE                                       = 4
%SW_HIDE                                        = 0
%SW_MAXIMIZE                                    = 3
%SW_SHOW                                        = 5
%SW_MINIMIZE                                    = 6
%SW_RESTORE                                     = 9
%WM_COPYDATA                                    = &H4A
%WM_DESTROY                                     = &H2
%WM_MOVE                                        = &H3
%WM_SIZE                                        = &H5
%WM_SIZING                                      = &H214
%WM_MOVING                                      = &H216
%WM_SETREDRAW                                   = &HB
%WM_PAINT                                       = &HF
%WM_CLOSE                                       = &H10
%WM_ERASEBKGND                                  = &H14
%WM_GETMINMAXINFO                               = &H24
%WM_SETFONT                                     = &H30
%WM_NCHITTEST                                   = &H084
%WM_NCPAINT                                     = &H85
%WM_NCACTIVATE                                  = &H86
%WM_COMMAND                                     = &H111
%WM_PRINT                                       = &H317
%WM_PRINTCLIENT                                 = &H318
%WM_SETTEXT                                     = &HC
%WM_NCLBUTTONDOWN                               = &H0A1
%WM_NCLBUTTONDBLCLK                             = &H0A3

%WM_MOUSEMOVE                                   = &H200
%WM_LBUTTONDOWN                                 = &H201
%WM_LBUTTONUP                                   = &H202
%WM_LBUTTONDBLCLK                               = &H203
%WM_RBUTTONDOWN                                 = &H204
%WM_RBUTTONUP                                   = &H205
%WM_RBUTTONDBLCLK                               = &H206
%WM_MBUTTONDOWN                                 = &H207
%WM_MBUTTONUP                                   = &H208
%WM_MBUTTONDBLCLK                               = &H209
%WM_MOUSEWHEEL                                  = &H20A
%WM_XBUTTONDOWN                                 = &H20B
%WM_XBUTTONUP                                   = &H20C
%WM_XBUTTONDBLCLK                               = &H20D

%WM_KEYDOWN                                     = &H100
%WM_KEYUP                                       = &H101
%WM_CHAR                                        = &H102
%WM_DEADCHAR                                    = &H103
%WM_SYSKEYDOWN                                  = &H104
%WM_SYSKEYUP                                    = &H105
%WM_SYSCHAR                                     = &H106
%WM_SYSDEADCHAR                                 = &H107
%WM_UNICHAR                                     = &H0109

%WM_TIMER                                       = &H113
%WM_DRAWITEM                                    = &H2B
%WM_MEASUREITEM                                 = &H2C
%BST_UNCHECKED                                  = &H00
%BST_CHECKED                                    = &H01
%BST_INDETERMINATE                              = &H02
%HTNOWHERE                                      = 0
%HTCLIENT                                       = 1
%HTCAPTION                                      = 2
%HTLEFT                                         = 10
%HTRIGHT                                        = 11
%HTTOP                                          = 12
%HTTOPLEFT                                      = 13
%HTTOPRIGHT                                     = 14
%HTBOTTOM                                       = 15
%HTBOTTOMLEFT                                   = 16
%HTBOTTOMRIGHT                                  = 17
%LWA_COLORKEY                                   = &H00000001
%LWA_ALPHA                                      = &H00000002
%WS_POPUP                                       = &H80000000
%WS_CHILD                                       = &H40000000
%WS_VISIBLE                                     = &H10000000
%WS_CLIPSIBLINGS                                = &H04000000
%WS_CLIPCHILDREN                                = &H02000000
%WS_TABSTOP                                     = &H00010000
%WS_DISABLED                                    = &H08000000
%WS_EX_TRANSPARENT                              = &H00000020
%WS_EX_COMPOSITED                               = &H02000000
%WS_EX_LAYERED                                  = &H00080000
%CS_DROPSHADOW                                  = &H00020000
%CS_VREDRAW                                     = &H1
%CS_HREDRAW                                     = &H2
%CS_DBLCLKS                                     = &H8
%CS_PARENTDC                                    = &H80
%PM_REMOVE                                      = &H0001
%CW_USEDEFAULT                                  = &H80000000&
%SM_CXSCREEN                                    = 0
%SM_CYSCREEN                                    = 1
%COLOR_INFOTEXT                                 = 23
%COLOR_INFOBK                                   = 24
%GWL_EXSTYLE                                    = -20
%SS_CENTER                                      = &H00000001
%MK_LBUTTON                                     = &H0001
%FORMAT_MESSAGE_FROM_SYSTEM                     = &H1000
%TTS_ALWAYSTIP                                  = &H0001
%TTF_IDISHWND                                   = &H00000001
%TTF_SUBCLASS                                   = &H00000010
%TTM_ADDTOOL                                    = %WM_USER +  4
%TTM_GETTEXT                                    = %WM_USER + 11
%TTM_UPDATETIPTEXT                              = %WM_USER + 12
%TTM_SETTIPBKCOLOR                              = %WM_USER + 19
%TTM_SETTIPTEXTCOLOR                            = %WM_USER + 20
%TTM_SETMAXTIPWIDTH                             = %WM_USER + 24

%SWP_NOSIZE         = &H0001
%SWP_NOMOVE         = &H0002
%SWP_NOZORDER       = &H0004
%SWP_NOREDRAW       = &H0008
%SWP_NOACTIVATE     = &H0010
%SWP_FRAMECHANGED   = &H0020  ' The frame changed: send WM_NCCALCSIZE
%SWP_SHOWWINDOW     = &H0040
%SWP_HIDEWINDOW     = &H0080
%SWP_NOCOPYBITS     = &H0100
%SWP_NOOWNERZORDER  = &H0200  ' Don't do owner Z ordering
%SWP_NOSENDCHANGING = &H0400  ' Don't send WM_WINDOWPOSCHANGING
%SWP_DRAWFRAME      = %SWP_FRAMECHANGED
%SWP_NOREPOSITION   = %SWP_NOOWNERZORDER
%SWP_DEFERERASE     = &H2000
%SWP_ASYNCWINDOWPOS = &H4000
%HWND_TOP           = 0
%HWND_BOTTOM        = 1
%HWND_TOPMOST       = -1
%HWND_NOTOPMOST     = -2
%HWND_MESSAGE       = -3

%TPM_RETURNCMD                                  = &H0100&
%MF_BYCOMMAND                                   = &H0&
%MF_BYPOSITION                                  = &H400&
%MF_SEPARATOR                                   = &H800&
%MF_ENABLED                                     = &H0&
%MF_GRAYED                                      = &H1&
%MF_UNCHECKED                                   = &H0&
%MF_CHECKED                                     = &H8&
%MF_STRING                                      = &H0&
%MF_POPUP                                       = &H10&

%ODT_MENU                                       = 1
%ODT_LISTBOX                                    = 2
%ODT_COMBOBOX                                   = 3
%ODT_BUTTON                                     = 4
%ODS_SELECTED                                   = &H0001
%ODS_GRAYED                                     = &H0002
%ODS_CHECKED                                    = &H0008
%ODS_FOCUS                                      = &H0010

%ETO_GRAYED                                     = 1
%ETO_OPAQUE                                     = 2

%COLOR_MENU                                     = 4
%COLOR_MENUTEXT                                 = 7
%COLOR_HIGHLIGHT                                = 13
%COLOR_HIGHLIGHTTEXT                            = 14
%COLOR_GRAYTEXT                                 = 17

%MF_OWNERDRAW                                   = &H100&

%FO_MOVE                                        = 1
%FO_COPY                                        = 2
%FOF_SILENT                                     = &H00004  ' don't create progress/report
%FOF_NOCONFIRMATION                             = &H00010  ' Don't prompt the user.
%FOF_SIMPLEPROGRESS                             = &H00100  ' means don't show names of files
%FOF_NOCONFIRMMKDIR                             = &H00200  ' don't confirm making any needed dirs

'-----------------------------------------------------------------
' TYPE and UNION structures:  15
'-----------------------------------------------------------------
TYPE SIZEL
    cx AS LONG
    cy AS LONG
END TYPE

TYPE BLENDFUNCTION
    BlendOp AS BYTE
    BlendFlags AS BYTE
    SourceConstantAlpha AS BYTE
    AlphaFormat AS BYTE
END TYPE

TYPE POINTS
    x AS INTEGER
    y AS INTEGER
END TYPE

TYPE COPYDATASTRUCT
    dwData AS DWORD
    cbData AS DWORD
    lpData AS DWORD
END TYPE

TYPE RECTF
    nLEFT   AS SINGLE
    nTop    AS SINGLE
    nRIGHT  AS SINGLE
    nBottom AS SINGLE
END TYPE

TYPE RECT
    nLeft AS LONG
    nTop AS LONG
    nRight AS LONG
    nBottom AS LONG
END TYPE

TYPE MEASUREITEMSTRUCT
    CtlType AS DWORD
    CtlID AS DWORD
    itemID AS DWORD
    itemWidth AS DWORD
    itemHeight AS DWORD
    itemData AS DWORD
END TYPE

TYPE DRAWITEMSTRUCT
    CtlType AS DWORD
    CtlID AS DWORD
    itemID AS DWORD
    itemAction AS DWORD
    itemState AS DWORD
    hwndItem AS LONG
    hDC AS DWORD
    rcItem AS RECT
    itemData AS DWORD
END TYPE

TYPE POINTAPI
    x AS LONG
    y AS LONG
END TYPE

TYPE tagMSG
    hwnd AS DWORD
    message AS DWORD
    wParam AS LONG
    lParam AS LONG
    time AS DWORD
    pt AS POINTAPI
END TYPE

TYPE SECURITY_ATTRIBUTES
    nLength AS DWORD
    lpSecurityDescriptor AS LONG
    bInheritHandle AS LONG
END TYPE

TYPE FILETIME
    dwLowDateTime AS DWORD
    dwHighDateTime AS DWORD
END TYPE

TYPE OVERLAPPED
    Internal AS DWORD
    InternalHigh AS DWORD
    offset AS DWORD
    OffsetHigh AS DWORD
    hEvent AS DWORD
END TYPE

TYPE WNDCLASSEX
    cbSize AS DWORD
    STYLE AS DWORD
    lpfnWndProc AS LONG
    cbClsExtra AS LONG
    cbWndExtra AS LONG
    hInstance AS DWORD
    hIcon AS DWORD
    hCursor AS DWORD
    hbrBackground AS DWORD
    lpszMenuName AS ASCIIZ PTR
    lpszClassName AS ASCIIZ PTR
    hIconSm AS DWORD
END TYPE

TYPE WIN32_FIND_DATA
    dwFileAttributes AS DWORD
    ftCreationTime AS FILETIME
    ftLastAccessTime AS FILETIME
    ftLastWriteTime AS FILETIME
    nFileSizeHigh AS DWORD
    nFileSizeLow AS DWORD
    dwReserved0 AS DWORD
    dwReserved1 AS DWORD
    cFileName AS ASCIIZ * %MAX_PATH
    cAlternateFileName AS ASCIIZ * 14
END TYPE

TYPE RGBQUAD
    rgbBlue AS BYTE
    rgbGreen AS BYTE
    rgbRed AS BYTE
    rgbReserved AS BYTE
END TYPE

TYPE BITMAPINFOHEADER
    biSize AS DWORD
    biWidth AS LONG
    biHeight AS LONG
    biPlanes AS WORD
    biBitCount AS WORD
    biCompression AS DWORD
    biSizeImage AS DWORD
    biXPelsPerMeter AS LONG
    biYPelsPerMeter AS LONG
    biClrUsed AS DWORD
    biClrImportant AS DWORD
END TYPE

TYPE RGNDATAHEADER
    dwSize AS DWORD
    iType AS DWORD
    nCount AS DWORD
    nRgnSize AS DWORD
    rcBound AS RECT
END TYPE

TYPE MYBITMAPINFO
    bmiHeader AS BITMAPINFOHEADER
    bmiColors(256) AS RGBQUAD ' Patrice
END TYPE

TYPE BITMAP
    bmType AS LONG
    bmWidth AS LONG
    bmHeight AS LONG
    bmWidthBytes AS LONG
    bmPlanes AS WORD
    bmBitsPixel AS WORD
    bmBits AS BYTE PTR
END TYPE

TYPE TRIVERTEX
    x AS LONG
    y AS LONG
    Red AS WORD
    Green AS WORD
    Blue AS WORD
    Alpha AS WORD
END TYPE

TYPE GRADIENT_RECT
    UpperLeft AS DWORD
    LowerRight AS DWORD
END TYPE

TYPE MINMAXINFO
    ptReserved AS POINTAPI
    ptMaxSize AS POINTAPI
    ptMaxPosition AS POINTAPI
    ptMinTrackSize AS POINTAPI
    ptMaxTrackSize AS POINTAPI
END TYPE

TYPE PAINTSTRUCT
    hDC AS DWORD
    fErase AS LONG
    rcPaint AS RECT
    fRestore AS LONG
    fIncUpdate AS LONG
    rgbReserved(0 TO 31) AS BYTE
END TYPE

TYPE DEVMODE
  dmDeviceName AS ASCIIZ * %CCHDEVICENAME
  dmSpecVersion AS WORD
  dmDriverVersion AS WORD
  dmSize AS WORD
  dmDriverExtra AS WORD
  dmFields AS DWORD
  dmOrientation AS INTEGER
  dmPaperSize AS INTEGER
  dmPaperLength AS INTEGER
  dmPaperWidth AS INTEGER
  dmScale AS INTEGER
  dmCopies AS INTEGER
  dmDefaultSource AS INTEGER
  dmPrintQuality AS INTEGER
  dmColor AS INTEGER
  dmDuplex AS INTEGER
  dmYResolution AS INTEGER
  dmTTOption AS INTEGER
  dmCollate AS INTEGER
  dmFormName AS ASCIIZ * %CCHFORMNAME
  dmLogPixels AS WORD
  dmBitsPerPel AS DWORD
  dmPelsWidth AS DWORD
  dmPelsHeight AS DWORD
  dmDisplayFlags AS DWORD
  dmDisplayFrequency AS DWORD
  dmICMMethod AS DWORD
  dmICMIntent AS DWORD
  dmMediaType AS DWORD
  dmDitherType AS DWORD
  dmICCManufacturer AS DWORD
  dmICCModel AS DWORD
  dmPanningWidth AS DWORD
  dmPanningHeight AS DWORD
END TYPE

TYPE TOOLINFO
  cbSize AS DWORD
  uFlags AS DWORD
  hwnd AS DWORD
  uId AS DWORD
  rec AS RECT
  hinst AS DWORD
  lpszText AS ASCIIZ PTR
  lParam AS LONG
  lpReserved AS DWORD
END TYPE

' Custom types
TYPE COLORBYTES
    B AS BYTE
    G AS BYTE
    R AS BYTE
    A AS BYTE
END TYPE

TYPE COLORLONG
   longval AS LONG
END TYPE

TYPE TPMPARAMS
    cbSize AS DWORD
    rcExclude AS RECT
END TYPE

TYPE SHFILEOPSTRUCT
    hwnd AS DWORD
    wFunc AS DWORD
    pFrom AS ASCIIZ PTR
    pTo AS ASCIIZ PTR
    fFlags AS WORD
    fAnyOperationsAborted AS LONG
    hNameMappings AS DWORD
    lpszProgressTitle AS ASCIIZ PTR  ' only used if FOF_SIMPLEPROGRESS
END TYPE

'-----------------------------------------------------------------
' Declared Functions:
'-----------------------------------------------------------------
DECLARE FUNCTION UpdateLayeredWindow LIB "USER32.DLL" ALIAS "UpdateLayeredWindow" (BYVAL DWORD, BYVAL DWORD, pptDst AS POINTAPI, psize AS SIZEL, BYVAL DWORD, pptSrc AS POINTAPI, BYVAL DWORD, pblend AS BLENDFUNCTION, BYVAL DWORD) AS LONG
DECLARE FUNCTION SetLayeredWindowAttributes LIB "USER32.DLL" ALIAS "SetLayeredWindowAttributes" (BYVAL hwnd AS DWORD, BYVAL crKey AS DWORD, BYVAL bAlpha AS BYTE, BYVAL dwFlags AS DWORD) AS LONG
DECLARE FUNCTION SetCurrentDirectory LIB "KERNEL32.DLL" ALIAS "SetCurrentDirectoryA" (BYREF ASCIIZ) AS LONG
DECLARE FUNCTION SetFileAttributes LIB "KERNEL32.DLL" ALIAS "SetFileAttributesA" (lpFileName AS ASCIIZ, BYVAL dwFileAttributes AS DWORD) AS LONG
DECLARE FUNCTION DeleteFile LIB "KERNEL32.DLL" ALIAS "DeleteFileA" (lpFileName AS ASCIIZ) AS LONG
DECLARE FUNCTION SHFileOperation LIB "SHELL32.DLL" ALIAS "SHFileOperationA" (lpFileOp AS SHFILEOPSTRUCT) AS LONG
DECLARE SUB MoveMemory LIB "KERNEL32.DLL" ALIAS "RtlMoveMemory" (pDestination AS ANY, pSource AS ANY, BYVAL cbLength AS LONG)
DECLARE FUNCTION GetClassName LIB "USER32.DLL" ALIAS "GetClassNameA" (BYVAL hwnd AS DWORD, lpClassName AS ASCIIZ, BYVAL nMaxCount AS LONG) AS LONG
DECLARE FUNCTION LockWindowUpdate LIB "USER32.DLL" ALIAS "LockWindowUpdate" (BYVAL hWndLock AS DWORD) AS LONG
DECLARE FUNCTION BeginDeferWindowPos LIB "USER32.DLL" ALIAS "BeginDeferWindowPos" (BYVAL nNumWindows AS LONG) AS LONG
DECLARE FUNCTION DeferWindowPos LIB "USER32.DLL" ALIAS "DeferWindowPos" (BYVAL hWinPosInfo AS DWORD, BYVAL hWnd AS DWORD, BYVAL hWndInsertAfter AS DWORD, BYVAL x AS LONG, BYVAL y AS LONG, BYVAL cx AS LONG, BYVAL cy AS LONG, _
                 BYVAL wFlags AS DWORD) AS LONG
DECLARE FUNCTION EndDeferWindowPos LIB "USER32.DLL" ALIAS "EndDeferWindowPos" (BYVAL hWinPosInfo AS DWORD) AS LONG
DECLARE FUNCTION SetBkColor LIB "GDI32.DLL" ALIAS "SetBkColor" (BYVAL hdc AS DWORD, BYVAL crColor AS DWORD) AS DWORD
DECLARE FUNCTION SetTextColor LIB "GDI32.DLL" ALIAS "SetTextColor" (BYVAL hdc AS DWORD, BYVAL crColor AS DWORD) AS DWORD
DECLARE FUNCTION ExtTextOut LIB "GDI32.DLL" ALIAS "ExtTextOutA" (BYVAL hdc AS DWORD, BYVAL x AS LONG, BYVAL y AS LONG, BYVAL dwOptions AS DWORD, lpRect AS RECT, lpString AS ASCIIZ, BYVAL nCount AS DWORD, lpDx AS LONG) AS LONG
DECLARE FUNCTION GetMenuString LIB "USER32.DLL" ALIAS "GetMenuStringA" (BYVAL hMenu AS DWORD, BYVAL uIDItem AS DWORD, lpString AS ASCIIZ, BYVAL nMaxCount AS LONG, BYVAL uFlag AS DWORD) AS LONG
DECLARE FUNCTION CreatePopupMenu LIB "USER32.DLL" ALIAS "CreatePopupMenu" () AS LONG
DECLARE FUNCTION AppendMenu LIB "USER32.DLL" ALIAS "AppendMenuA" (BYVAL hMenu AS DWORD, BYVAL uFlags AS DWORD, BYVAL uIDNewItem AS DWORD, lpNewItem AS ASCIIZ) AS LONG
DECLARE FUNCTION InsertMenu LIB "USER32.DLL" ALIAS "InsertMenuA" (BYVAL hMenu AS DWORD, BYVAL dwPosition AS DWORD, BYVAL dwFlags AS DWORD, BYVAL dwIDNewItem AS DWORD, lpNewItem AS ASCIIZ) AS LONG
DECLARE FUNCTION TrackPopupMenuEx LIB "USER32.DLL" ALIAS "TrackPopupMenuEx" (BYVAL hMenu AS DWORD, BYVAL uFlags AS DWORD, BYVAL x AS LONG, BYVAL y AS LONG, BYVAL hWnd AS DWORD, lpTPMParams AS TPMPARAMS) AS LONG
DECLARE FUNCTION GetMenuItemCount LIB "USER32.DLL" ALIAS "GetMenuItemCount" (BYVAL hMenu AS DWORD) AS LONG
DECLARE FUNCTION EnableMenuItem LIB "USER32.DLL" ALIAS "EnableMenuItem" (BYVAL hMenu AS DWORD, BYVAL uIDEnableItem AS DWORD, BYVAL uEnable AS DWORD) AS LONG
DECLARE FUNCTION DeleteMenu LIB "USER32.DLL" ALIAS "DeleteMenu" (BYVAL hMenu AS DWORD, BYVAL nPosition AS LONG, BYVAL wFlags AS DWORD) AS LONG
DECLARE FUNCTION DestroyMenu LIB "USER32.DLL" ALIAS "DestroyMenu" (BYVAL hMenu AS DWORD) AS LONG
DECLARE FUNCTION DestroyWindow LIB "USER32.DLL" ALIAS "DestroyWindow" (BYVAL hWnd AS DWORD) AS LONG
DECLARE FUNCTION SetMenuItemBitmaps LIB "USER32.DLL" ALIAS "SetMenuItemBitmaps" (BYVAL hMenu AS DWORD, BYVAL nPosition AS LONG, BYVAL wFlags AS DWORD, BYVAL hBitmapUnchecked AS DWORD, BYVAL hBitmapChecked AS DWORD) AS LONG
DECLARE FUNCTION ShellExecute LIB "SHELL32.DLL" ALIAS "ShellExecuteA" (BYVAL hwnd AS DWORD, lpOperation AS ASCIIZ, lpFile AS ASCIIZ, lpParameters AS ASCIIZ, lpDirectory AS ASCIIZ, BYVAL nShowCmd AS LONG) AS DWORD
DECLARE FUNCTION SetCursor LIB "USER32.DLL" ALIAS "SetCursor" (BYVAL hCursor AS DWORD) AS DWORD
DECLARE FUNCTION GetDesktopWindow LIB "USER32.DLL" ALIAS "GetDesktopWindow" () AS LONG
DECLARE FUNCTION GetWindowDC LIB "USER32.DLL" ALIAS "GetWindowDC" (BYVAL hWnd AS DWORD) AS LONG
DECLARE FUNCTION ReleaseDC LIB "USER32.DLL" ALIAS "ReleaseDC" (BYVAL hWnd AS DWORD, BYVAL hDC AS DWORD) AS LONG
DECLARE FUNCTION GetStretchBltMode LIB "GDI32.DLL" ALIAS "GetStretchBltMode" (BYVAL hdc AS DWORD) AS LONG
DECLARE FUNCTION SetBrushOrgEx LIB "GDI32.DLL" ALIAS "SetBrushOrgEx" (BYVAL hdc AS DWORD, BYVAL nXOrg AS LONG, BYVAL nYOrg AS LONG, lppt AS POINTAPI) AS LONG
DECLARE FUNCTION SetStretchBltMode LIB "GDI32.DLL" ALIAS "SetStretchBltMode" (BYVAL hdc AS DWORD, BYVAL nStretchMode AS LONG) AS LONG
DECLARE FUNCTION StretchBlt LIB "GDI32.DLL" ALIAS "StretchBlt" (BYVAL hdc AS DWORD, BYVAL x AS LONG, BYVAL y AS LONG, BYVAL nWidth AS LONG, BYVAL nHeight AS LONG, BYVAL hSrcDC AS DWORD, BYVAL xSrc AS LONG, BYVAL ySrc AS LONG, _
                 BYVAL nSrcWidth AS LONG, BYVAL nSrcHeight AS LONG, BYVAL dwRop AS DWORD) AS LONG
DECLARE FUNCTION CreateRectRgn LIB "GDI32.DLL" ALIAS "CreateRectRgn" (BYVAL X1 AS LONG, BYVAL Y1 AS LONG, BYVAL X2 AS LONG, BYVAL Y2 AS LONG) AS DWORD
DECLARE FUNCTION GetWindowRgn LIB "USER32.DLL" ALIAS "GetWindowRgn" (BYVAL hWnd AS DWORD, BYVAL hRgn AS DWORD) AS LONG
DECLARE FUNCTION SelectClipRgn LIB "GDI32.DLL" ALIAS "SelectClipRgn" (BYVAL hdc AS DWORD, BYVAL hRgn AS DWORD) AS LONG
DECLARE FUNCTION CombineRgn LIB "GDI32.DLL" ALIAS "CombineRgn" (BYVAL hDestRgn AS DWORD, BYVAL hSrcRgn1 AS DWORD, BYVAL hSrcRgn2 AS DWORD, BYVAL nCombineMode AS LONG) AS LONG
DECLARE FUNCTION OffsetRgn LIB "GDI32.DLL" ALIAS "OffsetRgn" (BYVAL hRgn AS DWORD, BYVAL x AS LONG, BYVAL y AS LONG) AS LONG
DECLARE SUB      apiSleep LIB "KERNEL32.DLL" ALIAS "Sleep" (BYVAL dwMilliseconds AS DWORD)
DECLARE FUNCTION PostMessage LIB "USER32.DLL" ALIAS "PostMessageA" (BYVAL hWnd AS DWORD, BYVAL dwMsg AS DWORD, BYVAL wParam AS DWORD, BYVAL lParam AS LONG) AS LONG
DECLARE FUNCTION IsDialogMessage LIB "USER32.DLL" ALIAS "IsDialogMessageA" (BYVAL hDlg AS DWORD, lpMsg AS tagMSG) AS LONG
DECLARE FUNCTION GetVersionEx LIB "KERNEL32.DLL" ALIAS "GetVersionExA" (lpVersionInformation AS ANY) AS LONG
DECLARE FUNCTION GetDlgCtrlID LIB "USER32.DLL" ALIAS "GetDlgCtrlID" (BYVAL hWnd AS DWORD) AS LONG
DECLARE FUNCTION LoadIcon LIB "USER32.DLL" ALIAS "LoadIconA" (BYVAL hInstance AS DWORD, lpIconName AS ASCIIZ) AS DWORD
DECLARE FUNCTION MyCreateDIBSection LIB "GDI32.DLL" ALIAS "CreateDIBSection" (BYVAL hdc AS DWORD, pbmi AS MYBITMAPINFO, BYVAL dwUsage AS DWORD, BYVAL ppvBits AS DWORD, BYVAL hSection AS DWORD, BYVAL dwOffset AS DWORD) AS DWORD
DECLARE FUNCTION AdjustWindowRectEx LIB "USER32.DLL" ALIAS "AdjustWindowRectEx" (lpRect AS RECT, BYVAL dsStyle AS LONG, BYVAL bMenu AS LONG, BYVAL dwEsStyle AS DWORD) AS LONG
DECLARE FUNCTION BeginPaint LIB "USER32.DLL" ALIAS "BeginPaint" (BYVAL hWnd AS DWORD, lpPaint AS PAINTSTRUCT) AS LONG
DECLARE FUNCTION BitBlt LIB "GDI32.DLL" ALIAS "BitBlt" (BYVAL hDestDC AS DWORD, BYVAL x AS LONG, BYVAL y AS LONG, BYVAL nWidth AS LONG, BYVAL nHeight AS LONG, BYVAL hSrcDC AS DWORD, BYVAL xSrc AS LONG, BYVAL ySrc AS LONG, _
                 BYVAL dwRop AS DWORD) AS LONG
DECLARE FUNCTION CallWindowProc LIB "USER32.DLL" ALIAS "CallWindowProcA" (BYVAL lpPrevWndFunc AS DWORD, BYVAL hWnd AS DWORD, BYVAL uMsg AS DWORD, BYVAL wParam AS DWORD, BYVAL lParam AS LONG) AS LONG
DECLARE FUNCTION CloseHandle LIB "KERNEL32.DLL" ALIAS "CloseHandle" (BYVAL hObject AS DWORD) AS LONG
DECLARE FUNCTION CreateCompatibleDC LIB "GDI32.DLL" ALIAS "CreateCompatibleDC" (BYVAL hdc AS DWORD) AS DWORD
DECLARE FUNCTION CreateCompatibleBitmap LIB "GDI32.DLL" ALIAS "CreateCompatibleBitmap" (BYVAL hdc AS DWORD, BYVAL nWidth AS LONG, BYVAL nHeight AS LONG) AS DWORD
DECLARE FUNCTION CreateIC LIB "GDI32.DLL" ALIAS "CreateICA" (lpDriverName AS ASCIIZ, lpDeviceName AS ASCIIZ, lpOutput AS ASCIIZ, lpInitData AS DEVMODE) AS DWORD
DECLARE FUNCTION CreateMutex LIB "KERNEL32.DLL" ALIAS "CreateMutexA" (lpMutexAttributes AS SECURITY_ATTRIBUTES, BYVAL bInitialOwner AS LONG, lpName AS ASCIIZ) AS LONG
DECLARE FUNCTION CreateSolidBrush LIB "GDI32.DLL" ALIAS "CreateSolidBrush" (BYVAL crColor AS DWORD) AS DWORD
DECLARE FUNCTION CreateWindowEx LIB "USER32.DLL" ALIAS "CreateWindowExA" (BYVAL dwExStyle AS DWORD, lpClassName AS ASCIIZ, lpWindowName AS ASCIIZ, BYVAL dwStyle AS DWORD, BYVAL x AS LONG, BYVAL y AS LONG, _
    BYVAL nWidth AS LONG, BYVAL nHeight AS LONG, BYVAL hWndParent AS DWORD, BYVAL hMenu AS DWORD, BYVAL hInstance AS DWORD, lpParam AS ANY) AS DWORD
DECLARE FUNCTION DefWindowProc LIB "USER32.DLL" ALIAS "DefWindowProcA" (BYVAL hWnd AS DWORD, BYVAL uMsg AS DWORD, BYVAL wParam AS DWORD, BYVAL lParam AS LONG) AS LONG
DECLARE FUNCTION WriteFile LIB "KERNEL32.DLL" ALIAS "WriteFile" (BYVAL hFile AS DWORD, lpBuffer AS ANY, BYVAL nNumberOfBytesToWrite AS LONG, lpNumberOfBytesWritten AS LONG, lpOverlapped AS OVERLAPPED) AS LONG
DECLARE FUNCTION CharLower LIB "USER32.DLL" ALIAS "CharLowerA" (lpsz AS ASCIIZ) AS DWORD
DECLARE FUNCTION DeleteDC LIB "GDI32.DLL" ALIAS "DeleteDC" (BYVAL hdc AS DWORD) AS LONG
DECLARE FUNCTION DeleteObject LIB "GDI32.DLL" ALIAS "DeleteObject" (BYVAL hObject AS DWORD) AS LONG
DECLARE FUNCTION DispatchMessage LIB "USER32.DLL" ALIAS "DispatchMessageA" (lpMsg AS tagMSG) AS LONG
DECLARE FUNCTION DrawEdge LIB "USER32.DLL" ALIAS "DrawEdge" (BYVAL hDC AS DWORD, qrc AS RECT, BYVAL edge AS LONG, BYVAL grfFlags AS LONG) AS LONG
DECLARE FUNCTION SetCapture LIB "USER32.DLL" ALIAS "SetCapture" (BYVAL hWnd AS DWORD) AS LONG
DECLARE FUNCTION ReleaseCapture LIB "USER32.DLL" ALIAS "ReleaseCapture" () AS LONG
DECLARE FUNCTION EndPaint LIB "USER32.DLL" ALIAS "EndPaint" (BYVAL hWnd AS DWORD, lpPaint AS PAINTSTRUCT) AS LONG
DECLARE FUNCTION FormatMessage LIB "KERNEL32.DLL" ALIAS "FormatMessageA" (BYVAL dwFlags AS DWORD, lpSource AS ANY, BYVAL dwMessageId AS DWORD, BYVAL dwLanguageId AS DWORD, lpBuffer AS ASCIIZ, BYVAL nSize AS DWORD, Arguments AS ANY) AS DWORD
DECLARE FUNCTION SetTimer LIB "USER32.DLL" ALIAS "SetTimer" (BYVAL hWnd AS DWORD, BYVAL nIDEvent AS LONG, BYVAL uElapse AS DWORD, BYVAL lpTimerFunc AS LONG) AS LONG
DECLARE FUNCTION GetTickCount LIB "KERNEL32.DLL" ALIAS "GetTickCount" () AS DWORD
DECLARE FUNCTION KillTimer LIB "USER32.DLL" ALIAS "KillTimer" (BYVAL hWnd AS DWORD, BYVAL nIDEvent AS LONG) AS LONG
DECLARE FUNCTION EnumChildWindows LIB "USER32.DLL" ALIAS "EnumChildWindows" (BYVAL hwndParent AS DWORD, BYVAL lpEnumFunc AS LONG, BYVAL lParam AS LONG) AS LONG
DECLARE FUNCTION SetWindowPos LIB "USER32.DLL" ALIAS "SetWindowPos" (BYVAL hWnd AS DWORD, BYVAL hWndInsertAfter AS DWORD, BYVAL x AS LONG, BYVAL y AS LONG, BYVAL cx AS LONG, BYVAL cy AS LONG, BYVAL wFlags AS DWORD) AS LONG
DECLARE FUNCTION FillRect LIB "USER32.DLL" ALIAS "FillRect" (BYVAL hDC AS DWORD, lpRect AS RECT, BYVAL hBrush AS DWORD) AS LONG
DECLARE FUNCTION EnableWindow LIB "USER32.DLL" ALIAS "EnableWindow" (BYVAL hWnd AS DWORD, BYVAL fEnable AS LONG) AS LONG
DECLARE FUNCTION FindClose LIB "KERNEL32.DLL" ALIAS "FindClose" (BYVAL hFindFile AS DWORD) AS LONG
DECLARE FUNCTION MyFindFirstFile LIB "KERNEL32.DLL" ALIAS "FindFirstFileA" (lpFileName AS ASCIIZ, lpFindFileData AS WIN32_FIND_DATA) AS LONG
DECLARE FUNCTION FindNextFile LIB "KERNEL32.DLL" ALIAS "FindNextFileA" (BYVAL hFindFile AS DWORD, lpFindFileData AS WIN32_FIND_DATA) AS LONG
DECLARE FUNCTION FindWindow LIB "USER32.DLL" ALIAS "FindWindowA" (lpClassName AS ASCIIZ, lpWindowName AS ASCIIZ) AS LONG
DECLARE FUNCTION CombineRgn LIB "GDI32.DLL" ALIAS "CombineRgn" (BYVAL hDestRgn AS DWORD, BYVAL hSrcRgn1 AS DWORD, BYVAL hSrcRgn2 AS DWORD, BYVAL nCombineMode AS LONG) AS LONG
DECLARE FUNCTION GetWindowText LIB "USER32.DLL" ALIAS "GetWindowTextA" (BYVAL hWnd AS DWORD, lpString AS ASCIIZ, BYVAL cch AS LONG) AS LONG
DECLARE FUNCTION ExtCreateRegion LIB "GDI32.DLL" ALIAS "ExtCreateRegion" (lpXform AS ANY, BYVAL nCount AS DWORD, lpRgnData AS ANY) AS DWORD
DECLARE FUNCTION FreeLibrary LIB "KERNEL32.DLL" ALIAS "FreeLibrary" (BYVAL hLibModule AS DWORD) AS LONG
DECLARE FUNCTION SetFocus LIB "USER32.DLL" ALIAS "SetFocus" (BYVAL hWnd AS DWORD) AS LONG
DECLARE FUNCTION GetAsyncKeyState LIB "USER32.DLL" ALIAS "GetAsyncKeyState" (BYVAL vKey AS LONG) AS INTEGER
DECLARE FUNCTION GetClassInfoEx LIB "USER32.DLL" ALIAS "GetClassInfoExA" (BYVAL hInst AS DWORD, lpszClass AS ASCIIZ, lpWndClass AS WNDCLASSEX) AS LONG
DECLARE FUNCTION GetDC LIB "USER32.DLL" ALIAS "GetDC" (BYVAL hWnd AS DWORD) AS DWORD
DECLARE FUNCTION GetClientRect LIB "USER32.DLL" ALIAS "GetClientRect" (BYVAL hwnd AS DWORD, lpRect AS RECT) AS LONG
DECLARE FUNCTION GetCursor LIB "USER32.DLL" ALIAS "GetCursor" () AS LONG
DECLARE FUNCTION GetCursorPos LIB "USER32.DLL" ALIAS "GetCursorPos" (lpPoint AS POINTAPI) AS LONG
DECLARE FUNCTION GetDlgItem LIB "USER32.DLL" ALIAS "GetDlgItem" (BYVAL hDlg AS DWORD, BYVAL nIDDlgItem AS LONG) AS DWORD
DECLARE FUNCTION GetForegroundWindow LIB "USER32.DLL" ALIAS "GetForegroundWindow" () AS DWORD
DECLARE FUNCTION GetFocus LIB "USER32.DLL" ALIAS "GetFocus" () AS DWORD
DECLARE FUNCTION GetLastError LIB "KERNEL32.DLL" ALIAS "GetLastError" () AS LONG
DECLARE FUNCTION GetLocaleInfo LIB "KERNEL32.DLL" ALIAS "GetLocaleInfoA" (BYVAL Locale AS LONG, BYVAL LCType AS LONG, lpLCData AS ASCIIZ, BYVAL cchData AS LONG) AS LONG
DECLARE FUNCTION GetMessage LIB "USER32.DLL" ALIAS "GetMessageA" (lpMsg AS tagMSG, BYVAL hWnd AS DWORD, BYVAL uMsgFilterMin AS DWORD, BYVAL uMsgFilterMax AS DWORD) AS LONG
DECLARE FUNCTION GetModuleHandle LIB "KERNEL32.DLL" ALIAS "GetModuleHandleA" (lpModuleName AS ASCIIZ) AS DWORD
DECLARE FUNCTION GetObject LIB "GDI32.DLL" ALIAS "GetObjectA" (BYVAL hObject AS DWORD, BYVAL nCount AS LONG, lpObject AS ANY) AS LONG
DECLARE FUNCTION SetWindowRgn LIB "USER32.DLL" ALIAS "SetWindowRgn" (BYVAL hWnd AS DWORD, BYVAL hRgn AS DWORD, BYVAL bRedraw AS LONG) AS LONG
DECLARE FUNCTION GetParent LIB "USER32.DLL" ALIAS "GetParent" (BYVAL hWnd AS DWORD) AS LONG
DECLARE FUNCTION GetProcAddress LIB "KERNEL32.DLL" ALIAS "GetProcAddress" (BYVAL hModule AS DWORD, lpProcName AS ASCIIZ) AS LONG
DECLARE FUNCTION GetStockObject LIB "GDI32.DLL" ALIAS "GetStockObject" (BYVAL nIndex AS LONG) AS DWORD
DECLARE FUNCTION GetSysColor LIB "USER32.DLL" ALIAS "GetSysColor" (BYVAL nIndex AS LONG) AS LONG
DECLARE FUNCTION GetSystemMetrics LIB "USER32.DLL" ALIAS "GetSystemMetrics" (BYVAL nIndex AS LONG) AS LONG
DECLARE FUNCTION GetWindowLong LIB "USER32.DLL" ALIAS "GetWindowLongA" (BYVAL hWnd AS DWORD, BYVAL nIndex AS LONG) AS LONG
DECLARE FUNCTION GetWindowRect LIB "USER32.DLL" ALIAS "GetWindowRect" (BYVAL hWnd AS DWORD, lpRect AS RECT) AS LONG
DECLARE FUNCTION GradientFill LIB "MSIMG32.DLL" ALIAS "GradientFill" (BYVAL hdc AS DWORD, pVertex AS TRIVERTEX, BYVAL dwNumVertex AS DWORD, pMesh AS ANY, BYVAL dwNumMesh AS DWORD, BYVAL dwMode AS DWORD) AS LONG
DECLARE FUNCTION InvalidateRect LIB "USER32.DLL" ALIAS "InvalidateRect" (BYVAL hWnd AS DWORD, lpRect AS RECT, BYVAL bErase AS LONG) AS LONG
DECLARE FUNCTION ValidateRect LIB "USER32.DLL" ALIAS "ValidateRect" (BYVAL hWnd AS DWORD, lpRect AS RECT) AS LONG
DECLARE FUNCTION IsIconic LIB "USER32.DLL" ALIAS "IsIconic" (BYVAL hWnd AS DWORD) AS LONG
'DECLARE FUNCTION IsWindow LIB "USER32.DLL" ALIAS "IsWindow" (BYVAL hWnd AS DWORD) AS LONG
DECLARE FUNCTION IsWindowEnabled LIB "USER32.DLL" ALIAS "IsWindowEnabled" (BYVAL hWnd AS DWORD) AS LONG
DECLARE FUNCTION IsWindowVisible LIB "USER32.DLL" ALIAS "IsWindowVisible" (BYVAL hWnd AS DWORD) AS LONG
DECLARE FUNCTION IsZoomed LIB "USER32.DLL" ALIAS "IsZoomed" (BYVAL hWnd AS DWORD) AS LONG
DECLARE FUNCTION LoadCursor LIB "USER32.DLL" ALIAS "LoadCursorA" (BYVAL hInstance AS DWORD, lpCursorName AS ASCIIZ) AS DWORD
DECLARE FUNCTION LoadLibrary LIB "KERNEL32.DLL" ALIAS "LoadLibraryA" (lpLibFileName AS ASCIIZ) AS LONG
DECLARE FUNCTION MoveWindow LIB "USER32.DLL" ALIAS "MoveWindow" (BYVAL hWnd AS DWORD, BYVAL x AS LONG, BYVAL y AS LONG, BYVAL nWidth AS LONG, BYVAL nHeight AS LONG, BYVAL bRepaint AS LONG) AS LONG
DECLARE FUNCTION PeekMessage LIB "USER32.DLL" ALIAS "PeekMessageA" (lpMsg AS tagMSG, BYVAL hWnd AS DWORD, BYVAL dwMsgFilterMin AS DWORD, BYVAL dwMsgFilterMax AS DWORD, BYVAL dwRemoveMsg AS DWORD) AS LONG
DECLARE FUNCTION PtInRect LIB "USER32.DLL" ALIAS "PtInRect" (lpRect AS RECT, BYVAL ptx AS LONG, BYVAL pty AS LONG) AS LONG
DECLARE FUNCTION RegisterClassEx LIB "USER32.DLL" ALIAS "RegisterClassExA" (pcWndClassEx AS WNDCLASSEX) AS WORD
DECLARE FUNCTION ScreenToClient LIB "USER32.DLL" ALIAS "ScreenToClient" (BYVAL hWnd AS DWORD, lpPoint AS POINTAPI) AS LONG
DECLARE FUNCTION SelectObject LIB "GDI32.DLL" ALIAS "SelectObject" (BYVAL hdc AS DWORD, BYVAL hObject AS DWORD) AS DWORD
DECLARE FUNCTION SendMessage LIB "USER32.DLL" ALIAS "SendMessageA" (BYVAL hWnd AS DWORD, BYVAL dwMsg AS DWORD, BYVAL wParam AS DWORD, BYVAL lParam AS LONG) AS LONG
DECLARE FUNCTION SetForegroundWindow LIB "USER32.DLL" ALIAS "SetForegroundWindow" (BYVAL hWnd AS DWORD) AS LONG
DECLARE FUNCTION SetRect LIB "USER32.DLL" ALIAS "SetRect" (lpRect AS RECT, BYVAL X1 AS LONG, BYVAL Y1 AS LONG, BYVAL X2 AS LONG, BYVAL Y2 AS LONG) AS LONG
DECLARE FUNCTION SetWindowLong LIB "USER32.DLL" ALIAS "SetWindowLongA" (BYVAL hWnd AS DWORD, BYVAL nIndex AS LONG, BYVAL lNewLong AS LONG) AS LONG
DECLARE FUNCTION ShowWindow LIB "USER32.DLL" ALIAS "ShowWindow" (BYVAL hWnd AS DWORD, BYVAL nCmdShow AS LONG) AS LONG
DECLARE FUNCTION TranslateMessage LIB "USER32.DLL" ALIAS "TranslateMessage" (lpMsg AS tagMSG) AS LONG
DECLARE FUNCTION UpdateWindow LIB "USER32.DLL" ALIAS "UpdateWindow" (BYVAL hWnd AS DWORD) AS LONG
'DECLARE FUNCTION BringWindowToTop LIB "USER32.DLL" ALIAS "BringWindowToTop" (BYVAL hWnd AS DWORD) AS LONG
DECLARE FUNCTION ClientToScreen LIB "USER32.DLL" ALIAS "ClientToScreen" (BYVAL hWnd AS DWORD, lpPoint AS POINTAPI) AS LONG
DECLARE FUNCTION GetTempPath LIB "KERNEL32.DLL" ALIAS "GetTempPathA" (BYVAL nBufferLength AS LONG, lpBuffer AS ASCIIZ) AS LONG
DECLARE FUNCTION CopyFile LIB "KERNEL32.DLL" ALIAS "CopyFileA" (lpExistingFileName AS ASCIIZ, lpNewFileName AS ASCIIZ, BYVAL bFailIfExists AS LONG) AS LONG

'-----------------------------------------------------------------
' Declared Subs:  2
'-----------------------------------------------------------------
DECLARE SUB InitCommonControls LIB "COMCTL32.DLL" ALIAS "InitCommonControls" ()
DECLARE SUB PostQuitMessage LIB "USER32.DLL" ALIAS "PostQuitMessage" (BYVAL nExitCode AS LONG)

'// Fast line input replacement section
TYPE OVERLAPPED
  Internal AS DWORD
  InternalHigh AS DWORD
  offset AS DWORD
  OffsetHigh AS DWORD
  hEvent AS DWORD
END TYPE

TYPE SECURITY_ATTRIBUTES
  nLength AS DWORD
  lpSecurityDescriptor AS LONG
  bInheritHandle AS LONG
END TYPE

TYPE FILETIME
  dwLowDateTime AS DWORD
  dwHighDateTime AS DWORD
END TYPE

TYPE WIN32_FIND_DATA
  dwFileAttributes AS DWORD
  ftCreationTime AS FILETIME
  ftLastAccessTime AS FILETIME
  ftLastWriteTime AS FILETIME
  nFileSizeHigh AS DWORD
  nFileSizeLow AS DWORD
  dwReserved0 AS DWORD
  dwReserved1 AS DWORD
  cFileName AS ASCIIZ * %MAX_PATH
  cAlternateFileName AS ASCIIZ * 14
END TYPE

%GENERIC_READ                                   = &H80000000&
%GENERIC_WRITE                                  = &H40000000&
%FILE_SHARE_READ                                = &H00000001
%FILE_SHARE_WRITE                               = &H00000002
%FILE_ATTRIBUTE_NORMAL                          = &H00000080
%MAXDWORD                                       = &HFFFFFFFF???
%INVALID_HANDLE_VALUE                           = -1
%FILE_BEGIN                                     = 0
%FILE_FLAG_WRITE_THROUGH                        = &H080000000
%OPEN_ALWAYS                                    = 4
%FILE_TYPE_DISK                                 = &H1
%STD_OUTPUT_HANDLE                              = -11&
%MAX_PATH                                       = 260  ' max. length of full pathname

%PAINT_TILING_MODE          = 0 '// Main form background paint mode
%PAINT_STRETCH_MODE         = 1 '// Main form background paint mode

%ID_CLOSE           = -32768
%ID_RESTORE         = -32767
%ID_MAXIMIZE        = -32766
%ID_MINIMIZE        = -32765
%ID_LED             = -32764
%ID_DOCKIN          = -32763
%ID_DOCKOUT         = -32762
%ID_LISTFNAME       = -32761
%ID_LISTIMAGE       = -32760
%ID_COLORPICKBUTTON = -32759

%IMAGE_EXTRA  = 1

' DO NOT use or alter these properties!
%FORM_TopLeft     = 1  ' Skin top left corner
%FORM_TopMid      = 2  ' Skin stretched top mid
%FORM_TopRight    = 3  ' Skin top right corner
%FORM_SideLeft    = 4  ' Skin stretched left side
%FORM_Center      = 5  ' Skin center
%FORM_SideRight   = 6  ' Skin stretched right side
%FORM_BottomLeft  = 7  ' Skin bottom left corner
%FORM_BottomMid   = 8  ' Skin stretched bottom side
%FORM_BottomRight = 9  ' Skin bottom right corner
%FORM_PaintDC     = 10 ' Internal DC
%FORM_PaintBitmap = 11 ' Memory Bitmap
%BACK_PaintBitmap = 12 ' Memory Bitmap

%EXTEND_EXTRA = %BACK_PaintBitmap ' %FORM_PaintBitmap ' MAXIMUM 40 bytes on 95/98/ME

$Anti = "\"
$ZBUTIMAGE = "ZBUTIMAGE"

%TRACK_HORZ          = -1
%TRACK_VERT          = 0

%BS_PUSHBUTTON       = &H0&
%BS_AUTOCHECKBOX     = &H3&
%BS_AUTORADIOBUTTON  = &H9&
%BS_BITMAP           = &H80&
%BS_GROUPBOX         = &H7&
%BS_USERBUTTON       = &H8&
    %BS_LEFT         = &H100&
    %BS_RIGHT        = &H200&
    %BS_CENTER       = &H300&
    %BS_TOP          = &H400&
    %BS_BOTTOM       = &H800&
    %BS_VCENTER      = &HC00&
    %BS_MULTILINE    = &H00002000&
%BS_LABEL_LEFT       = %BS_USERBUTTON + %BS_LEFT
%BS_LABEL_RIGHT      = %BS_USERBUTTON + %BS_RIGHT
%BS_LABEL_CENTER     = %BS_USERBUTTON + %BS_CENTER
%BS_LABEL_MULTILINE  = %BS_USERBUTTON + %BS_LEFT + %BS_MULTILINE

%FILLRECTANGLE       = &HA&

%PROP_IMAGE_BACK     = 1
%PROP_STYLE          = 2
%PROP_COLOR          = 3
%PROP_TEXT_COLOR     = %PROP_COLOR
%PROP_USE_3D         = 4
%PROP_STATEMAX       = 5
%PROP_IMAGE_FRONT    = 6

%TRACK_IMAGE         = %PROP_IMAGE_BACK
%TRACK_MINVAL        = 2
%TRACK_MAXVAL        = 3
%TRACK_VALUE         = 4
%TRACK_XY            = 5
%TRACK_THUMB_MOVING  = 6
%TRACK_WAS_VALUE     = 7
%TRACK_ARGB          = 9
%TRACK_PROGRESSCOLOR = 10
%TRACK_DEFAULT_VALUE = 11

%COLORPICK_IMAGE     = 1 '// Color picker
%COLORPICK_COLOR     = 2 '// Color picker
%COLORPICK_COMBO     = 3 '// Color picker
'------------------------------------------------------------------------------------------
' ANCHOR section
'------------------------------------------------------------------------------------------
TYPE ANCHORPROPERTY
    hWnd        AS LONG
    anchor      AS LONG
    rc          AS RECT
    centerx     AS LONG
    centery     AS LONG
END TYPE

%ANCHOR_NONE                = 0
%ANCHOR_WIDTH               = 1
%ANCHOR_RIGHT               = 2
%ANCHOR_CENTER_HORZ         = 3
%ANCHOR_HEIGHT              = 4
%ANCHOR_HEIGHT_WIDTH        = 5
%ANCHOR_HEIGHT_RIGHT        = 6
%ANCHOR_BOTTOM              = 7
%ANCHOR_BOTTOM_WIDTH        = 8
%ANCHOR_BOTTOM_RIGHT        = 9
%ANCHOR_CENTER_HORZ_BOTTOM  = 10
%ANCHOR_CENTER_VERT         = 11
%ANCHOR_CENTER_VERT_RIGHT   = 12
%ANCHOR_CENTER              = 13

GLOBAl gProp() AS ANCHORPROPERTY, gColorCaption AS LONG
GLOBAL gZorder() AS LONG

'-----------------------------------------------------------------
' Declared Functions:  11
'-----------------------------------------------------------------
DECLARE FUNCTION CreateFile LIB "KERNEL32.DLL" ALIAS "CreateFileA" (lpFileName AS ASCIIZ, BYVAL dwDesiredAccess AS DWORD, BYVAL dwShareMode AS DWORD, lpSecurityAttributes AS SECURITY_ATTRIBUTES, BYVAL dwCreationDisposition AS DWORD, _
                 BYVAL dwFlagsAndAttributes AS DWORD, BYVAL hTemplateFile AS DWORD) AS DWORD
DECLARE FUNCTION GetFileSize LIB "KERNEL32.DLL" ALIAS "GetFileSize" (BYVAL hFile AS DWORD, lpFileSizeHigh AS LONG) AS LONG
DECLARE FUNCTION GetFileType LIB "KERNEL32.DLL" ALIAS "GetFileType" (BYVAL hFile AS DWORD) AS LONG
DECLARE FUNCTION ReadFile LIB "KERNEL32.DLL" ALIAS "ReadFile" (BYVAL hFile AS DWORD, lpBuffer AS ANY, BYVAL nNumberOfBytesToRead AS DWORD, lpNumberOfBytesRead AS DWORD, lpOverlapped AS OVERLAPPED) AS LONG
DECLARE FUNCTION SetFilePointer LIB "KERNEL32.DLL" ALIAS "SetFilePointer" (BYVAL hFile AS DWORD, BYVAL lDistanceToMove AS LONG, lpDistanceToMoveHigh AS LONG, BYVAL dwMoveMethod AS DWORD) AS LONG
DECLARE FUNCTION WriteConsole LIB "KERNEL32.DLL" ALIAS "WriteConsoleA" (BYVAL hConsoleOutput AS DWORD, lpBuffer AS ASCIIZ, BYVAL nNumberOfCharsToWrite AS LONG, lpNumberOfCharsWritten AS LONG, BYVAL lpReserved AS LONG) AS LONG
DECLARE FUNCTION GetStdHandle LIB "KERNEL32.DLL" ALIAS "GetStdHandle" (BYVAL nStdHandle AS LONG) AS LONG
DECLARE FUNCTION GetShortPathName LIB "KERNEL32.DLL" ALIAS "GetShortPathNameA" (lpszLongPath AS ASCIIZ, lpszShortPath AS ASCIIZ, BYVAL cchBuffer AS LONG) AS LONG

%LB_ADDSTRING          = &H180
%LB_INSERTSTRING       = &H181
%LB_FINDSTRING         = &H18F
%LB_GETTEXT            = &H189
%LB_GETTEXTLEN         = &H18A
%LB_DELETESTRING       = &H182
%LB_RESETCONTENT       = &H184
%LB_SETCURSEL          = &H186
%LB_GETCURSEL          = &H188
%LB_GETCOUNT           = &H18B
%LBS_HASSTRINGS        = &H40&
%LBS_SORT              = &H2&

'------------------------------------------------------------------------------------------
' GDIPLUS section
'------------------------------------------------------------------------------------------
$Dot        = "."
$zLim       = "|"
$GDIPLUSIMG = ".DIB.EMF.GIF.JPG.JPEG.PNG.TIF.TIFF.WMF."
$GDIPLUSEXT = $GDIPLUSIMG + "BMP.ICO."
%UnitPixel  = 2 ' Each unit is one device pixel.

%MatrixOrderPrepend = 0
%MatrixOrderAppend = 1
%CombineModeIntersect = 1

%FontStyleRegular = 0
%TextRenderingHintSystemDefault            = 0 ' Glyph with system default rendering hint
%TextRenderingHintSingleBitPerPixelGridFit = 1 ' Glyph bitmap with hinting
%TextRenderingHintSingleBitPerPixel        = 2 ' Glyph bitmap without hinting
%TextRenderingHintAntiAliasGridFit         = 3 ' Glyph anti-alias bitmap with hinting
%TextRenderingHintAntiAlias                = 4 ' Glyph anti-alias bitmap without hinting
%TextRenderingHintClearTypeGridFit         = 5 ' Glyph CT bitmap with hinting
%TextRenderingDefault                      = %TextRenderingHintClearTypeGridFit

'%ZD_TextHorzUp = &H0                  ' Horizontal text orientation
'%ZD_TextVertUp = &H1                  ' Vertical text orientation from bottom to top
'%ZD_TextVertDn = &H2                  ' Vertical text orientation from top to bottom

%WrapModeTile        = 0
%WrapModeTileFlipX   = 1
%WrapModeTileFlipY   = 2
%WrapModeTileFlipXY  = 3
%WrapModeClamp       = 4

%SmoothingModeAntiAlias = 4

TYPE GdiplusStartupInput
   GdiplusVersion AS LONG             ' Must be 1
   DebugEventCallback AS LONG         ' Ignored on free builds
   SuppressBackgroundThread AS LONG   ' FALSE unless you're prepared to call
                                      ' the hook/unhook functions properly
   SuppressExternalCodecs AS LONG     ' FALSE unless you want GDI+ only to use
                                      ' its internal image codecs.
END TYPE

DECLARE FUNCTION GdiplusStartup LIB "gdiplus.dll" ALIAS "GdiplusStartup" (token&, inputbuf AS GdiplusStartupInput, OPTIONAL BYVAL outputbuf&) AS LONG
DECLARE FUNCTION GdiplusShutdown LIB "gdiplus.dll" ALIAS "GdiplusShutdown" (BYVAL token&) AS LONG
DECLARE FUNCTION GdipLoadImageFromFile LIB "gdiplus.dll" ALIAS "GdipLoadImageFromFile" (zFilName AS ASCIIZ, nImage&) AS LONG
DECLARE FUNCTION GdipGetImageWidth LIB "gdiplus.dll" ALIAS "GdipGetImageWidth" (BYVAL nImage&, nWidth&) AS LONG
DECLARE FUNCTION GdipGetImageHeight LIB "gdiplus.dll" ALIAS "GdipGetImageHeight" (BYVAL nImage&, Height&) AS LONG
DECLARE FUNCTION GdipDisposeImage LIB "gdiplus.dll" ALIAS "GdipDisposeImage" (BYVAL nImage&) AS LONG
DECLARE FUNCTION GdipCreateFromHDC LIB "gdiplus.dll" ALIAS "GdipCreateFromHDC" (BYVAL hdc&, graphics&) AS LONG
DECLARE FUNCTION GdipDrawImageRectRectI LIB "gdiplus.dll" ALIAS "GdipDrawImageRectRectI" (BYVAL graphics&, BYVAL nImage&, BYVAL dstx&, BYVAL dsty&, BYVAL dstwidth&, BYVAL dstheight&, BYVAL srcx&, BYVAL srcy&, BYVAL srcwidth&, BYVAL srcheight&, _
                                                                                          BYVAL srcUnit&, OPTIONAL BYVAL imageAttributes&, OPTIONAL BYVAL pCALLBACK&, OPTIONAL BYVAL callbackData&) AS LONG
DECLARE FUNCTION GdipDrawImageRectI LIB "gdiplus.dll" ALIAS "GdipDrawImageRectI" (BYVAL graphics&, BYVAL nImage&, BYVAL x&, BYVAL y&, BYVAL nWidth&, BYVAL Height&) AS LONG
DECLARE FUNCTION GdipCreateStringFormat LIB "gdiplus.dll" ALIAS "GdipCreateStringFormat" (BYVAL formatAttributes&, BYVAL language AS INTEGER, StringFormat&) AS LONG
DECLARE FUNCTION GdipDeleteGraphics LIB "gdiplus.dll" ALIAS "GdipDeleteGraphics" (BYVAL graphics&) AS LONG
DECLARE FUNCTION GdipCreateFont LIB "gdiplus.dll" ALIAS "GdipCreateFont" (BYVAL fontFamily&, BYVAL emSize!, BYVAL style&, BYVAL unit&, createdfont&) AS LONG
DECLARE FUNCTION GdipCreateFontFromDC LIB "gdiplus.dll" ALIAS "GdipCreateFontFromDC" (BYVAL hDC&, createdfont&) AS LONG
DECLARE FUNCTION GdipCreateFontFamilyFromName LIB "gdiplus.dll" ALIAS "GdipCreateFontFamilyFromName" (zFontName AS ASCIIZ, BYVAL fontCollection&, fontFamily&) AS LONG
DECLARE FUNCTION GdipDeleteFont LIB "gdiplus.dll" ALIAS "GdipDeleteFont" (BYVAL curFont&) AS LONG
DECLARE FUNCTION GdipMeasureString LIB "gdiplus.dll" ALIAS "GdipMeasureString" (BYVAL graphics&, zString AS ASCIIZ, BYVAL length&, BYVAL thefont&, layoutRect AS RECTF, BYVAL StringFormat&, boundingBox AS RECTF, _
                                                                                codepointsFitted&, linesFilled&) AS LONG
DECLARE FUNCTION GdipDeleteFontFamily LIB "gdiplus.dll" ALIAS "GdipDeleteFontFamily" (BYVAL fontFamily&) AS LONG
DECLARE FUNCTION GdipDeleteBrush LIB "gdiplus.dll" ALIAS "GdipDeleteBrush" (BYVAL brush&) AS LONG
DECLARE FUNCTION GdipResetWorldTransform LIB "gdiplus.dll" ALIAS "GdipResetWorldTransform" (BYVAL graphics&) AS LONG
DECLARE FUNCTION GdipDeleteStringFormat LIB "gdiplus.dll" ALIAS "GdipDeleteStringFormat" (BYVAL StringFormat&) AS LONG
DECLARE FUNCTION GdipDrawString LIB "gdiplus.dll" ALIAS "GdipDrawString" (BYVAL graphics&, zStr AS ASCIIZ, BYVAL length&, BYVAL thefont&, layoutRect AS RECTF, BYVAL StringFormat&, BYVAL brush&) AS LONG
DECLARE FUNCTION GdipCreateSolidFill LIB "gdiplus.dll" ALIAS "GdipCreateSolidFill" (BYVAL argb&, brush&) AS LONG
DECLARE FUNCTION GdipSetTextRenderingHint LIB "gdiplus.dll" ALIAS "GdipSetTextRenderingHint" (BYVAL graphics&, BYVAL mode&) AS LONG
DECLARE FUNCTION GdipRotateWorldTransform LIB "gdiplus.dll" ALIAS "GdipRotateWorldTransform" (BYVAL graphics&, BYVAL angle!, BYVAL order&) AS LONG
DECLARE FUNCTION GdipSetStringFormatFlags LIB "gdiplus.dll" ALIAS "GdipSetStringFormatFlags" (BYVAL StringFormat&, BYVAL flags&) AS LONG

DECLARE FUNCTION GdipSetStringFormatAlign LIB "gdiplus.dll" ALIAS "GdipSetStringFormatAlign" (BYVAL StringFormat&, BYVAL align&) AS LONG
DECLARE FUNCTION GdipSetStringFormatLineAlign LIB "gdiplus.dll" ALIAS "GdipSetStringFormatLineAlign" (BYVAL StringFormat&, BYVAL align&) AS LONG

DECLARE FUNCTION GdipTranslateWorldTransform LIB "gdiplus.dll" ALIAS "GdipTranslateWorldTransform" (BYVAL graphics&, BYVAL dx!, BYVAL dy!, BYVAL order&) AS LONG
DECLARE FUNCTION GdipCreateBitmapFromHICON LIB "gdiplus.dll" ALIAS "GdipCreateBitmapFromHICON" (BYVAL hicon&, nBitmap&) AS LONG
DECLARE FUNCTION GdipCreateBitmapFromHBITMAP LIB "gdiplus.dll" ALIAS "GdipCreateBitmapFromHBITMAP" (BYVAL hbm&, BYVAL hpal&, nBitmap&) AS LONG
DECLARE FUNCTION GdipCreateBitmapFromGraphics LIB "gdiplus.dll" ALIAS "GdipCreateBitmapFromGraphics" (BYVAL nWidth&, BYVAL Height&, BYVAL graphics&, nBitmap&) AS LONG
DECLARE FUNCTION GdipSetInterpolationMode LIB "gdiplus.dll" ALIAS "GdipSetInterpolationMode" (BYVAL graphics&, BYVAL interpolation&) AS LONG
DECLARE FUNCTION GdipDrawLineI LIB "gdiplus.dll" ALIAS "GdipDrawLineI" (BYVAL graphics&, BYVAL pen&, BYVAL x1&, BYVAL y1&, BYVAL x2&, BYVAL y2&) AS LONG
DECLARE FUNCTION GdipDeletePen LIB "gdiplus.dll" ALIAS "GdipDeletePen" (BYVAL pen&) AS LONG
DECLARE FUNCTION GdipCreatePen1 LIB "gdiplus.dll" ALIAS "GdipCreatePen1" (BYVAL Colr&, BYVAL nWidth!, BYVAL unit&, pen&) AS LONG
DECLARE FUNCTION GdipSetClipRectI LIB "gdiplus.dll" ALIAS "GdipSetClipRectI" (BYVAL graphics&, BYVAL x&, BYVAL y&, BYVAL nWidth&, BYVAL Height&, BYVAL CombineMd&) AS LONG
DECLARE FUNCTION GdipResetClip LIB "gdiplus.dll" ALIAS "GdipResetClip" (BYVAL graphics&) AS LONG
DECLARE FUNCTION GdipFillRectangleI LIB "gdiplus.dll" ALIAS "GdipFillRectangleI" (BYVAL graphics&, BYVAL brush&, BYVAL x&, BYVAL y&, BYVAL nWidth&, BYVAL Height&) AS LONG
DECLARE FUNCTION GdipCreateLineBrushI LIB "gdiplus.dll" ALIAS "GdipCreateLineBrushI" (point1 AS POINTAPI, point2 AS POINTAPI, BYVAL color1&, BYVAL color2&, BYVAL WrapMd&, lineGradient&) AS LONG
DECLARE FUNCTION GdipCreatePen2 LIB "gdiplus.dll" ALIAS "GdipCreatePen2" (BYVAL brush&, BYVAL nWidth!, BYVAL unit&, pen&) AS LONG
DECLARE FUNCTION GdipFillEllipseI LIB "gdiplus.dll" ALIAS "GdipFillEllipseI" (BYVAL graphics&, BYVAL brush&, BYVAL x&, BYVAL y&, BYVAL nWidth&, BYVAL Height&) AS LONG
DECLARE FUNCTION GdipSetSmoothingMode LIB "gdiplus.dll" ALIAS "GdipSetSmoothingMode" (BYVAL graphics&, BYVAL SmoothingMd&) AS LONG
DECLARE FUNCTION GdipCloneBitmapAreaI LIB "gdiplus.dll" ALIAS "GdipCloneBitmapAreaI" (BYVAL x&, BYVAL y&, BYVAL nWidth&, BYVAL Height&, BYVAL PixelFormat&, BYVAL srcBitmap&, dstBitmap&) AS LONG

TYPE OSVERSIONINFO
    dwOSVersionInfoSize AS DWORD
    dwMajorVersion AS DWORD
    dwMinorVersion AS DWORD
    dwBuildNumber AS DWORD
    dwPlatformId AS DWORD
    szCSDVersion AS ASCIIZ * 128  ' Maintenance string for PSS usage
END TYPE

FUNCTION zOsVersion () AS LONG

    DIM os AS OSVERSIONINFO

    os.dwOSVersionInfoSize = SIZEOF(os)

    IF GetVersionEx(os) THEN

       SELECT CASE LONG os.dwPlatformId
       CASE 1
            FUNCTION = os.dwPlatformId
            IF os.dwMinorVersion = 0 THEN
               FUNCTION = 95  ' "Windows 95"
            ELSEIF os.dwMinorVersion = 10 THEN
               FUNCTION = 98  ' "Windows 98"
            ELSEIF os.dwMinorVersion = 90 THEN
               FUNCTION = 100 ' "Windows ME"
            END IF
       CASE 2
            FUNCTION = os.dwPlatformId
            IF os.dwMajorVersion = 3 THEN
               FUNCTION = 351 ' "Windows NT 3.51"
            ELSEIF os.dwMajorVersion = 4 THEN
               FUNCTION = 400 ' "Windows NT 4.0"
            ELSEIF os.dwMajorVersion = 5 THEN
               FUNCTION = 500 ' "Windows 2000"
               IF os.dwMinorVersion = 1 THEN
                  FUNCTION = 501 ' "Windows XP"
               END IF
            ELSEIF os.dwMajorVersion = 6 THEN
               FUNCTION = 600 ' "Windows VISTA"
            END IF
       CASE ELSE
            FUNCTION = -1     ' "Unknown"
       END SELECT
    ELSE
       FUNCTION = 0           ' "Failed"
    END IF

END FUNCTION

'// VISTA detection
FUNCTION Vista() AS LONG
    Static Done, nRet AS LONG
    IF Done = 0 THEN Done = -1: IF zOsVersion > 599 THEN nRet = -1
    FUNCTION = nRet
END FUNCTION

'// Static function to save the main window handle.
FUNCTION zMainWindow(BYVAL hMain AS LONG) AS LONG
    STATIC WasMain AS LONG
    IF hMain THEN
       WasMain = hMain
    END IF
    FUNCTION = WasMain
END FUNCTION

'// START VISTA SECTION --------------------------------------------
%S_OK = 0
%WM_DWMCOMPOSITIONCHANGED     = &H031E
%DWM_BB_ENABLE                = &H00000001
%DWM_BB_BLURREGION            = &H00000002
%DWM_BB_TRANSITIONONMAXIMIZED = &H00000004
%DWM_EC_ENABLECOMPOSITION     = 1
%DWM_EC_DISABLECOMPOSITION    = 0

TYPE DWM_BLURBEHIND
    dwFlags  AS DWORD
    fEnable  AS LONG
    hRgnBlur AS DWORD
    fTransitionOnMaximized AS LONG
END TYPE

TYPE MARGINS
    cxLeftWidth    AS LONG
    cxRightWidth   AS LONG
    cyTopHeight    AS LONG
    cyBottomHeight AS LONG
END TYPE

FUNCTION LoadDWM () AS LONG
    STATIC hLib AS DWORD, nChecked AS LONG
    IF nChecked = 0 THEN nChecked = -1: hLib = LoadLibrary ("dwmapi.dll")
    FUNCTION = hLib
END FUNCTION

DECLARE FUNCTION DwmEnableComposition (BYVAL uCompositionAction AS LONG) AS LONG
SUB zDwmEnableComposition (BYVAL uCompositionAction AS LONG)
    LOCAL nRet AS LONG, hLib AS DWORD
    STATIC hProc AS DWORD
    hLib = LoadDWM()
    IF hLib THEN
       IF hProc = 0 THEN hProc = GetProcAddress(hLib, "DwmEnableComposition")
       IF hProc THEN
          CALL DWORD hProc USING DwmEnableComposition(uCompositionAction) TO nRet
       END IF
    END IF
END SUB

DECLARE FUNCTION DwmIsCompositionEnabled () AS LONG
FUNCTION zDwmIsCompositionEnabled () AS LONG
    LOCAL nRet AS LONG, hLib AS DWORD
    STATIC hProc AS DWORD
    hLib = LoadDWM()
    IF hLib THEN
       IF hProc = 0 THEN hProc = GetProcAddress(hLib, "DwmIsCompositionEnabled")
       IF hProc THEN
          CALL DWORD hProc USING DwmIsCompositionEnabled() TO nRet
          IF nRet THEN FUNCTION = -1
       END IF
    END IF
END FUNCTION

DECLARE FUNCTION DwmEnableBlurBehindWindow (BYVAL LONG, pBlurBehind AS DWM_BLURBEHIND) AS LONG
SUB zSetBlurBehindMode(BYVAl hWnd AS LONG, BYVAL nBOOL AS LONG, BYVAL hRgnBlur AS LONG)
    LOCAL bb AS DWM_BLURBEHIND
    LOCAL hLib AS DWORD, nRet AS LONG
    STATIC hProc AS DWORD
    hLib = LoadDWM ()
    IF hLIB THEN
       IF zDwmIsCompositionEnabled() THEN
          IF hProc = 0 THEN hProc = GetProcAddress(hLib, "DwmEnableBlurBehindWindow")
          IF hProc THEN
             nRet = %S_OK
'            // Create and populate the BlurBehind structure.
'            // Set Blur Behind and Blur Region.
             bb.fEnable = nBOOL
             bb.dwFlags = %DWM_BB_ENABLE OR %DWM_BB_BLURREGION
             bb.hRgnBlur = hRgnBlur
'            // Set Blur Behind mode.
             CALL DWORD hProc USING DwmEnableBlurBehindWindow(hWnd, bb) TO nRet
          END IF
       END IF
    END IF
END SUB

SUB zSetCrystalBehindMode(BYVAl hWnd AS LONG, BYVAL nBOOL AS LONG)
    LOCAL bb AS DWM_BLURBEHIND
    LOCAL hLib AS DWORD, nRet, hRgnBlur AS LONG
    STATIC hProc AS DWORD
    hLib = LoadDWM ()
    IF hLIB THEN
       IF zDwmIsCompositionEnabled() THEN
          IF hProc = 0 THEN hProc = GetProcAddress(hLib, "DwmEnableBlurBehindWindow")
          IF hProc THEN
             nRet = %S_OK
'            // Create and populate the BlurBehind structure.
'            // Set Blur Behind and Blur Region.
             bb.fEnable = nBOOL
             bb.dwFlags = %DWM_BB_ENABLE OR %DWM_BB_BLURREGION
             bb.fTransitionOnMaximized = 0
'            // Fool VISTA with a fake region
             IF nBOOL THEN hRgnBlur = CreateRectRgn(-1, -1, 0, 0)
             bb.hRgnBlur = hRgnBlur
'            // Set Blur Behind mode.
             CALL DWORD hProc USING DwmEnableBlurBehindWindow(hWnd, bb) TO nRet
          END IF
       END IF
    END IF
END SUB
'// END VISTA SECTION --------------------------------------------

FUNCTION zCharLower(zTmp AS ASCIIZ) AS STRING
    CharLower(zTmp)
    FUNCTION = zTmp
END FUNCTION

FUNCTION zCursorWait () AS LONG
    FUNCTION = SetCursor(LoadCursor(%NULL, BYVAL %IDC_WAIT))
END FUNCTION

FUNCTION zCursorStd () AS LONG
    FUNCTION = SetCursor(LoadCursor(%NULL, BYVAL %IDC_ARROW))
END FUNCTION

'// SKIN PROPERTIES
FUNCTION zSkinAuthor(BYVAL sAuthor AS STRING) AS STRING
    STATIC sWasAuthor AS STRING
    IF LEN(sAuthor) THEN sWasAuthor = sAuthor
    FUNCTION = sWasAuthor
END FUNCTION
'// Return the SKIN Author's name
FUNCTION SK_AUTHOR() AS STRING
    FUNCTION = zSkinAuthor("")
END FUNCTION

FUNCTION zCXSYSICON(BYVAL N AS LONG, BYVAL RW AS LONG) AS LONG
    STATIC WasN AS LONG
    IF RW THEN WasN = N
    FUNCTION = WasN
END FUNCTION
FUNCTION zCYSYSICON(BYVAL N AS LONG, BYVAL RW AS LONG) AS LONG
    STATIC WasN AS LONG
    IF RW THEN WasN = N
    FUNCTION = WasN
END FUNCTION
'// Return ICON's location
SUB zGetSysIconXY(BYREF x AS LONG, BYREF y AS LONG)
    x = zCXSYSICON(0, 0)
    y = zCYSYSICON(0, 0)
END SUB

FUNCTION zCXCAPTEXT(BYVAL N AS LONG, BYVAL RW AS LONG) AS LONG
    STATIC WasN AS LONG
    IF RW THEN WasN = N
    FUNCTION = WasN
END FUNCTION
FUNCTION zCYCAPTEXT(BYVAL N AS LONG, BYVAL RW AS LONG) AS LONG
    STATIC WasN AS LONG
    IF RW THEN WasN = N
    FUNCTION = WasN
END FUNCTION
'// Return CAPTION's location
SUB zGetCaptionXY(BYREF x AS LONG, BYREF y AS LONG)
    x = zCXCAPTEXT(0, 0)
    y = zCYCAPTEXT(0, 0)
END SUB

FUNCTION zBTNFIXX(BYVAL N AS LONG, BYVAL RW AS LONG) AS LONG
    STATIC WasN AS LONG
    IF RW THEN WasN = N
    FUNCTION = WasN
END FUNCTION
FUNCTION zBTNFIXY(BYVAL N AS LONG, BYVAL RW AS LONG) AS LONG
    STATIC WasN AS LONG
    IF RW THEN WasN = N
    FUNCTION = WasN
END FUNCTION
'// Return BUTTON's fixed border X,Y size
SUB zGetButtonFixXY(BYREF x AS LONG, BYREF y AS LONG)
    x = zBTNFIXX(0, 0)
    y = zBTNFIXY(0, 0)
END SUB

FUNCTION zFOLDER(BYVAL sPath AS STRING, BYVAL RW AS LONG) AS STRING
    STATIC sWasPath AS STRING
    IF RW THEN sWasPath = sPath
    FUNCTION = sWasPath
END FUNCTION
FUNCTION SK_FOLDER() AS STRING
    FUNCTION = zFOLDER("", 0)
END FUNCTION

FUNCTION zCENTERFORM(BYVAL sPath AS STRING, BYVAL RW AS LONG) AS STRING
    STATIC sWasPath AS STRING
    IF RW THEN sWasPath = sPath
    FUNCTION = sWasPath
END FUNCTION
FUNCTION SK_CENTERFORM() AS STRING
    FUNCTION = zCENTERFORM("", 0)
END FUNCTION

FUNCTION zSkinPath(BYVAL sBF AS STRING, BYVAL sExePath AS STRING) AS STRING
    sBF = PARSE$(sBF, 2): REPLACE "@PATH@" WITH sExePath IN sBF
    FUNCTION = sBF
END FUNCTION

FUNCTION zACTIVECAPTION(BYVAL nColor AS LONG, BYVAL RW AS LONG) AS LONG
    STATIC WasColor AS LONG
    IF RW THEN WasColor = nColor
    FUNCTION = WasColor
END FUNCTION
FUNCTION SK_ACTIVECAPTION() AS LONG
    FUNCTION = zACTIVECAPTION(0, 0)
END FUNCTION

FUNCTION zINACTIVECAPTION(BYVAL nColor AS LONG, BYVAL RW AS LONG) AS LONG
    STATIC WasColor AS LONG
    IF RW THEN WasColor = nColor
    FUNCTION = WasColor
END FUNCTION
FUNCTION SK_INACTIVECAPTION() AS LONG
    FUNCTION = zINACTIVECAPTION(0,0)
END FUNCTION

FUNCTION zTEXTCOLOR(BYVAL nColor AS LONG, BYVAL RW AS LONG) AS LONG
    STATIC WasColor AS LONG
    IF RW THEN WasColor = nColor
    FUNCTION = WasColor
END FUNCTION
FUNCTION SK_TEXTCOLOR() AS LONG
    FUNCTION = zTEXTCOLOR(0,0)
END FUNCTION

FUNCTION zBTNTEXTCOLOR(BYVAL nColor AS LONG, BYVAL RW AS LONG) AS LONG
    STATIC WasColor AS LONG
    IF RW THEN WasColor = nColor
    FUNCTION = WasColor
END FUNCTION
FUNCTION SK_BTNTEXTCOLOR() AS LONG
    FUNCTION = zBTNTEXTCOLOR(0,0)
END FUNCTION

FUNCTION zPOPMENUTEXT(BYVAL nColor AS LONG, BYVAL RW AS LONG) AS LONG
    STATIC WasColor AS LONG
    IF RW THEN WasColor = nColor
    FUNCTION = WasColor
END FUNCTION
FUNCTION SK_POPMENUTEXT() AS LONG
    FUNCTION = zPOPMENUTEXT(0,0)
END FUNCTION

FUNCTION zPOPMENUHILITE(BYVAL nColor AS LONG, BYVAL RW AS LONG) AS LONG
    STATIC WasColor AS LONG
    IF RW THEN WasColor = nColor
    FUNCTION = WasColor
END FUNCTION
FUNCTION SK_POPMENUHILITE() AS LONG
    FUNCTION = zPOPMENUHILITE(0,0)
END FUNCTION

FUNCTION zACTIVEMENUBAR(BYVAL nColor AS LONG, BYVAL RW AS LONG) AS LONG
    STATIC WasColor AS LONG
    IF RW THEN WasColor = nColor
    FUNCTION = WasColor
END FUNCTION
FUNCTION SK_ACTIVEMENUBAR() AS LONG
    FUNCTION = zACTIVEMENUBAR(0,0)
END FUNCTION

FUNCTION zINACTIVEMENUBAR(BYVAL nColor AS LONG, BYVAL RW AS LONG) AS LONG
    STATIC WasColor AS LONG
    IF RW THEN WasColor = nColor
    FUNCTION = WasColor
END FUNCTION
FUNCTION SK_INACTIVEMENUBAR() AS LONG
    FUNCTION = zINACTIVEMENUBAR(0,0)
END FUNCTION

FUNCTION zCAPTIONFONT(BYVAL sCaptionFont AS STRING, BYVAL RW AS LONG) AS STRING
    STATIC sWasFont AS STRING
    IF RW THEN sWasFont = sCaptionFont
    FUNCTION = sWasFont
END FUNCTION
FUNCTION SK_CAPTIONFONT() AS STRING
    FUNCTION = zCAPTIONFONT("", 0)
END FUNCTION

FUNCTION zCAPTIONFONTHEIGHT(BYVAL N AS LONG, BYVAL RW AS LONG) AS LONG
    STATIC WasN AS LONG
    IF RW THEN WasN = N
    FUNCTION = WasN
END FUNCTION
FUNCTION SK_CAPTIONFONTHEIGHT() AS LONG
    FUNCTION = zCAPTIONFONTHEIGHT(0,0)
END FUNCTION

FUNCTION zPUSHBUTFONTSIZE(BYVAL N AS LONG, BYVAL RW AS LONG) AS LONG
    STATIC WasN AS LONG
    IF RW THEN WasN = N
    FUNCTION = WasN
END FUNCTION
FUNCTION SK_PUSHBUTFONTSIZE() AS LONG
    FUNCTION = zPUSHBUTFONTSIZE(0,0)
END FUNCTION

FUNCTION zICONSIZE(BYVAL N AS LONG, BYVAL RW AS LONG) AS LONG
    STATIC WasN AS LONG
    IF RW THEN WasN = N
    FUNCTION = WasN
END FUNCTION
FUNCTION SK_ICONSIZE() AS LONG
    FUNCTION = zICONSIZE(0,0)
END FUNCTION

FUNCTION zTRACKHICOLOR(BYVAL nColor AS LONG, BYVAL RW AS LONG) AS LONG
    STATIC WasColor AS LONG
    IF RW THEN WasColor = nColor
    FUNCTION = WasColor
END FUNCTION
FUNCTION SK_TRACKHICOLOR() AS LONG
    FUNCTION = zTRACKHICOLOR(0,0)
END FUNCTION

FUNCTION zPAINT_BORDER(BYVAL nMode AS LONG, BYVAL RW AS LONG) AS LONG
    STATIC WasMode AS LONG
    IF RW THEN WasMode = nMode
    FUNCTION = WasMode
END FUNCTION
FUNCTION SK_PAINT_BORDER() AS LONG
    FUNCTION = zPAINT_BORDER(0,0)
END FUNCTION

FUNCTION zPAINT_BACKGROUND(BYVAL nMode AS LONG, BYVAL RW AS LONG) AS LONG
    STATIC WasMode AS LONG
    IF RW THEN WasMode = nMode
    FUNCTION = WasMode
END FUNCTION
FUNCTION SK_PAINT_BACKGROUND() AS LONG
    FUNCTION = zPAINT_BACKGROUND(0,0)
END FUNCTION

FUNCTION zDRAG_BACKGROUND(BYVAL nMode AS LONG, BYVAL RW AS LONG) AS LONG
    STATIC WasMode AS LONG
    IF RW THEN WasMode = nMode
    FUNCTION = WasMode
END FUNCTION
FUNCTION SK_DRAG_BACKGROUND() AS LONG
    FUNCTION = zDRAG_BACKGROUND(0,0)
END FUNCTION

FUNCTION zTEXTFONT(BYVAL sTextFont AS STRING, BYVAL RW AS LONG) AS STRING
    STATIC sWasFont AS STRING
    IF RW THEN sWasFont = sTextFont
    FUNCTION = sWasFont
END FUNCTION
FUNCTION SK_TEXTFONT() AS STRING
    FUNCTION = zTEXTFONT("", 0)
END FUNCTION

FUNCTION zSHADOWCOLOR(BYVAL nColor AS LONG, BYVAL RW AS LONG) AS LONG
    STATIC WasColor AS LONG
    IF RW THEN WasColor = nColor
    FUNCTION = WasColor
END FUNCTION
FUNCTION SK_SHADOWCOLOR() AS LONG
    FUNCTION = zSHADOWCOLOR(0,0)
END FUNCTION

FUNCTION zAEROEMULATE(BYVAL nMode AS LONG, BYVAL RW AS LONG) AS LONG
    STATIC WasMode AS LONG
    IF RW THEN WasMode = nMode
    FUNCTION = WasMode
END FUNCTION
FUNCTION SK_AEROEMULATE() AS LONG
    FUNCTION = zAEROEMULATE(0,0)
END FUNCTION

FUNCTION zAEROBLURLEVEL(BYVAL nMode AS LONG, BYVAL RW AS LONG) AS LONG
    STATIC WasMode AS LONG
    IF RW THEN WasMode = MIN&(MAX&(nMode, 0), 20)
    FUNCTION = WasMode
END FUNCTION
FUNCTION SK_AEROBLURLEVEL() AS LONG
    FUNCTION = zAEROBLURLEVEL(0,0)
END FUNCTION

FUNCTION zAEROCOLOR(BYVAL nColor AS LONG, BYVAL RW AS LONG) AS LONG
    STATIC WasColor AS LONG
    IF RW THEN WasColor = nColor
    FUNCTION = WasColor
END FUNCTION
FUNCTION SK_AEROCOLOR() AS LONG
    FUNCTION = zAEROCOLOR(0,0)
END FUNCTION

FUNCTION zAEROTIMERDELAY(BYVAL nMode AS LONG, BYVAL RW AS LONG) AS LONG
    STATIC WasMode AS LONG
    IF RW THEN WasMode = MIN&(MAX&(nMode, 0), 1000)
    FUNCTION = WasMode
END FUNCTION
FUNCTION SK_AEROTIMERDELAY() AS LONG
    FUNCTION = zAEROTIMERDELAY(0,0)
END FUNCTION

FUNCTION zCOLORLABEL(BYVAL sColorLabel AS STRING, BYVAL RW AS LONG) AS STRING
    STATIC sWasColorLabel AS STRING
    IF RW THEN sWasColorLabel = sColorLabel
    FUNCTION = sWasColorLabel
END FUNCTION
FUNCTION SK_COLORLABEL() AS STRING
    FUNCTION = zCOLORLABEL("", 0)
END FUNCTION

FUNCTION zUSEVISTABLUR(BYVAL nMode AS LONG, BYVAL RW AS LONG) AS LONG
    STATIC WasMode AS LONG
    IF RW THEN
       IF WasMode AND nMode = 0 THEN zSetBlurBehindMode(zMainWindow(0), %FALSE, 0)
       WasMode = nMode
    END IF
    FUNCTION = WasMode
END FUNCTION
FUNCTION SK_USEVISTABLUR() AS LONG
    FUNCTION = zUSEVISTABLUR(0,0)
END FUNCTION

FUNCTION zUSEVISTACRYSTAL(BYVAL nMode AS LONG, BYVAL RW AS LONG) AS LONG
    STATIC WasMode AS LONG
    IF RW THEN
       IF WasMode AND nMode = 0 THEN zSetCrystalBehindMode(zMainWindow(0), %FALSE)
       WasMode = nMode
    END IF
    FUNCTION = WasMode
END FUNCTION
FUNCTION SK_USEVISTACRYSTAL() AS LONG
    FUNCTION = zUSEVISTACRYSTAL(0,0)
END FUNCTION

FUNCTION zTEXTRENDERING(BYVAL nMode AS LONG, BYVAL RW AS LONG) AS LONG
    STATIC WasMode AS LONG
    IF RW THEN WasMode = nMode
    FUNCTION = WasMode
END FUNCTION
FUNCTION SK_TEXTRENDERING() AS LONG
    FUNCTION = zTEXTRENDERING(0,0)
END FUNCTION

FUNCTION zPROGRESSCOLOR(BYVAL nColor AS LONG, BYVAL RW AS LONG) AS LONG
    STATIC WasColor AS LONG
    IF RW THEN WasColor = nColor
    FUNCTION = WasColor
END FUNCTION
FUNCTION SK_PROGRESSCOLOR() AS LONG
    FUNCTION = zPROGRESSCOLOR(0,0)
END FUNCTION

FUNCTION zREMOVEBORDER(BYVAL nMode AS LONG, BYVAL RW AS LONG) AS LONG
    STATIC WasMode AS LONG
    IF RW THEN WasMode = nMode
    FUNCTION = WasMode
END FUNCTION
FUNCTION SK_REMOVEBORDER() AS LONG
    FUNCTION = zREMOVEBORDER(0,0)
END FUNCTION

FUNCTION zPAINTBACKCOLOR(BYVAL nARGB AS LONG, BYVAL RW AS LONG) AS LONG
    STATIC WasnARGB AS LONG
    IF RW THEN WasnARGB = nARGB
    FUNCTION = WasnARGB
END FUNCTION
FUNCTION SK_PAINTBACKCOLOR() AS LONG
    FUNCTION = zPAINTBACKCOLOR(0,0)
END FUNCTION

'// Static function to save tooltip handle.
FUNCTION zToolTipData (BYVAL hTooltip AS LONG, BYVAL RW AS LONG) AS LONG
    STATIC WasTooltip AS LONG
    IF RW THEN WasTooltip = hTooltip
    FUNCTION = WasTooltip
END FUNCTION

'// Load the GDI+ Dll
FUNCTION zGdipStart() EXPORT AS LONG
    DIM GpInput AS GdiplusStartupInput
    GpInput.GdiplusVersion = 1
    IF GdiplusStartup(hGDIplus&, GpInput) = 0 THEN FUNCTION = hGDIplus&
END FUNCTION

'// GDIPLUS unload (unload the GDIPLUS.DLL)
SUB zGdipEnd(BYVAL hGDIplus&) EXPORT
  ' Unload the GDI+ Dll
    IF hGDIplus& THEN GdiplusShutdown(hGDIplus&): hGDIplus& = 0
END SUB

'// Detect if Main window uses WS_EX_COMPOSITED extended style
FUNCTION zComposited() AS LONG
    IF (GetWindowLong(zMainWindow(0), %GWL_EXSTYLE) AND %WS_EX_COMPOSITED) = %WS_EX_COMPOSITED THEN FUNCTION = -1
END FUNCTION

'// Retrieve the current module instance.
FUNCTION zsInstance () AS LONG
    FUNCTION = GetModuleHandle("")
END FUNCTION

'// Full file detection.
FUNCTION zsExist (zFileSpec AS ASCIIZ) AS LONG
    LOCAL fd AS WIN32_FIND_DATA, hFind AS LONG
    IF LEN(zFileSpec) THEN
       hFind = MyFindFirstFile(zFileSpec, fd)
       IF hFind <> CLNG(%INVALID_HANDLE_VALUE) THEN
          FindClose(hFind&)
          FUNCTION = -1
       END IF
    END IF
END FUNCTION

' Changes the character being used as delimiter to read in a sequential text file.
FUNCTION zsSetBufinChar (BYVAL Char$) STATIC AS STRING
    IF LEN(Char$) THEN UserChar$ = Char$
    IF LEN(UserChar$) THEN
       FUNCTION = UserChar$
    ELSE
       FUNCTION = CHR$(13)
    END IF
END FUNCTION

' Generic open file function
FUNCTION zsFOpen (zFilName AS ASCIIZ, BYVAL AccessMode AS LONG, BYVAL ShareMode AS LONG, hFile AS LONG) AS LONG

    LOCAl AccessIs, ShareIs, FlagAndAttribute AS LONG

    AccessMode = MIN(MAX(AccessMode, 0), 2)  ' Coherce between 0-2
    IF AccessMode = 0 THEN                   ' 0 Open for read only.
       AccessIs = %GENERIC_READ
    ELSEIF AccessMode = 1 THEN               ' 1 Open for write only.
       AccessIs = %GENERIC_WRITE
    ELSE                                     ' 2 Open for read and write.
       AccessIs = %GENERIC_READ OR %GENERIC_WRITE
    END IF

    ShareMode = MIN(MAX(ShareMode, 1), 4)    ' Coherce between 1-4
    IF ShareMode = 1 THEN                    ' 1 Deny read/write access.
       ShareIs = 0
    ELSEIF ShareMode = 2 THEN                ' 2 Deny write access.
       ShareIs =  %FILE_SHARE_READ
    ELSEIF ShareMode = 3 THEN                ' 3 Deny read access.
       ShareIs =  %FILE_SHARE_WRITE
    ELSE                                     ' 4 Deny none (full share mode).
       ShareIs =  %FILE_SHARE_READ OR %FILE_SHARE_WRITE
    END IF

    IF hFile = -1 THEN
       FlagAndAttribute = %FILE_ATTRIBUTE_NORMAL OR %FILE_FLAG_WRITE_THROUGH
    ELSE
       FlagAndAttribute = %FILE_ATTRIBUTE_NORMAL
    END IF

    hFile = CreateFile(zFilName, AccessIs, ShareIs, BYVAL %NULL, %OPEN_ALWAYS, FlagAndAttribute, BYVAL %NULL)

    IF hFile = CLNG(%INVALID_HANDLE_VALUE) THEN    ' -1 Fail to create the file
       FUNCTION = GetLastError               ' Set the error code
       hFile = 0                             ' Reset handle number
    END IF

END FUNCTION

FUNCTION zsFileSize(zFilName AS ASCIIZ) AS QUAD
    LOCAL fd AS WIN32_FIND_DATA, hFind AS LONG
    hFind = MyFindFirstFile(zFilName, fd)
    IF hFind <> CLNG(%INVALID_HANDLE_VALUE) THEN
       FUNCTION = (fd.nFileSizeHigh * (%MAXDWORD + 1)) + fd.nFileSizeLow
       FindClose(hFind)
    END IF
END FUNCTION

' Dito LOF
FUNCTION zsFlof (BYVAL hFile AS LONG) AS LONG
    IF GetFileType(hFile) = %FILE_TYPE_DISK THEN
       LOCAL fSize AS LONG
       fSize = GetFileSize(hFile, BYVAL %NULL)
       IF fSize > -1 THEN FUNCTION = fSize
    END IF
END FUNCTION

FUNCTION zsFPut (BYVAL hFile AS LONG, BYVAL Buf$) AS LONG
    LOCAL LenBuf, ByttesWritten AS LONG
    IF hFile THEN
       LenBuf = LEN(Buf$)
       IF LenBuf THEN
          IF WriteFile(hFile, BYVAL STRPTR(Buf$), LenBuf, ByttesWritten, BYVAL %NULL) = 0 THEN
             FUNCTION = GetLastError()
          END IF
       END IF
    END IF
END FUNCTION

' Dito SEEK
FUNCTION zsFSeek (BYVAL hFile AS LONG, BYVAL PosByte AS LONG) AS LONG
    IF SetFilePointer(hFile, PosByte, BYVAL %NULL, %FILE_BEGIN) < 0 THEN
       FUNCTION = GetLastError
    END IF
END FUNCTION

' Dito GET
FUNCTION zsFGet (BYVAL hFile AS LONG, StringBuf AS STRING) AS LONG
    IF hFile THEN
       LOCAL LenBuf, ByttesReaded AS LONG
       LenBuf = LEN(StringBuf)
       IF LenBuf THEN
          IF ReadFile(hFile, BYVAL STRPTR(StringBuf), LenBuf, ByttesReaded, BYVAL %NULL) = 0 THEN
             FUNCTION = GetLastError
          END IF
       END IF
    END IF
END FUNCTION

' GET at a specific offset
FUNCTION zsFGetAt (BYVAL hFile AS LONG, BYVAL nPosByte AS LONG, Buf$) AS LONG
    LOCAL nErrCode AS LONG
    nErrCode = zsFSeek(hFile, nPosByte)
    IF nErrCode = 0 THEN nErrCode = zsFGet(hFile, Buf$)
    FUNCTION = nErrCode
END FUNCTION

' Dito CLOSE
SUB zsFClose ALIAS "zsFClose" (hFile AS LONG)
    IF hFile THEN CloseHandle(hFile)
    hFile = 0
END SUB

' Enhanced sequential LINEINPUT
FUNCTION zsBufin (zFileName AS ASCIIZ, nDone AS LONG) STATIC AS STRING
DIM sCr AS STRING, sBuffer AS STRING
DIM hFile AS LONG, nLocation AS LONG, nBufSize AS LONG, nBufPos AS LONG, nErrCode AS LONG, nRemaining AS LONG
DIM nCr AS LONG, nSlop AS LONG, nReading AS LONG, nLenCr AS LONG, nSizeFile AS LONG, nSaveCr AS LONG
IF LEN(zFileName) THEN
   IF NOT nReading THEN
      sCr = zsSetBufinChar("")          ' added for spec char
      nReading = -1: nDone = 0
      IF ASC(sCr) = 13 THEN             ' added for spec char
         nLenCr = 0: sCr = CHR$(13)
      ELSE                              ' added for spec char
         nLenCr = LEN(sCr)              ' added for spec char
      END IF                            ' added for spec char
      nCr = 0: nLocation = 0
      IF NOT zsExist(zFileName) THEN GOTO BufEnd  ' Nothing to do
      nErrCode = zsFOpen(zFileName, 0, 2, hFile)
      IF nErrCode THEN
         nDone = nErrCode: nReading = 0
         EXIT FUNCTION
      END IF
      nRemaining = zsFlof(hFile)                  ' Bytes count to be read
      nSizeFile = nRemaining                     ' Remember this
      IF nRemaining = 0 GOTO BufEnd              ' Nothing to read
      nBufSize = 16384
      sBuffer = SPACE$(nBufSize)
   END IF
   DO WHILE nRemaining                           ' While more in the file
      IF nCr = 0 THEN                            ' If no return was found
         IF nRemaining < nBufSize THEN           ' read only what remains.
            nBufSize = nRemaining                ' Resize the buffer.
            IF nBufSize < 1 THEN EXIT DO         ' Possible only if EOF 26.
            sBuffer = SPACE$(nBufSize)
         END IF
         nErrCode = zsFGetAt(hFile, nLocation, sBuffer) ' Read a bloc.
         nLocation = nLocation + nBufSize        ' Here we are.
         nBufPos = 1                             ' Start at the beginning
      END IF                                     ' of that bloc.
      DO                                         ' Walk through buffer.
         nCr = INSTR(nBufPos, sBuffer, sCr)      ' Look for a Return.
         IF nLenCr = 0 THEN                      ' Do this to read files with
            nLenCr = 1                           ' or without LF after CR.
            IF ASC(sBuffer, nCr + 1) = 10 THEN nLenCr = 2
         END IF
         IF nCr THEN                             ' We found one.
            nSaveCr = nCr                        ' Save where
            FUNCTION = MID$(sBuffer, nBufPos, nCr - nBufPos)
            nBufPos = nCr + nLenCr               ' In case of LF skip it
            EXIT FUNCTION                        ' all done for now.
         ELSE                                    ' Back up in the file.
          ' If we reached the end of file and no nCr
          ' was found, return what remains in the string.
            IF nLocation >= nSizeFile THEN
             ' Assign function and trap ^Z
               FUNCTION = RTRIM$(MID$(sBuffer, nSaveCr + nLenCr), CHR$(26))
               nRemaining = nBufSize
               EXIT DO
            END IF
          ' 05-06-1998 () were missing on each side of (nLenCr - 1)
            nSlop = nBufSize - nSaveCr - (nLenCr - 1) ' Calc buffer excess.
            nRemaining = nRemaining + nSlop           ' Calc file excess.
            nLocation = nLocation - nSlop
         END IF
      LOOP WHILE nCr                                 ' While more in buffer.
      nRemaining = nRemaining - nBufSize
      nSaveCr = 0
   LOOP
END IF

BufEnd:
nReading = 0: nDone = -1: zsFClose(hFile)
END FUNCTION

DECLARE FUNCTION GetCurrentDirectory LIB "KERNEL32.DLL" ALIAS "GetCurrentDirectoryA" (BYVAL nBufferLength AS LONG, lpBuffer AS ASCIIZ) AS LONG
' Returns current Disk and Path
SUB zDskPath(Dsk$, Path$)
'   Dsk$ and Path$ are ready to be concatened with a filename
'   Dsk$ and Paths correspond to the current directory
    LOCAL zTmp AS ASCIIZ * 260
    IF GetCurrentDirectory(BYVAL SIZEOF(zTmp), zTmp) THEN
       Dsk$ = LEFT$(zTmp, 2)
       Path$ = RTRIM$(MID$(zTmp, 3), ANY CHR$(0,92)) + $Anti
    END IF
END SUB

' Splits a full path name, and return the current disk and directory
SUB zSplitN (BYVAL sFullName$, sPathName$, sFilName$)
' If no path is specified then the current directory is being used.
    sPathName$ = "": sFilName$ = ""
    Length& = LEN(sFullName$)
    IF Length& THEN
       zDskPath(Dsk$, ThisPath$): sFilName$ = sFullName$
       So& = INSTR(-1, sFullName$, $Anti)
       IF So& THEN
          sPathName$ = LEFT$(sFullName$, So&)
       ELSE
          So& = INSTR(sFullName$, ":")
       END IF
       IF sPathName$ = Dsk$ OR LEN(sPathName$) = 0 THEN
          sPathName$ = Dsk$ + ThisPath$
       END IF
       IF So& THEN sFilName$ = MID$(sFullName$, So& + 1, Length& - So&)
    END IF
END SUB

DECLARE FUNCTION GetModuleFileName LIB "KERNEL32.DLL" ALIAS "GetModuleFileNameA" (BYVAL hModule AS DWORD, lpFileName AS ASCIIZ, BYVAL nSize AS DWORD) AS DWORD
FUNCTION zExeName () AS STRING
    LOCAL zTmp AS ASCIIZ * 260
    LenExeName& = GetModuleFileName(BYVAL %NULL, zTmp, SIZEOF(zTmp))
    IF LenExeName& THEN
       LenExeName& = MIN&(LenExeName&, SIZEOF(zTmp))
       FUNCTION = LEFT$(zTmp, LenExeName&)
    END IF
END FUNCTION

FUNCTION zSkinARGB(BYVAL sBF AS STRING) AS LONG
    DIM bytestruct AS COLORBYTES
    DIM result AS COLORLONG
    bytestruct.A = VAL(PARSE$(sBF, 2))
    bytestruct.R = VAL(PARSE$(sBF, 3))
    bytestruct.G = VAL(PARSE$(sBF, 4))
    bytestruct.B = VAL(PARSE$(sBF, 5))
    LSET result = bytestruct
    FUNCTION = result.longval
END FUNCTION

' WinXP Theme support declares (if applicable)
DECLARE FUNCTION EnableDialogTheme(BYVAL hDlg AS DWORD, BYVAL dwStyle AS DWORD) AS LONG
DECLARE FUNCTION IsThemeActive() AS LONG

'// Get Red byte from a RGB color.
FUNCTION zGetRValue (BYVAL colrRGB???) AS BYTE
    FUNCTION = (colrRGB??? AND &H000000FF???)
END FUNCTION

'// Get Green byte from a RGB color.
FUNCTION zGetGValue (BYVAL colrRGB???) AS BYTE
    SHIFT RIGHT colrRGB???, 8
    FUNCTION = (colrRGB??? AND &H000000FF???)
END FUNCTION

'// Get Blue byte from a RGB color.
FUNCTION zGetBValue (BYVAL colrRGB???) AS BYTE
    SHIFT RIGHT colrRGB???, 16
    FUNCTION = (colrRGB??? AND &H000000FF???)
END FUNCTION

'// Computes location and size to stretch a bitmap preserving its aspect.
SUB zComputeAspect (BYVAL xPicSize AS LONG, BYVAL yPicSize AS LONG, BYVAL xCell AS LONG, BYVAL yCell AS LONG, BYREF xPos AS LONG, BYREF yPos AS LONG, BYREF xSize AS LONG, BYREF ySize AS LONG)
    LOCAL scale AS SINGLE
    IF xPicSize THEN scale = xCell / xPicSize
    xSize = xPicSize * scale: ySize = yPicSize * scale
    IF ySize < yCell THEN
       IF yPicSize THEN scale = yCell / yPicSize
       xSize = xPicSize * scale: ySize = yPicSize * scale
    END IF
    xPos = (xCell - xSize) \ 2: yPos = (yCell - ySize) \ 2
END SUB

'// Split a true 32-bit ARGB color into its four components.
SUB zSplitColorARGB (BYVAL ARGB AS LONG, A AS BYTE, R AS BYTE, G AS BYTE, B AS BYTE)
    DIM bytestruct AS COLORBYTES
    LSET bytestruct = MKL$(ARGB&)
    A? = bytestruct.A
    R? = bytestruct.R
    G? = bytestruct.G
    B? = bytestruct.B
END SUB

'// Add the alpha channel to RGB color to create true 32-bit ARGB color.
FUNCTION zColorARGB (BYVAL AlphaChannel AS BYTE, BYVAL ColrRGB???) AS LONG
    DIM bytestruct AS COLORBYTES
    DIM result AS COLORLONG

    bytestruct.A = AlphaChannel
    bytestruct.R = zGetRValue(ColrRGB???)
    bytestruct.G = zGetGValue(ColrRGB???)
    bytestruct.B = zGetBValue(ColrRGB???)

    LSET result = bytestruct
    FUNCTION = result.longval
END FUNCTION

'// Render GDIPLUS string into graphics
FUNCTION zDrawStringFormatedEx(BYVAL graphics AS LONG, BYVAL sTxt AS STRING, _
                               BYVAL x AS LONG, BYVAL y AS LONG, BYVAL xWidth AS LONG, BYVAL yHeight AS LONG, _
                               BYVAL ColrARGB AS LONG, BYVAL TextRendering AS LONG, BYVAL curFont AS LONG, _
                               BYVAL ShadowOffSet AS LONG, BYVAL UseStrFormat AS LONG) AS LONG
    LOCAL rcLayout AS RECTF
    LOCAl nRet, brush, strFormat AS LONG
    nRet = -1
    IF graphics THEN
       IF UseStrFormat THEN
          IF UseStrFormat = %ZS_TextVertUp THEN
             SWAP xWidth, yHeight
             GdipTranslateWorldTransform(graphics, 0, y + yHeight, %MatrixOrderPrepend)
             GdipRotateWorldTransform(graphics, 270, %MatrixOrderPrepend)
          ELSEIF UseStrFormat = %BS_LABEL_MULTILINE THEN
             GdipCreateStringFormat(0, 0, strFormat)
             GdipSetStringFormatAlign(strFormat, 0)' %StringAlignmentNear)
             GdipSetStringFormatLineAlign(strFormat, 0)' %StringAlignmentNear)
          ELSE
             SWAP xWidth, yHeight
             GdipCreateStringFormat(0, 0, strFormat)
             GdipSetStringFormatFlags(strFormat, UseStrFormat)
          END IF
       END IF

       GdipSetTextRenderingHint(graphics, TextRendering)
       IF TextRendering < %TextRenderingHintClearTypeGridFit THEN y = y + 1

       IF ShadowOffset THEN
        ' Create a brush for the text shadow with
          GdipCreateSolidFill(SK_SHADOWCOLOR(), brush)
        ' Set up a drawing area for the shadow
        ' NOTE: Leaving the right and bottom values at zero means there is no boundary
          rcLayout.nLeft = x + ShadowOffset
          rcLayout.nTop = y + ShadowOffset

          IF UseStrFormat = %ZS_TextVertUp THEN
             rcLayout.nLEFT = 0  - ABS(ShadowOffset)
             rcLayout.nTop = x + ShadowOffset
             rcLayout.nRIGHT = yHeight: rcLayout.nBottom = xWidth
          END IF

          nRet = GdipDrawString(graphics, (UCODE$(sTxt)), LEN(sTxt), curFont, rcLayout, strFormat, brush)
        ' Cleanup
          GdipDeleteBrush(brush)
       END IF

       GdipCreateSolidFill(ColrARGB, brush)
       rcLayout.nLeft  = x:      rcLayout.nTop    = y
       rcLayout.nRight = xWidth: rcLayout.nBottom = yHeight

       IF UseStrFormat = %ZS_TextVertUp THEN
          rcLayout.nLEFT = 0: rcLayout.nTop = x
          rcLayout.nRIGHT = yHeight: rcLayout.nBottom = xWidth
       END IF

       nRet = GdipDrawString(graphics, (UCODE$(sTxt)), LEN(sTxt), curFont, rcLayout, strFormat, brush)

     ' Cleanup
       IF UseStrFormat THEN
          IF UseStrFormat = %ZS_TextVertUp THEN
             GdipResetWorldTransform(graphics)
          ELSE
             GdipDeleteStringFormat(strFormat)
          END IF
       END IF
       GdipDeleteBrush(brush)
    END IF
    FUNCTION = nRet
END FUNCTION

'// Draw text using GDIPLUS on any DC
FUNCTION zDrawTextToDC( _
         BYVAL hDC AS LONG, _
         zUseText AS ASCIIZ, _
         BYVAL x AS LONG, _
         BYVAL y AS LONG, _
         BYVAL ColrARGB AS LONG, _
         zUseFont AS ASCIIZ, _
         BYVAL UseSize AS LONG, _
         BYVAL Use3D AS LONG, _
         BYVAL UseStrFormat AS LONG) AS LONG
    LOCAL layoutRect  AS RECTF
    LOCAL boundingBox AS RECTF
    LOCAl nRet, graphics, strFormat, Fam, TempFont, zdW, zdH AS LONG
    LOCAL sUseText, sUseFont, sCaption AS STRING

    sUseText = zUseText: sUseFont = zUseFont

  ' Create matching font
    GdipCreateFontFamilyFromName((UCODE$(sUseFont)), 0, Fam)
    IF Fam THEN
       GdipCreateFont(Fam, UseSize, %FontStyleRegular, %UnitPixel, TempFont)
       IF TempFont THEN
        ' Shadow offset use NULL if you don't want a shadow,
        ' use positive value to display shadow right, negative value to display shadow left
        ' Draw the string
          GdipCreateStringFormat(0, 0, strFormat)
          GdipCreateFromHDC(hDC, graphics)
          sCaption = TRIM$(sUseText, ANY CHR$(0,32))
          GdipMeasureString(graphics, (UCODE$(sCaption)), LEN(sCaption), TempFont, layoutRect, strFormat, boundingBox, BYVAL %NULL, BYVAL %NULL)
          GdipDeleteStringFormat(strFormat)
          zdW   = CLNG(boundingBox.nRight + .5)
          zdH   = CLNG(boundingBox.nBottom + 1.5)
          nRet = zDrawStringFormatedEx(graphics, _
                                       sUseText, _
                                       x, y, _
                                       zdW, zdH, _
                                       ColrARGB, _
                                       SK_TEXTRENDERING(), _'%TextRenderingHintAntiAlias, _
                                       TempFont, _
                                       Use3D, _
                                       UseStrFormat)
          GdipDeleteGraphics(graphics)
          GdipDeleteFont(TempFont) ' Delete the font object
       END IF
       GdipDeleteFontFamily(Fam)   ' Delete the font family object
    END IF
    FUNCTION = nRet
END FUNCTION

'// Get window texte.
FUNCTION zGetCTLText(BYVAL hCtrl AS LONG) AS STRING
    LOCAL szText AS ASCIIZ * 4096, Length AS LONG
    Length = GetWindowText(hCtrl, szText, SIZEOF(szText))
    IF Length THEN FUNCTION = LEFT$(szText, Length)
END FUNCTION

'// To detect the language being used on the host computer.
FUNCTION IsFrench() AS LONG
    L$ = SPACE$(6)
    GetLocaleInfo(%LOCALE_USER_DEFAULT, %LOCALE_SENGLANGUAGE, BYVAL STRPTR(L$), LEN(L$))
    IF UCASE$(L$) = "FRENCH" THEN FUNCTION = -1
END FUNCTION

'// Anchor item detection.
FUNCTION zAnchorItem (BYVAL hWnd AS LONG) AS LONG
    LOCAL nItem AS LONG
    IF UBOUND(gProp) > 0 THEN
       ARRAY SCAN gProp(), FROM 1 TO 4, = MKL$(hWnd), TO nItem
    END IF
    FUNCTION = nItem
END FUNCTION

'// Delete a specific anchor property
SUB zDeleteAnchor (BYVAL hOwner AS LONG)
    LOCAL nItem AS LONG
    nItem = zAnchorItem(hOwner)
    IF nItem THEN
       ARRAY DELETE gProp(nItem)
       nItem = UBOUND(gProp) - 1
       REDIM PRESERVE gProp(1 TO nItem) AS ANCHORPROPERTY
    END IF
END SUB

'// Anchor properties setup.
FUNCTION zSetAnchorMode (BYVAL hWnd AS LONG, BYVAL AnchorMode AS LONG) AS LONG
    LOCAL pZP AS LONG
    IF hWnd THEN
       LOCAL rc AS RECT, pr AS RECT, p AS POINTAPI

       pZP = zAnchorItem(hWnd)
       IF pZP = 0 THEN ' If the object already exist then we ReUse it
          pZP = MAX&(UBOUND(gProp) + 1, 1)
          REDIM PRESERVE gProp(1 TO pZP) AS ANCHORPROPERTY
       END IF
       gProp(pZP).hWnd = hWnd
       GetWindowRect(hWnd, rc)
       p.X = rc.nLeft: p.Y = rc.nTop
       ScreenToClient(Getparent(hWnd), p)
       GetClientRect(Getparent(hWnd), pr)
       gProp(pZP).anchor     = MIN&(MAX&(AnchorMode, %ANCHOR_NONE), %ANCHOR_CENTER)
       gProp(pZP).rc.nLeft   = p.X
       gProp(pZP).rc.nTop    = p.Y
       gProp(pZP).rc.nRight  = pr.nRight - (rc.nRight - rc.nLeft + p.X)
       gProp(pZP).rc.nBottom = pr.nBottom - (rc.nBottom - rc.nTop + p.Y)

       gProp(pZP).centerx    = p.X - (pr.nRight \ 2)
       gProp(pZP).centery    = p.Y - (pr.nBottom \ 2)

       FUNCTION = -1
    END IF
END FUNCTION

'// Anchor enum callback function.
FUNCTION AnchorEnum (BYVAL hWnd AS LONG, BYVAL lParam AS LONG) AS LONG

    IF IsIconic(zMainWindow(0)) THEN FUNCTION = %FALSE: EXIT FUNCTION ' Stop enumeration

    'LOCAL zChildClass AS ASCIIZ * 32
    LOCAL pr AS RECT, rw AS RECT, nW, nH, pZP AS LONG
    LOCAL x, y, xW, yH AS LONG
    'IF GetClassName(hWnd, zChildClass, SIZEOF(zChildClass)) THEN
       pZP = zAnchorItem(hWnd)
       IF pZP THEN
          IF gProp(pZP).anchor > %ANCHOR_NONE THEN
             GetWindowRect(hWnd, rw)
             nW = rw.nRight - rw.nLeft
             nH = rw.nBottom - rw.nTop
             GetClientRect(GetParent(hWnd), pr)
             x = 0: y = 0: xW = 0: yH = 0
             SELECT CASE LONG gProp(pZP).anchor
            'CASE %ANCHOR_NONE                '= 0
             CASE %ANCHOR_WIDTH               '= 1
                  x&  = gProp(pZP).rc.nLeft
                  y&  = gProp(pZP).rc.nTop
                  xW& = MAX&(pr.nRight - gProp(pZP).rc.nLeft - gProp(pZP).rc.nRight, 0)
                  yH& = nH
             CASE %ANCHOR_RIGHT               '= 2
                  x&  = pr.nRight - nW - gProp(pZP).rc.nRight
                  y&  = gProp(pZP).rc.nTop
                  xW& = nW
                  yH& = nH
             CASE %ANCHOR_CENTER_HORZ         '= 3
                  x&  = (pr.nRight \ 2) + gProp(pZP).centerx
                  y&  = gProp(pZP).rc.nTop
                  xW& = nW
                  yH& = nH
             CASE %ANCHOR_HEIGHT              '= 4
                  x&  = gProp(pZP).rc.nLeft
                  y&  = gProp(pZP).rc.nTop
                  xW& = nW
                  yH& = MAX&(pr.nBottom - gProp(pZP).rc.nTop - gProp(pZP).rc.nBottom, 0)
             CASE %ANCHOR_HEIGHT_WIDTH        '= 5
                  x& = gProp(pZP).rc.nLeft
                  y& = gProp(pZP).rc.nTop
                  xW& = MAX&(pr.nRight - gProp(pZP).rc.nLeft - gProp(pZP).rc.nRight, 0)
                  yH& = MAX&(pr.nBottom - gProp(pZP).rc.nTop - gProp(pZP).rc.nBottom, 0)
             CASE %ANCHOR_HEIGHT_RIGHT        '= 6
                  x&  = pr.nRight - nW - gProp(pZP).rc.nRight
                  y&  = gProp(pZP).rc.nTop
                  xW& = nW
                  yH& = MAX&(pr.nBottom - gProp(pZP).rc.nTop - gProp(pZP).rc.nBottom, 0)
             CASE %ANCHOR_BOTTOM              '= 7
                  x&  = gProp(pZP).rc.nLeft
                  y&  = pr.nBottom - gProp(pZP).rc.nBottom - nH
                  xW& = nW
                  yH& = nH
             CASE %ANCHOR_BOTTOM_WIDTH        '= 8
                  x&  = gProp(pZP).rc.nLeft
                  y&  = pr.nBottom - gProp(pZP).rc.nBottom - nH
                  xW& = MAX&(pr.nRight - gProp(pZP).rc.nLeft - gProp(pZP).rc.nRight, 0)
                  yH& = nH
             CASE %ANCHOR_BOTTOM_RIGHT        '= 9
                  x&  = pr.nRight - nW - gProp(pZP).rc.nRight
                  y&  = pr.nBottom - gProp(pZP).rc.nBottom - nH
                  xW& = nW
                  yH& = nH
             CASE %ANCHOR_CENTER_HORZ_BOTTOM  '= 10
                  x&  = (pr.nRight \ 2) + gProp(pZP).centerx
                  y&  = pr.nBottom - gProp(pZP).rc.nBottom - nH
                  xW& = nW
                  yH& = nH
             CASE %ANCHOR_CENTER_VERT         '= 11
                  x&  = gProp(pZP).rc.nLeft
                  y&  = (pr.nBottom - nH) \ 2
                  xW& = nW
                  yH& = nH
             CASE %ANCHOR_CENTER_VERT_RIGHT   '= 12
                  x&  = pr.nRight - nW - gProp(pZP).rc.nRight
                  y&  = (pr.nBottom - nH) \ 2
                  xW& = nW
                  yH& = nH
             CASE %ANCHOR_CENTER              '= 13
                  x&  = (pr.nRight \ 2) + gProp(pZP).centerx
                  y&  = (pr.nBottom \ 2) + gProp(pZP).centery
                  xW& = nW
                  yH& = nH
             END SELECT
             IF lParam THEN
                DeferWindowPos(lParam, hWnd, 0, x&, y&, xW&, yH&, %SWP_NOZORDER OR %SWP_NOREDRAW)
             ELSE
                MoveWindow(hWnd, x&, y&, xW&, yH&, %FALSE)
             END IF
          END IF
       END IF
    'END IF
    FUNCTION = %TRUE ' Continue enumeration of children
END FUNCTION

'// Safe delete for GDI objects.
SUB zDeleteObject (hObject AS LONG)
    IF hObject THEN DeleteObject(hObject): hObject = 0
END SUB

'// Fills a rectangle using a specific color.
SUB zFillRect (BYVAL hGDImageDC AS LONG, BYVAL x AS LONG, BYVAL y AS LONG, BYVAL xW AS LONG, BYVAL yH AS LONG, BYVAL RGBcolor AS LONG)
    LOCAL rc AS Rect, hBrush AS LONG
    SetRect(rc, x, y, x + xW, y + yH)
    hBrush = CreateSolidBrush(RGBcolor)
    FillRect(hGDImageDC, rc, hBrush)
    zDeleteObject(hBrush)
END SUB

'// Set color for gradient fill.
FUNCTION zSetColor (BYVAL ColorByte AS BYTE) AS WORD ' AS INT
    FUNCTION = MAKWRD(0, ColorByte) ' CVI(CHR$(0,ColorByte))
END FUNCTION

'// Gradient fill.
SUB zGradientPaintDC (BYVAL hDC AS LONG, BYVAL x AS LONG, BYVAL y AS LONG, BYVAL xW AS LONG, BYVAL yH AS LONG, BYVAL TopRGB AS LONG, BYVAL BottomRGB AS LONG)
    IF TopRGB = BottomRGB THEN
       zFillRect(hDC, x, y, xW, yH, TopRGB)
    ELSE
       DIM vert(1) AS TRIVERTEX
       DIM gRect AS GRADIENT_RECT
     ' Tile the background
       vert(0).x      = x
       vert(0).y      = y
       vert(0).Red   = zSetColor(zGetRValue(TopRGB))
       vert(0).Green = zSetColor(zGetGValue(TopRGB))
       vert(0).Blue  = zSetColor(zGetBValue(TopRGB))
       vert(0).Alpha = &h0000
       vert(1).x      = xW
       vert(1).y      = yH
       vert(1).Red    = zSetColor(zGetRValue(BottomRGB))
       vert(1).Green  = zSetColor(zGetGValue(BottomRGB))
       vert(1).Blue   = zSetColor(zGetBValue(BottomRGB))
       vert(1).Alpha  = &h0000
       gRect.UpperLeft  = 0
       gRect.LowerRight = 1
       GradientFill(hDC, vert(0), 2, gRect, 1, %GRADIENT_FILL_RECT_V)
    END IF
END SUB

'// Create default font.
FUNCTION zDefaultFont () AS LONG
    STATIC hDefault AS LONG
    IF hDefault = 0 THEN hDefault = GetStockObject(%ANSI_VAR_FONT)
    FUNCTION = hDefault
END FUNCTION

'// Set the font being used for a specific control.
SUB zSetCTLFont (BYVAL hCtl AS LONG, BYVAL hFont AS LONG)
    SendMessage(hCtl, %WM_SETFONT, hFont, 0)
END SUB

'// Center text in a static control.
FUNCTION zStaticCenter (BYVAL Label$, BYVAL x AS LONG, BYVAL y AS LONG, BYVAL w AS LONG, BYVAL h AS LONG, BYVAL hParent AS LONG, BYVAL ID AS LONG) AS LONG
    LOCAL hCtl AS LONG
    hCtl = CreateWindowEx(0, "STATIC", (Label$), %WS_CHILD OR %WS_VISIBLE OR %SS_CENTER, _
                           x, y, w, h, hParent, ID, zsInstance, BYVAL %NULL)
    zSetCTLFont(hCtl, zDefaultFont)
    FUNCTION = hCtl
END FUNCTION

'// Get Main window private property
FUNCTION zGetProperty (BYVAL hWnd AS LONG, BYVAL Item AS LONG) AS LONG
    IF Item > 0 AND Item < %EXTEND_EXTRA + 1 AND hWnd THEN
       FUNCTION = GetWindowLong(hWnd, (Item - 1) * 4)
    END IF
END FUNCTION

'// Set Main window private property
SUB zSetProperty (BYVAL hWnd AS LONG, BYVAL Item AS LONG, BYVAL V AS LONG)
    IF Item > 0 AND Item < %EXTEND_EXTRA + 1 AND hWnd THEN
       SetWindowLong(hWnd, (Item - 1) * 4, V)
    END IF
END SUB

'// Create DIB section
FUNCTION zCreateDIBSection (BYVAL hDC AS LONG, BYVAL nWidth AS LONG, BYVAL nHeight AS LONG, BYVAL BitCount AS LONG) AS LONG
    LOCAL bi AS MYBITMAPINFO
    bi.bmiHeader.biSize = SIZEOF(bi.bmiHeader)
    bi.bmiHeader.biWidth = nWidth
    bi.bmiHeader.biHeight = nHeight
    bi.bmiHeader.biPlanes = 1
    bi.bmiHeader.biBitCount = BitCount
    bi.bmiHeader.biCompression = %BI_RGB
    FUNCTION = MyCreateDIBSection(hDC, bi, %DIB_RGB_COLORS, 0, 0, 0)
END FUNCTION

SUB zPaintBrushBitmap(BYVAL hDC AS LONG, BYVAL x AS LONG, BYVAL y AS LONG, BYVAL nWidth AS LONG, BYVAL nHeight AS LONG, BYVAL ARGBcolor AS LONG)
    LOCAL hDIB AS LONG, hTempDC AS LONG

    hTempDC = CreateCompatibleDC(hDC)
    hDIB = zCreateDIBSection(hTempDC, nWidth, nHeight, 32)
    SelectObject(hTempDC, hDIB)
''''''''''''''''''''''
    LOCAL bm AS BITMAP
    LOCAL pBits AS BYTE PTR, P AS LONG

    zSplitColorARGB(ARGBcolor, A?, R?, G?, B?)

    GetObject(hDIB, SIZEOF(bm), bm)
    pBits = bm.bmBits
    FOR P = (nWidth * nHeight) TO 1 STEP - 1
    'FOR Y& = rc.nBottom - 1 TO 0 STEP - 1
    '   FOR X& = 0 TO rc.nRight - 1
           @pBits[3] = A?
           @pBits[2] = R?
           @pBits[1] = G?
           @pBits[0] = B?
           pBits = pBits + 4
    '   NEXT
    NEXT
''''''''''''''''''''''
    BitBlt(hDC, x, y, nWidth, nHeight, hTempDC, 0, 0, %SRCCOPY)
    DeleteDC(hTempDC)
    zDeleteObject(hDIB)
END SUB

'// Get the size of the double buffer private bitmap
SUB zGetBitmapSize (BYVAL hBmp AS LONG, bmW AS LONG, bmH AS LONG)
    LOCAL bm AS BITMAP
    IF hBmp THEN
       GetObject(hBmp, SIZEOF(bm), bm)
       bmW = bm.bmWidth
       bmH = bm.bmHeight
    END IF
END SUB

'// Get the double buffer private bitmap.
FUNCTION zGetPaintBitmap (BYVAL hWnd AS LONG) AS LONG
    FUNCTION = zGetProperty(hWnd, %FORM_PaintBitmap)
END FUNCTION

FUNCTION zGetBackBitmap (BYVAL hWnd AS LONG) AS LONG
    FUNCTION = zGetProperty(hWnd, %BACK_PaintBitmap)
END FUNCTION

'// Get the double buffer private DC.
FUNCTION zGetPaintDC (BYVAL hWnd AS LONG) AS LONG
    FUNCTION = zGetProperty(hWnd, %FORM_PaintDC)
END FUNCTION

'// Create temporary double buffer
FUNCTION zDoubleBuffer(BYVAL hDC AS LONG, BYVAL x AS LONG, BYVAL y AS LONG, BYVAL Action AS LONG) STATIC AS LONG
    DIM Xx AS LONG, Yy AS LONG, UseDC AS LONG, hDCTemp AS LONG, hBMTemp AS LONG, hBMPrev AS LONG
    IF Action THEN
     ' Create OFF screen bitmap to avoid flickering and allow smooth display
     ' ---------------------------------------------------------------------
       hDCTemp = CreateCompatibleDC(hDC)
       hBMTemp = CreateCompatibleBitmap(hDC, x, y)
       hBMPrev = SelectObject(hDCTemp, hBMTemp)
       Xx = x: Yy = y
       UseDC = hDC
       FUNCTION = hDCTemp
    ELSE
     ' End of OFF screen drawing, fast BitBlt to the target display Window
     ' -------------------------------------------------------------------
     ' Draw final result to the target window
       BitBlt(UseDC, x, y, Xx, Yy, hDCTemp, 0, 0, %SRCCOPY)
     ' Deallocate system resources
       SelectObject(hDCTemp, hBMPrev)
       DeleteObject(hBMTemp)
       DeleteDC(hDCTemp)
       FUNCTION = 0
    END IF

END FUNCTION

'// Create permanent double buffer
FUNCTION zPaintToScreen (BYVAL hWnd AS LONG, BYVAL hDC AS LONG, BYVAL X AS LONG, BYVAL Y AS LONG, BYVAL Action AS LONG) AS LONG
    LOCAL rc AS RECT
    LOCAL bmW, bmH, ExistBitmap, hDCTemp, hPaintBitmap, hBackBitmap AS LONG

    GetClientRect(hWnd, rc)
    IF Action THEN
     ' Create OFF screen bitmap to avoid flickering and allow smooth display
     ' ---------------------------------------------------------------------
       ExistBitmap = zGetPaintBitmap(hWnd)
       IF ExistBitmap THEN
          zGetBitmapSize(ExistBitmap, bmW, bmH)
          IF MAX&(rc.nRight, X) < bmW + 1 AND MAX&(rc.nBottom, Y) < bmH + 1 THEN
             FUNCTION = zGetPaintDC(hWnd): EXIT FUNCTION
          END IF
          zDeleteObject(ExistBitmap)
          DeleteDC(zGetPaintDC(hWnd))

          '// %BACK_PaintBitmap
          hBackBitmap = zGetBackBitmap(hWnd)
          zDeleteObject(hBackBitmap): zSetProperty(hWnd, %BACK_PaintBitmap, hBackBitmap)

       END IF
       hDCTemp = CreateCompatibleDC(hDC)

       hPaintBitmap = zCreateDIBSection(hDC, MAX&(rc.nRight, X), MAX&(rc.nBottom, Y), 32)

       '// %BACK_PaintBitmap
       hBackBitmap = zCreateDIBSection(hDC, MAX&(rc.nRight, X), MAX&(rc.nBottom, Y), 32)
       zSetProperty(hWnd, %BACK_PaintBitmap, hBackBitmap)

       SelectObject(hDCTemp, hPaintBitmap)
       zSetProperty(hWnd, %FORM_PaintDC, hDCTemp)
       zSetProperty(hWnd, %FORM_PaintBitmap, hPaintBitmap)
       FUNCTION = hDCTemp
    ELSE
     ' End of OFF screen drawing, fast BitBlt to the target display Window
     ' -------------------------------------------------------------------
     ' Draw final result to the target window
       BitBlt(hDC, X, Y, rc.nRight, rc.nBottom, zGetPaintDC(hWnd), 0, 0, %SRCCOPY)
    END IF

END FUNCTION

'// To perform immediate redraw of any Windows control.
SUB zUpdateWindow (BYVAL hWnd AS LONG, BYVAL FlagMode AS LONG)
    InvalidateRect(hWnd, BYVAL 0&, FlagMode)
    UpdateWindow(hWnd)
END SUB

'// We process our custom system buttons command there.
FUNCTION zButtonSysCommand (BYVAL hWnd AS LONG, BYVAL wParam AS LONG) AS LONG
    LOCAL Done AS LONG
    Done = 0
    SELECT CASE LONG LO(INTEGER, wParam)
    CASE %ID_CLOSE
         SendMessage(hWnd, %WM_CLOSE, 0, 0)
         Done = -1
    CASE %ID_MAXIMIZE

         ShowWindow(hWnd, %SW_MAXIMIZE)
         ShowWindow(GetDlgItem(hWnd, %ID_RESTORE), %SW_SHOW)
         ShowWindow(GetDlgItem(hWnd, %ID_MAXIMIZE), %SW_HIDE)

         EnumChildWindows(hWnd, CODEPTR(AnchorEnum), 0)
         zDrawBackground()

         Done = -1
    CASE %ID_RESTORE
         ShowWindow(hWnd, %SW_RESTORE)
         ShowWindow(GetDlgItem(hWnd, %ID_MAXIMIZE), %SW_SHOW)
         ShowWindow(GetDlgItem(hWnd, %ID_RESTORE), %SW_HIDE)

'        '// I must do this, as a work around the WINDOWS way of doing RESTORE
         ShowWindow(hWnd, %SW_HIDE)

         EnumChildWindows(hWnd, CODEPTR(AnchorEnum), 0)
         zDrawBackground()

         ShowWindow(hWnd, %SW_SHOW)
         '// I must do this, as a work around the WINDOWS way of doing RESTORE

         Done = -1
    CASE %ID_MINIMIZE
         ShowWindow(hWnd, %SW_MINIMIZE)
         Done = -1
    END SELECT
    FUNCTION = Done
END FUNCTION

'// To check KEY or MOUSE button state.
FUNCTION zIsKeyDown (BYVAL CheckKey AS LONG) AS LONG
    LOCAL KeyDown AS LONG
    KeyDown = GetAsyncKeyState(CheckKey)
    FUNCTION = BIT(KeyDown, 15)
END FUNCTION

'// To check SHIFT key state.
FUNCTION zIsShiftKeyPressed () AS LONG
    FUNCTION = zIsKeyDown(16)
END FUNCTION

'// To check CTRL key state.
FUNCTION zIsCtrlKeyPressed () AS LONG
    FUNCTION = zIsKeyDown(17)
END FUNCTION

'// To check the left mouse button state.
FUNCTION zIsLButtonDown () AS LONG
    FUNCTION = zIsKeyDown(1)
END FUNCTION

'// To check the right mouse button state.
FUNCTION zIsRButtonDown () AS LONG
    FUNCTION = zIsKeyDown(2)
END FUNCTION

'// Static property to save previous procedure being used by the button's superclass
FUNCTION zButOldProc (BYVAL OldProc AS LONG, BYVAL RW AS LONG) AS LONG
    STATIC WasOldProc AS LONG
    IF RW THEN WasOldProc = OldProc
    FUNCTION = WasOldProc
END FUNCTION

'// Static property to store the previous size of the wcx.cbWndExtra class member.
FUNCTION zButOldExtra (BYVAL OldExtra AS LONG, BYVAL RW AS LONG) AS LONG
    STATIC WasOldExtra AS LONG
    IF RW THEN WasOldExtra = OldExtra \ 4
    FUNCTION = WasOldExtra
END FUNCTION

'// Get button's property.
FUNCTION zGetButProperty (BYVAL hWnd AS LONG, BYVAL Item AS LONG) AS LONG
    IF Item > 0 AND Item < %EXTEND_EXTRA + 1 AND hWnd THEN
       FUNCTION = GetWindowLong(hWnd, (zButOldExtra(0, 0) + Item - 1) * 4)
    END IF
END FUNCTION

'// Get button's image property.
FUNCTION zGetButImageBackProperty (BYVAL hWnd AS LONG) AS LONG
    FUNCTION = zGetButProperty(hWnd, %PROP_IMAGE_BACK)
END FUNCTION

'// Get button's image property.
FUNCTION zGetButImageFrontProperty (BYVAL hWnd AS LONG) AS LONG
    FUNCTION = zGetButProperty(hWnd, %PROP_IMAGE_FRONT)
END FUNCTION

'// Get button's style property.
FUNCTION zGetButStyle (BYVAL hWnd AS LONG) AS LONG
    FUNCTION = zGetButProperty(hWnd, %PROP_STYLE)
END FUNCTION

'// Set button's property.
SUB zSetImageProperty (BYVAL hWnd AS LONG, BYVAL Item AS LONG, BYVAL V AS LONG)
    IF Item > 0 AND Item < %EXTEND_EXTRA + 1 AND hWnd THEN
       SetWindowLong(hWnd, (zButOldExtra(0, 0) + Item - 1) * 4, V)
    END IF
END SUB

'// Return width and height size of a GDIPLUS image.
SUB zGetImageSize (BYVAL Img AS LONG, imgW AS LONG, imgH AS LONG)
    GdipGetImageWidth(Img, imgW)
    GdipGetImageHeight(Img, imgH)
END SUB

'// Create GDIPLUS image from any of the supported graphic format.
'// I mainly use full 32-bit PNG with transparent section and/or variable opacity
FUNCTION zCreateImageFromFile (zFullName AS ASCIIZ) AS LONG
    LOCAL So, ImageType, Img AS LONG
    So = INSTR(-1, zFullName, $Dot)
    IF NOT zsExist(zFullName) THEN So = 0
    IF So THEN
       ImageType = INSTR($GDIPLUSEXT, UCASE$(MID$(zFullName, So)) + $Dot)
       IF ImageType THEN
        ' Load the image
          IF GdipLoadImageFromFile((UCODE$(zFullName)), Img) = 0 THEN
             FUNCTION = Img
          END IF
       END IF
    END IF
END FUNCTION

SUB zDisposeImage (BYREF Img AS LONG)
    IF Img THEN GdipDisposeImage(Img): Img = 0
END SUB

FUNCTION zRegisterButton(zClass AS ASCIIZ) AS LONG
    LOCAL wcx  AS WNDCLASSEX
    LOCAL IsInitialized AS LONG
    wcx.cbSize = SIZEOF(wcx)
    IsInitialized = GetClassInfoEx(zsInstance, zClass, wcx)
    IF IsInitialized = 0 THEN
       IsInitialized = GetClassInfoEx(%NULL, "BUTTON", wcx)
       IF IsInitialized THEN
          zButOldProc(wcx.lpfnWndProc, 1)
          zButOldExtra(wcx.cbWndExtra, 1)
          wcx.lpfnWndProc   = CODEPTR(zImageButProc)
          '// %EXTEND_EXTRA
          '// We reserve %EXTEND_EXTRA bytes to easily store private properties
          '// that can be retrieved using: zSetImageProperty and zGetButProperty
          wcx.cbWndExtra    = wcx.cbWndExtra + (%EXTEND_EXTRA * 4)
          wcx.hInstance     = zsInstance
          wcx.lpszClassName = VARPTR(zClass)
          IsInitialized =  RegisterClassEx(wcx)
       END IF
    END IF
    FUNCTION = IsInitialized
END FUNCTION

FUNCTION zGetMainItem(BYVAL UseID AS LONG) AS LONG
    FUNCTION = GetDlgItem(zMainWindow(0), UseID)
END FUNCTION

'// Add image resource to LISTFNAME and LISTIMAGE
FUNCTION zAddResource(BYVAL sResource AS STRING) AS LONG
'FUNCTION = zCreateImageFromFile((sResource)): EXIT FUNCTION

    LOCAL UseStyle, hMain, hLISTFNAME, hLISTIMAGE, nIndex, hImage, nCount AS LONG
    LOCAL zTmp AS ASCIIZ * 265 ' %MAX_PATH + 5
    LOCAL zData AS ASCIIZ * 16
    GetShortPathName((sResource), zTmp, SIZEOF(zTmp))
    zTmp = UCASE$(zTmp)
    hMain = zMainWindow(0)

    UseStyle = %WS_CHILD OR %LBS_HASSTRINGS
    hLISTFNAME = zGetMainItem(%ID_LISTFNAME)
    IF hLISTFNAME = 0 THEN
       hLISTFNAME = CreateWindowEx(0, "LISTBOX", "", UseStyle, 0, 0, 0, 0, hMain, %ID_LISTFNAME, zsInstance(), BYVAL %NULL)
    END IF
    hLISTIMAGE = zGetMainItem(%ID_LISTIMAGE)
    IF hLISTIMAGE = 0 THEN
       hLISTIMAGE = CreateWindowEx(0, "LISTBOX", "", UseStyle, 0, 0, 0, 0, hMain, %ID_LISTIMAGE, zsInstance(), BYVAL %NULL)
    END IF

    IF hLISTFNAME THEN
       nIndex = SendMessage(hLISTFNAME, %LB_FINDSTRING, -1, VARPTR(zTmp))
       IF nIndex > -1 THEN '// We found same resource
          SendMessage(hLISTIMAGE, %LB_GETTEXT, nIndex, VARPTR(zData))
          hImage = VAL(zData)
'         // Get full string item
          SendMessage(hLISTFNAME, %LB_GETTEXT, nIndex, VARPTR(zTmp))
'         // Delete item before update
          SendMessage(hLISTFNAME, %LB_DELETESTRING, nIndex, 0)
          SendMessage(hLISTIMAGE, %LB_DELETESTRING, nIndex, 0)
          sResource = LEFT$(zTmp, LEN(zTmp) - 4)
          nCount = VAL(RIGHT$(zTmp, 4)) + 1
          zTmp = sResource + RIGHT$("0000" + LTRIM$(STR$(nCount)), 4)
          IF SendMessage(hLISTFNAME, %LB_ADDSTRING, 0, VARPTR(zTmp)) < 0 THEN hImage = 0
          IF SendMessage(hLISTIMAGE, %LB_ADDSTRING, 0, VARPTR(zData)) < 0 THEN hImage = 0
       ELSE                     '// Resource doesn't exist, add it
          hImage = zCreateImageFromFile((sResource))
          IF hImage THEN
             zTmp = zTmp + "0001"
             IF SendMessage(hLISTFNAME, %LB_ADDSTRING, 0, VARPTR(zTmp)) < 0 THEN zDisposeImage(hImage)
             IF hImage THEN
                zData = STR$(hImage)
                IF SendMessage(hLISTIMAGE, %LB_ADDSTRING, 0, VARPTR(zData)) < 0 THEN hImage = 0
             END IF
          END IF
       END IF
    END IF
    FUNCTION = hImage
END FUNCTION

SUB zDeleteResource(BYREF hImage AS LONG)
'zDisposeImage(hImage): EXIT SUB

    LOCAL nIndex, nCount, hLISTIMAGE, hLISTFNAME AS LONG, sResource AS STRING
    LOCAL zData AS ASCIIZ * 16, zTmp AS ASCIIZ * 265
    IF hImage THEN
       zData = STR$(hImage)
       hLISTIMAGE = zGetMainItem(%ID_LISTIMAGE)
       IF hLISTIMAGE THEN
          nIndex = SendMessage(hLISTIMAGE, %LB_FINDSTRING, -1, VARPTR(zData))
          IF nIndex > -1 THEN
             hLISTFNAME = zGetMainItem(%ID_LISTFNAME)
             IF hLISTFNAME THEN
                SendMessage(hLISTFNAME, %LB_GETTEXT, nIndex, VARPTR(zTmp))
'               // Delete item before update
                SendMessage(hLISTFNAME, %LB_DELETESTRING, nIndex, 0)
                SendMessage(hLISTIMAGE, %LB_DELETESTRING, nIndex, 0)
                sResource = LEFT$(zTmp, LEN(zTmp) - 4)
                nCount = VAL(RIGHT$(zTmp, 4)) - 1
                IF nCount > 0 THEN
                   zTmp = sResource + RIGHT$("0000" + LTRIM$(STR$(nCount)), 4)
                   SendMessage(hLISTFNAME, %LB_ADDSTRING, 0, VARPTR(zTmp))
                   SendMessage(hLISTIMAGE, %LB_ADDSTRING, 0, VARPTR(zData))
                ELSE '// No more in use, then safely delete the GDIPLUS image
                   zDisposeImage(hImage)
                END IF

             END IF
          END IF
       END IF
    END IF
END SUB

'// Remove all image resource from memory
'// Must be done just before to exit the main program in case zAddResource
'// has been used to store image handles that are not tied to a specific control.
'// For example: Image used in an ownerdrawn menu.
SUB zRemoveAllImageResource()
    LOCAL hImage, nIndex, nCount, hLISTIMAGE AS LONG
    LOCAL zData AS ASCIIZ * 16
    hLISTIMAGE = zGetMainItem(%ID_LISTIMAGE)
    IF hLISTIMAGE THEN
       nCount = SendMessage(hLISTIMAGE, %LB_GETCOUNT, 0, 0)
       IF nCount > 0 THEN
          FOR nIndex = 0 TO nCount -1
              SendMessage(hLISTIMAGE, %LB_GETTEXT, nIndex, VARPTR(zData))
              hImage = VAL(zData): zDisposeImage(hImage)
          NEXT
       END IF
'      // Destroy LISTIMAGE
       DestroyWindow(hLISTIMAGE)
    END IF
END SUB

'// Create an image button control
FUNCTION zButImage (BYVAL hOwner AS LONG, zFullpathImageName AS ASCIIZ, BYVAL x AS LONG, BYVAL y AS LONG, BYVAL ButID AS LONG, BYVAL StateMax AS LONG) AS LONG
    LOCAL hBut AS LONG

    IF zRegisterButton($ZBUTIMAGE) THEN
       LOCAL Img AS LONG
'      // Create GDIPLUS image from file
       Img = zAddResource((zFullpathImageName))
       IF Img THEN
          LOCAL btW, btH, imgW, imgH AS LONG
'         // Get the GDIPLUS image size
          zGetImageSize(Img, imgW, imgH)
          IF StateMax < 1 THEN StateMax = 5
          'IF ButID = %ID_LED THEN
          '   btW = imgW \ UseState
          'ELSE
             btW = imgW \ StateMax
          'END IF
          btH = imgH
          Style& = %WS_CHILD OR %WS_VISIBLE OR %WS_TABSTOP OR %BS_PUSHBUTTON

          IF ButID = %ID_LED THEN Style& = Style& OR %WS_DISABLED

          hBut = CreateWindowEx(%WS_EX_TRANSPARENT, $ZBUTIMAGE, "", Style&, x, y, btW, btH, hOwner, ButID, zsInstance, BYVAL %NULL)
          IF hBut THEN
'            // Save Img handle as a property
             zSetImageProperty(hBut, %PROP_IMAGE_BACK, Img)
             zSetImageProperty(hBut, %PROP_STYLE, %BS_BITMAP)
             zSetImageProperty(hBut, %PROP_STATEMAX, StateMax)
             FUNCTION = hBut
          ELSE
'            // Delete image
             zDeleteResource(Img)
          END IF
       END IF
    END IF
END FUNCTION

FUNCTION zDisplayDC() AS LONG
    FUNCTION = CreateIC("DISPLAY", BYVAL 0, BYVAL 0, BYVAL 0)
END FUNCTION

'// Create new Main form region on the fly
SUB zCreateFormRegion(BYVAL TransColor AS LONG)

    IF (GetWindowLong(zMainWindow(0), %GWL_EXSTYLE) AND %WS_EX_LAYERED) THEN EXIT SUB

    LOCAL bm AS BITMAP
    LOCAL rdh AS RGNDATAHEADER PTR
    LOCAL lpRect AS RECT PTR
    LOCAl hRgn1 AS LONG, hRgn2 AS LONG, TT AS LONG, MaxRegions AS LONG, sRegionData AS STRING
    LOCAL hDIB, I, J, K, M, IsSame, bRedraw AS LONG

    hDIB = zGetPaintBitmap(zMainWindow(0)): IF hDIB = 0 THEN EXIT SUB

    MaxRegions = 4000

    GetObject(hDIB, SIZEOF(bm), bm)
    REDIM Ar(0) AS LONG AT bm.bmBits

  ' Set up the transparent color
    IF TransColor = -1 THEN ' Common Trancolor is magenta &HFF00FF
       TransColor = (Ar((bm.bmHeight - 1) * bm.bmWidth) AND &HFFFFFF)'<--- (0, 0)
    END IF

    sRegionData = STRING$(LEN(RGNDATAHEADER) + LEN(RECT) * MaxRegions, 0)
    rdh = STRPTR(sRegionData)
    @rdh.nCount = MaxRegions + 1
    @rdh.dwSize = LEN(RGNDATAHEADER)
    @rdh.iType = %RDH_RECTANGLES
    @rdh.rcBound.nLeft = 0
    @rdh.rcBound.nTop = 0
    @rdh.rcBound.nRight = bm.bmWidth
    @rdh.rcBound.nBottom = bm.bmHeight
    FOR J = 0 TO bm.bmHeight - 1
        TT = bm.bmWidth * (bm.bmHeight - 1 - J): M = -1
        FOR I = 0 TO bm.bmWidth
            IF I = bm.bmWidth THEN K = TransColor ELSE K = (Ar(TT) AND &HFFFFFF): TT = TT + 1

            IF K = TransColor THEN IsSame = -1 ELSE IsSame = 0

            IF IsSame = 0 THEN
               IF M = -1 THEN M = I
            ELSEIF M >= 0 THEN
               IF @rdh.nCount >= MaxRegions THEN
                  hRgn2 = ExtCreateRegion(BYVAL 0, LEN(RGNDATAHEADER) + (LEN(RECT) * @rdh.nCount), BYVAL rdh)
                  IF hRgn1 = 0 THEN
                     hRgn1 = hRgn2
                  ELSE
                     CombineRgn(hRgn1, hRgn1, hRgn2, %RGN_OR)
                     zDeleteObject(hRgn2)
                  END IF
                  lpRect = LEN(RGNDATAHEADER) + rdh
                  @rdh.nCount = 0
               END IF
               INCR @rdh.nCount
               @lpRect.nLeft = M
               @lpRect.nRight = I
               @lpRect.nTop = J
               @lpRect.nBottom = J + 1
               lpRect = lpRect + LEN(RECT)
               M = -1
            END IF
        NEXT
    NEXT
    hRgn2 = ExtCreateRegion(BYVAL 0, LEN(RGNDATAHEADER) + (LEN(RECT) * @rdh.nCount), BYVAL rdh)
    IF hRgn1 = 0 THEN
       hRgn1 = hRgn2
    ELSE
       CombineRgn(hRgn1, hRgn1, hRgn2, %RGN_OR)
       DeleteObject(hRgn2)
    END IF

    IF hRgn1 THEN
       IF IsWindowVisible(zMainWindow(0)) THEN bRedraw = %TRUE ELSE bRedraw = %FALSE
       SetWindowRgn(zMainWindow(0), hRgn1, bRedraw)
    END IF

END SUB

'// Paint image in tiling mode
SUB zTilePaint (BYVAL graphics AS LONG, BYVAL Img AS LONG, BYVAL xOffset AS LONG, BYVAL yOffset AS LONG, BYVAL nPaintWidth AS LONG, BYVAL nPaintHeight AS LONG)
    IF Img THEN
       LOCAL Rows, Cols, nX, nY, nDX, nDY, ImgW, ImgH, WasImgW, ImgAttr AS LONG
       zGetImageSize(Img, ImgW, ImgH)
'      // Calc number of rows and columns to paint.
       IF ImgW THEN Rows = nPaintWidth \ ImgW: IF Rows * ImgW < nPaintWidth THEN Rows = Rows + 1
       IF ImgH THEN Cols = nPaintHeight \ ImgH: IF Cols * ImgH < nPaintHeight THEN Cols = Cols + 1
'      // Spray out across destination.
       WasImgW = ImgW
       FOR nY = 1 TO Cols + 1
           IF nDY + ImgH > nPaintHeight THEN ImgH = nPaintHeight - nDY
           nDX = 0: ImgW = WasImgW
           FOR nX = 1 TO Rows + 1
               IF nDX + ImgW > nPaintWidth THEN ImgW = nPaintWidth - nDX
               GdipDrawImageRectRectI(graphics, Img, xOffset + nDX, yOffset + nDY, ImgW, ImgH, _
                                           0, 0, ImgW, ImgH, %UnitPixel, ImgAttr)
               nDX += ImgW
           NEXT
           nDY += ImgH
       NEXT
    END IF
END SUB

'// Return a full text system error message
FUNCTION zSysErrorMessage(BYVAL nError AS LONG) AS STRING
    LOCAL zbuffer AS ASCIIZ * 256
    FormatMessage(%FORMAT_MESSAGE_FROM_SYSTEM, BYVAL %NULL, nError, %NULL, zbuffer, SIZEOF(zbuffer), BYVAL %NULL)
    IF LEN(zbuffer) THEN
       Buffer$ = RTRIM$(zBuffer, $CRLF)
       REPLACE $CRLF WITH $zLim IN Buffer$
       FUNCTION = Buffer$
    ELSE
       IF IsFrench THEN
          Af$ = "Code d'erreur inconnu : "
       ELSE
          Af$ = "Unknown error code: "
       END IF
       FUNCTION = Af$ + LTRIM$(STR$(nError))
    END IF
END FUNCTION

FUNCTION zStretchBlt ALIAS "zStretchBlt" ( _
         BYVAL hDCdest AS LONG, BYVAL xDest AS LONG, BYVAL yDest AS LONG, BYVAL DestWidth AS LONG, BYVAL DestHeight AS LONG, BYVAL hDCsrce AS LONG, BYVAL xSrce AS LONG, BYVAL ySrce AS LONG, BYVAL SrceWidth AS LONG, BYVAL SrceHeight AS LONG, _
         BYVAL dwRop AS LONG) EXPORT AS LONG
    IF zOsVersion > 499 THEN UseMode& = %HALFTONE ELSE UseMode& = %COLORONCOLOR
    IF GetStretchBltMode(hDCdest) <> UseMode& THEN
       SetStretchBltMode(hDCdest, UseMode&)
    END IF
    FUNCTION = StretchBlt(hDCdest, xDest, yDest, DestWidth, DestHeight, hDCsrce, xSrce, ySrce, SrceWidth, SrceHeight, dwRop)
    IF zOsVersion > 499 THEN
       SetBrushOrgEx(hDCdest, 0, 0, BYVAL %NULL)
    END IF
END FUNCTION

SUB zGdipBlur(BYVAL hDCdest AS LONG, BYVAL xDest AS LONG, BYVAL yDest AS LONG, BYVAL xSrce AS LONG, BYVAL ySrce AS LONG, BYVAL xWidth AS LONG, BYVAL yHeight AS LONG)
    LOCAL graphics, hDC1, hDC2, hBM1, hBM2, Img, xDiv, yDiv, nDiv, ImgAttr, hDeskTop, hDCSrce AS LONG

    IF zDwmIsCompositionEnabled() THEN

       IF SK_USEVISTABLUR() THEN
          zSetBlurBehindMode(zMainWindow(0), %TRUE, 0)
          zPaintBrushBitmap(hDCdest, 0, 0, xWidth, yHeight, zColorARGB(0, 0))
          EXIT SUB
       END IF

       IF SK_USEVISTACRYSTAL() THEN
          zSetCrystalBehindMode(zMainWindow(0), %TRUE)
          zPaintBrushBitmap(hDCdest, 0, 0, xWidth, yHeight, zColorARGB(0, 0))
          EXIT SUB
       END IF

    END IF

    hDeskTop = GetDesktopWindow(): hDCSrce = GetWindowDC(hDeskTop)

    nDiv = SK_AEROBLURLEVEL()
    IF nDiv THEN
       nDiv = nDiv + 1
       xDiv = xWidth \ nDiv
       yDiv = yHeight \ nDiv

       hDC1 = CreateCompatibleDC(hDCdest)
       hBM1 = zCreateDIBSection(hDCdest, xWidth, yHeight, 32)
       SelectObject(hDC1, hBM1)
'      // Copy from DC source
       BitBlt(hDC1, 0, 0, xWidth, yHeight, hDCSrce, xSrce, ySrce, %SRCCOPY)

       hDC2 = CreateCompatibleDC(hDCdest)
       hBM2 = zCreateDIBSection(hDCdest, xDiv, yDiV, 32)
       SelectObject(hDC2, hBM2)

'      // Perform reduction
       IF GdipCreateFromHDC(hDC2, graphics) = 0 THEN
          GdipCreateBitmapFromHBITMAP(hBM1, BYVAL %NULL, Img)
          GdipSetInterpolationMode(graphics, 2)
          GdipDrawImageRectRectI(graphics, Img, 0, 0, xDiv, yDiv, 0, 0, xWidth, yHeight, %UnitPixel, ImgAttr)
          GdipDeleteGraphics(graphics)
          GdipDisposeImage(Img)
       END IF
       zDeleteObject(hBM1)
       DeleteDC(hDC1)

'      // Blur from reduction
       IF GdipCreateFromHDC(hDCdest, graphics) = 0 THEN
          GdipCreateBitmapFromHBITMAP(hBM2, BYVAL %NULL, Img)
          GdipSetInterpolationMode(graphics, 2)
          GdipDrawImageRectRectI(graphics, Img, xDest, yDest, xWidth, yHeight, 0, 0, xDiv, yDiv, %UnitPixel, ImgAttr)
          GdipDeleteGraphics(graphics)
          GdipDisposeImage(Img)
       END IF
       zDeleteObject(hBM2)
       DeleteDC(hDC2)
    ELSE
       BitBlt(hDCdest, xDest, yDest, xWidth, yHeight, hDCSrce, xSrce, ySrce, %SRCCOPY)
    END IF

    ReleaseDC(hDeskTop, hDCSrce)

END SUB

FUNCTION zIsAeroLayered() AS LONG
    LOCAL AlphaChannel AS BYTE
    zSplitColorARGB(SK_AEROCOLOR(), AlphaChannel, 0, 0, 0)
    IF AlphaChannel < 255 THEN FUNCTION = -1
END FUNCTION

'// Paint our custom background there
SUB zMoveBackground(BYVAL rwX AS LONG, BYVAL rwY AS LONG, BYVAL nCreateRegion AS LONG)
    LOCAL hMain, hIC, hDC AS LONG, rc AS RECT
    LOCAL x, y, graphics, Img, ImgW, ImgH, Wider, ImgAttr, UseStretchMode AS LONG

    hMain = zMainWindow(0)
    IF IsIconic(hMain) THEN EXIT SUB

    GetClientRect(hMain, rc)
    hIC = zDisplayDC()
    hDC = zPaintToScreen(hMain, hIC, rc.nRight, rc.nBottom, 1)

    IF SK_AEROEMULATE() THEN
       IF zIsAeroLayered() THEN
          zGdipBlur(hDC, 0, 0, rwX, rwY, rc.nRight, rc.nBottom)
       END IF
    END IF

    IF GdipCreateFromHDC(hDC, graphics) = 0 THEN
'      // Wider is being used to compensate the stretching mode
       Wider = 20

       IF SK_AEROEMULATE() = 0 AND SK_REMOVEBORDER() = 0 THEN
'         // paint first the center
          Img = zGetProperty(hMain, %FORM_Center): zGetImageSize(Img, ImgW, ImgH)
          UseStretchMode = SK_PAINT_BACKGROUND()
'         // Paint in stretch mode
          IF UseStretchMode = %PAINT_STRETCH_MODE THEN
             LOCAL xP, yP, xS, yS AS LONG
             zComputeAspect(ImgW, ImgH, rc.nRight, rc.nBottom, xP, yP, xS, yS)
'            // Set up stretching QualityMode
             GdipSetInterpolationMode(graphics, 2)
             GdipDrawImageRectRectI(graphics, Img, xP, yP, xS, yS, _
                                         0, 0, ImgW, ImgH, %UnitPixel, ImgAttr)
          ELSE
'         // Paint in tile mode
             zTilePaint(graphics, Img, 0, 0, rc.nRight, rc.nBottom)
          END IF
       ELSE
          'GdipCreateSolidFill(SK_AEROCOLOR(), brush&)
          'Ret& = GdipFillRectangleI(graphics&, brush&, 0, 0, rc.nRight, rc.nBottom)
          'GdipDeleteBrush(brush&)
          IF SK_REMOVEBORDER() THEN
             zsGdipFillRect(graphics, 0, 0, rc.nRight, rc.nBottom, SK_PAINTBACKCOLOR() )
          ELSE
             zsGdipFillRect(graphics, 0, 0, rc.nRight, rc.nBottom, SK_AEROCOLOR() )
          END IF
       END IF

       IF SK_REMOVEBORDER() = 0 THEN
          LOCAL ImgTL, TLW, TLH AS LONG
          ImgTL = zGetProperty(hMain, %FORM_TopLeft): zGetImageSize(ImgTL, TLW, TLH)
          LOCAL ImgTR, TRW, TRH AS LONG
          ImgTR = zGetProperty(hMain, %FORM_TopRight): zGetImageSize(ImgTR, TRW, TRH)
          LOCAL ImgBL, BLW, BLH AS LONG
          ImgBL = zGetProperty(hMain, %FORM_BottomLeft): zGetImageSize(ImgBL, BLW, BLH)
          LOCAL ImgBR, BRW, BRH AS LONG
          ImgBR = zGetProperty(hMain, %FORM_BottomRight): zGetImageSize(ImgBR, BRW, BRH)

          UseStretchMode = SK_PAINT_BORDER()

'         // paint top side
          Img = zGetProperty(hMain, %FORM_TopMid): zGetImageSize(Img, ImgW, ImgH)
'         // Paint in stretch mode
          IF UseStretchMode = %PAINT_STRETCH_MODE THEN
             GdipSetClipRectI(graphics, TLW, 0, rc.nRight - (TLW + TRW), ImgH, %CombineModeIntersect)
             GdipDrawImageRectRectI(graphics, Img, 0, 0, rc.nRight + Wider, ImgH, _
                                         0, 0, ImgW, ImgH, %UnitPixel, ImgAttr)
             GdipResetClip(graphics)
          ELSE
'         // Paint in tile mode
             zTilePaint(graphics, Img, TLW, 0, rc.nRight - (TLW + TRW), ImgH)
          END IF

'         // paint bottom side
          Img = zGetProperty(hMain, %FORM_BottomMid): zGetImageSize(Img, ImgW, ImgH)
'         // Paint in stretch mode
          IF UseStretchMode THEN
             GdipSetClipRectI(graphics, BLW, rc.nBottom - ImgH, rc.nRight - (BLW + BRW), ImgH, %CombineModeIntersect)
             GdipDrawImageRectRectI(graphics, Img, 0, rc.nBottom - ImgH, rc.nRight + Wider, ImgH, _
                                         0, 0, ImgW, ImgH, %UnitPixel, ImgAttr)
             GdipResetClip(graphics)
          ELSE
             zTilePaint(graphics, Img, BLW, rc.nBottom - ImgH, rc.nRight - (BLW + BRW), ImgH)
          END IF

'         // paint left side
          Img = zGetProperty(hMain, %FORM_SideLeft): zGetImageSize(Img, ImgW, ImgH)
'         // Paint in stretch mode
          IF UseStretchMode THEN
             GdipSetClipRectI(graphics, 0, TLH, ImgW, rc.nBottom - (TLH + BLH), %CombineModeIntersect)
             GdipDrawImageRectRectI(graphics, Img, 0, 0, ImgW, rc.nBottom + Wider, _
                                         0, 0, ImgW, ImgH, %UnitPixel, ImgAttr)
             GdipResetClip(graphics)
          ELSE
             zTilePaint(graphics, Img, 0, TLH, ImgW, rc.nBottom - (TLH + BLH))
          END IF

'         // paint right side
          Img = zGetProperty(hMain, %FORM_SideRight): zGetImageSize(Img, ImgW, ImgH)
'         // Paint in stretch mode
          IF UseStretchMode THEN
             GdipSetClipRectI(graphics, rc.nRight - ImgW, TRH, ImgW, rc.nBottom - (TRH + BRH), %CombineModeIntersect)
             GdipDrawImageRectRectI(graphics, Img, rc.nRight - ImgW, 0, ImgW, rc.nBottom + Wider, _
                                         0, 0, ImgW, ImgH, %UnitPixel, ImgAttr)
             GdipResetClip(graphics)
          ELSE
             zTilePaint(graphics, Img, rc.nRight - ImgW, TRH, ImgW, rc.nBottom - (TRH + BRH))
          END IF

'         // paint top left
          GdipDrawImageRectRectI(graphics, ImgTL, 0, 0, TLW, TLH, _
                                      0, 0, TLW, TLH, %UnitPixel, ImgAttr)
'         // paint top right
          GdipDrawImageRectRectI(graphics, ImgTR, rc.nRight - TRW, 0, TRW, TRH, _
                                      0, 0, TRW, TRH, %UnitPixel, ImgAttr)
'         // paint bottom left
          GdipDrawImageRectRectI(graphics, ImgBL, 0, rc.nBottom - BLH, BLW, BLH, _
                                      0, 0, BLW, BLH, %UnitPixel, ImgAttr)
'         // paint bottom right
          GdipDrawImageRectRectI(graphics, ImgBR, rc.nRight - BRW, rc.nBottom - BRH, BRW, BRH, _
                                      0, 0, BRW, BRH, %UnitPixel, ImgAttr)

'         // paint icon
'         // Note: that we could use PNG icon either.
          'IF GdipCreateBitmapFromHICON(LoadIcon(zsInstance, "PROGRAM"), Img) = 0 THEN
          '   zGetImageSize(Img, ImgW, ImgH)
          '   zGetSysIconXY(x, y)
'         '   // Set up stretching QualityMode
          '   GdipSetInterpolationMode(graphics, 2)
          '   GdipDrawImageRectRectI(graphics, Img, x, y, SK_ICONSIZE(), SK_ICONSIZE(), _
          '                               0, 0, ImgW, ImgH, %UnitPixel, ImgAttr)
          '   zDisposeImage(Img)
          'END IF
       END IF

'      // Create the form region
       IF nCreateRegion THEN zCreateFormRegion(&hFF00FF) ' &HFF00FF = Magenta color

'      // Paint GROUPBOX with respect of the z-order
       'IF Vista() THEN PaintGroupBox(hMain, graphics)
       IF NOT zComposited() THEN PaintGroupBox(hMain, graphics)

       GdipDeleteGraphics(graphics)
    END IF

    '// %BACK_PaintBitmap
    hDCBack& = CreateCompatibleDC(hDC)
    SelectObject(hDCBack&, zGetBackBitmap(hMain))
    BitBlt(hDCBack&, 0, 0, rc.nRight, rc.nBottom, hDC, 0, 0, %SRCCOPY)
    DeleteDC(hDCBack&)

'   // Paint caption text
    zGetCaptionXY(x, y)
    zDrawTextToDC(hDC, (zGetCTLText(hMain)), x, y, gColorCaption, SK_CAPTIONFONT(), SK_CAPTIONFONTHEIGHT(), -1, 0)

    DeleteDC(hIC)
END SUB

'// Paint custom background
SUB zPaintBackground(BYVAL nCreateRegion AS LONG)
    LOCAL rw AS RECT
    GetWindowRect(zMainWindow(0), rw)
    zMoveBackground(rw.nLeft, rw.nTop, nCreateRegion)
END SUB

'// Draw our custom background there
SUB zDrawBackground()
    IF IsIconic(zMainWindow(0)) THEN EXIT SUB
'   // Paint custom background
    zPaintBackground(-1) '// -1 to create the form region
'   // We use Magenta color, -1 means use the top left pixel color at coordinate 0,0.
    '//zCreateFormRegion(&hFF00FF) ' &HFF00FF = Magenta color
END SUB

'// Draw button text
FUNCTION zDrawButtonText( _
         BYVAL hWnd AS LONG, _
         BYVAL graphics AS LONG, _
         zUseText AS ASCIIZ, _
         BYVAL xW AS LONG, _
         BYVAL yH AS LONG, _
         BYVAL ColrARGB AS LONG, _
         zUseFont AS ASCIIZ, _
         BYVAL UseSize AS LONG, _
         BYVAL Use3D AS LONG, _
         BYVAL UseStrFormat AS LONG) AS LONG
    LOCAL layoutRect  AS RECTF
    LOCAL boundingBox AS RECTF
    LOCAl x, y, nRet, strFormat, Fam, TempFont, zdW, zdH, ButtonStyle, Img, ImgW, ImgH AS LONG
    LOCAL sUseText, sUseFont, sLabel AS STRING

    sUseText = zUseText: sUseFont = zUseFont

  ' Create matching font
    GdipCreateFontFamilyFromName((UCODE$(sUseFont)), 0, Fam)
    IF Fam THEN
       GdipCreateFont(Fam, UseSize, %FontStyleRegular, %UnitPixel, TempFont)
       IF TempFont THEN

          ButtonStyle = zGetButStyle(hWnd)

        ' Shadow offset use NULL if you don't want a shadow,
        ' use positive value to display shadow right, negative value to display shadow left
        ' Draw the string
          GdipCreateStringFormat(0, 0, strFormat)
          sLabel = TRIM$(sUseText, ANY CHR$(0,32))
          GdipMeasureString(graphics, (UCODE$(sLabel)), LEN(sLabel), TempFont, layoutRect, strFormat, boundingBox, BYVAL %NULL, BYVAL %NULL)
          GdipDeleteStringFormat(strFormat)
          zdW   = CLNG(boundingBox.nRight + .5)
          zdH   = CLNG(boundingBox.nBottom + .5)' + 1.5)
          y = MAX&((yH - zdH) \ 2, 0) - 1
          IF ButtonStyle = %BS_AUTOCHECKBOX THEN
             Img = zGetButImageBackProperty(hWnd): zGetImageSize(Img, ImgW, ImgH)
             x = ImgW \ 2 + 2
          ELSEIF ButtonStyle = %BS_LABEL_LEFT THEN
             x = 0
          ELSEIF ButtonStyle = %BS_LABEL_RIGHT THEN
             LOCAL rc AS RECT
             GetClientRect(hWnd, rc)
             x = rc.nRight - zdW
          ELSEIF ButtonStyle = %BS_LABEL_MULTILINE THEN
             x = 0: y = 0: zdW = xW: zdH = yH
             UseStrFormat = %BS_LABEL_MULTILINE
          ELSE
             x = MAX&((xW - zdW) \ 2, 0)
          END IF
'         %TextRenderingHintSystemDefault            = 0 ' Glyph with system default rendering hint
'         %TextRenderingHintSingleBitPerPixelGridFit = 1 ' Glyph bitmap with hinting
'         %TextRenderingHintSingleBitPerPixel        = 2 ' Glyph bitmap without hinting
'         %TextRenderingHintAntiAliasGridFit         = 3 ' Glyph anti-alias bitmap with hinting
'         %TextRenderingHintAntiAlias                = 4 ' Glyph anti-alias bitmap without hinting
'         %TextRenderingHintClearTypeGridFit         = 5 ' Glyph CT bitmap with hinting
          nRet = zDrawStringFormatedEx(graphics, _
                                       sUseText, _
                                       x, y, _
                                       zdW, zdH, _
                                       ColrARGB, _
                                       SK_TEXTRENDERING(),_ ' %TextRenderingHintAntiAlias, _
                                       TempFont, _
                                       Use3D, _
                                       UseStrFormat)

          GdipDeleteFont(TempFont) ' Delete the font object
       END IF
       GdipDeleteFontFamily(Fam)   ' Delete the font family object
    END IF
    FUNCTION = nRet
END FUNCTION

'// Get check button status
FUNCTION zGetCheckButtonStatus(BYVAL hBut AS LONG) AS LONG
    IF SendMessage(hBut, %BM_GETCHECK, 0, 0) = %BST_CHECKED THEN
       FUNCTION = -1
    END IF
END FUNCTION

'// Set check button status
SUB zSetCheckButtonStatus(BYVAL hBut AS LONG, BYVAL TrueFalse AS LONG)
    LOCAL UseState AS LONG
    IF TrueFalse THEN UseState = %BST_CHECKED ELSE UseState = %BST_UNCHECKED
    SendMessage(hBut, %BM_SETCHECK, UseState, 0)
END SUB

'// Image button procedure
FUNCTION zImageButProc (BYVAL hWnd AS LONG, BYVAL Msg AS LONG, BYVAL wParam AS LONG, BYVAL lParam AS LONG) AS LONG
    LOCAL hDC, Img, ImgW, ImgH, graphics, ImgAttr, UseState, StateMax, IsStaticLabel AS LONG
    LOCAL rw AS RECT, rc AS RECT, lp AS POINTAPI, x, y, ButtonStyle AS LONG
    LOCAL sUseText AS STRING, nTextColor, hParent AS LONG

    SELECT CASE LONG Msg

    CASE %WM_SETTEXT
'        // Windows please do your job first.
         SendMessage(hWnd, %WM_SETREDRAW, 0, 0)
         FUNCTION = CallWindowProc(zButOldProc(0,0), hWnd, Msg, wParam, lParam)
         SendMessage(hWnd, %WM_SETREDRAW, 1, 0)
'*'         zRedrawBackground(hWnd)
         zUpdateWindow(hWnd, 1)
         EXIT FUNCTION

    CASE %WM_UPDATEUISTATE
'        // Avoid the defaut procedure to paint standard button window hover our skinned control
         EXIT FUNCTION

    CASE %WM_ERASEBKGND
         FUNCTION = 1: EXIT FUNCTION

    CASE %WM_NCPAINT
         FUNCTION = 0: EXIT FUNCTION

    CASE %WM_PAINT, %WM_PRINT
         Img = zGetButImageBackProperty(hWnd)
         ButtonStyle = zGetButStyle(hWnd)
         IF (ButtonStyle AND %BS_USERBUTTON) = %BS_USERBUTTON THEN IsStaticLabel = -1

         IF Img OR IsStaticLabel THEN
            LOCAL ps AS PAINTSTRUCT

            GetClientRect(hWnd, rc)
            IF Msg = %WM_PAINT THEN

'/////////////////////////////////////
               hDC = BeginPaint(hWnd, ps)

               IF NOT zComposited() AND ButtonStyle <> %BS_GROUPBOX THEN
                  hParent = GetParent(hWnd)
                  IF hParent = zMainwindow(0) THEN
                     hDC = zDoubleBuffer(ps.hDC, rc.nRight, rc.nBottom, 1)
'                    // Paint background first dito %WM_ERASEBKGND
                     GetWindowRect(hWnd, rw)
                     lp.x = rw.nLeft: lp.y = rw.nTop
                     ScreenToClient(hParent, lp)
'                    // BACK_PaintBitmap
                     hDCBack& = CreateCompatibleDC(hDC)
                     SelectObject(hDCBack&, zGetBackBitmap(hParent))
                     BitBlt(hDC, 0, 0, rc.nRight, rc.nBottom, hDCBack&, lp.x, lp.y, %SRCCOPY)
                     DeleteDC(hDCBack&)
                  END IF

               ELSE
                  '// In case of VISTA we paint directly into our own MainWindow double buffer
                  '// to work around the "dvm compositing" flickering
                  'IF Vista() THEN hDC = zGetPaintDC(zMainwindow(0))
                  IF NOT zComposited() THEN hDC = zGetPaintDC(zMainwindow(0))

               END IF
'/////////////////////////////////////

            ELSE ' // WM_PRINT

'/////////////////////////////////////
'              // Work around VISTA bug that doesn't respect the z-order even if it says so
               IF ButtonStyle = %BS_GROUPBOX THEN EXIT FUNCTION
'/////////////////////////////////////

               hDC = wParam

            END IF

            IF GdipCreateFromHDC(hDC, graphics) = 0 THEN

'              // Clip drawing to control size
               GdipSetClipRectI(graphics, 0, 0, rc.nRight, rc.nBottom, %CombineModeIntersect)

               GetWindowRect(hWnd, rw)
               lp.x = rw.nLeft: lp.y = rw.nTop
               ScreenToClient(GetParent(hWnd), lp)

               zGetImageSize(Img, ImgW, ImgH)

               StateMax = zGetButProperty(hWnd, %PROP_STATEMAX)

               IF GetDlgCtrlID(hWnd) = %ID_LED THEN
                  ImgW = ImgW \ StateMax
                  IF zMainWindow(0) = GetForegroundWindow THEN
                     UseState = 1
                  ELSE
                     UseState = 2
                  END IF
               ELSEIF ButtonStyle = %BS_AUTOCHECKBOX THEN
                  ImgW = ImgW \ StateMax
                  UseState = 1
                  IF zGetCheckButtonStatus(hWnd) THEN UseState = 2
               ELSEIF IsStaticLabel THEN

               ELSE
                  ImgW = ImgW \ StateMax
                  IF IsWindowEnabled(hWnd) THEN
                     UseState = 1: IF hWnd = GetFocus() AND StateMax > 3 THEN UseState = 4
                     GetCursorPos(lp)
                     ScreenToClient(hWnd, lp)
                     IF PtInRect(rc, lp.x, lp.y) THEN
                        IF zIsLButtonDown() THEN
                           IF hWnd = GetFocus() THEN
                              IF GetCursor() = LoadCursor(%NULL, BYVAL %IDC_ARROW) AND StateMax > 1 THEN UseState = 2
                           END IF
                        ELSE
                           IF StateMax > 4 THEN UseState = 5
                        END IF
                     END IF
                  ELSE
                     IF StateMax > 2 THEN UseState = 3
                  END IF
               END IF

               IF ButtonStyle = %BS_PUSHBUTTON THEN
                  zPaintButton(graphics, UseState, Img, 0, 0, rc.nRight, rc.nBottom, ButtonStyle, zGetButImageFrontProperty(hWnd))
                  sUseText = zGetCTLText(hWnd)
                  IF LEN(sUseText) THEN
                     nTextColor = zGetButProperty(hWnd, %PROP_TEXT_COLOR)
                     IF IsWindowEnabled(hWnd) = %FALSE THEN
                        zSplitColorARGB(nTextColor, A?, R?, G?, B?)
                        nTextColor = zColorARGB(64, RGB(A?, R?, B?))
                     END IF
                     zDrawButtonText(hWnd, graphics, (sUseText), _
                                          rc.nRight, rc.nBottom, _
                                          nTextColor, _                          ' ARGB color
                                          SK_TEXTFONT(), _                       ' The font to use
                                          SK_PUSHBUTFONTSIZE(), _                ' font size
                                          zGetButProperty(hWnd, %PROP_USE_3D), _ ' 3D effect
                                          0)
                  END IF
               ELSEIF ButtonStyle = %BS_GROUPBOX THEN
                  zPaintButton(graphics, 1, Img, 0, 0, rc.nRight, rc.nBottom, ButtonStyle, 0)

               ELSEIF IsStaticLabel THEN
                  sUseText = zGetCTLText(hWnd)
                  IF LEN(sUseText) THEN
                     nTextColor = zGetButProperty(hWnd, %PROP_TEXT_COLOR)
                     zDrawButtonText(hWnd, graphics, (sUseText), _
                                          rc.nRight, rc.nBottom, _
                                          nTextColor, _             ' ARGB color
                                          SK_TEXTFONT(), _          ' The font to use
                                          SK_PUSHBUTFONTSIZE(), _   ' font size
                                          zGetButProperty(hWnd, %PROP_USE_3D), _ ' 3D effect
                                          0)
                  END IF

               ELSE '                  %BS_BITMAP

                  IF ButtonStyle = %BS_AUTOCHECKBOX THEN
                     x = 0: y = (rc.nBottom - ImgH) \ 2
                  ELSE
                     x = 0: y = 0
                  END IF

                  GdipDrawImageRectRectI(graphics, Img, _
                                              x, y, ImgW, ImgH, _
                                              ImgW * UseState - ImgW, 0, ImgW, ImgH, %UnitPixel, _
                                              ImgAttr)
                  IF ButtonStyle = %BS_AUTOCHECKBOX THEN
                     sUseText = zGetCTLText(hWnd)
                     IF LEN(sUseText) THEN
                        nTextColor = zGetButProperty(hWnd, %PROP_TEXT_COLOR)
                        IF IsWindowEnabled(hWnd) = %FALSE THEN
                           zSplitColorARGB(nTextColor, A?, R?, G?, B?)
                           nTextColor = zColorARGB(64, RGB(A?, R?, B?))
                        END IF
                        zDrawButtonText(hWnd, graphics, (sUseText), _
                                             rc.nRight, rc.nBottom, _
                                             nTextColor, _                          ' ARGB color
                                             SK_TEXTFONT(), _                       ' The font to use
                                             SK_PUSHBUTFONTSIZE(), _                ' font size
                                             zGetButProperty(hWnd, %PROP_USE_3D), _ ' 3D effect
                                             0)
                     END IF
                  END IF
               END IF
               GdipDeleteGraphics(graphics)
            END IF

            IF Msg = %WM_PAINT THEN
               IF NOT zComposited() THEN zDoubleBuffer(0, 0, 0, 0)
               EndPaint(hWnd, ps)
            END IF

            FUNCTION = 0: EXIT FUNCTION
         END IF
    CASE %WM_DESTROY
'        // Delete the GDIPLUS button image
         zDeleteResource(zGetButImageBackProperty(hWnd))
         zDeleteResource(zGetButImageFrontProperty(hWnd))

    END SELECT

    FUNCTION = CallWindowProc(zButOldProc(0,0), hWnd, Msg, wParam, lParam)

END FUNCTION

'// Main window minimum horizontal track size
FUNCTION zMinTrackSizeX(BYVAL SizeX AS LONG) AS LONG
    STATIC WasSizeX AS LONG
    IF SizeX THEN WasSizeX = SizeX
    FUNCTION = WasSizeX
END FUNCTION

'// Main window minimum vertical track size
FUNCTION zMinTrackSizeY(BYVAL SizeY AS LONG) AS LONG
    STATIC WasSizeY AS LONG
    IF SizeY THEN WasSizeY = SizeY
    FUNCTION = WasSizeY
END FUNCTION

'// This procedure is being used to paint the push-buttons.
SUB zPaintButton(BYVAL gDest AS LONG, BYVAL UseState AS LONG, BYVAL ImgBack AS LONG, BYVAL x AS LONG, BYVAL y AS LONG, BYVAL xW AS LONG, BYVAL yH AS LONG, ButtonStyle AS LONG, BYVAL ImgFront AS LONG)

    LOCAL BackW, BackH, FrontW, FrontH, Xm, Ym, ImgAttr, xOffset AS LONG

    zGetImageSize(ImgBack, BackW, BackH)
    IF ButtonStyle = %BS_PUSHBUTTON THEN BackW = BackW \ 5

    zGetButtonFixXY(Xm, Ym) ' Horizontal and vertical fixed border size for stretched pushbutton

    xOffset = BackW * UseState - BackW

  ' Horizontal up
    GdipDrawImageRectRectI(gDest, ImgBack, _
                                x + xW - Xm, y, Xm, Ym, _
                                BackW * UseState - Xm, 0, Xm, Ym, _
                                %UnitPixel, ImgAttr)
    GdipDrawImageRectRectI(gDest, ImgBack, _
                                x + Xm, y, xW - Xm * 2, Ym, _
                                BackW * UseState - BackW + Xm, 0, BackW - Xm * 2, Ym, _
                                %UnitPixel, ImgAttr)
  ' Vertical left
    GdipDrawImageRectRectI(gDest, ImgBack, _
                                x, y, Xm, Ym, _
                                BackW * UseState - BackW, 0, Xm, Ym, _
                                %UnitPixel, ImgAttr)
    GdipDrawImageRectRectI(gDest, ImgBack, _
                                x, y + Ym, Xm, yH - Ym * 2, _
                                BackW * UseState - BackW, Ym, Xm, BackH - Ym * 2, _
                                %UnitPixel, ImgAttr)
    GdipDrawImageRectRectI(gDest, ImgBack, _
                                x, y + yH - Ym, Xm, Ym, _
                                BackW * UseState - BackW, BackH - Ym, Xm, Ym, _
                                %UnitPixel, ImgAttr)

  ' Middle button (draw the whole surface except the pixels border)
    GdipDrawImageRectRectI(gDest, ImgBack, _
                                x + Xm, y + Ym, xW - Xm * 2, yH - Ym * 2, _
                                BackW * UseState - BackW + Xm, 0 + Ym, BackW - Xm * 2, BackH - Ym * 2, _
                                %UnitPixel, ImgAttr)

  ' Horizontal down
    GdipDrawImageRectRectI(gDest, ImgBack, _
                                x + Xm, y + yH - Ym, xW - Xm * 2, Ym, _
                                BackW * UseState - BackW + Xm, BackH - Ym, BackW - Xm * 2, Ym, _
                                %UnitPixel, ImgAttr)
  ' Vertical right
    GdipDrawImageRectRectI(gDest, ImgBack, _
                                x + xW - Xm, y + Ym, Xm, yH - Ym * 2, _
                                BackW * UseState - Xm, Ym, Xm, BackH - Ym * 2, _
                                %UnitPixel, ImgAttr)
    GdipDrawImageRectRectI(gDest, ImgBack, _
                                x + xW - Xm, y + yH - Ym, Xm, Ym, _
                                BackW * UseState - Xm, BackH - Ym, Xm, Ym, _
                                %UnitPixel, ImgAttr)

    IF ImgFront THEN
       zGetImageSize(ImgFront, FrontW, FrontH)
       Xm = (xW - FrontW) \ 2: Ym = (yH - FrontH) \ 2
       IF UseState = 2 THEN Xm = Xm + 1: Ym = Ym + 1
       GdipDrawImageRectRectI(gDest, ImgFront, x + Xm, y + Ym, FrontW, FrontH, 0, 0, FrontW, FrontH, %UnitPixel, ImgAttr)
    END IF

END SUB

'// Create a static label control
FUNCTION zStaticLabelEx (BYVAL hOwner AS LONG, zLabel AS ASCIIZ, BYVAL x AS LONG, BYVAL y AS LONG, BYVAL xW AS LONG, BYVAL yH AS LONG, BYVAL ButID AS LONG, BYVAL ARGBColor AS LONG, BYVAL UseStyle AS LONG, BYVAL Use3D AS LONG) AS LONG
    LOCAL hBut AS LONG
    IF zRegisterButton($ZBUTIMAGE) THEN
       Style& = %WS_CHILD OR %WS_VISIBLE OR %WS_DISABLED
       StyleEx& = %WS_EX_TRANSPARENT
       hBut = CreateWindowEx(StyleEx&, $ZBUTIMAGE, zLabel, Style&, x, y, xW, yH, hOwner, ButID, zsInstance, BYVAL %NULL)
       IF hBut THEN
          zSetImageProperty(hBut, %PROP_TEXT_COLOR, ARGBColor)
          IF UseStyle = 0 THEN UseStyle = %BS_LABEL_LEFT
          zSetImageProperty(hBut, %PROP_STYLE, UseStyle)
          IF Use3D THEN zSetImageProperty(hBut, %PROP_USE_3D, Use3D)
          FUNCTION = hBut
       END IF
    END IF
END FUNCTION

'// Create a static label control
FUNCTION zStaticLabel (BYVAL hOwner AS LONG, zLabel AS ASCIIZ, BYVAL x AS LONG, BYVAL y AS LONG, BYVAL xW AS LONG, BYVAL yH AS LONG, BYVAL ButID AS LONG, BYVAL ARGBColor AS LONG, BYVAL UseStyle AS LONG) AS LONG
    FUNCTION = zStaticLabelEx (hOwner, zLabel, x, y, xW, yH, ButID, ARGBColor, UseStyle, 0)
END FUNCTION

'// Create a frame button control
FUNCTION zFrameButton (BYVAL hOwner AS LONG, zFullpathImageName AS ASCIIZ, zLabel AS ASCIIZ, BYVAL x AS LONG, BYVAL y AS LONG, BYVAL xW AS LONG, BYVAL yH AS LONG, BYVAL ButID AS LONG, BYVAL StateMax AS LONG) AS LONG
    LOCAL hBut AS LONG
    IF zRegisterButton($ZBUTIMAGE) THEN
       LOCAL Img AS LONG
'      // Create GDIPLUS image from file
       Img = zAddResource((zFullpathImageName))
       IF Img THEN
          Style& = %WS_CHILD OR %WS_VISIBLE OR %WS_DISABLED
          hBut = CreateWindowEx(%WS_EX_TRANSPARENT, $ZBUTIMAGE, zLabel, Style&, x, y, xW, yH, hOwner, ButID, zsInstance, BYVAL %NULL)
          IF hBut THEN
             IF StateMax < 1 THEN StateMax = 1
'            // Save Img handle as a property
             zSetImageProperty(hBut, %PROP_STYLE, %BS_GROUPBOX)
             zSetImageProperty(hBut, %PROP_IMAGE_BACK, Img)
             zSetImageProperty(hBut, %PROP_STATEMAX, StateMax)
             FUNCTION = hBut
          ELSE
'            // Delete image
             zDeleteResource(Img)
          END IF
       END IF
    END IF
END FUNCTION

'// Create a check button control
FUNCTION zCheckButton (BYVAL hOwner AS LONG, zFullpathImageName AS ASCIIZ, zLabel AS ASCIIZ, BYVAL x AS LONG, BYVAL y AS LONG, BYVAL xW AS LONG, BYVAL yH AS LONG, BYVAL ButID AS LONG, BYVAL ARGBColor AS LONG, BYVAL StateMax AS LONG) AS LONG
    LOCAL hBut AS LONG
    IF zRegisterButton($ZBUTIMAGE) THEN
       LOCAL Img AS LONG
'      // Create GDIPLUS image from file
       Img = zAddResource((zFullpathImageName))
       IF Img THEN
          Style& = %WS_CHILD OR %WS_VISIBLE OR %WS_TABSTOP OR %BS_AUTOCHECKBOX
          hBut = CreateWindowEx(%WS_EX_TRANSPARENT, $ZBUTIMAGE, zLabel, Style&, x, y, xW, yH, hOwner, ButID, zsInstance, BYVAL %NULL)
          IF hBut THEN
             IF StateMax < 1 THEN StateMax = 2
'            // Save Img handle as a property
             zSetImageProperty(hBut, %PROP_IMAGE_BACK, Img)
             zSetImageProperty(hBut, %PROP_STYLE, %BS_AUTOCHECKBOX)
             zSetImageProperty(hBut, %PROP_TEXT_COLOR, ARGBColor)
             zSetImageProperty(hBut, %PROP_STATEMAX, StateMax)
             FUNCTION = hBut
          ELSE
'            // Delete image
             zDeleteResource(Img)
          END IF
       END IF
    END IF
END FUNCTION

'// Create a radio button control
FUNCTION zRadioButton (BYVAL hOwner AS LONG, zFullpathImageName AS ASCIIZ, zLabel AS ASCIIZ, BYVAL x AS LONG, BYVAL y AS LONG, BYVAL xW AS LONG, BYVAL yH AS LONG, BYVAL ButID AS LONG, BYVAL ARGBColor AS LONG, BYVAL StateMax AS LONG) AS LONG
    LOCAL hBut AS LONG
    IF zRegisterButton($ZBUTIMAGE) THEN
       LOCAL Img AS LONG
'      // Create GDIPLUS image from file
       Img = zAddResource((zFullpathImageName))
       IF Img THEN
          Style& = %WS_CHILD OR %WS_VISIBLE OR %WS_TABSTOP OR %BS_AUTORADIOBUTTON
          hBut = CreateWindowEx(%WS_EX_TRANSPARENT, $ZBUTIMAGE, zLabel, Style&, x, y, xW, yH, hOwner, ButID, zsInstance, BYVAL %NULL)
          IF hBut THEN
             IF StateMax < 1 THEN StateMax = 2
'            // Save Img handle as a property
             zSetImageProperty(hBut, %PROP_IMAGE_BACK, Img)
             zSetImageProperty(hBut, %PROP_STYLE, %BS_AUTOCHECKBOX)
             zSetImageProperty(hBut, %PROP_TEXT_COLOR, ARGBColor)
             zSetImageProperty(hBut, %PROP_STATEMAX, StateMax)
             FUNCTION = hBut
          ELSE
'            // Delete image
             zDeleteResource(Img)
          END IF
       END IF
    END IF
END FUNCTION

'// Create a push button control
FUNCTION zPushButtonEx (BYVAL hOwner AS LONG, zFullpathImageBack AS ASCIIZ, zLabel AS ASCIIZ, _
                      BYVAL x AS LONG, BYVAL y AS LONG, BYVAL xW AS LONG, BYVAL yH AS LONG, _
                      BYVAL ButID AS LONG, BYVAL ARGBColor AS LONG, BYVAL Use3D AS LONG, BYVAL StateMax AS LONG, zFullpathImageFront AS ASCIIZ) AS LONG
    LOCAL hBut AS LONG

    IF zRegisterButton($ZBUTIMAGE) THEN
       LOCAL ImgBack, ImgFront AS LONG
'      // Create GDIPLUS image from file
       ImgBack = zAddResource((zFullpathImageBack))
       IF ImgBack THEN
          Style& = %WS_CHILD OR %WS_VISIBLE OR %WS_TABSTOP OR %BS_PUSHBUTTON
          hBut = CreateWindowEx(%WS_EX_TRANSPARENT, $ZBUTIMAGE, zLabel, Style&, x, y, xW, yH, hOwner, ButID, zsInstance, BYVAL %NULL)
          IF hBut THEN
             IF StateMax < 1 THEN StateMax = 5
'            // Save ImgBack handle as a property
             zSetImageProperty(hBut, %PROP_IMAGE_BACK, ImgBack)
             zSetImageProperty(hBut, %PROP_STYLE, %BS_PUSHBUTTON)
             zSetImageProperty(hBut, %PROP_TEXT_COLOR, ARGBColor)
             zSetImageProperty(hBut, %PROP_USE_3D, Use3D)
             zSetImageProperty(hBut, %PROP_STATEMAX, StateMax)

             ImgFront = zAddResource((zFullpathImageFront))
             zSetImageProperty(hBut, %PROP_IMAGE_FRONT, ImgFront)

             FUNCTION = hBut
          ELSE
'            // Delete image
             zDeleteResource(ImgBack)
          END IF
       END IF
    END IF
END FUNCTION

FUNCTION zPushButton (BYVAL hOwner AS LONG, zFullpathImageName AS ASCIIZ, zLabel AS ASCIIZ, _
                      BYVAL x AS LONG, BYVAL y AS LONG, BYVAL xW AS LONG, BYVAL yH AS LONG, _
                      BYVAL ButID AS LONG, BYVAL ARGBColor AS LONG, BYVAL Use3D AS LONG, BYVAL StateMax AS LONG) AS LONG
    FUNCTION = zPushButtonEx(hOwner, zFullpathImageName, zLabel, x, y, xW, yH, ButID, ARGBColor, Use3D, StateMax, "")
END FUNCTION

' Allows to use Windows translucency with 2000 and XP
FUNCTION zSetLayeredAlpha (BYVAL hWnd AS LONG, BYVAL TransLevel AS BYTE) AS LONG
    STATIC hLib???, hProc???
    IF hLib??? = 0 THEN hLib??? = LoadLibrary ("User32.dll")
    IF hLib??? AND zOsVersion > 499 THEN ' If Windows 2000 or XP
       IF hProc??? = 0 THEN hProc??? = GetProcAddress(hLib???, "SetLayeredWindowAttributes")
       IF hProc??? THEN
          OldStyle& = GetWindowLong(hWnd, %GWL_EXSTYLE)
          SetWindowLong(hWnd, %GWL_EXSTYLE, OldStyle& OR %WS_EX_LAYERED)
        ' Use this with a transparent color
        ' CALL DWORD hProc??? USING SetLayeredWindowAttributes (hWnd&, RGB(255,0,255), TransLevel?, %LWA_ALPHA OR %LWA_COLORKEY) TO lRet&
          CALL DWORD hProc??? USING SetLayeredWindowAttributes (hWnd, 0, TransLevel, %LWA_ALPHA) TO lRet&
          IF lRet& THEN FUNCTION = -1
       END IF
    END IF
END FUNCTION

'// Create or add tooltip
FUNCTION zCreateToolTip (BYVAL hObj AS LONG, zText AS ASCIIZ) AS LONG

    LOCAL hTooltip AS LONG, StyleEx AS LONG, hParent AS LONG, ti AS TOOLINFO

    hParent = GetParent(hObj)
    hTooltip = zToolTipData(0, 0)
    IF hTooltip = 0 THEN
       InitCommonControls()
       StyleEx = 0 ' %WS_EX_TOPMOST ' Instead of 0 to use it with skMsgBox buttons
       hTooltip = CreateWindowEx(StyleEx, _
                             "tooltips_class32", _
                             BYVAL %NULL, _
                             %WS_POPUP OR %TTS_ALWAYSTIP, _
                             %CW_USEDEFAULT, _
                             %CW_USEDEFAULT, _
                             %CW_USEDEFAULT, _
                             %CW_USEDEFAULT, _
                             BYVAL hParent, _
                             BYVAL %NULL, _
                             zsInstance(), _
                             BYVAL %NULL)
       IF hTooltip THEN
          zToolTipData(hTooltip, 1)
          zSplitColorARGB(SK_ACTIVECAPTION(), A?, R?, G?, B?)
          SendMessage(hTooltip, %TTM_SETTIPTEXTCOLOR, RGB(R?, G?, B?), 0)
          zSplitColorARGB(SK_INACTIVECAPTION(), A?, R?, G?, B?)
          SendMessage(hTooltip, %TTM_SETTIPBKCOLOR, RGB(R?, G?, B?), 0)
          SendMessage(hTooltip, %TTM_SETMAXTIPWIDTH, 0, 400)
       END IF
    END IF
    IF hTooltip THEN
       ti.cbSize   = sizeof(ti)
       ti.hinst    = zsInstance
       ti.uFlags   = %TTF_IDISHWND OR %TTF_SUBCLASS
       ti.hWnd     = hParent
       ti.uId      = hObj
     ' Add tooltip now.
       SendMessage(hTooltip, %TTM_ADDTOOL, 0, BYVAL VARPTR(ti))
       zSetToolTipText(hObj, zText)
    END IF
    FUNCTION = hTooltip
END FUNCTION

'// Update tooltip item.
SUB zSetToolTipText (BYVAL hObj AS LONG, zText AS ASCIIZ)
    LOCAL ti AS TOOLINFO
    LOCAL hTooltip AS LONG, sText AS STRING, zLabel AS ASCIIZ * 256
    sText = zText
    REPLACE $zLim WITH $CR IN sText
    zLabel = sText
    hTooltip = zToolTipData(0, 0)
    IF hTooltip THEN
       ti.cbSize   = sizeof(ti)
       ti.hinst    = zsInstance
       ti.uFlags   = %TTF_IDISHWND
       ti.hWnd     = GetParent(hObj)
       ti.uId      = hObj
       ti.lpszText = VARPTR(zLabel)
     ' Add tooltip now.
       SendMessage(hTooltip, %TTM_UPDATETIPTEXT, 0, BYVAL VARPTR(ti))
    END IF
END SUB

'// Get tooltip text
FUNCTION zGetToolTipText (BYVAL hObj AS LONG) AS STRING
    LOCAL ti AS TOOLINFO
    LOCAL hTooltip AS LONG, zLabel AS ASCIIZ * 256
    hTooltip = zToolTipData(0, 0)
    IF hTooltip THEN
       ti.cbSize   = sizeof(ti)
       ti.hinst    = zsInstance
       ti.uFlags   = %TTF_IDISHWND
       ti.hWnd     = GetParent(hObj)
       ti.uId      = hObj
       ti.lpszText = VARPTR(zLabel)
     ' Get tooltip now.
       SendMessage(hTooltip, %TTM_GETTEXT, 0, BYVAL VARPTR(ti))
    END IF
    FUNCTION = zLabel
END FUNCTION

'// Set control z-order
SUB zSetZorder(BYVAL hWnd AS LONG, BYVAL UseOrder AS LONG)
    SetWindowPos(hWnd, UseOrder, 0, 0, 0, 0, %SWP_NOMOVE OR %SWP_NOSIZE OR %SWP_NOACTIVATE)
END SUB

'// Detect track bar orientation
FUNCTION TrackOrientation(BYVAL hWnd AS LONG) AS LONG
    LOCAL rc AS RECT
    GetClientRect(hWnd, rc): IF rc.nRight > rc.nBottom THEN FUNCTION = %TRACK_HORZ ' -1
END FUNCTION

'// Get track value
FUNCTION zGetTrackValue(BYVAL hWnd AS LONG) AS LONG
    IF hWnd THEN FUNCTION = zGetProperty(hWnd, %TRACK_VALUE)
END FUNCTION

'// Update trackbar Min Max values
SUB zSetTrackMinMax(BYVAL hCtrl AS LONG, BYVAL tMin AS LONG, BYVAL tMax AS LONG)
    zSetProperty(hCtrl, %TRACK_MINVAL, tMin)
    zSetProperty(hCtrl, %TRACK_MAXVAL, tMax)
END SUB

'// Update track value
SUB zSetTrackValue(BYVAL hWnd AS LONG, BYVAL tVal AS LONG)
    LOCAL tMin, tMax AS LONG
    tMin = zGetProperty(hWnd, %TRACK_MINVAL)
    tMax = zGetProperty(hWnd, %TRACK_MAXVAL)
    IF tMin > tMax THEN SWAP tMin, tMax ' <--- Must check for this first
    tVal = MIN&(MAX&(tMin, tVAL), tMax)
    IF tVal <> zGetTrackValue(hWnd) THEN
       zSetProperty(hWnd, %TRACK_VALUE, tVal)
       zSetProperty(hWnd, %TRACK_WAS_VALUE, tVal)

'       LOCAL rw AS RECT
'       LOCAL lp AS POINTAPI
'       GetWindowRect(hWnd, rw)
'       lp.x = rw.nLeft: lp.y = rw.nTop
'       ScreenToClient(GetParent(hWnd), lp)
'       SetRect(rw, lp.x, lp.y, lp.x + rw.nRight - rw.nLeft, lp.y + rw.nBottom - rw.nTop)
'       InvalidateRect(GetParent(hWnd), rw, %TRUE)

       zUpdateWindow(hWnd, 0) '//VISTA
    END IF
END SUB

'// Compute X,Y thumb location based on the current tVal (value)
SUB GetThumbTrackLocation(BYVAL hWnd AS LONG, BYREF tx AS LONG, BYREF ty AS LONG)
    LOCAL rc AS RECT, increment AS DOUBLE, Img, imgW, imgH, tMin, tMax, tVal, range AS LONG

    GetClientRect(hWnd, rc)

    Img  = zGetProperty(hWnd, %TRACK_IMAGE): zGetImageSize(Img, imgW, imgH)
    tMin = zGetProperty(hWnd, %TRACK_MINVAL)
    tMax = zGetProperty(hWnd, %TRACK_MAXVAL)
    tVal = zGetTrackValue(hWnd)

    IF TrackOrientation(hWnd) = %TRACK_HORZ THEN
        ty = (rc.nBottom - imgW) \ 2
        range = rc.nRight - imgW
        increment = (tMax - tMin) / range
        IF increment = 0 THEN
            tx = 0
        ELSE
            tx = (tVal - tMin) / increment
        END IF
    ELSE
        tx = (rc.nRight - imgW) \ 2 + 1
        range = rc.nBottom - imgH
        increment = (tMax - tMin) / range
        IF increment = 0 THEN
            ty = 0
        ELSE
            ty = (tVal - tMin) / increment
        END IF
    END IF
    zSetProperty(hWnd, %TRACK_XY, MAKLNG(tx,ty))
END SUB

'// Update X,Y thumb location
SUB SetThumbLocation(BYVAL hWnd AS LONG, x AS LONG, y AS LONG)
    LOCAL rc AS RECT, increment AS DOUBLE, Img, imgW, imgH, tx, ty, tMin, tMax, tVal, range AS LONG
    GetClientRect(hWnd, rc)
    Img  = zGetProperty(hWnd, %TRACK_IMAGE): zGetImageSize(Img, imgW, imgH)
    tMin = zGetProperty(hWnd, %TRACK_MINVAL)
    tMax = zGetProperty(hWnd, %TRACK_MAXVAL)

    IF TrackOrientation(hWnd) = %TRACK_HORZ THEN
       'x = MIN&(MAX&(x, 0), rc.nRight)
       tx = MIN&(MAX&(x - imgW \ 2, 0), rc.nRight - imgW)
       ty = ((rc.nBottom - imgW ) \ 2)
       range = rc.nRight - imgW
       increment = (tMax - tMin) / range
       tVal = (increment * tx) + tMin
    ELSE
       tx = (rc.nRight - imgW) \ 2 + 1
       ty = MIN&(MAX&(y - imgH \ 2, 0), rc.nBottom - imgH)
       range = rc.nBottom - imgH
       increment = (tMax - tMin) / range
       tVal = (increment * ty) + tMin
    END IF
    zSetProperty(hWnd, %TRACK_VALUE, tVal)
    zSetProperty(hWnd, %TRACK_XY, MAKLNG(tx,ty))

    IF tVal <> zGetProperty(hWnd, %TRACK_WAS_VALUE) THEN
       zUpdateWindow(hWnd, 0)
       zSetToolTipText(hWnd, (LTRIM$(STR$(tVal))))
    END IF
    zSetProperty(hWnd, %TRACK_WAS_VALUE, tVal)

END SUB

'// Detect if mouse cursor hover track thumb
FUNCTION CheckOverThumb(BYVAL hWnd AS LONG, BYVAL x AS LONG, y AS LONG) AS LONG
    LOCAL r AS RECT, tx, ty, Img, imgW, imgH AS LONG
    tx = LO(INTEGER, zGetProperty(hWnd, %TRACK_XY))
    ty = HI(INTEGER, zGetProperty(hWnd, %TRACK_XY))
    Img  = zGetProperty(hWnd, %TRACK_IMAGE): zGetImageSize(Img, imgW, imgH)
    GetClientRect(hWnd, r)
    SetRect(r, tx, ty, tx + imgW, ty + imgH)
    FUNCTION = PtInRect(r, x, y)
END FUNCTION

'// We handle all our custom trackbar messages there
FUNCTION TrackProc (BYVAL hWnd AS LONG, BYVAL Msg AS LONG, BYVAL wParam AS LONG, BYVAL lParam AS LONG) EXPORT AS LONG
    LOCAL rc AS RECT, rw AS RECT
    LOCAL lp AS POINTAPI
    LOCAL hDC, graphics, WasValue AS LONG

    SELECT CASE LONG Msg

    CASE %WM_MOUSEMOVE
         IF zGetProperty(hWnd, %TRACK_THUMB_MOVING) THEN
'           // Check if left mouse button still down
            LOCAL LeftButtonDown AS LONG
            LeftButtonDown = (wParam AND %MK_LBUTTON)
            IF LeftButtonDown = 0 THEN
               zSetToolTipText(hWnd, (zGetCTLText(hWnd)))
'              // Send message to parent to notify the new value
               SendMessage(GetParent(hWnd), %WM_COMMAND, MAKLNG(GetDlgCtrlID(hWnd),0), zGetTrackValue(hWnd))
            END IF
            zSetProperty(hWnd, %TRACK_THUMB_MOVING, LeftButtonDown)
         END IF
         IF zGetProperty(hWnd, %TRACK_THUMB_MOVING) THEN
            WasValue = zGetProperty(hWnd, %TRACK_WAS_VALUE)
            SetThumbLocation(hWnd, LO(INTEGER, lParam), HI(INTEGER, lParam))
            IF WasValue <> zGetProperty(hWnd, %TRACK_VALUE) THEN
               '//Send message to parent to notify the new value
               SendMessage(GetParent(hWnd), %WM_COMMAND, MAKLNG(GetDlgCtrlID(hWnd),0), zGetTrackValue(hWnd))
            END IF
         END IF

    CASE %WM_LBUTTONDOWN
         ReleaseCapture
         SetCapture(hWnd)

         sToolTip$ = zGetToolTipText(hWnd)
         SendMessage(hWnd, %WM_SETTEXT, 0, STRPTR(sToolTip$))
         WasValue = zGetProperty(hWnd, %TRACK_WAS_VALUE)
         zSetProperty(hWnd, %TRACK_THUMB_MOVING, %TRUE)
         SetThumbLocation(hWnd, LO(INTEGER, lParam), HI(INTEGER, lParam))
         IF WasValue <> zGetProperty(hWnd, %TRACK_VALUE) THEN
            '//Send message to parent to notify the new value
            SendMessage(GetParent(hWnd), %WM_COMMAND, MAKLNG(GetDlgCtrlID(hWnd),0), zGetTrackValue(hWnd))
         END IF

    CASE %WM_RBUTTONDOWN
         WasValue = zGetProperty(hWnd, %TRACK_WAS_VALUE)
         IF WasValue <> zGetProperty(hWnd, %TRACK_DEFAULT_VALUE) THEN
            zSetTrackValue(hWnd, zGetProperty(hWnd, %TRACK_DEFAULT_VALUE))
            SendMessage(GetParent(hWnd), %WM_COMMAND, MAKLNG(GetDlgCtrlID(hWnd),0), zGetTrackValue(hWnd))
         END IF

    CASE %WM_LBUTTONUP
         ReleaseCapture

         zSetToolTipText(hWnd, (zGetCTLText(hWnd)))
         zSetProperty(hWnd, %TRACK_THUMB_MOVING, %FALSE)
'        // Send message to parent to notify the new value
         SendMessage(GetParent(hWnd), %WM_COMMAND, MAKLNG(GetDlgCtrlID(hWnd),0), zGetTrackValue(hWnd))

    CASE %WM_ERASEBKGND
         FUNCTION = 1: EXIT FUNCTION

    CASE %WM_PAINT, %WM_PRINT
         LOCAL Img, imgW, imgH, tMin, tMax, tVal, tx, ty, x, y, ImgAttr AS LONG
         LOCAL ARGB, PROGRESScolor AS LONG, A, R, G, B AS BYTE

         Img  = zGetProperty(hWnd, %TRACK_IMAGE)
         tMin = zGetProperty(hWnd, %TRACK_MINVAL)
         tMax = zGetProperty(hWnd, %TRACK_MAXVAL)
         tVal = zGetTrackValue(hWnd)
         ARGB = zGetProperty(hWnd, %TRACK_ARGB)
         PROGRESScolor = zGetProperty(hWnd, %TRACK_PROGRESSCOLOR)
         IF Img THEN
            LOCAL ps AS PAINTSTRUCT
            GetClientRect(hWnd, rc)
            IF Msg = %WM_PAINT THEN

               hDC = BeginPaint(hWnd, ps)

               IF NOT zComposited() THEN
                  hDC = zDoubleBuffer(ps.hDC, rc.nRight, rc.nBottom, 1)
'                 // Paint background first dito %WM_ERASEBKGND
                  GetWindowRect(hWnd, rw)
                  lp.x = rw.nLeft: lp.y = rw.nTop
                  ScreenToClient(zMainwindow(0), lp)

                  '// BACK_PaintBitmap
                  hDCBack& = CreateCompatibleDC(hDC)
                  SelectObject(hDCBack&, zGetBackBitmap(zMainwindow(0)))
                  BitBlt(hDC, 0, 0, rc.nRight, rc.nBottom, hDCBack&, lp.x, lp.y, %SRCCOPY)
                  DeleteDC(hDCBack&)

               'ELSE
               '   '// In case of VISTA we paint directly into our own MainWindow double buffer
               '   '// to work around the "dvm compositing" flickering
               '   IF Vista() THEN hDC = zGetPaintDC(zMainwindow(0))
               END IF

            ELSE ' // WM_PRINT
               hDC = wParam
            END IF
            IF GdipCreateFromHDC(hDC, graphics) = 0 THEN

               zGetImageSize(Img, imgW, imgH)
               GetThumbTrackLocation(hWnd, tx, ty)

               LOCAL LEFTorTOPfront, LEFTorTOPback, MIDDLEfront AS LONG
               LOCAL MIDDLEback, RIGHTorBOTTOMfront, RIGHTorBOTTOMback AS LONG

   '            zSplitColorARGB(ARGB, A, R, G, B)

               IF PROGRESScolor THEN
                  zSplitColorARGB(PROGRESScolor, A, R, G, B)
                  GdipCreatePen1(zColorARGB(A, RGB(MAX&(R - 20, 0), MAX&(G - 20, 0), MAX&(B - 20, 0))), 1, %UnitPixel, LEFTorTOPfront)
                  GdipCreatePen1(PROGRESScolor, 1, %UnitPixel, MIDDLEfront)
                  GdipCreatePen1(zColorARGB(A, RGB(MIN&(R - 10, 0), MAX&(G - 10, 0), MIN&(B - 10, 0))), 1, %UnitPixel, RIGHTorBOTTOMfront)
               ELSE
                  zSplitColorARGB(ARGB, A, R, G, B)
                  GdipCreatePen1(zColorARGB(A, RGB(R, G, B)), 1, %UnitPixel, LEFTorTOPfront)
                  GdipCreatePen1(zColorARGB(A, RGB(MAX&(R - 74, 0), MAX&(G - 84, 0), MAX&(B - 28, 0))), 1, %UnitPixel, MIDDLEfront)
                  GdipCreatePen1(zColorARGB(A, RGB(MIN&(R + 4, 255), MAX&(G - 10, 0), MIN&(B + 28, 255))), 1, %UnitPixel, RIGHTorBOTTOMfront)
               END IF

               GdipCreatePen1(zColorARGB(255, RGB(55, 60, 74)), 1, %UnitPixel, LEFTorTOPback)
               GdipCreatePen1(zColorARGB(255, RGB(0, 0, 0)), 1, %UnitPixel, MIDDLEback)
               GdipCreatePen1(zColorARGB(255, RGB(87, 94, 110)), 1, %UnitPixel, RIGHTorBOTTOMback)

               IF TrackOrientation(hWnd) = %TRACK_HORZ THEN
                   y = rc.nBottom \ 2

                   IF tMin > tMax THEN
                       GdipDrawLineI(graphics, LEFTorTOPback, 0, y - 1, tx + ImgW \ 2, y - 1)
                       GdipDrawLineI(graphics, LEFTorTOPfront, tx + 1 + ImgW \ 2, y - 1, rc.nRight, y - 1)
                       GdipDrawLineI(graphics, MIDDLEback, 0, y, tx + ImgW \ 2, y)
                       GdipDrawLineI(graphics, MIDDLEfront, tx + 1 + ImgW \ 2, y, rc.nRight, y)
                       GdipDrawLineI(graphics, RIGHTorBOTTOMback, 0, y + 1, tx + ImgW \ 2, y + 1)
                       GdipDrawLineI(graphics, RIGHTorBOTTOMfront, tx + 1 + ImgW \ 2, y + 1, rc.nRight, y + 1)
                   ELSE
                       GdipDrawLineI(graphics, LEFTorTOPfront, 0, y - 1, tx + ImgW \ 2, y - 1)
                       GdipDrawLineI(graphics, LEFTorTOPback, tx + 1 + ImgW \ 2, y - 1, rc.nRight, y - 1)
                       GdipDrawLineI(graphics, MIDDLEfront, 0, y, tx + ImgW \ 2, y)
                       GdipDrawLineI(graphics, MIDDLEback, tx + 1 + ImgW \ 2, y, rc.nRight, y)
                       GdipDrawLineI(graphics, RIGHTorBOTTOMfront, 0, y + 1, tx + ImgW \ 2, y + 1)
                       GdipDrawLineI(graphics, RIGHTorBOTTOMback, tx + 1 + ImgW \ 2, y + 1, rc.nRight, y + 1)
                   END IF
               ELSE
                   x = rc.nRight \ 2

                   IF tMin > tMax THEN
                       GdipDrawLineI(graphics, LEFTorTOPback, x - 1, 0, x - 1, ty + ImgH \ 2)
                       GdipDrawLineI(graphics, LEFTorTOPfront, x - 1, ty + 1 + ImgH \ 2, x - 1, rc.nBottom)
                       GdipDrawLineI(graphics, MIDDLEback, x, 0, x, ty + ImgH \ 2)
                       GdipDrawLineI(graphics, MIDDLEfront, x, ty + 1 + ImgH \ 2, x, rc.nBottom)
                       GdipDrawLineI(graphics, RIGHTorBOTTOMback, x + 1, 0, x + 1, ty + ImgH \ 2)
                       GdipDrawLineI(graphics, RIGHTorBOTTOMfront, x + 1, ty + 1 + ImgH \ 2, x + 1, rc.nBottom)
                   ELSE
                       GdipDrawLineI(graphics, LEFTorTOPfront, x - 1, 0, x - 1, ty + ImgH \ 2)
                       GdipDrawLineI(graphics, LEFTorTOPback, x - 1, ty + 1 + ImgH \ 2, x - 1, rc.nBottom)
                       GdipDrawLineI(graphics, MIDDLEfront, x, 0, x, ty + ImgH \ 2)
                       GdipDrawLineI(graphics, MIDDLEback, x, ty + 1 + ImgH \ 2, x, rc.nBottom)
                       GdipDrawLineI(graphics, RIGHTorBOTTOMfront, x + 1, 0, x + 1, ty + ImgH \ 2)
                       GdipDrawLineI(graphics, RIGHTorBOTTOMback, x + 1, ty + 1 + ImgH \ 2, x + 1, rc.nBottom)
                   END IF
               END IF

               '// Draw thumb tracker only during %WM_PAINT
               GdipDrawImageRectRectI(graphics, Img, tx, ty, ImgW, ImgH, 0, 0, ImgW, ImgH, %UnitPixel, ImgAttr)

               '// Release pen resources
               GdipDeletePen(LEFTorTOPfront)
               GdipDeletePen(LEFTorTOPback)
               GdipDeletePen(MIDDLEfront)
               GdipDeletePen(MIDDLEback)
               GdipDeletePen(RIGHTorBOTTOMfront)
               GdipDeletePen(RIGHTorBOTTOMback)

               GdipDeleteGraphics(graphics)
            END IF
            IF Msg = %WM_PAINT THEN
               IF NOT zComposited() THEN zDoubleBuffer(0, 0, 0, 0)
               EndPaint(hWnd, ps)
            END IF
            FUNCTION = 0: EXIT FUNCTION
         END IF

    CASE %WM_DESTROY
'        // Delete the GDIPLUS thumb image
         zDeleteResource(zGetProperty(hWnd, %TRACK_IMAGE))
    END SELECT

    FUNCTION = DefWindowProc(hWnd, Msg, wParam, lParam)

END FUNCTION

'// Create an image trackbar control
FUNCTION zTrackbarEx (BYVAL hOwner AS LONG, zFullpathImageName AS ASCIIZ, _
                    BYVAL x AS LONG, BYVAL y AS LONG, BYVAL tW AS LONG, BYVAL tH AS LONG, BYVAL ButID AS LONG, _
                    BYVAL tMin AS LONG, BYVAL tMax AS LONG, BYVAL tVal AS LONG, BYVAL ARGBcolor AS LONG, BYVAL PROGRESScolor AS LONG) AS LONG
    LOCAL wcx  AS WNDCLASSEX
    LOCAL zClass AS ASCIIZ * 10
    LOCAL hCtrl, IsInitialized AS LONG

    IF tMin = tMax THEN EXIT FUNCTION

    zClass = "ZTRACKBAR"
    wcx.cbSize = SIZEOF(wcx)
    IsInitialized = GetClassInfoEx(zsInstance, zClass, wcx)
    IF IsInitialized    = 0 THEN
       wcx.style         = %CS_HREDRAW OR %CS_VREDRAW OR %CS_DBLCLKS OR %CS_PARENTDC
       wcx.lpfnWndProc   = CODEPTR(TrackProc)
       wcx.cbClsExtra    = 0
       wcx.cbWndExtra    = %EXTEND_EXTRA * 4
       wcx.hInstance     = zsInstance
       wcx.hIcon         = %NULL ' LoadIcon(wcx.hInstance, "PROGRAM")
       wcx.hCursor       = %NULL
       wcx.hbrBackground = %NULL ' Don't paint the class window background
       wcx.lpszMenuName  = %NULL
       wcx.lpszClassName = VARPTR(zClass)
       wcx.hIconSm       = wcx.hIcon
       IF RegisterClassEx(wcx) THEN IsInitialized = %TRUE
    END IF
'
    IF IsInitialized THEN
       LOCAL Img AS LONG
'      // Create GDIPLUS image from file
       Img = zAddResource((zFullpathImageName))
       IF Img THEN
          LOCAL imgW, imgH AS LONG
'         // Get the Thumb GDIPLUS image size
          zGetImageSize(Img, imgW, imgH)
          Style& = %WS_CHILD OR %WS_VISIBLE OR %WS_TABSTOP ' OR %BS_OWNERDRAW

          hCtrl = CreateWindowEx(%WS_EX_TRANSPARENT, zClass, "", Style&, x, y, tW, tH, hOwner, ButID, zsInstance, BYVAL %NULL)
          IF hCtrl THEN
'            // Save new properties
             zSetProperty(hCtrl, %TRACK_IMAGE, Img)
             zSetProperty(hCtrl, %TRACK_MINVAL, tMin)
             zSetProperty(hCtrl, %TRACK_MAXVAL, tMax)
             zSetProperty(hCtrl, %TRACK_VALUE, tVal)
             zSetProperty(hCtrl, %TRACK_WAS_VALUE, tVal)
             zSetProperty(hCtrl, %TRACK_ARGB, ARGBcolor)
             zSetProperty(hCtrl, %TRACK_PROGRESSCOLOR, PROGRESScolor)
             zSetProperty(hCtrl, %TRACK_DEFAULT_VALUE, tVal)
             FUNCTION = hCtrl
          ELSE
'            // Delete image
             zDeleteResource(Img)
          END IF
       END IF
    END IF
END FUNCTION

'// Create an image trackbar control
FUNCTION zTrackbar (BYVAL hOwner AS LONG, zFullpathImageName AS ASCIIZ, _
                    BYVAL x AS LONG, BYVAL y AS LONG, BYVAL tW AS LONG, BYVAL tH AS LONG, BYVAL ButID AS LONG, _
                    BYVAL tMin AS LONG, BYVAL tMax AS LONG, BYVAL tVal AS LONG, BYVAL ARGBcolor AS LONG) AS LONG
    FUNCTION = zTrackbarEx(hOwner, zFullpathImageName, x, y, tW, tH, ButID, tMin, tMax, tVal, ARGBcolor, 0)
END FUNCTION

FUNCTION zsExePath() AS STRING
    LOCAL sExePath AS STRING
    zSplitN(zExeName(), sExePath, "")
    FUNCTION = sExePath
END FUNCTION

'// Load SKIN components and create SYS buttons
SUB zInitSkin (BYVAL hMain AS LONG, zConfigFile AS ASCIIZ)
    LOCAL rc AS RECT
    LOCAL hBut, imgW, imgH, MinSizeX, StartX, StartY, x, y, Done AS LONG
    LOCAL zTip AS ASCIIZ * 20
    LOCAL zImageFile AS ASCIIZ * %MAX_PATH
    LOCAL sExePath, sSkinPath AS STRING

    LOCAL Item, S1, S2, S3, MiC, xLed, yLed AS LONG
    LOCAL sCfg, sBF AS STRING

    IF hMain THEN

'      // Save hMain handle
       zMainWindow(hMain)

'      // Setup default text rendering
       zTEXTRENDERING(%TextRenderingDefault, 1)

       GetClientRect(hMain, rc)

       sExePath = zsExePath()

       '// Make sure the current directory matches the EXE path
       SetCurrentDirectory((sExePath))

       Item = 0
       DO WHILE Done = 0
          sCfg = LTRIM$(zsBufin(zConfigFile, Done))
          IF LEN(sCfg) THEN
             IF ASC(LTRIM$(sCfg)) = 39 THEN sCfg = "" ' "'"
             S1 = INSTR(sCfg, "`")
             S2 = INSTR(-1, sCfg, CHR$(34))
             IF S1 = 0 THEN
                S3 = INSTR(-1, sCfg, "'"): IF S3 > S2 THEN S1 = S3
             END IF
             IF S1 THEN sCfg = RTRIM$(LEFT$(sCfg, S1 - 1))
             S1 = INSTR(sCfg, CHR$(34))
             IF S1 AND S1 < S2 THEN
                MiC = ASC(sCfg, LEN(sCfg))
                sCfg = MID$(sCfg, S1 + 1, S2 - S1 - 1)

                sBF = sBF + sCfg
                IF MiC <> 95 THEN
                   INCR Item
                   ON Item GOSUB AUTHOR,CXSYSBUT,CYSYSBUT,CXSYSICON,CYSYSICON,CXCAPTEXT,CYCAPTEXT,CXSYSLED,CYSYSLED, _
                                 BTN_FIX_X,BTN_FIX_Y,CENTER,TOP_LEFT,TOP_MID,TOP_RIGHT,SIDE_LEFT,SIDE_RIGHT,BOTTOM_LEFT, _
                                 BOTTOM_MID,BOTTOM_RIGHT,LED,PUSHBUT,CHECKBUT,ACTIVECAPTION,INACTIVECAPTION,TEXTCOLOR, _
                                 BTNTEXTCOLOR,POPMENUTEXT,POPMENUHILITE,ACTIVEMENUBAR,INACTIVEMENUBAR,CAPTIONFONT, _
                                 CAPTIONFONTHEIGHT,PUSHBUTFONTSIZE,ICONSIZE,TRACKHICOLOR,PAINT_BORDER,PAINT_BACKGROUND, _
                                 DRAG_BACKGROUND,TEXTFONT,SHADOWCOLOR,AEROEMULATE,AEROBLURLEVEL,AEROCOLOR,AEROTIMERDELAY, _
                                 COLORLABEL,TRACKPROGRESSCOLOR
                   sBF = ""
                END IF
             END IF
          END IF
       LOOP

       zImageFile = sSkinPath + "BTN_Close.png"
       hBut = zButImage(hMain, zImageFile, -100, -100, %ID_CLOSE, 0)
       zGetImageSize(zGetButImageBackProperty(hBut), imgW, imgH): imgW = imgW \ 5
       MinSizeX = MinSizeX + imgW
       x = rc.nRight - imgW - StartX: y = StartY: MoveWindow(hBut, x, y, imgW, imgH, %TRUE)
       zSetAnchorMode(hBut, %ANCHOR_RIGHT)
       IF IsFrench() THEN zTip = "Fermer" ELSE zTip = "Close"
       zCreateToolTip(hBut, zTip)

       zImageFile = sSkinPath + "BTN_Restore.png"
       hBut = zButImage(hMain, zImageFile, -100, -100, %ID_RESTORE, 0)
       ShowWindow(hBut, %SW_HIDE)
       zGetImageSize(zGetButImageBackProperty(hBut), imgW, imgH): imgW = imgW \ 5
       MinSizeX = MinSizeX + imgW
       x = x - imgW: MoveWindow(hBut, x, y, imgW, imgH, %FALSE)
       zSetAnchorMode(hBut, %ANCHOR_RIGHT)
       IF IsFrench() THEN zTip = "Niveau infrieur" ELSE zTip = "Restore"
       zCreateToolTip(hBut, zTip)

       zImageFile = sSkinPath + "BTN_Maximize.png"
       hBut = zButImage(hMain, zImageFile, -100, -100, %ID_MAXIMIZE, 0)
       zGetImageSize(zGetButImageBackProperty(hBut), imgW, imgH): imgW = imgW \ 5
       MoveWindow(hBut, x, y, imgW, imgH, %TRUE)
       zSetAnchorMode(hBut, %ANCHOR_RIGHT)
       IF IsFrench() THEN zTip = "Agrandir" ELSE zTip = "Maximize"
       zCreateToolTip(hBut, zTip)

       zImageFile = sSkinPath + "BTN_Minimize.png"
       hBut = zButImage(hMain, zImageFile, -100, -100, %ID_MINIMIZE, 0)
       zGetImageSize(zGetButImageBackProperty(hBut), imgW, imgH): imgW = imgW \ 5
       MinSizeX = MinSizeX + imgW
       x = x - imgW: MoveWindow(hBut, x, y, imgW, imgH, %TRUE)
       zSetAnchorMode(hBut, %ANCHOR_RIGHT)
       IF IsFrench() THEN zTip = "Reduire" ELSE zTip = "Iconize"
       zCreateToolTip(hBut, zTip)

'      // Create GDIPLUS image from file
       zDrawBackground()

       zMinTrackSizeX(rc.nRight)  ' MinSizeX
       zMinTrackSizeY(rc.nBottom) ' MAX&(imgH, 22)

'      // Set caption color
       gColorCaption = SK_ACTIVECAPTION()

'      // We use a layered window for the purpose of compositing
'      // and to get child enumeration from bottom to top
       IF zComposited() THEN zSetLayeredAlpha(hMain, 0)
    END IF

EXIT SUB

AUTHOR:
zSkinAuthor(PARSE$(sBF, 2))
RETURN

CXSYSBUT:
StartX = VAL(PARSE$(sBF, 2))
RETURN

CYSYSBUT:
StartY = VAL(PARSE$(sBF, 2))
RETURN

CXSYSICON:
zCXSYSICON(VAL(PARSE$(sBF, 2)), 1)
RETURN

CYSYSICON:
zCYSYSICON(VAL(PARSE$(sBF, 2)), 1)
RETURN

CXCAPTEXT:
zCXCAPTEXT(VAL(PARSE$(sBF, 2)), 1)
RETURN

CYCAPTEXT:
zCYCAPTEXT(VAL(PARSE$(sBF, 2)), 1)
RETURN

CXSYSLED:
xLed = rc.nRight - VAL(PARSE$(sBF, 2))
RETURN

CYSYSLED:
yLed = VAL(PARSE$(sBF, 2))
RETURN

BTN_FIX_X:
zBTNFIXX(VAL(PARSE$(sBF, 2)), 1)
RETURN

BTN_FIX_Y:
zBTNFIXY(VAL(PARSE$(sBF, 2)), 1)
RETURN

CENTER:
zCENTERFORM((zSkinPath(sBF, sExePath)),1)
zSetProperty(hMain, %FORM_Center, zCreateImageFromFile((zSkinPath(sBF, sExePath))))
zSplitN(zSkinPath(sBF, sExePath), sSkinPath, "")
zFOLDER(sSkinPath,1)
RETURN

TOP_LEFT:
zSetProperty(hMain, %FORM_TopLeft, zCreateImageFromFile((zSkinPath(sBF, sExePath))))
RETURN

TOP_MID:
zSetProperty(hMain, %FORM_TopMid, zCreateImageFromFile((zSkinPath(sBF, sExePath))))
RETURN

TOP_RIGHT:
zSetProperty(hMain, %FORM_TopRight, zCreateImageFromFile((zSkinPath(sBF, sExePath))))
RETURN

SIDE_LEFT:
zSetProperty(hMain, %FORM_SideLeft, zCreateImageFromFile((zSkinPath(sBF, sExePath))))
RETURN

SIDE_RIGHT:
zSetProperty(hMain, %FORM_SideRight, zCreateImageFromFile((zSkinPath(sBF, sExePath))))
RETURN

BOTTOM_LEFT:
zSetProperty(hMain, %FORM_BottomLeft, zCreateImageFromFile((zSkinPath(sBF, sExePath))))
RETURN

BOTTOM_MID:
zSetProperty(hMain, %FORM_BottomMid, zCreateImageFromFile((zSkinPath(sBF, sExePath))))
RETURN

BOTTOM_RIGHT:
zSetProperty(hMain, %FORM_BottomRight, zCreateImageFromFile((zSkinPath(sBF, sExePath))))
RETURN

LED:
hBut = zButImage(hMain, (zSkinPath(sBF, sExePath)), xLed, yLed, %ID_LED, 2)
zSetAnchorMode(hBut, %ANCHOR_RIGHT)
RETURN

PUSHBUT:
'zCreateImageFromFile((zSkinPath(sBF, sExePath)))
RETURN

CHECKBUT:
'zCreateImageFromFile((zSkinPath(sBF, sExePath)))
RETURN

ACTIVECAPTION:
zACTIVECAPTION(zSkinARGB(sBF), 1)
RETURN

INACTIVECAPTION:
zINACTIVECAPTION(zSkinARGB(sBF), 1)
RETURN

TEXTCOLOR:
zTEXTCOLOR(zSkinARGB(sBF), 1)
RETURN

BTNTEXTCOLOR:
zBTNTEXTCOLOR(zSkinARGB(sBF), 1)
RETURN

POPMENUTEXT:
zPOPMENUTEXT(zSkinARGB(sBF), 1)
RETURN

POPMENUHILITE:
zPOPMENUHILITE(zSkinARGB(sBF), 1)
RETURN

ACTIVEMENUBAR:
zACTIVEMENUBAR(zSkinARGB(sBF), 1)
RETURN

INACTIVEMENUBAR:
zINACTIVEMENUBAR(zSkinARGB(sBF), 1)
RETURN

CAPTIONFONT:
zCAPTIONFONT(PARSE$(sBF, 2), 1)
RETURN

CAPTIONFONTHEIGHT:
zCAPTIONFONTHEIGHT(VAL(PARSE$(sBF, 2)), 1)
RETURN

PUSHBUTFONTSIZE:
zPUSHBUTFONTSIZE(VAL(PARSE$(sBF, 2)), 1)
RETURN

ICONSIZE:
zICONSIZE(VAL(PARSE$(sBF, 2)), 1)
RETURN

TRACKHICOLOR:
zTRACKHICOLOR(zSkinARGB(sBF), 1)
RETURN

PAINT_BORDER:
zPAINT_BORDER(VAL(PARSE$(sBF, 2)), 1)
RETURN

PAINT_BACKGROUND:
zPAINT_BACKGROUND(VAL(PARSE$(sBF, 2)), 1)
RETURN

DRAG_BACKGROUND:
zDRAG_BACKGROUND(VAL(PARSE$(sBF, 2)), 1)
RETURN

TEXTFONT:
zTEXTFONT(PARSE$(sBF, 2), 1)
RETURN

SHADOWCOLOR:
zSHADOWCOLOR(zSkinARGB(sBF), 1)
RETURN

AEROEMULATE:
zAEROEMULATE(VAL(PARSE$(sBF, 2)), 1)
RETURN

AEROBLURLEVEL:
zAEROBLURLEVEL(VAL(PARSE$(sBF, 2)), 1)
RETURN

AEROCOLOR:
zAEROCOLOR(zSkinARGB(sBF), 1)
RETURN

AEROTIMERDELAY:
zAEROTIMERDELAY(VAL(PARSE$(sBF, 2)), 1)
RETURN

COLORLABEL:
zCOLORLABEL(sBF, 1)
RETURN

TRACKPROGRESSCOLOR:
zPROGRESSCOLOR(zSkinARGB(sBF), 1)
RETURN

END SUB

'// To detect if the main window is resizable or not
FUNCTION zWinResizable(BYVAL hWnd AS LONG) AS LONG
    LOCAL hCtl AS LONG
    hCtl = GetDlgItem(hWnd, %ID_MAXIMIZE)
    IF hCtl THEN
       IF IsWindowVisible(hCtl) THEN FUNCTION = -1
    END IF
END FUNCTION

'// Monitor Windows DEF PROC to take over HITTEST detection
FUNCTION zDefWindowProc(BYVAL hWnd AS LONG, BYVAL Msg AS LONG, BYVAL wParam AS LONG, BYVAL lParam AS LONG) AS LONG
    LOCAL nRet, HITTEST, CaptionHeight AS LONG
    LOCAL rc AS RECT, p AS POINTAPI

    nRet = DefWindowProc(hWnd, Msg, wParam, lParam)

    IF Msg = %WM_NCHITTEST THEN
       zGetImageSize(zGetProperty(hWnd, %FORM_TopMid), 0, CaptionHeight)
       p.X = LO(INTEGER, lParam): p.Y = HI(INTEGER, lParam)
       ScreenToClient(hWnd, p)
       IF IsZoomed(hWnd) = 0 THEN
          IF nRet = %HTCLIENT THEN
             HITTEST = %HTCAPTION
             IF SK_DRAG_BACKGROUND() = 0 THEN
                IF p.Y > CaptionHeight AND CaptionHeight > 0 THEN
                   HITTEST = %HTNOWHERE
                   IF hWnd <> GetForegroundWindow THEN SetFocus(hWnd)
                END IF
             END IF
             IF zWinResizable(hWnd) THEN ' We fool Window
                GetClientRect (hWnd, rc)
                LOCAL xF, yF, xSide, Border AS LONG
                xF = rc.nRight: yF = rc.nBottom
                xSide = 0
                Border = GetSystemMetrics(32) ' %SM_CXFRAME
                IF ((p.X >= xF - Border) AND ((p.Y >= yF - Border))) THEN
                   HITTEST = %HTBOTTOMRIGHT
                ELSE
                   '// Left side
                   IF (p.X <= 8) THEN
                       IF (p.X <= Border) THEN HITTEST = %HTLEFT
                       xSide = 1
                   END IF
                   '// Right side
                   IF (p.X >= xF - 8) THEN
                       IF (p.X >= xF - Border) THEN HITTEST = %HTRIGHT
                       xSide = 2
                   END IF
                   '// Top side
                   IF (p.Y <= Border) THEN
                       HITTEST = %HTTOP
                       IF (xSide = 1) THEN
                           HITTEST = %HTTOPLEFT
                       ELSEIF (xSide = 2) THEN
                           HITTEST = %HTTOPRIGHT
                       END IF
                   END IF
                   '// Bottom side
                   IF (p.Y >= yF - Border) THEN
                       IF (xSide = 1) THEN
                           HITTEST = %HTBOTTOMLEFT
                       ELSE
                           HITTEST = %HTBOTTOM
                       END IF
                   END IF
                END IF
             END IF
             nRet = HITTEST
          END IF
       '//ELSE ' See %WM_LBUTTONDBLCLK below
       '//   IF p.Y < CaptionHeight THEN nRet = %HTCAPTION
       END IF
    ELSEIF Msg = %WM_LBUTTONDBLCLK THEN
       IF IsZoomed(hWnd) THEN
          p.X = LO(INTEGER, lParam): p.Y = HI(INTEGER, lParam)
          zGetImageSize(zGetProperty(hWnd, %FORM_TopMid), 0, CaptionHeight)
          IF p.Y < CaptionHeight AND IsWindowVisible(GetDlgItem(hWnd, %ID_RESTORE)) THEN
             zButtonSysCommand(hWnd, MAKLNG(%ID_RESTORE, 0))
          END IF
       END IF
    END IF

    FUNCTION = nRet
END FUNCTION

'// Show Main form
SUB zShowMainWindow(BYVAL UseStep AS LONG)
    LOCAL K, hMain AS LONG
    hMain = zMainWindow(0)
'   // *************************************************
'   // Create region and paint controls to double buffer
'   // *************************************************
'   // We use Magenta color, -1 means use the top left pixel color at coordinate 0,0.
    zCreateFormRegion(&hFF00FF) ' &HFF00FF = Magenta color

'   // Show main window
    ShowWindow(hMain, %SW_SHOW)
'   // What about a small animation effect
    IF zComposited() THEN
       IF UseStep THEN
          UseStep = MIN&(MAX&(UseStep, 0), 255)
          FOR K = 1 TO 255 STEP UseStep: zSetLayeredAlpha(hMain, K): NEXT
       END IF
       zSetLayeredAlpha(hMain, 255)
    END IF

    SetFocus(hMain)

END SUB

'// Changes control text.
SUB zSetCTLText(BYVAL hCTRL AS LONG, zText AS ASCIIZ)
    IF hCtrl THEN
       IF zText <> zGetCTLText(hCtrl) THEN SendMessage(hCTRL, %WM_SETTEXT, 0, VARPTR(zText))
    END IF
END SUB

'// Create a folder
DECLARE FUNCTION CreateDirectory LIB "KERNEL32.DLL" ALIAS "CreateDirectoryA" (lpPathName AS ASCIIZ, lpSecurityAttributes AS SECURITY_ATTRIBUTES) AS LONG
FUNCTION zMakeDir(zRep AS ASCIIZ) AS LONG
    LOCAL sChm, sDirectory AS STRING, P1, P2, ErrCode AS LONG

    IF LEFT$(zRep, 2) = "\\" THEN EXIT FUNCTION
    sDirectory = RTRIM$(zRep, $Anti)
    IF LEN(sDirectory) THEN
       P1 = 1
       DO
          P2 = INSTR(P1, sDirectory, $Anti)
          IF P2 THEN
             sChm = MID$(sDirectory, 1, P2& - 1): P1 = P2 + 1
          ELSE
             sChm = sDirectory
          END IF
          IF LEN(DIR$(sChm, 16)) = 0 THEN
             'MKDIR sChm
             IF CreateDirectory((sChm), BYVAL 0&) = 0 THEN
                ErrCode = GetLastError(): EXIT DO
             END IF
          END IF
       LOOP UNTIL P2 = 0
    END IF
    FUNCTION = ErrCode
END FUNCTION

FUNCTION zGetWindowRgn(BYVAL x AS LONG, BYVAL y AS LONG, BYVAL hWnd AS LONG) AS LONG
    LOCAL hRgn AS LONG
    hRgn = CreateRectRgn(0, 0, 0, 0)
    IF GetWindowRgn(hWnd, hRgn) THEN
       IF OffsetRgn(hRgn, x, y) THEN FUNCTION = hRgn
    END IF
END FUNCTION

'// Emulate left mouse button click
SUB zPutFocusOn(BYVAL nObjectHandle AS LONG)
    PostMessage (nObjectHandle, 513 , 0, 0) '// WM_LBUTTONDOWN
    PostMessage (nObjectHandle, 514 , 0, 0) '// WM_LBUTTONUP
END SUB

FUNCTION zBeginDeferWindowPos(BYVAL hWnd AS LONG, BYVAL nWindowCount AS LONG) AS LONG
    LockWindowUpdate(hWnd)
    SendMessage(hWnd, %WM_SETREDRAW, 0, 0)
    IF nWindowCount = < 128 THEN nWindowCount = 128
    FUNCTION = BeginDeferWindowPos(nWindowCount)
END FUNCTION

SUB zEndDeferWindowPos(BYVAL hWnd AS LONG, lRes AS LONG)
    EndDeferWindowPos(lRes)
    SendMessage(hWnd, %WM_SETREDRAW, 1, 0)
    LockWindowUpdate(0)
END SUB

'// Build the child z-order array
FUNCTION ChildEnum (BYVAL hWnd AS LONG, BYVAL lParam AS LONG) AS LONG
    LOCAL Item AS LONG
    LOCAL zChildClass AS ASCIIZ * 32
    IF GetClassName(hWnd, zChildClass, SIZEOF(zChildClass)) THEN
       IF zChildClass = "ZIMAGECTRL" THEN
'         // Do not enumerate GDImage control
       ELSEIF IsWindowVisible(hWnd) THEN
          Item = MAX&(UBOUND(gZorder) + 1, 1)
          REDIM PRESERVE gZorder(1 TO Item)
          gZorder(Item) = hWnd
       END IF
    END IF
    FUNCTION = %TRUE ' Continue enumeration of children
END FUNCTION

'// Paint GROUPBOX with respect of the z-order
SUB PaintGroupBox(BYVAL hWnd AS LONG, BYVAL graphics AS LONG)
    LOCAL K, pX, pY, Img, ButtonStyle AS LONG, rw AS RECT

    GetWindowRect(hWnd, rw)
    pX = rw.nLeft: pY = rw.nTop

    ERASE gZorder()
    EnumChildWindows(hWnd, CODEPTR(ChildEnum), 0)
'   Draw from bottom to top of z-order
    FOR K = UBOUND(gZorder) TO 1 STEP -1
        ButtonStyle = zGetButStyle(gZorder(K))
        IF ButtonStyle = %BS_GROUPBOX THEN
           Img = zGetButImageBackProperty(gZorder(K))
           IF Img THEN
              GetWindowRect(gZorder(K), rw)
              zPaintButton(graphics, 1, Img, rw.nLeft - pX, rw.nTop - pY, rw.nRight - rw.nLeft, rw.nBottom - rw.nTop, ButtonStyle, 0)
           END IF
        ELSEIF ButtonStyle = %FILLRECTANGLE THEN
           GetWindowRect(gZorder(K), rw)
           zsGdipFillRect(graphics, rw.nLeft - pX, rw.nTop - pY, rw.nRight - rw.nLeft, rw.nBottom - rw.nTop, zGetButProperty(gZorder(K), %PROP_COLOR) )
           'zsGdipFillRect(graphics, 50, 50, 200, 200, zColorARGB(255,255))' zGetProperty(gZorder(K), %PROP_COLOR) )
        END IF
    NEXT
END SUB

'// Paint from zSkin internal double buffer
SUB zPaintDoubleBuffer(BYVAL hWnd AS LONG, BYVAL hDC AS LONG)
    LOCAL lParam AS LONG
    '*'
    IF NOT zComposited() THEN
       zPaintBackground(0)
       lParam = %PRF_CHILDREN OR %PRF_CLIENT OR %PRF_NONCLIENT OR %PRF_CHECKVISIBLE' OR %PRF_OWNED
       SendMessage(hWnd, %WM_PRINT, zGetPaintDC(hWnd), lParam)
    END IF
    '*'
    zPaintToScreen(hWnd, hDC, 0, 0, 0)
END SUB

'// Redraw background in case of WM_SETTEXT text has been changed
SUB zRedrawBackground(BYVAL hWnd AS LONG)
    LOCAL K AS LONG
    IF GetParent(hWnd) = zMainWindow(0) THEN
       zPaintBackground(0)
       ERASE gZorder()
       EnumChildWindows(hWnd, CODEPTR(ChildEnum), 0)
'      Draw from bottom to top of z-order
       FOR K = UBOUND(gZorder) TO 1 STEP -1
           SendMessage(gZorder(K), %WM_PRINT, zGetPaintDC(hWnd), 0)'lParam)
       NEXT
    END IF
    zUpdateWindow(hWnd, 0)
END SUB

SUB zDestroyWindowResource(BYVAL hWnd AS LONG)
'   // Delete the GDIPLUS image skin components
    LOCAL K, hResource AS LONG
    FOR K = %FORM_TopLeft TO %FORM_BottomRight
        zDisposeImage(zGetProperty(hWnd, K))
    NEXT
'   // Clear paint resources
    hResource = zGetPaintBitmap(hWnd)
    zDeleteObject(hResource): zSetProperty(hWnd, %FORM_PaintBitmap, hResource)
'   // Delete DC
    hResource = zGetPaintDC(hWnd)
    IF hResource THEN DeleteDC(hResource): hResource = 0: zSetProperty(hWnd, %FORM_PaintDC, hResource)
'   // %BACK_PaintBitmap
    hResource = zGetBackBitmap(hWnd)
    zDeleteObject(hResource): zSetProperty(hWnd, %FORM_PaintBitmap, hResource)
END SUB

%ZM_STRINGDATA = 0
FUNCTION zSendPrivateMsg(BYVAL hFound AS LONG, BYVAL UseMsg AS LONG, BYVAL sBuff AS STRING) AS LONG

    LOCAL cds AS COPYDATASTRUCT, LenBuff AS LONG

    LenBuff = LEN(sBuff)
    REDIM Buf(LenBuff) AS BYTE
    POKE$ VARPTR(Buf(0)), sBuff
    cds.dwData = UseMsg
    cds.cbData = UBOUND(Buf) - LBOUND(Buf) + 1
    cds.lpData = VARPTR(Buf(0))
    FUNCTION = SendMessage(hFound, %WM_COPYDATA, LenBuff, VARPTR(cds))

END FUNCTION

FUNCTION zGetPrivateMsg(BYREF sPrivateMsg AS STRING, BYVAL wParam AS LONG, BYVAL lParam AS LONG) AS LONG

    LOCAL cds AS COPYDATASTRUCT

    REDIM Buf(wParam) AS BYTE
    MoveMemory(cds, BYVAL lParam, SIZEOF(cds))
    MoveMemory(buf(0), BYVAL cds.lpData, cds.cbData)
    sPrivateMsg = PEEK$(VARPTR(buf(0)), wParam)
    FUNCTION = cds.dwData

END FUNCTION

FUNCTION zsFileOperation(BYVAL hDlg AS LONG, zSrce AS ASCIIZ, zTarget AS ASCIIZ, zTitle AS ASCIIZ, BYVAL FlagDialog AS LONG, BYVAL wFunc AS LONG) AS LONG
    LOCAL ErrCode AS LONG
    DIM Sh AS SHFILEOPSTRUCT
    IF zsExist(zSrce) THEN
       Sh.hWnd = hDlg&
       Sh.wFunc = wFunc
       Sh.pFrom = VARPTR(zSrce)
       Sh.pTo = VARPTR(zTarget)
       Sh.fFlags = %FOF_SILENT OR %FOF_NOCONFIRMATION OR %FOF_NOCONFIRMMKDIR
       IF FlagDialog THEN
          Sh.lpszProgressTitle = VARPTR(zTitle)
          Sh.fFlags = %FOF_NOCONFIRMATION OR %FOF_NOCONFIRMMKDIR OR %FOF_SIMPLEPROGRESS
       END IF
       ErrCode = SHFileOperation(Sh)
    ELSE
       ErrCode = 2 ' The system cannot find the file specified
    END IF
    FUNCTION = ErrCode
END FUNCTION

FUNCTION zsFileCopy(BYVAL hDlg AS LONG, zSrce AS ASCIIZ, zTarget AS ASCIIZ, zTitle AS ASCIIZ, BYVAL FlagDialog AS LONG) AS LONG
    FUNCTION = zsFileOperation (hDlg, zSrce, zTarget, zTitle, FlagDialog, %FO_COPY)
    'TRY
    '    FILECOPY zSrce, zTarget
    'CATCH
    '    FUNCTION = ERR
    '    EXIT TRY
    'END TRY
END FUNCTION

FUNCTION zsCopyFile(szSrce AS ASCIIZ, szDest AS ASCIIZ) AS LONG
    FUNCTION = CopyFile(szSrce, szDest, 0)
END FUNCTION

FUNCTION zsFileMove(BYVAL hDlg AS LONG, zSrce AS ASCIIZ, zTarget AS ASCIIZ, zTitle AS ASCIIZ, BYVAL FlagDialog AS LONG) AS LONG
    FUNCTION = zsFileOperation (hDlg, zSrce, zTarget, zTitle, FlagDialog, %FO_MOVE)
END FUNCTION

SUB zsEvent()
    DIM Msg AS tagMsg
    WHILE PeekMessage(Msg, %NULL, 0, 0, %PM_REMOVE)
       TranslateMessage(Msg)
       DispatchMessage(Msg)
    WEND
END SUB

'// Kill directly a file without sending it to recycle.bin
FUNCTION zsKillFile (zFullName AS ASCIIZ) EXPORT AS LONG
    LOCAL zTmp AS ASCIIZ * %MAX_PATH, sPathName, sToKill AS STRING
    zSplitN (zFullName$, sPathName, sToKill)
    sToKill = DIR$(zFullName, 39) ' %NORMAL + %READONLY + %HIDDEN + %SYSTEM + %ARCHIVE
    DO WHILE LEN(sToKill)
       zTmp = sPathName + sToKill
       SetFileAttributes(zTmp, %FILE_ATTRIBUTE_NORMAL)
       IF DeleteFile(zTmp) = 0 THEN FUNCTION = GetLastError: EXIT DO
       sToKill = DIR$
    LOOP
END FUNCTION

'// To create embedded subfolders
FUNCTION zsMakeDir (zDir AS ASCIIZ) AS LONG
    LOCAL sDir, sFolderName AS STRING, Done, P1, P2, ErrCode AS LONG
    IF LEFT$(zDir, 2) = "\\" THEN EXIT FUNCTION
    ON ERROR GOTO ErrCredir
    sDir = RTRIM$(zDir, $Anti)
    IF LEN(sDir) THEN
       P1 = 1
       DO
          P2 = INSTR(P1, sDir, $Anti)
          IF P2 THEN
             sFolderName = MID$(sDir, 1, P2 - 1): P1 = P2 + 1
          ELSE
             sFolderName = sDir
          END IF
          IF LEN(DIR$(sFolderName, 16)) = 0 THEN MKDIR sFolderName
       LOOP UNTIL P2 = 0
    END IF
ErrCredir:
    ErrCode = ERRCLEAR
    IF ErrCode AND Done = 0 THEN Done = ErrCode: RESUME ErrCredir
    IF Done THEN ErrCode = Done
    FUNCTION = ErrCode
END FUNCTION

SUB zsGdipLine(BYVAL graphics AS LONG, BYVAL x1 AS LONG, BYVAL y1 AS LONG, BYVAL x2 AS LONG, BYVAL y2 AS LONG, BYVAL ARGB AS LONG)
    LOCAL hPen AS LONG
    GdipCreatePen1(ARGB, 1, %UnitPixel, hPen)
    GdipDrawLineI(graphics, hPen, x1, y1, x2, y2)
    GdipDeletePen(hPen)
END SUB

SUB zsGdipFillRect(BYVAL graphics AS LONG, BYVAL x1 AS LONG, BYVAL y1 AS LONG, BYVAL x2 AS LONG, BYVAL y2 AS LONG, BYVAL ARGB AS LONG)
    LOCAL hBrush AS LONG
    GdipCreateSolidFill(ARGB, hBrush)
    GdipFillRectangleI(graphics, hBrush, x1, y1, x2, y2)
    GdipDeleteBrush(hBrush)
END SUB

FUNCTION zsGetTempPath () AS STRING
    LOCAL sTempPath AS STRING, nSize AS LONG
    sTempPath = SPACE$(GetTempPath(0, BYVAL %NULL))
    nSize = GetTempPath(LEN(sTempPath), BYVAL STRPTR(sTempPath))
    sTempPath = RTRIM$(sTempPath, ANY CHR$(0,92))
    sTempPath = sTempPath + $Anti
    FUNCTION = sTempPath
END FUNCTION
